Attribute VB_Name = "Common"
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3E0698FA004A"
Option Explicit
  
  Private CRC32Table(255) As Long
  Private CRC32Loaded As Boolean
  
  Public strTempDir As String
  
  Public Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
  Public Declare Function GetTempFileName Lib "kernel32" Alias "GetTempFileNameA" (ByVal lpszPath As String, ByVal lpPrefixString As String, ByVal wUnique As Long, ByVal lpTempFileName As String) As Long
  Public Declare Function GetShortPathName Lib "kernel32" Alias "GetShortPathNameA" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long

  Public Const dblLogConst = 2.50858329719984E-02 ' = Log10(2 ^ (1/12))
  Public Const QUOTECHAR = """"
  Public Const ARG1 = "%1"
  Public Const ARG2 = "%2"
  Public Const ARG3 = "%3"
  
  Public Const WINAGI_VERSION_1 = "WINAGI v1.0     "
  Public Const WINAGI_VERSION_BETA = "1.0 BETA        "
  
  Public Const sAPPNAME As String = "WinAGI Game Development System 1.1"

Public Function GuessSyntax(OldSource As String, ByVal DefaultSyntax As LogicSyntaxType) As LogicSyntaxType
  
  Dim Cscore As Long
  Dim VBScore As Long
  
  On Error Resume Next
  
  'check for c markers
  If InStrB(1, OldSource, "==") <> 0 Then
    Cscore = Cscore + 1
  End If
  If InStrB(1, OldSource, "||") <> 0 Then
    Cscore = Cscore + 1
  End If
  If InStrB(1, OldSource, "&&") <> 0 Then
    Cscore = Cscore + 1
  End If
  If InStrB(1, OldSource, ") {") <> 0 Then
    Cscore = Cscore + 1
  End If
  If InStrB(1, OldSource, "#message") <> 0 Then
    Cscore = Cscore + 1
  End If
  
  'check for vb markers
  If InStrB(1, OldSource, "Const ") <> 0 Then
    VBScore = VBScore + 1
  End If
  If InStrB(1, OldSource, "Message(") <> 0 Then
    VBScore = VBScore + 1
  End If
  If InStrB(1, OldSource, "End If") <> 0 Then
    VBScore = VBScore + 1
  End If
  If InStrB(1, OldSource, "Then" & vbNewLine) <> 0 Then
    VBScore = VBScore + 1
  End If
  
  'if either score is 0 and other is >0
  If Cscore > 0 And VBScore = 0 Then
    'assume current logic is agi
    GuessSyntax = lsAGI
  ElseIf Cscore = 0 And VBScore > 0 Then
    GuessSyntax = lsVB
  Else
    'some of both elements found;
    If Cscore - VBScore > 1 Then
      GuessSyntax = lsAGI
    ElseIf VBScore - Cscore > 1 Then
      GuessSyntax = lsVB
    Else
      'not sure- use default
      GuessSyntax = DefaultSyntax
    End If
  End If
End Function
Public Function Hex2(ByVal lngVal As Long) As String

  'improved hex function that adds extra pad for
  'single digit hex values
  
  On Error GoTo ErrHandler
  
  Hex2 = Hex$(lngVal)
  If Len(Hex2) = 1 Then
    Hex2 = "0" & Hex2
  End If
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function

Public Function IsInvObject(ByVal lngStartPos As Long, strText As String, ByVal Syntax As LogicSyntaxType) As Boolean

  On Error GoTo ErrHandler
  
  'check for has cmd
  'check for obj.in.room cmd
  'check for drop cmd
  'check for get cmd
  'check for put cmd
  
  
  
  
  '*****not implemented yet; always return true
  IsInvObject = True

Exit Function

ErrHandler:

End Function


Public Function IsVocabWord(ByVal lngStartPos As Long, strText As String, ByVal Syntax As LogicSyntaxType) As Boolean

  On Error GoTo ErrHandler
  
  'check for 'said' cmd
  'check for  'word.to.string'

  '*****not implemented yet; always return true
  IsVocabWord = True



Exit Function

ErrHandler:

End Function
Public Function Log10(ByVal x As Double) As Double
  On Error Resume Next
  Log10 = Log(x) / Log(10#)
End Function

Public Function AGIForNext(ByVal fS As Long, ByVal fE As Long, ByVal fStep As Long) As Boolean

  Dim vbCtr As Integer, vbCount As Integer, vbEnd As Integer
  Dim agCtr As Integer, agCount As Integer, agEnd As Integer
  Dim agStep As Integer
  
  If fStep = 0 Then
    AGIForNext = True
    Exit Function
  End If
  
  vbCount = 0
  For vbCtr = fS To fE Step fStep
    vbCount = vbCount + 1
  Next vbCtr
  vbEnd = AGIVal(vbCtr)
  
  Select Case Sgn(fStep)
  Case 1
    agCount = 0
    agCtr = fS
    If agCtr <= fE Then
StartForPlus:
      agCount = agCount + 1
      agCtr = AGIVal(agCtr + fStep)
      If agCtr < fStep Then
        GoTo EndForPlus
      End If
      If agCtr <= fE Then
        GoTo StartForPlus
      End If
    End If
EndForPlus:
    agEnd = agCtr
    
  Case -1
    agCount = 0
    agCtr = fS
    agStep = AGIVal(0 - Abs(fStep))
    If agCtr >= fE Then
StartForMinus:
      agCount = agCount + 1
      agCtr = AGIVal(agCtr + agStep)
      If agCtr >= agStep Then
        GoTo EndForMinus
      End If
      If agCtr >= fE Then
        GoTo StartForMinus
      End If
    End If
EndForMinus:
    agEnd = agCtr
  End Select
  
  AGIForNext = (agCount = vbCount) And (agEnd = vbEnd)
End Function

Public Function CopyFile2(SourceFilename As String, ByVal DestFilename As String, blnDestDir As Boolean) As Boolean
  'copies file from source to destination
  'if blnDestDir is true, destFilename is a directory only
  'and old filename will be used in new directory
  '
  'returns true if successful
  'returns false if not successful
  
  Dim strFilenameOnly As String
  
  On Error GoTo CopyFile2_Err

  'if copying file to a new directory only,
  If blnDestDir Then
      'build new destfilename
      strFilenameOnly = Right$(SourceFilename, Len(SourceFilename) - InStrRev(SourceFilename, "\"))
      DestFilename = DestFilename & strFilenameOnly
  End If
  
  'attempt to copy file
  FileCopy SourceFilename, DestFilename
  
  'return true
  CopyFile2 = True
Exit Function

CopyFile2_Err:
    Err.Clear
    CopyFile2 = False
End Function

Public Function AGIVal(ByVal IntIn As Integer) As Byte
  
    Select Case IntIn
    Case Is < 0
      Do
        IntIn = IntIn + 256
      Loop Until IntIn >= 0
    Case Is > 255
      Do
        IntIn = IntIn - 256
      Loop Until IntIn <= 255
    End Select
    AGIVal = CByte(IntIn)
End Function


Public Function CompactPath(ByVal LongPath As String, Optional ByVal MaxLength As Long = 40) As String
  'this method will ensure LongPath is compacted
  'to be less than MaxLength characters long, if possible
  'by eliminating directories and replacing them with ellipse(...)
  
  Dim strDirs() As String
  Dim i As Long, lngLength As Long
  Dim lngUbound As Long
  Dim blnPathOnly As Boolean
  
  On Error GoTo ErrHandler
  
  'if already fits,
  If Len(LongPath) <= MaxLength Then
    'return entire path
    CompactPath = LongPath
    Exit Function
  End If
  
  'if no subdirectories
  If InStrB(1, LongPath, "\") = 0 Then
    'return truncated path
    CompactPath = Left$(LongPath, MaxLength - 3) & "..."
    Exit Function
  End If
  
  'if not a valid path (i.e.doesn't start with a drive letter, and a colon and a backslash
  If AscW(LCase$(LongPath)) < 97 Or AscW(LCase$(LongPath)) > 122 Or Mid$(LongPath, 2, 1) <> ":" Or Mid$(LongPath, 3, 1) <> "\" Then
    'return truncated path
    CompactPath = Left$(LongPath, MaxLength - 3) & "..."
    Exit Function
  End If
  
  'if path ends with '\'
  If Right$(LongPath, 1) = "\" Then
    'strip it off temporarily
    LongPath = Left$(LongPath, Len(LongPath) - 1)
    'reduce maxlength by one so the '\' can be re-added
    MaxLength = MaxLength - 1
    'set flag
    blnPathOnly = True
  End If
  
  'split into elements
  strDirs = Split(LongPath, "\")
  
  'get upperbound
  lngUbound = UBound(strDirs)
  
  'if name is too long (longer than max length minus drive and '\...\'
  If Len(strDirs(lngUbound)) > MaxLength - Len(strDirs(0)) - 5 Then
    'if only two elements
    If lngUbound = 1 Then
      'add drive and enough of name to just fit with a trailing ellipsis
      CompactPath = strDirs(0) & "\" & Left$(strDirs(lngUbound), MaxLength - Len(strDirs(0)) - 4) & "..."
    Else
      'add drive and '\..\' and enough of name to just fit with a trailing ellipsis
      CompactPath = strDirs(0) & "\...\" & Left$(strDirs(lngUbound), MaxLength - Len(strDirs(0)) - 8) & "..."
    End If
    'if path only,
    If blnPathOnly Then
      'add trailing backslash
      CompactPath = CompactPath & "\"
    End If
    Exit Function
  End If
    
  'adjust maxlength to allow for the drive letter, and '\...\' and name (strDirs(lngUbound))
  MaxLength = MaxLength - Len(strDirs(0)) - 5 - Len(strDirs(lngUbound))
  
  'add directories until too long
  i = lngUbound - 1
  
  For i = lngUbound - 1 To 1 Step -1
    'if remaining space left for path is not at least four characters (x..\)
    If Len(CompactPath) >= MaxLength - 4 Then
      Exit For
    End If
    
    'is there room for entire directory?
    If Len(strDirs(i)) <= MaxLength - Len(CompactPath) - 1 Then
      'add entire directory
      CompactPath = strDirs(i) & "\" & CompactPath
    Else
      'add two dots to end of path so it adds up to maxlength
      CompactPath = Left$(strDirs(i), MaxLength - Len(CompactPath) - 3) & "..\" & CompactPath
    End If
  Next i
  
  'add ellipse and name
  CompactPath = strDirs(0) & "\...\" & CompactPath & strDirs(lngUbound)
  'if path only,
  If blnPathOnly Then
    'add trailing backslash
    CompactPath = CompactPath & "\"
  End If
Exit Function

ErrHandler:
  Debug.Assert False
  'just return string, truncated
  CompactPath = Left$(LongPath, MaxLength - 3) & "..."
End Function


Public Function CRC32(DataIn() As Byte) As Long
  'calculates the CRC32 for an input array of bytes
  'a special table is necessary; the table is loaded
  'at program startup
  
  'the CRC is calculated according to the following equation:
  '
  '  CRC[i] = LSHR8(CRC[i-1]) Xor CRC32Table((CRC[i-1] And &HFF) Xor DataIn[i])
  '
  'initial value of CRC is &HFFFFFFFF; iterate the equation
  'for each byte of data; then end by XORing final result with &HFFFFFFFF
  
  Dim i As Long
  
  'if table not loaded
  If Not CRC32Loaded Then
    CRC32Setup
  End If
    
  'initial value
  CRC32 = &HFFFFFFFF
  
  'iterate CRC equation
  For i = 0 To UBound(DataIn())
   CRC32 = LSHR8(CRC32) Xor CRC32Table((CRC32 And &HFF) Xor DataIn(i))
  Next i
  
  'xor to create final answer
  CRC32 = CRC32 Xor &HFFFFFFFF
End Function

Public Function LSHR8(lngIn As Long) As Long
  'shifts IntIn by bytNum positions, without carry
  Dim lngBit31 As Long
  
  'capture the high bit
  If (lngIn And &H80000000) Then
    lngBit31 = &H800000
  End If
  
  'clear out  bit 31 and the 8 least significant bits
  '(by 'AND'ing with &HFFFFFF00) and divide to shift;
  'then add bit31 (by 'OR'ing)
  LSHR8 = ((lngIn And &H7FFFFF00) \ &H100&) Or lngBit31
End Function

Public Sub CRC32Setup()
  'build the CRC table
  
  CRC32Table(0) = &H0&
  CRC32Table(1) = &H77073096
  CRC32Table(2) = &HEE0E612C
  CRC32Table(3) = &H990951BA
  CRC32Table(4) = &H76DC419
  CRC32Table(5) = &H706AF48F
  CRC32Table(6) = &HE963A535
  CRC32Table(7) = &H9E6495A3
  CRC32Table(8) = &HEDB8832
  CRC32Table(9) = &H79DCB8A4
  CRC32Table(10) = &HE0D5E91E
  CRC32Table(11) = &H97D2D988
  CRC32Table(12) = &H9B64C2B
  CRC32Table(13) = &H7EB17CBD
  CRC32Table(14) = &HE7B82D07
  CRC32Table(15) = &H90BF1D91
  CRC32Table(16) = &H1DB71064
  CRC32Table(17) = &H6AB020F2
  CRC32Table(18) = &HF3B97148
  CRC32Table(19) = &H84BE41DE
  CRC32Table(20) = &H1ADAD47D
  CRC32Table(21) = &H6DDDE4EB
  CRC32Table(22) = &HF4D4B551
  CRC32Table(23) = &H83D385C7
  CRC32Table(24) = &H136C9856
  CRC32Table(25) = &H646BA8C0
  CRC32Table(26) = &HFD62F97A
  CRC32Table(27) = &H8A65C9EC
  CRC32Table(28) = &H14015C4F
  CRC32Table(29) = &H63066CD9
  CRC32Table(30) = &HFA0F3D63
  CRC32Table(31) = &H8D080DF5
  CRC32Table(32) = &H3B6E20C8
  CRC32Table(33) = &H4C69105E
  CRC32Table(34) = &HD56041E4
  CRC32Table(35) = &HA2677172
  CRC32Table(36) = &H3C03E4D1
  CRC32Table(37) = &H4B04D447
  CRC32Table(38) = &HD20D85FD
  CRC32Table(39) = &HA50AB56B
  CRC32Table(40) = &H35B5A8FA
  CRC32Table(41) = &H42B2986C
  CRC32Table(42) = &HDBBBC9D6
  CRC32Table(43) = &HACBCF940
  CRC32Table(44) = &H32D86CE3
  CRC32Table(45) = &H45DF5C75
  CRC32Table(46) = &HDCD60DCF
  CRC32Table(47) = &HABD13D59
  CRC32Table(48) = &H26D930AC
  CRC32Table(49) = &H51DE003A
  CRC32Table(50) = &HC8D75180
  CRC32Table(51) = &HBFD06116
  CRC32Table(52) = &H21B4F4B5
  CRC32Table(53) = &H56B3C423
  CRC32Table(54) = &HCFBA9599
  CRC32Table(55) = &HB8BDA50F
  CRC32Table(56) = &H2802B89E
  CRC32Table(57) = &H5F058808
  CRC32Table(58) = &HC60CD9B2
  CRC32Table(59) = &HB10BE924
  CRC32Table(60) = &H2F6F7C87
  CRC32Table(61) = &H58684C11
  CRC32Table(62) = &HC1611DAB
  CRC32Table(63) = &HB6662D3D
  CRC32Table(64) = &H76DC4190
  CRC32Table(65) = &H1DB7106
  CRC32Table(66) = &H98D220BC
  CRC32Table(67) = &HEFD5102A
  CRC32Table(68) = &H71B18589
  CRC32Table(69) = &H6B6B51F
  CRC32Table(70) = &H9FBFE4A5
  CRC32Table(71) = &HE8B8D433
  CRC32Table(72) = &H7807C9A2
  CRC32Table(73) = &HF00F934
  CRC32Table(74) = &H9609A88E
  CRC32Table(75) = &HE10E9818
  CRC32Table(76) = &H7F6A0DBB
  CRC32Table(77) = &H86D3D2D
  CRC32Table(78) = &H91646C97
  CRC32Table(79) = &HE6635C01
  CRC32Table(80) = &H6B6B51F4
  CRC32Table(81) = &H1C6C6162
  CRC32Table(82) = &H856530D8
  CRC32Table(83) = &HF262004E
  CRC32Table(84) = &H6C0695ED
  CRC32Table(85) = &H1B01A57B
  CRC32Table(86) = &H8208F4C1
  CRC32Table(87) = &HF50FC457
  CRC32Table(88) = &H65B0D9C6
  CRC32Table(89) = &H12B7E950
  CRC32Table(90) = &H8BBEB8EA
  CRC32Table(91) = &HFCB9887C
  CRC32Table(92) = &H62DD1DDF
  CRC32Table(93) = &H15DA2D49
  CRC32Table(94) = &H8CD37CF3
  CRC32Table(95) = &HFBD44C65
  CRC32Table(96) = &H4DB26158
  CRC32Table(97) = &H3AB551CE
  CRC32Table(98) = &HA3BC0074
  CRC32Table(99) = &HD4BB30E2
  CRC32Table(100) = &H4ADFA541
  CRC32Table(101) = &H3DD895D7
  CRC32Table(102) = &HA4D1C46D
  CRC32Table(103) = &HD3D6F4FB
  CRC32Table(104) = &H4369E96A
  CRC32Table(105) = &H346ED9FC
  CRC32Table(106) = &HAD678846
  CRC32Table(107) = &HDA60B8D0
  CRC32Table(108) = &H44042D73
  CRC32Table(109) = &H33031DE5
  CRC32Table(110) = &HAA0A4C5F
  CRC32Table(111) = &HDD0D7CC9
  CRC32Table(112) = &H5005713C
  CRC32Table(113) = &H270241AA
  CRC32Table(114) = &HBE0B1010
  CRC32Table(115) = &HC90C2086
  CRC32Table(116) = &H5768B525
  CRC32Table(117) = &H206F85B3
  CRC32Table(118) = &HB966D409
  CRC32Table(119) = &HCE61E49F
  CRC32Table(120) = &H5EDEF90E
  CRC32Table(121) = &H29D9C998
  CRC32Table(122) = &HB0D09822
  CRC32Table(123) = &HC7D7A8B4
  CRC32Table(124) = &H59B33D17
  CRC32Table(125) = &H2EB40D81
  CRC32Table(126) = &HB7BD5C3B
  CRC32Table(127) = &HC0BA6CAD
  CRC32Table(128) = &HEDB88320
  CRC32Table(129) = &H9ABFB3B6
  CRC32Table(130) = &H3B6E20C
  CRC32Table(131) = &H74B1D29A
  CRC32Table(132) = &HEAD54739
  CRC32Table(133) = &H9DD277AF
  CRC32Table(134) = &H4DB2615
  CRC32Table(135) = &H73DC1683
  CRC32Table(136) = &HE3630B12
  CRC32Table(137) = &H94643B84
  CRC32Table(138) = &HD6D6A3E
  CRC32Table(139) = &H7A6A5AA8
  CRC32Table(140) = &HE40ECF0B
  CRC32Table(141) = &H9309FF9D
  CRC32Table(142) = &HA00AE27
  CRC32Table(143) = &H7D079EB1
  CRC32Table(144) = &HF00F9344
  CRC32Table(145) = &H8708A3D2
  CRC32Table(146) = &H1E01F268
  CRC32Table(147) = &H6906C2FE
  CRC32Table(148) = &HF762575D
  CRC32Table(149) = &H806567CB
  CRC32Table(150) = &H196C3671
  CRC32Table(151) = &H6E6B06E7
  CRC32Table(152) = &HFED41B76
  CRC32Table(153) = &H89D32BE0
  CRC32Table(154) = &H10DA7A5A
  CRC32Table(155) = &H67DD4ACC
  CRC32Table(156) = &HF9B9DF6F
  CRC32Table(157) = &H8EBEEFF9
  CRC32Table(158) = &H17B7BE43
  CRC32Table(159) = &H60B08ED5
  CRC32Table(160) = &HD6D6A3E8
  CRC32Table(161) = &HA1D1937E
  CRC32Table(162) = &H38D8C2C4
  CRC32Table(163) = &H4FDFF252
  CRC32Table(164) = &HD1BB67F1
  CRC32Table(165) = &HA6BC5767
  CRC32Table(166) = &H3FB506DD
  CRC32Table(167) = &H48B2364B
  CRC32Table(168) = &HD80D2BDA
  CRC32Table(169) = &HAF0A1B4C
  CRC32Table(170) = &H36034AF6
  CRC32Table(171) = &H41047A60
  CRC32Table(172) = &HDF60EFC3
  CRC32Table(173) = &HA867DF55
  CRC32Table(174) = &H316E8EEF
  CRC32Table(175) = &H4669BE79
  CRC32Table(176) = &HCB61B38C
  CRC32Table(177) = &HBC66831A
  CRC32Table(178) = &H256FD2A0
  CRC32Table(179) = &H5268E236
  CRC32Table(180) = &HCC0C7795
  CRC32Table(181) = &HBB0B4703
  CRC32Table(182) = &H220216B9
  CRC32Table(183) = &H5505262F
  CRC32Table(184) = &HC5BA3BBE
  CRC32Table(185) = &HB2BD0B28
  CRC32Table(186) = &H2BB45A92
  CRC32Table(187) = &H5CB36A04
  CRC32Table(188) = &HC2D7FFA7
  CRC32Table(189) = &HB5D0CF31
  CRC32Table(190) = &H2CD99E8B
  CRC32Table(191) = &H5BDEAE1D
  CRC32Table(192) = &H9B64C2B0
  CRC32Table(193) = &HEC63F226
  CRC32Table(194) = &H756AA39C
  CRC32Table(195) = &H26D930A
  CRC32Table(196) = &H9C0906A9
  CRC32Table(197) = &HEB0E363F
  CRC32Table(198) = &H72076785
  CRC32Table(199) = &H5005713
  CRC32Table(200) = &H95BF4A82
  CRC32Table(201) = &HE2B87A14
  CRC32Table(202) = &H7BB12BAE
  CRC32Table(203) = &HCB61B38
  CRC32Table(204) = &H92D28E9B
  CRC32Table(205) = &HE5D5BE0D
  CRC32Table(206) = &H7CDCEFB7
  CRC32Table(207) = &HBDBDF21
  CRC32Table(208) = &H86D3D2D4
  CRC32Table(209) = &HF1D4E242
  CRC32Table(210) = &H68DDB3F8
  CRC32Table(211) = &H1FDA836E
  CRC32Table(212) = &H81BE16CD
  CRC32Table(213) = &HF6B9265B
  CRC32Table(214) = &H6FB077E1
  CRC32Table(215) = &H18B74777
  CRC32Table(216) = &H88085AE6
  CRC32Table(217) = &HFF0F6A70
  CRC32Table(218) = &H66063BCA
  CRC32Table(219) = &H11010B5C
  CRC32Table(220) = &H8F659EFF
  CRC32Table(221) = &HF862AE69
  CRC32Table(222) = &H616BFFD3
  CRC32Table(223) = &H166CCF45
  CRC32Table(224) = &HA00AE278
  CRC32Table(225) = &HD70DD2EE
  CRC32Table(226) = &H4E048354
  CRC32Table(227) = &H3903B3C2
  CRC32Table(228) = &HA7672661
  CRC32Table(229) = &HD06016F7
  CRC32Table(230) = &H4969474D
  CRC32Table(231) = &H3E6E77DB
  CRC32Table(232) = &HAED16A4A
  CRC32Table(233) = &HD9D65ADC
  CRC32Table(234) = &H40DF0B66
  CRC32Table(235) = &H37D83BF0
  CRC32Table(236) = &HA9BCAE53
  CRC32Table(237) = &HDEBB9EC5
  CRC32Table(238) = &H47B2CF7F
  CRC32Table(239) = &H30B5FFE9
  CRC32Table(240) = &HBDBDF21C
  CRC32Table(241) = &HCABAC28A
  CRC32Table(242) = &H53B39330
  CRC32Table(243) = &H24B4A3A6
  CRC32Table(244) = &HBAD03605
  CRC32Table(245) = &HCDD70693
  CRC32Table(246) = &H54DE5729
  CRC32Table(247) = &H23D967BF
  CRC32Table(248) = &HB3667A2E
  CRC32Table(249) = &HC4614AB8
  CRC32Table(250) = &H5D681B02
  CRC32Table(251) = &H2A6F2B94
  CRC32Table(252) = &HB40BBE37
  CRC32Table(253) = &HC30C8EA1
  CRC32Table(254) = &H5A05DF1B
  CRC32Table(255) = &H2D02EF8D
  
  'set flag
  CRC32Loaded = True
  
End Sub

Public Function vCint(ByVal InputNum As Double) As Integer
  
  vCint = Int(InputNum) + CInt(InputNum - Int(InputNum) + 1) - 1
End Function

Public Function FindWholeWord(ByVal lngStartPos As Long, strText As String, strFind As String, _
                              Optional ByVal MatchCase As Boolean = False, _
                              Optional ByVal RevSearch As Boolean = False, _
                              Optional ByVal SearchType As AGIResType = rtNone, _
                              Optional ByVal Syntax As LogicSyntaxType = lsUnknown) As Long
                              
  'will return the character position of first occurence of strFind in strText,
  'only if it is a whole word
  'whole word is defined as a word where the character in front of the word is a
  'separator (or word is at beginning of string) AND character after word is a
  'separator (or word is at end of string)
  '
  'separators are any character EXCEPT:
  ' #, $, %, ., 0-9, @, A-Z, _, a-z
  '(codes 35 To 37, 46, 48 To 57, 64 To 90, 95, 97 To 122)
  
  Dim lngPos As Long
  Dim blnFrontOK As Boolean
  Dim StringCompare As VbCompareMethod
  
  On Error GoTo ErrHandler
  
  'if no search string passed
  If LenB(strFind) = 0 Then
    'return zero
    FindWholeWord = 0
    Exit Function
  End If
  
  'set compare method
  If MatchCase Then
    StringCompare = vbBinaryCompare
  Else
    StringCompare = vbTextCompare
  End If
  
  'set position to start
  lngPos = lngStartPos
  Do
    'if doing a reverse search
    If RevSearch Then
      lngPos = InStrRev(strText, strFind, lngPos, StringCompare)
    Else
      'get position of string in strtext
      lngPos = InStr(lngPos, strText, strFind, StringCompare)
    End If
    
    'easy check is to see if strFind is even in strText
    If lngPos = 0 Then
      FindWholeWord = 0
      Exit Function
    End If
    
    'check character in front
    If lngPos > 1 Then
      Select Case AscW(Mid$(strText, lngPos - 1))
      ' #, $, %, ., 0-9, A-Z, _, a-z
      Case 35 To 37, 46, 48 To 57, 64 To 90, 95, 97 To 122
        'word is NOT whole word
        blnFrontOK = False
      Case Else
        blnFrontOK = True
      End Select
    Else
      blnFrontOK = True
    End If
    
    'if front is ok,
    If blnFrontOK Then
      'check character in back
      If lngPos + Len(strFind) <= Len(strText) Then
        Select Case AscW(Mid$(strText, lngPos + Len(strFind)))
        Case 35 To 37, 46, 48 To 57, 64 To 90, 95, 97 To 122
          'word is NOT whole word
          'let loop try again at next position in string
        Case Else
          'if validation required
          Select Case SearchType
          Case rtWords  'check against vocabword
            If IsVocabWord(lngPos, strText, Syntax) Then
              'word IS a whole word
              FindWholeWord = lngPos
              Exit Function
            End If
          Case rtObjects  'validate an inventory object
            If IsInvObject(lngPos, strText, Syntax) Then
              'word IS a whole word
              FindWholeWord = lngPos
              Exit Function
            End If
          Case Else 'no validation
            'word IS a whole word
            FindWholeWord = lngPos
            Exit Function
          End Select
        End Select
      Else
        'word IS a whole word
        FindWholeWord = lngPos
        Exit Function
      End If
    End If
    
    'entire string not checked yet
    If RevSearch Then
      lngPos = lngPos - 1
    Else
      lngPos = lngPos + 1
    End If
  Loop Until lngPos = 0
  'if no position found,
  FindWholeWord = 0
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function

Public Function DirIsEmpty(strDir As String) As Boolean
    Dim strFile As String
    
    DirIsEmpty = False
    strFile = Dir(strDir & "*.*")
    
    If LenB(strFile) <> 0 Then
        Do While strFile <> vbNullString And (strFile = "." Or strFile = "..")
            strFile = Dir()
        Loop
      DirIsEmpty = (LenB(strFile) <> 0)
    End If
End Function
Public Function FileExists(strFullPathName As String, Optional Attributes As VbFileAttribute = vbNormal) As Boolean
  On Error Resume Next
  
  'returns true if strFullPathName exists,
  If LenB(Dir(strFullPathName, Attributes)) <> 0 And LenB(strFullPathName) <> 0 Then
    FileExists = True
  Else
    FileExists = False
  End If
End Function




Public Function Floor(ByVal vInput As Single) As Long
  'returns floor of input
  On Error Resume Next
  Floor = Int(vInput)
End Function


Public Function JustPath(strFullPathName As String, Optional NoSlash As Boolean = False) As String
  'will extract just the path name by removing the filename
  'if optional NoSlash is true, the trailing backslash will be dropped
  
  Dim strSplitName() As String
  
  On Error Resume Next
  
  'split into directories and filename
  strSplitName() = Split(strFullPathName, "\")
  'if no splits,
  If UBound(strSplitName) <= 0 Then
    'return empty- no path information in this string
    JustPath = vbNullString
  Else
    'eliminate last entry (which is filename)
    ReDim Preserve strSplitName(UBound(strSplitName()) - 1)
    'rebuild name
    JustPath = Join(strSplitName, "\")
  End If
  'if slash should be added,
  If Not NoSlash Then
    JustPath = JustPath & "\"
  End If
End Function


Public Function BytSHL(bytIn As Byte, ByVal vNum As Byte) As Byte
  'shifts byteIn LEFT by bytNum positions, without carry
  
  If Val(vNum) < 0 Then
    vNum = 0
  End If
  
  'Assign original value to return value
  BytSHL = bytIn
  
  'shift left, once for each count as bytNum
  
  Do While vNum > 0
    'clear out most significant bit (by 'AND'ing with &H7F)
    BytSHL = BytSHL And &H7F
    'multiply by two
    BytSHL = BytSHL * 2
    'decrement intCount
    vNum = vNum - 1
  Loop
End Function




Public Function BytSHR(bytIn As Byte, ByVal vNum As Byte) As Byte
  'shifts byteIn by bytNum positions, without carry
  
  If Val(vNum) < 0 Then
    vNum = 0
  End If
  
  'assign original value to return value
  BytSHR = bytIn
  
  'shift right, once for each count of bytNum
  Do While vNum > 0
    'clear out least significant bit (by 'AND'ing with &HFE)
    BytSHR = BytSHR And &HFE
    'divide by two
    BytSHR = BytSHR / 2
    'decrement counter
    vNum = vNum - 1
  Loop
End Function




Public Function LngSHR(lngIn As Long, ByVal vNum As Byte) As Long
  'shifts IntIn by bytNum positions, without carry
  Dim lngBit31 As Long
  
  If Val(vNum) < 0 Then
    vNum = 0
  End If
  
  'assign original value to return value
  LngSHR = lngIn
  
  'if a negative value is passed,
  If LngSHR < 0 Then
    'need to save the bit in position 32
    'so it can be reinserted at bit position 31 after first shift
    lngBit31 = &H40000000
    'remove bit 32 so it doesn't interfere with the division function
    LngSHR = LngSHR And &H7FFFFFFF
  End If
  
  'shift right, once for each count of bytNum
  Do While vNum > 0
    'clear out least significant bit (by 'AND'ing with &HFFFFFFFE)
    LngSHR = LngSHR And &HFFFFFFFE
    'divide by two
    LngSHR = LngSHR / 2
    'add bit 32 into bit 31 place
    LngSHR = LngSHR Or lngBit31
    'ensure bit31 is cleared for any other shifts
    lngBit31 = 0
    
    'decrement counter
    vNum = vNum - 1
  Loop

End Function

Public Function LngSHL(lngIn As Long, ByVal vNum As Byte) As Long
  'shifts lngIn LEFT by bytNum positions, without carry
  
  Dim lngBit32 As Long
  On Error GoTo ErrHandler
  
  If Val(vNum) < 0 Then
    vNum = 0
  End If
  
  
  'Assign original value to return value
  LngSHL = lngIn
  
  'shift left, once for each count as bytNum
  Do While vNum > 0
    'clear out most significant bit (by 'AND'ing with &H7FFFFFFF)
    LngSHL = LngSHL And &H7FFFFFFF
    'if bit 31 is set,
    If (LngSHL And &H40000000) Then
      'save the bit to reinsert in position 32 after shift
      lngBit32 = &H80000000
      'clear out bit 32 so multiply works correctly
      LngSHL = LngSHL And &H3FFFFFFF
    Else
      'clear it
      lngBit32 = 0
    End If
      
    'multiply by two
    LngSHL = LngSHL * 2&
    'add bit 32 back in
    LngSHL = LngSHL Or lngBit32
    'decrement intCount
    vNum = vNum - 1
  Loop
  Exit Function
ErrHandler:
  'should never get error
End Function

Public Function MultStr(strIn As String, ByVal NumCopies As Byte) As String

Dim i As Integer

  For i = 1 To NumCopies
      MultStr = MultStr & strIn
  Next i
End Function


Public Function ShortFileName(strLongFileName As String) As String
  'returns the short filename of a file
  'to make it compatible with DOS programs
  
  Dim rtn As Long
  Dim lngStrLen As Long
  Dim strTemp As String
  
  'get size of required buffer
  lngStrLen = GetShortPathName(strLongFileName, strTemp, 0)
  strTemp = String$(lngStrLen, 0)
  
  'now get path
  rtn = GetShortPathName(strLongFileName, strTemp, lngStrLen)
  
  'if error
  If lngStrLen = 0 Then
    'raise error
    On Error GoTo 0: On Error GoTo 0: Err.Raise 53
    Exit Function
  End If
  
  'strip off null char
  ShortFileName = Left$(strTemp, Len(strTemp) - 1)
  
End Function


Public Function TempFileName() As String
  Dim sTmpName As String * 576
  Dim rtn As Long

  On Error GoTo ErrHandler
  
  'get temp file name with this prefix
  rtn = GetTempFileName(strTempDir, "AGI", 0, sTmpName)
  'if successful,
  If rtn <> 0 Then
    TempFileName = Left$(sTmpName, InStr(sTmpName, vbNullChar) - 1)
    'verify a filename was generated
    If LenB(TempFileName) <> 0 Then
      Exit Function
    End If
  End If

ErrHandler:
  On Error GoTo 0: On Error GoTo 0: Err.Raise vbObjectError + 547, "WinAGI.TempFileName", Replace(LoadResString(547), ARG1, CStr(Err.Number))
End Function





Public Function CanAccessFile(strFilename As String) As Boolean

  Dim intFile As Integer
  
  On Error Resume Next
  
  
  If FileExists(strFilename) Then
    intFile = FreeFile()
    Open strFilename For Binary As intFile
    Seek intFile, 1
    If Err.Number = 0 Then
      CanAccessFile = True
    End If
  End If
  
  Close intFile
  Err.Clear
End Function




Public Function Ceil(ByVal vInput As Single) As Long
  'returns ceiling value of integer
  On Error Resume Next
  'if not an even integer
  If Int(vInput) <> vInput Then
    Ceil = Int(vInput) + 1
  Else
    Ceil = CLng(vInput)
  End If
  
End Function




Public Function cDir(strDirIn As String) As String
  'this function ensures a trailing "\" is included on strDirIn
  If LenB(strDirIn) <> 0 Then
    If Right$(strDirIn, 1) <> "\" Then
      cDir = strDirIn & "\"
    Else
      cDir = strDirIn
    End If
  End If
End Function
Public Function JustFileName(strFullPathName As String) As String
  'will extract just the file name by removing the path info
  Dim strSplitName() As String
  
  On Error Resume Next
  
  strSplitName() = Split(strFullPathName, "\")
  If UBound(strSplitName) <= 0 Then
    JustFileName = strFullPathName
  Else
    JustFileName = strSplitName(UBound(strSplitName()))
  End If
  
End Function




Public Function vClng(ByVal InputNum As Double) As Long
  
  vClng = Int(InputNum) + CLng(InputNum - Int(InputNum) + 1) - 1
End Function


