Attribute VB_Name = "AGICommandFunctions"
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3E0698F50396"
Option Explicit
Option Compare Text

Public agArgTypPref(8) As String
Public agArgTypName(8) As String

Public agNumTestCmds As Byte
Public agNumCmds As Byte

Public agTestCmds(18) As CommandStruct
Public agCmds(182) As CommandStruct

'predefined arguments
Public agResAsText As Boolean    'true if reserved variables and flags show up as text when decompiling
Public agUseRes As Boolean       'true if predefined variables and flags are used during compilation
Public agPreDefSyntax As LogicSyntaxType  'indicates current syntax of builtin args
Public agResVar(26) As TDefine    'text name of built in variables
Public agResFlag(17) As TDefine   'text name of built in flags
Public agEdgeCodes(4) As TDefine   'text of edge codes
Public agEgoDir(8) As TDefine      'text of ego direction codes
Public agVideoMode(4) As TDefine   'text of video mode codes
Public agResDef(5) As TDefine  'defines for ego, gamever, gameabout, gameid, invobj count

'user defined global arguments
Public agGlobal() As TDefine
Public agGlobalCount As Long
Public agGlobalsSet As Boolean
Public agGlobalCRC As Long

Public agCurrentSyntax As LogicSyntaxType

Public Sub AssignCommands()
  
  agNumTestCmds = 18
  agNumCmds = 182   ' not counting return()
   
  agTestCmds(1).Name = "equaln"
  agTestCmds(1).ArgCount = 2
  agTestCmds(1).ArgType(0) = atVar
  agTestCmds(1).ArgType(1) = atNum
  
  agTestCmds(2).Name = "equalv"
  agTestCmds(2).ArgCount = 2
  agTestCmds(2).ArgType(0) = atVar
  agTestCmds(2).ArgType(1) = atVar
  
  agTestCmds(3).Name = "lessn"
  agTestCmds(3).ArgCount = 2
  agTestCmds(3).ArgType(0) = atVar
  agTestCmds(3).ArgType(1) = atNum

  agTestCmds(4).Name = "lessv"
  agTestCmds(4).ArgCount = 2
  agTestCmds(4).ArgType(0) = atVar
  agTestCmds(4).ArgType(1) = atVar
  
  agTestCmds(5).Name = "greatern"
  agTestCmds(5).ArgCount = 2
  agTestCmds(5).ArgType(0) = atVar
  agTestCmds(5).ArgType(1) = atNum
  
  agTestCmds(6).Name = "greaterv"
  agTestCmds(6).ArgCount = 2
  agTestCmds(6).ArgType(0) = atVar
  agTestCmds(6).ArgType(1) = atVar
  
  agTestCmds(7).Name = "isset"
  agTestCmds(7).ArgCount = 1
  agTestCmds(7).ArgType(0) = atFlag
  
  agTestCmds(8).Name = "issetv"
  agTestCmds(8).ArgCount = 1
  agTestCmds(8).ArgType(0) = atVar
  
  agTestCmds(9).Name = "has"
  agTestCmds(9).ArgCount = 1
  agTestCmds(9).ArgType(0) = atIObj
  
  agTestCmds(10).Name = "obj.in.room"
  agTestCmds(10).ArgCount = 2
  agTestCmds(10).ArgType(0) = atIObj
  agTestCmds(10).ArgType(1) = atVar
  
  agTestCmds(11).Name = "posn"
  agTestCmds(11).ArgCount = 5
  agTestCmds(11).ArgType(0) = atSObj
  agTestCmds(11).ArgType(1) = atNum
  agTestCmds(11).ArgType(2) = atNum
  agTestCmds(11).ArgType(3) = atNum
  agTestCmds(11).ArgType(4) = atNum
  
  agTestCmds(12).Name = "controller"
  agTestCmds(12).ArgCount = 1
  agTestCmds(12).ArgType(0) = atCtrl
  
  agTestCmds(13).Name = "have.key"
  agTestCmds(13).ArgCount = 0
  
  agTestCmds(14).Name = "said"
  agTestCmds(14).ArgCount = 0 'special command so we don't need to set the right argument types for it
  
  agTestCmds(15).Name = "compare.strings"
  agTestCmds(15).ArgCount = 2
  agTestCmds(15).ArgType(0) = atStr
  agTestCmds(15).ArgType(1) = atStr
  
  agTestCmds(16).Name = "obj.in.box"
  agTestCmds(16).ArgCount = 5
  agTestCmds(16).ArgType(0) = atSObj
  agTestCmds(16).ArgType(1) = atNum
  agTestCmds(16).ArgType(2) = atNum
  agTestCmds(16).ArgType(3) = atNum
  agTestCmds(16).ArgType(4) = atNum
  
  agTestCmds(17).Name = "center.posn"
  agTestCmds(17).ArgCount = 5
  agTestCmds(17).ArgType(0) = atSObj
  agTestCmds(17).ArgType(1) = atNum
  agTestCmds(17).ArgType(2) = atNum
  agTestCmds(17).ArgType(3) = atNum
  agTestCmds(17).ArgType(4) = atNum
  
  agTestCmds(18).Name = "right.posn"
  agTestCmds(18).ArgCount = 5
  agTestCmds(18).ArgType(0) = atSObj
  agTestCmds(18).ArgType(1) = atNum
  agTestCmds(18).ArgType(2) = atNum
  agTestCmds(18).ArgType(3) = atNum
  agTestCmds(18).ArgType(4) = atNum
    
  'agi commands:
  agCmds(0).Name = "return"
  agCmds(0).ArgCount = 0
  
  agCmds(1).Name = "increment"
  agCmds(1).ArgCount = 1
  agCmds(1).ArgType(0) = atVar
  
  agCmds(2).Name = "decrement"
  agCmds(2).ArgCount = 1
  agCmds(2).ArgType(0) = atVar
  
  agCmds(3).Name = "assignn"
  agCmds(3).ArgCount = 2
  agCmds(3).ArgType(0) = atVar
  agCmds(3).ArgType(1) = atNum
  
  agCmds(4).Name = "assignv"
  agCmds(4).ArgCount = 2
  agCmds(4).ArgType(0) = atVar
  agCmds(4).ArgType(1) = atVar
  
  agCmds(5).Name = "addn"
  agCmds(5).ArgCount = 2
  agCmds(5).ArgType(0) = atVar
  agCmds(5).ArgType(1) = atNum
  
  agCmds(6).Name = "addv"
  agCmds(6).ArgCount = 2
  agCmds(6).ArgType(0) = atVar
  agCmds(6).ArgType(1) = atVar
  
  agCmds(7).Name = "subn"
  agCmds(7).ArgCount = 2
  agCmds(7).ArgType(0) = atVar
  agCmds(7).ArgType(1) = atNum
  
  agCmds(8).Name = "subv"
  agCmds(8).ArgCount = 2
  agCmds(8).ArgType(0) = atVar
  agCmds(8).ArgType(1) = atVar
  
  agCmds(9).Name = "lindirectv"
  agCmds(9).ArgCount = 2
  agCmds(9).ArgType(0) = atVar
  agCmds(9).ArgType(1) = atVar
  
  agCmds(10).Name = "rindirect"
  agCmds(10).ArgCount = 2
  agCmds(10).ArgType(0) = atVar
  agCmds(10).ArgType(1) = atVar
  
  agCmds(11).Name = "lindirectn"
  agCmds(11).ArgCount = 2
  agCmds(11).ArgType(0) = atVar
  agCmds(11).ArgType(1) = atNum
  
  agCmds(12).Name = "set"
  agCmds(12).ArgCount = 1
  agCmds(12).ArgType(0) = atFlag
  
  agCmds(13).Name = "reset"
  agCmds(13).ArgCount = 1
  agCmds(13).ArgType(0) = atFlag
  
  agCmds(14).Name = "toggle"
  agCmds(14).ArgCount = 1
  agCmds(14).ArgType(0) = atFlag
  
  agCmds(15).Name = "set.v"
  agCmds(15).ArgCount = 1
  agCmds(15).ArgType(0) = atVar
  
  agCmds(16).Name = "reset.v"
  agCmds(16).ArgCount = 1
  agCmds(16).ArgType(0) = atVar
  
  agCmds(17).Name = "toggle.v"
  agCmds(17).ArgCount = 1
  agCmds(17).ArgType(0) = atVar
  
  agCmds(18).Name = "new.room"
  agCmds(18).ArgCount = 1
  agCmds(18).ArgType(0) = atNum
  
  agCmds(19).Name = "new.room.v"
  agCmds(19).ArgCount = 1
  agCmds(19).ArgType(0) = atVar
  
  agCmds(20).Name = "load.logics"
  agCmds(20).ArgCount = 1
  agCmds(20).ArgType(0) = atNum
  
  agCmds(21).Name = "load.logics.v"
  agCmds(21).ArgCount = 1
  agCmds(21).ArgType(0) = atVar
  
  agCmds(22).Name = "call"
  agCmds(22).ArgCount = 1
  agCmds(22).ArgType(0) = atNum
  
  agCmds(23).Name = "call.v"
  agCmds(23).ArgCount = 1
  agCmds(23).ArgType(0) = atVar
  
  agCmds(24).Name = "load.pic"
  agCmds(24).ArgCount = 1
  agCmds(24).ArgType(0) = atVar
  
  agCmds(25).Name = "draw.pic"
  agCmds(25).ArgCount = 1
  agCmds(25).ArgType(0) = atVar
  
  agCmds(26).Name = "show.pic"
  agCmds(26).ArgCount = 0
  
  agCmds(27).Name = "discard.pic"
  agCmds(27).ArgCount = 1
  agCmds(27).ArgType(0) = atVar
  
  agCmds(28).Name = "overlay.pic"
  agCmds(28).ArgCount = 1
  agCmds(28).ArgType(0) = atVar
  
  agCmds(29).Name = "show.pri.screen"
  agCmds(29).ArgCount = 0
  
  agCmds(30).Name = "load.view"
  agCmds(30).ArgCount = 1
  agCmds(30).ArgType(0) = atNum
  
  agCmds(31).Name = "load.view.v"
  agCmds(31).ArgCount = 1
  agCmds(31).ArgType(0) = atVar
  
  agCmds(32).Name = "discard.view"
  agCmds(32).ArgCount = 1
  agCmds(32).ArgType(0) = atNum
  
  agCmds(33).Name = "animate.obj"
  agCmds(33).ArgCount = 1
  agCmds(33).ArgType(0) = atSObj
  
  agCmds(34).Name = "unanimate.all"
  agCmds(34).ArgCount = 0
  
  agCmds(35).Name = "draw"
  agCmds(35).ArgCount = 1
  agCmds(35).ArgType(0) = atSObj
  
  agCmds(36).Name = "erase"
  agCmds(36).ArgCount = 1
  agCmds(36).ArgType(0) = atSObj
  
  agCmds(37).Name = "position"
  agCmds(37).ArgCount = 3
  agCmds(37).ArgType(0) = atSObj
  agCmds(37).ArgType(1) = atNum
  agCmds(37).ArgType(2) = atNum
  
  agCmds(38).Name = "position.v"
  agCmds(38).ArgCount = 3
  agCmds(38).ArgType(0) = atSObj
  agCmds(38).ArgType(1) = atVar
  agCmds(38).ArgType(2) = atVar
  
  agCmds(39).Name = "get.posn"
  agCmds(39).ArgCount = 3
  agCmds(39).ArgType(0) = atSObj
  agCmds(39).ArgType(1) = atVar
  agCmds(39).ArgType(2) = atVar
  
  agCmds(40).Name = "reposition"
  agCmds(40).ArgCount = 3
  agCmds(40).ArgType(0) = atSObj
  agCmds(40).ArgType(1) = atVar
  agCmds(40).ArgType(2) = atVar
  
  agCmds(41).Name = "set.view"
  agCmds(41).ArgCount = 2
  agCmds(41).ArgType(0) = atSObj
  agCmds(41).ArgType(1) = atNum
  
  agCmds(42).Name = "set.view.v"
  agCmds(42).ArgCount = 2
  agCmds(42).ArgType(0) = atSObj
  agCmds(42).ArgType(1) = atVar
  
  agCmds(43).Name = "set.loop"
  agCmds(43).ArgCount = 2
  agCmds(43).ArgType(0) = atSObj
  agCmds(43).ArgType(1) = atNum
  
  agCmds(44).Name = "set.loop.v"
  agCmds(44).ArgCount = 2
  agCmds(44).ArgType(0) = atSObj
  agCmds(44).ArgType(1) = atVar
  
  agCmds(45).Name = "fix.loop"
  agCmds(45).ArgCount = 1
  agCmds(45).ArgType(0) = atSObj
  
  agCmds(46).Name = "release.loop"
  agCmds(46).ArgCount = 1
  agCmds(46).ArgType(0) = atSObj
  
  agCmds(47).Name = "set.cel"
  agCmds(47).ArgCount = 2
  agCmds(47).ArgType(0) = atSObj
  agCmds(47).ArgType(1) = atNum
  
  agCmds(48).Name = "set.cel.v"
  agCmds(48).ArgCount = 2
  agCmds(48).ArgType(0) = atSObj
  agCmds(48).ArgType(1) = atVar
  
  agCmds(49).Name = "last.cel"
  agCmds(49).ArgCount = 2
  agCmds(49).ArgType(0) = atSObj
  agCmds(49).ArgType(1) = atVar
  
  agCmds(50).Name = "current.cel"
  agCmds(50).ArgCount = 2
  agCmds(50).ArgType(0) = atSObj
  agCmds(50).ArgType(1) = atVar
  
  agCmds(51).Name = "current.loop"
  agCmds(51).ArgCount = 2
  agCmds(51).ArgType(0) = atSObj
  agCmds(51).ArgType(1) = atVar
  
  agCmds(52).Name = "current.view"
  agCmds(52).ArgCount = 2
  agCmds(52).ArgType(0) = atSObj
  agCmds(52).ArgType(1) = atVar
  
  agCmds(53).Name = "number.of.loops"
  agCmds(53).ArgCount = 2
  agCmds(53).ArgType(0) = atSObj
  agCmds(53).ArgType(1) = atVar
  
  agCmds(54).Name = "set.priority"
  agCmds(54).ArgCount = 2
  agCmds(54).ArgType(0) = atSObj
  agCmds(54).ArgType(1) = atNum
  
  agCmds(55).Name = "set.priority.v"
  agCmds(55).ArgCount = 2
  agCmds(55).ArgType(0) = atSObj
  agCmds(55).ArgType(1) = atVar
  
  agCmds(56).Name = "release.priority"
  agCmds(56).ArgCount = 1
  agCmds(56).ArgType(0) = atSObj
  
  agCmds(57).Name = "get.priority"
  agCmds(57).ArgCount = 2
  agCmds(57).ArgType(0) = atSObj
  agCmds(57).ArgType(1) = atVar
  
  agCmds(58).Name = "stop.update"
  agCmds(58).ArgCount = 1
  agCmds(58).ArgType(0) = atSObj
  
  agCmds(59).Name = "start.update"
  agCmds(59).ArgCount = 1
  agCmds(59).ArgType(0) = atSObj
  
  agCmds(60).Name = "force.update"
  agCmds(60).ArgCount = 1
  agCmds(60).ArgType(0) = atSObj
  
  agCmds(61).Name = "ignore.horizon"
  agCmds(61).ArgCount = 1
  agCmds(61).ArgType(0) = atSObj
  
  agCmds(62).Name = "observe.horizon"
  agCmds(62).ArgCount = 1
  agCmds(62).ArgType(0) = atSObj
  
  agCmds(63).Name = "set.horizon"
  agCmds(63).ArgCount = 1
  agCmds(63).ArgType(0) = atNum
  
  agCmds(64).Name = "object.on.water"
  agCmds(64).ArgCount = 1
  agCmds(64).ArgType(0) = atSObj
  
  agCmds(65).Name = "object.on.land"
  agCmds(65).ArgCount = 1
  agCmds(65).ArgType(0) = atSObj
  
  agCmds(66).Name = "object.on.anything"
  agCmds(66).ArgCount = 1
  agCmds(66).ArgType(0) = atSObj
  
  agCmds(67).Name = "ignore.objs"
  agCmds(67).ArgCount = 1
  agCmds(67).ArgType(0) = atSObj
  
  agCmds(68).Name = "observe.objs"
  agCmds(68).ArgCount = 1
  agCmds(68).ArgType(0) = atSObj
  
  agCmds(69).Name = "distance"
  agCmds(69).ArgCount = 3
  agCmds(69).ArgType(0) = atSObj
  agCmds(69).ArgType(1) = atSObj
  agCmds(69).ArgType(2) = atVar
  
  agCmds(70).Name = "stop.cycling"
  agCmds(70).ArgCount = 1
  agCmds(70).ArgType(0) = atSObj
  
  agCmds(71).Name = "start.cycling"
  agCmds(71).ArgCount = 1
  agCmds(71).ArgType(0) = atSObj
  
  agCmds(72).Name = "normal.cycle"
  agCmds(72).ArgCount = 1
  agCmds(72).ArgType(0) = atSObj
  
  agCmds(73).Name = "end.of.loop"
  agCmds(73).ArgCount = 2
  agCmds(73).ArgType(0) = atSObj
  agCmds(73).ArgType(1) = atFlag
  
  agCmds(74).Name = "reverse.cycle"
  agCmds(74).ArgCount = 1
  agCmds(74).ArgType(0) = atSObj
  
  agCmds(75).Name = "reverse.loop"
  agCmds(75).ArgCount = 2
  agCmds(75).ArgType(0) = atSObj
  agCmds(75).ArgType(1) = atFlag
  
  agCmds(76).Name = "cycle.time"
  agCmds(76).ArgCount = 2
  agCmds(76).ArgType(0) = atSObj
  agCmds(76).ArgType(1) = atVar
  
  agCmds(77).Name = "stop.motion"
  agCmds(77).ArgCount = 1
  agCmds(77).ArgType(0) = atSObj
  
  agCmds(78).Name = "start.motion"
  agCmds(78).ArgCount = 1
  agCmds(78).ArgType(0) = atSObj
  
  agCmds(79).Name = "step.size"
  agCmds(79).ArgCount = 2
  agCmds(79).ArgType(0) = atSObj
  agCmds(79).ArgType(1) = atVar
  
  agCmds(80).Name = "step.time"
  agCmds(80).ArgCount = 2
  agCmds(80).ArgType(0) = atSObj
  agCmds(80).ArgType(1) = atVar
  
  agCmds(81).Name = "move.obj"
  agCmds(81).ArgCount = 5
  agCmds(81).ArgType(0) = atSObj
  agCmds(81).ArgType(1) = atNum
  agCmds(81).ArgType(2) = atNum
  agCmds(81).ArgType(3) = atNum
  agCmds(81).ArgType(4) = atFlag
  
  agCmds(82).Name = "move.obj.v"
  agCmds(82).ArgCount = 5
  agCmds(82).ArgType(0) = atSObj
  agCmds(82).ArgType(1) = atVar
  agCmds(82).ArgType(2) = atVar
  agCmds(82).ArgType(3) = atVar
  agCmds(82).ArgType(4) = atFlag
  
  agCmds(83).Name = "follow.ego"
  agCmds(83).ArgCount = 3
  agCmds(83).ArgType(0) = atSObj
  agCmds(83).ArgType(1) = atNum
  agCmds(83).ArgType(2) = atFlag
  
  agCmds(84).Name = "wander"
  agCmds(84).ArgCount = 1
  agCmds(84).ArgType(0) = atSObj
  
  agCmds(85).Name = "normal.motion"
  agCmds(85).ArgCount = 1
  agCmds(85).ArgType(0) = atSObj
  
  agCmds(86).Name = "set.dir"
  agCmds(86).ArgCount = 2
  agCmds(86).ArgType(0) = atSObj
  agCmds(86).ArgType(1) = atVar
  
  agCmds(87).Name = "get.dir"
  agCmds(87).ArgCount = 2
  agCmds(87).ArgType(0) = atSObj
  agCmds(87).ArgType(1) = atVar
  
  agCmds(88).Name = "ignore.blocks"
  agCmds(88).ArgCount = 1
  agCmds(88).ArgType(0) = atSObj
  
  agCmds(89).Name = "observe.blocks"
  agCmds(89).ArgCount = 1
  agCmds(89).ArgType(0) = atSObj
  
  agCmds(90).Name = "block"
  agCmds(90).ArgCount = 4
  agCmds(90).ArgType(0) = atNum
  agCmds(90).ArgType(1) = atNum
  agCmds(90).ArgType(2) = atNum
  agCmds(90).ArgType(3) = atNum
  
  agCmds(91).Name = "unblock"
  agCmds(91).ArgCount = 0
  
  agCmds(92).Name = "get"
  agCmds(92).ArgCount = 1
  agCmds(92).ArgType(0) = atIObj
  
  agCmds(93).Name = "get.v"
  agCmds(93).ArgCount = 1
  agCmds(93).ArgType(0) = atVar
  
  agCmds(94).Name = "drop"
  agCmds(94).ArgCount = 1
  agCmds(94).ArgType(0) = atIObj
  
  agCmds(95).Name = "put"
  agCmds(95).ArgCount = 2
  agCmds(95).ArgType(0) = atIObj
  agCmds(95).ArgType(1) = atVar
  
  agCmds(96).Name = "put.v"
  agCmds(96).ArgCount = 2
  agCmds(96).ArgType(0) = atVar
  agCmds(96).ArgType(1) = atVar
  
  agCmds(97).Name = "get.room.v"
  agCmds(97).ArgCount = 2
  agCmds(97).ArgType(0) = atVar
  agCmds(97).ArgType(1) = atVar
  
  agCmds(98).Name = "load.sound"
  agCmds(98).ArgCount = 1
  agCmds(98).ArgType(0) = atNum
  
  agCmds(99).Name = "sound"
  agCmds(99).ArgCount = 2
  agCmds(99).ArgType(0) = atNum
  agCmds(99).ArgType(1) = atFlag
  
  agCmds(100).Name = "stop.sound"
  agCmds(100).ArgCount = 0
  
  agCmds(101).Name = "print"
  agCmds(101).ArgCount = 1
  agCmds(101).ArgType(0) = atMsg
  
  agCmds(102).Name = "print.v"
  agCmds(102).ArgCount = 1
  agCmds(102).ArgType(0) = atVar
  
  agCmds(103).Name = "display"
  agCmds(103).ArgCount = 3
  agCmds(103).ArgType(0) = atNum
  agCmds(103).ArgType(1) = atNum
  agCmds(103).ArgType(2) = atMsg
  
  agCmds(104).Name = "display.v"
  agCmds(104).ArgCount = 3
  agCmds(104).ArgType(0) = atVar
  agCmds(104).ArgType(1) = atVar
  agCmds(104).ArgType(2) = atVar
  
  agCmds(105).Name = "clear.lines"
  agCmds(105).ArgCount = 3
  agCmds(105).ArgType(0) = atNum
  agCmds(105).ArgType(1) = atNum
  agCmds(105).ArgType(2) = atNum
  
  agCmds(106).Name = "text.screen"
  agCmds(106).ArgCount = 0
  
  agCmds(107).Name = "graphics"
  agCmds(107).ArgCount = 0
  
  agCmds(108).Name = "set.cursor.char"
  agCmds(108).ArgCount = 1
  agCmds(108).ArgType(0) = atMsg
  
  agCmds(109).Name = "set.text.attribute"
  agCmds(109).ArgCount = 2
  agCmds(109).ArgType(0) = atNum
  agCmds(109).ArgType(1) = atNum
  
  agCmds(110).Name = "shake.screen"
  agCmds(110).ArgCount = 1
  agCmds(110).ArgType(0) = atNum
  
  agCmds(111).Name = "configure.screen"
  agCmds(111).ArgCount = 3
  agCmds(111).ArgType(0) = atNum
  agCmds(111).ArgType(1) = atNum
  agCmds(111).ArgType(2) = atNum
  
  agCmds(112).Name = "status.line.on"
  agCmds(112).ArgCount = 0
  
  agCmds(113).Name = "status.line.off"
  agCmds(113).ArgCount = 0
  
  agCmds(114).Name = "set.string"
  agCmds(114).ArgCount = 2
  agCmds(114).ArgType(0) = atStr
  agCmds(114).ArgType(1) = atMsg
  
  agCmds(115).Name = "get.string"
  agCmds(115).ArgCount = 5
  agCmds(115).ArgType(0) = atStr
  agCmds(115).ArgType(1) = atMsg
  agCmds(115).ArgType(2) = atNum
  agCmds(115).ArgType(3) = atNum
  agCmds(115).ArgType(4) = atNum
  
  agCmds(116).Name = "word.to.string"
  agCmds(116).ArgCount = 2
'  the word arguments are zero-based (i.e.
'  first word is w0, second word is w1, etc
'  but when using format codes, the codes are 1-based
'  i.e. %w1 is first word, %w2 is second word, etc
'  to eliminate confusion, compiler automatically compensates
  agCmds(116).ArgType(0) = atStr
  agCmds(116).ArgType(1) = atWord
  
  agCmds(117).Name = "parse"
  agCmds(117).ArgCount = 1
  agCmds(117).ArgType(0) = atStr
  
  agCmds(118).Name = "get.num"
  agCmds(118).ArgCount = 2
  agCmds(118).ArgType(0) = atMsg
  agCmds(118).ArgType(1) = atVar
  
  agCmds(119).Name = "prevent.input"
  agCmds(119).ArgCount = 0
  
  agCmds(120).Name = "accept.input"
  agCmds(120).ArgCount = 0
  
  agCmds(121).Name = "set.key"
  agCmds(121).ArgCount = 3
  agCmds(121).ArgType(0) = atNum
  agCmds(121).ArgType(1) = atNum
  agCmds(121).ArgType(2) = atCtrl
  
  agCmds(122).Name = "add.to.pic"
  agCmds(122).ArgCount = 7
  agCmds(122).ArgType(0) = atNum
  agCmds(122).ArgType(1) = atNum
  agCmds(122).ArgType(2) = atNum
  agCmds(122).ArgType(3) = atNum
  agCmds(122).ArgType(4) = atNum
  agCmds(122).ArgType(5) = atNum
  agCmds(122).ArgType(6) = atNum
  
  agCmds(123).Name = "add.to.pic.v"
  agCmds(123).ArgCount = 7
  agCmds(123).ArgType(0) = atVar
  agCmds(123).ArgType(1) = atVar
  agCmds(123).ArgType(2) = atVar
  agCmds(123).ArgType(3) = atVar
  agCmds(123).ArgType(4) = atVar
  agCmds(123).ArgType(5) = atVar
  agCmds(123).ArgType(6) = atVar
  
  agCmds(124).Name = "status"
  agCmds(124).ArgCount = 0
  
  agCmds(125).Name = "save.game"
  agCmds(125).ArgCount = 0
  
  agCmds(126).Name = "restore.game"
  agCmds(126).ArgCount = 0
  
  agCmds(127).Name = "init.disk"
  agCmds(127).ArgCount = 0
  
  agCmds(128).Name = "restart.game"
  agCmds(128).ArgCount = 0
  
  agCmds(129).Name = "show.obj"
  agCmds(129).ArgCount = 1
  agCmds(129).ArgType(0) = atNum
  
  agCmds(130).Name = "random"
  agCmds(130).ArgCount = 3
  agCmds(130).ArgType(0) = atNum
  agCmds(130).ArgType(1) = atNum
  agCmds(130).ArgType(2) = atVar
  
  agCmds(131).Name = "program.control"
  agCmds(131).ArgCount = 0
  
  agCmds(132).Name = "player.control"
  agCmds(132).ArgCount = 0
  
  agCmds(133).Name = "obj.status.v"
  agCmds(133).ArgCount = 1
  agCmds(133).ArgType(0) = atVar
  
  agCmds(134).Name = "quit"
  agCmds(134).ArgCount = 1
  agCmds(134).ArgType(0) = atNum
  
  agCmds(135).Name = "show.mem"
  agCmds(135).ArgCount = 0
  
  agCmds(136).Name = "pause"
  agCmds(136).ArgCount = 0
  
  agCmds(137).Name = "echo.line"
  agCmds(137).ArgCount = 0
  
  agCmds(138).Name = "cancel.line"
  agCmds(138).ArgCount = 0
  
  agCmds(139).Name = "init.joy"
  agCmds(139).ArgCount = 0
  
  agCmds(140).Name = "toggle.monitor"
  agCmds(140).ArgCount = 0
  
  agCmds(141).Name = "version"
  agCmds(141).ArgCount = 0
  
  agCmds(142).Name = "script.size"
  agCmds(142).ArgCount = 1
  agCmds(142).ArgType(0) = atNum
  
  agCmds(143).Name = "set.game.id"
  agCmds(143).ArgCount = 1
  agCmds(143).ArgType(0) = atMsg
  
  agCmds(144).Name = "log"
  agCmds(144).ArgCount = 1
  agCmds(144).ArgType(0) = atMsg
  
  agCmds(145).Name = "set.scan.start"
  agCmds(145).ArgCount = 0
  
  agCmds(146).Name = "reset.scan.start"
  agCmds(146).ArgCount = 0
  
  agCmds(147).Name = "reposition.to"
  agCmds(147).ArgCount = 3
  agCmds(147).ArgType(0) = atSObj
  agCmds(147).ArgType(1) = atNum
  agCmds(147).ArgType(2) = atNum
  
  agCmds(148).Name = "reposition.to.v"
  agCmds(148).ArgCount = 3
  agCmds(148).ArgType(0) = atSObj
  agCmds(148).ArgType(1) = atVar
  agCmds(148).ArgType(2) = atVar
  
  agCmds(149).Name = "trace.on"
  agCmds(149).ArgCount = 0
  
  agCmds(150).Name = "trace.info"
  agCmds(150).ArgCount = 3
  agCmds(150).ArgType(0) = atNum
  agCmds(150).ArgType(1) = atNum
  agCmds(150).ArgType(2) = atNum
  
  agCmds(151).Name = "print.at"
  agCmds(151).ArgCount = 4
  agCmds(151).ArgType(0) = atMsg
  agCmds(151).ArgType(1) = atNum
  agCmds(151).ArgType(2) = atNum
  agCmds(151).ArgType(3) = atNum
  
  agCmds(152).Name = "print.at.v"
  agCmds(152).ArgCount = 4
  agCmds(152).ArgType(0) = atVar
  agCmds(152).ArgType(1) = atNum
  agCmds(152).ArgType(2) = atNum
  agCmds(152).ArgType(3) = atNum
  
  agCmds(153).Name = "discard.view.v"
  agCmds(153).ArgCount = 1
  agCmds(153).ArgType(0) = atVar
  
  agCmds(154).Name = "clear.text.rect"
  agCmds(154).ArgCount = 5
  agCmds(154).ArgType(0) = atNum
  agCmds(154).ArgType(1) = atNum
  agCmds(154).ArgType(2) = atNum
  agCmds(154).ArgType(3) = atNum
  agCmds(154).ArgType(4) = atNum
  
  agCmds(155).Name = "set.upper.left"
  agCmds(155).ArgCount = 2
  agCmds(155).ArgType(0) = atNum
  agCmds(155).ArgType(1) = atNum
  
  agCmds(156).Name = "set.menu"
  agCmds(156).ArgCount = 1
  agCmds(156).ArgType(0) = atMsg
  
  agCmds(157).Name = "set.menu.item"
  agCmds(157).ArgCount = 2
  agCmds(157).ArgType(0) = atMsg
  agCmds(157).ArgType(1) = atCtrl
  
  agCmds(158).Name = "submit.menu"
  agCmds(158).ArgCount = 0
  
  agCmds(159).Name = "enable.item"
  agCmds(159).ArgCount = 1
  agCmds(159).ArgType(0) = atCtrl
  
  agCmds(160).Name = "disable.item"
  agCmds(160).ArgCount = 1
  agCmds(160).ArgType(0) = atCtrl
  
  agCmds(161).Name = "menu.input"
  agCmds(161).ArgCount = 0
  
  agCmds(162).Name = "show.obj.v"
  agCmds(162).ArgCount = 1
  agCmds(162).ArgType(0) = atVar
  
  agCmds(163).Name = "open.dialogue"
  agCmds(163).ArgCount = 0
  
  agCmds(164).Name = "close.dialogue"
  agCmds(164).ArgCount = 0
  
  agCmds(165).Name = "mul.n"
  agCmds(165).ArgCount = 2
  agCmds(165).ArgType(0) = atVar
  agCmds(165).ArgType(1) = atNum
  
  agCmds(166).Name = "mul.v"
  agCmds(166).ArgCount = 2
  agCmds(166).ArgType(0) = atVar
  agCmds(166).ArgType(1) = atVar
  
  agCmds(167).Name = "div.n"
  agCmds(167).ArgCount = 2
  agCmds(167).ArgType(0) = atVar
  agCmds(167).ArgType(1) = atNum
  
  agCmds(168).Name = "div.v"
  agCmds(168).ArgCount = 2
  agCmds(168).ArgType(0) = atVar
  agCmds(168).ArgType(1) = atVar
  
  agCmds(169).Name = "close.window"
  agCmds(169).ArgCount = 0
  
  agCmds(170).Name = "set.simple"
  agCmds(170).ArgCount = 1
  agCmds(170).ArgType(0) = atStr
  
  agCmds(171).Name = "push.script"
  agCmds(171).ArgCount = 0
  
  agCmds(172).Name = "pop.script"
  agCmds(172).ArgCount = 0
  
  agCmds(173).Name = "hold.key"
  agCmds(173).ArgCount = 0
  
  agCmds(174).Name = "set.pri.base"
  agCmds(174).ArgCount = 1
  agCmds(174).ArgType(0) = atNum
  
  agCmds(175).Name = "discard.sound"
  agCmds(175).ArgCount = 1
  agCmds(175).ArgType(0) = atNum
  
  agCmds(176).Name = "hide.mouse"
  agCmds(176).ArgCount = 0
  agCmds(176).ArgType(0) = atNum
  
  agCmds(177).Name = "allow.menu"
  agCmds(177).ArgCount = 1
  agCmds(177).ArgType(0) = atNum
  
  agCmds(178).Name = "show.mouse"
  agCmds(178).ArgCount = 0
  
  agCmds(179).Name = "fence.mouse"
  agCmds(179).ArgCount = 4
  agCmds(179).ArgType(0) = atNum
  agCmds(179).ArgType(1) = atNum
  agCmds(179).ArgType(2) = atNum
  agCmds(179).ArgType(3) = atNum
  
  agCmds(180).Name = "mouse.posn"
  agCmds(180).ArgCount = 2
  agCmds(180).ArgType(0) = atNum
  agCmds(180).ArgType(1) = atNum
  
  agCmds(181).Name = "release.key"
  agCmds(181).ArgCount = 0
  
  agCmds(182).Name = "adj.ego.move.to.x.y"
  agCmds(182).ArgCount = 0
End Sub
Public Sub AssignReservedDefines(ByVal NewSyntax As LogicSyntaxType)
  ' predefined variables, flags, and objects
  ' Variables v0 - v26
  ' Flags f0 - f16, f20 (in version 3.102 and above)

  'create default variables, flags and constants
  'NOTE: object variable, o0, is considered a predefined
  'variable, as well as game version string, game about string
  'and inventory object count
    
  Dim i As Long
  
  Debug.Assert NewSyntax <> lsUnknown
  
  'if no change,
  If NewSyntax = agPreDefSyntax Then
    Exit Sub
  End If
  
  Select Case NewSyntax
  Case lsVB
    'Variables used by the interpreter
    '0 - Current room number (parameter new_room cmd), initially 0.
    agResVar(0).Name = "CurrentRoom"
    agResVar(0).Value = "v0"
    
    '1 - Previous room number.
    agResVar(1).Name = "PreviousRoom"
    agResVar(1).Value = "v1"
    
    '2 - Code of the border touched by EGO
    agResVar(2).Name = "EgoEdgeCode"
    agResVar(2).Value = "v2"
    
    '3 - Current score.
    agResVar(3).Name = "Score"
    agResVar(3).Value = "v3"
    
    '4 - Number of object, other than EGO, that touched the border.
    agResVar(4).Name = "ObjectTouchingEdge"
    agResVar(4).Value = "v4"
    
    '5 - The code of border touched by the object in Var (4).
    agResVar(5).Name = "ObjectEdgeCode"
    agResVar(5).Value = "v5"
    
    '6 - Direction of EGO's motion.
    agResVar(6).Name = "EgoDirection"
    agResVar(6).Value = "v6"
    
    '7 - Maximum score.
    agResVar(7).Name = "MaxScore"
    agResVar(7).Value = "v7"
    
    '8 - Number of free 256-byte pages of the interpreter's memory.
    agResVar(8).Name = "FreeMemory"
    agResVar(8).Value = "v8"
    
    '9 - If = 0, it is the number of the word in the user message that was not found in the dictionary.
    '[I would assume they mean "if != 0)=but that's what they say. --VB]
    agResVar(9).Name = "UnknownWordNum"
    agResVar(9).Value = "v9"
    
    '10 - Time delay between interpreter cycles in 1/20 second intervals.
    agResVar(10).Name = "CycleDelay"
    agResVar(10).Value = "v10"
    
    '11 - Seconds (interpreter's internal clock)
    agResVar(11).Name = "ClockSeconds"
    agResVar(11).Value = "v11"
    
    '12 - Minutes (interpreter's internal clock)
    agResVar(12).Name = "ClockMinutes"
    agResVar(12).Value = "v12"
    
    '13 - Hours (interpreter's internal clock)
    agResVar(13).Name = "ClockHours"
    agResVar(13).Value = "v13"
    
    '14 - Days (interpreter's internal clock)
    agResVar(14).Name = "ClockDays"
    agResVar(14).Value = "v14"
    
    '15 - Joystick sensitivity (if Flag (8) = 1).
    agResVar(15).Name = "JoystickSensitivity"
    agResVar(15).Value = "v15"
    
    '16 - ID number of the view-resource associated with EGO.
    agResVar(16).Name = "EgoViewNum"
    agResVar(16).Value = "v16"
    
    '17 - Interpreter error code (if = 0) [again I would expect this to say "if != 0". --VB]
    agResVar(17).Name = "ErrorCode"
    agResVar(17).Value = "v17"
    
    '18 - Additional information that goes with the error code.
    agResVar(18).Name = "ErrorInfo"
    agResVar(18).Value = "v18"
    
    '19 - Key pressed on the keyboard.
    agResVar(19).Name = "KeyPressed"
    agResVar(19).Value = "v19"
    
    '20 - Computer type. For IBM PC it always 0.
    agResVar(20).Name = "ComputerType"
    agResVar(20).Value = "v20"
    
    '21 - If Flag (15) = 0 (command reset 15 was issued) and
    'Var (21) is not equal to 0, the window is automatically closed after 1/2 * Var (21) seconds.
    agResVar(21).Name = "MsgWindowCloseTime"
    agResVar(21).Value = "v21"
    
    '22 - Number of sound channels enabled 1 or 3 depending on computer type
    agResVar(22).Name = "SoundChannelCount"
    agResVar(22).Value = "v22"
    
    '23 - 0F - sound volume (for TANDY).
    agResVar(23).Name = "SoundVolume"
    agResVar(23).Value = "v23"
    
    '24 - This variable stores the maximum number that can be entered in the input line. By default, this variable is set to 41 (29h)
    agResVar(24).Name = "MaxInputLength"
    agResVar(24).Value = "v24"
    
    '25 - ID number of the item selected using status command or FF if ESC was pressed.
    agResVar(25).Name = "SelectedItem"
    agResVar(25).Value = "v25"
    
    '26 - monitor type
    agResVar(26).Name = "MonitorType"
    agResVar(26).Value = "v26"
    
    '
    'Flags used by the interpreter
    'On the interpreter startup all flags are set to 0.
    '
    '0 - EGO base line is completely on pixels with priority = 3 (water surface).
    agResFlag(0).Name = "EgoOnWater"
    agResFlag(0).Value = "f0"
    '1 - EGO is invisible of the screen (completely obscured by another object).
    agResFlag(1).Name = "EgoIsHidden"
    agResFlag(1).Value = "f1"
    '2 - the player has issued a command line.
    agResFlag(2).Name = "InputEntered"
    agResFlag(2).Value = "f2"
    '3 - EGO base line has touched a pixel with priority 2 (signal).
    agResFlag(3).Name = "EgoOnSignalLine"
    agResFlag(3).Value = "f3"
    '4 - `said' command has accepted the user input.
    agResFlag(4).Name = "InputParsed"
    agResFlag(4).Value = "f4"
    '5 - The new room is executed for the first time.
    agResFlag(5).Name = "NewRoomInitialEntry"
    agResFlag(5).Value = "f5"
    '6 - `restart_game' command has been executed.
    agResFlag(6).Name = "GameRestarted"
    agResFlag(6).Value = "f6"
    '7 - if this flag is 1, writing to the script buffer is blocked.
    agResFlag(7).Name = "ScriptBufferBlocked"
    agResFlag(7).Value = "f7"
    '8 - if 1, Var(15) determines the joystick sensitivity.
    agResFlag(8).Name = "EnableJoystickSensitivity"
    agResFlag(8).Value = "f8"
    '9 - sound on/off.
    agResFlag(9).Name = "SoundOn"
    agResFlag(9).Value = "f9"
    '10 - 1 turns on the built-in debugger.
    agResFlag(10).Name = "DebugMode"
    agResFlag(10).Value = "f10"
    '11 - Noise channel status; depends on computer type.
    agResFlag(11).Name = "NoiseEnabled"
    agResFlag(11).Value = "f11"
    '12 - `restore_game' command has been executed.
    agResFlag(12).Name = "GameRestored"
    agResFlag(12).Value = "f12"
    '13 - 1 allows the `status' command to select items.
    agResFlag(13).Name = "InventorySelectEnabled"
    agResFlag(13).Value = "f13"
    '14 - 1 allows the menu to work.
    agResFlag(14).Name = "EnableMenus"
    agResFlag(14).Value = "f14"
    '15 - Determines the output mode of `print' and `print_at' commands
    '   set   - message window is left on the screen
    '   reset - message window is closed when Enter or Esc key are pressed.
    'If Var(21) is not 0, the window is closed automatically after 1/2 * Var(21) seconds
    agResFlag(15).Name = "MsgWindowsRemain"
    agResFlag(15).Value = "f15"
    '16 - Restart mode; if true restart doesn't ask for user input
    agResFlag(16).Name = "AutoRestart"
    agResFlag(16).Value = "f16"
    '20 - determines if autoloop is assigned for views with >4 loops
    agResFlag(17).Name = "AutoLoop"
    agResFlag(17).Value = "f20"
    
    'edge codes
    agEdgeCodes(0).Name = "ecNone"
    agEdgeCodes(0).Value = 0
    agEdgeCodes(1).Name = "ecHorizon"
    agEdgeCodes(1).Value = 1
    agEdgeCodes(2).Name = "ecRight"
    agEdgeCodes(2).Value = 2
    agEdgeCodes(3).Name = "ecBottom"
    agEdgeCodes(3).Value = 3
    agEdgeCodes(4).Name = "ecLeft"
    agEdgeCodes(4).Value = 4
    
    'object direction
    agEgoDir(0).Name = "odNone"
    agEgoDir(0).Value = 0
    agEgoDir(1).Name = "odUp"
    agEgoDir(1).Value = 1
    agEgoDir(2).Name = "odUpRight"
    agEgoDir(2).Value = 2
    agEgoDir(3).Name = "odRight"
    agEgoDir(3).Value = 3
    agEgoDir(4).Name = "odDownRight"
    agEgoDir(4).Value = 4
    agEgoDir(5).Name = "odDown"
    agEgoDir(5).Value = 5
    agEgoDir(6).Name = "odDownLeft"
    agEgoDir(6).Value = 6
    agEgoDir(7).Name = "odLeft"
    agEgoDir(7).Value = 7
    agEgoDir(8).Name = "odUpLeft"
    agEgoDir(8).Value = 8
       
    'video modes
    agVideoMode(0).Name = "vmCGA"
    agVideoMode(0).Value = 0
    agVideoMode(1).Name = "vmRGB"
    agVideoMode(1).Value = 1
    agVideoMode(2).Name = "vmHercules"
    agVideoMode(2).Value = 2
    agVideoMode(3).Name = "vmEGA"
    agVideoMode(3).Value = 3
    agVideoMode(4).Name = "vmVGA"
    agVideoMode(4).Value = 4
    
    'other predefines
    agResDef(0).Name = "Ego"
    agResDef(0).Value = "o0"
    agResDef(1).Name = "GameVersion"
    'agResDef(1).Value = vbNullString 'will be assigned by compiler
    agResDef(2).Name = "GameAbout"
    'agResDef(2).Value = vbNullString 'will be assigned by compiler
    agResDef(3).Name = "GameID"
    'agResDef(3).Value = vbNullString 'will be assigned by compiler
    agResDef(4).Name = "InvObjCount"
    'agResDef(4).Value = vbNullString 'will be assigned by compiler
    agResDef(5).Name = "InputPrompt"
    agResDef(5).Value = "s0"
    
  Case lsAGI
    'variables
    agResVar(0).Name = "room_no"
    agResVar(0).Value = "v0"
    agResVar(1).Name = "prev_room_no"
    agResVar(1).Value = "v1"
    agResVar(2).Name = "ego_edge_code"
    agResVar(2).Value = "v2"
    agResVar(3).Name = "score"
    agResVar(3).Value = "v3"
    agResVar(4).Name = "object_touching_edge"
    agResVar(4).Value = "v4"
    agResVar(5).Name = "object_edge_code"
    agResVar(5).Value = "v5"
    agResVar(6).Name = "ego_dir"
    agResVar(6).Value = "v6"
    agResVar(7).Name = "max_score"
    agResVar(7).Value = "v7"
    agResVar(8).Name = "free_memory"
    agResVar(8).Value = "v8"
    agResVar(9).Name = "unknown_word_no"
    agResVar(9).Value = "v9"
    agResVar(10).Name = "cycle_delay"
    agResVar(10).Value = "v10"
    agResVar(11).Name = "clock_seconds"
    agResVar(11).Value = "v11"
    agResVar(12).Name = "clock_minutes"
    agResVar(12).Value = "v12"
    agResVar(13).Name = "clock_hours"
    agResVar(13).Value = "v13"
    agResVar(14).Name = "clock_days"
    agResVar(14).Value = "v14"
    agResVar(15).Name = "joystick_sensitivity"
    agResVar(15).Value = "v15"
    agResVar(16).Name = "ego_view_no"
    agResVar(16).Value = "v16"
    agResVar(17).Name = "error_code"
    agResVar(17).Value = "v17"
    agResVar(18).Name = "error_information"
    agResVar(18).Value = "v18"
    agResVar(19).Name = "key_pressed"
    agResVar(19).Value = "v19"
    agResVar(20).Name = "computer_type"
    agResVar(20).Value = "v20"
    agResVar(21).Name = "window_close_time"
    agResVar(21).Value = "v21"
    agResVar(22).Name = "sound_channel_count"
    agResVar(22).Value = "v22"
    agResVar(23).Name = "sound_volume"
    agResVar(23).Value = "v23"
    agResVar(24).Name = "max_input_len"
    agResVar(24).Value = "v24"
    agResVar(25).Name = "selected_inventory_item"
    agResVar(25).Value = "v25"
    agResVar(26).Name = "video_mode"
    agResVar(26).Value = "v26"
    
    'flags
    agResFlag(0).Name = "ego_on_water"
    agResFlag(0).Value = "f0"
    agResFlag(1).Name = "ego_hidden"
    agResFlag(1).Value = "f1"
    agResFlag(2).Name = "input_received"
    agResFlag(2).Value = "f2"
    agResFlag(3).Name = "ego_touching_signal_line"
    agResFlag(3).Value = "f3"
    agResFlag(4).Name = "input_parsed"
    agResFlag(4).Value = "f4"
    agResFlag(5).Name = "new_room"
    agResFlag(5).Value = "f5"
    agResFlag(6).Name = "game_restarted"
    agResFlag(6).Value = "f6"
    agResFlag(7).Name = "script_buffer_blocked"
    agResFlag(7).Value = "f7"
    agResFlag(8).Name = "joystick_sensitivity_set"
    agResFlag(8).Value = "f8"
    agResFlag(9).Name = "sound_on"
    agResFlag(9).Value = "f9"
    agResFlag(10).Name = "trace_enabled"
    agResFlag(10).Value = "f10"
    agResFlag(11).Name = "noise_enabled"
    agResFlag(11).Value = "f11"
    agResFlag(12).Name = "game_restored"
    agResFlag(12).Value = "f12"
    agResFlag(13).Name = "inventory_select_enabled"
    agResFlag(13).Value = "f13"
    agResFlag(14).Name = "menu_enabled"
    agResFlag(14).Value = "f14"
    agResFlag(15).Name = "windows_remain"
    agResFlag(15).Value = "f15"
    agResFlag(16).Name = "auto_restart"
    agResFlag(16).Value = "f16"
    agResFlag(17).Name = "auto_loop"
    agResFlag(17).Value = "f20"
    
    'edge codes
    agEdgeCodes(0).Name = "no_edge"
    agEdgeCodes(0).Value = 0
    agEdgeCodes(1).Name = "horizon_edge"
    agEdgeCodes(1).Value = 1
    agEdgeCodes(2).Name = "right_edge"
    agEdgeCodes(2).Value = 2
    agEdgeCodes(3).Name = "bottom_edge"
    agEdgeCodes(3).Value = 3
    agEdgeCodes(4).Name = "left_edge"
    agEdgeCodes(4).Value = 4
    
    'object direction
    agEgoDir(0).Name = "stopped"
    agEgoDir(0).Value = 0
    agEgoDir(1).Name = "up"
    agEgoDir(1).Value = 1
    agEgoDir(2).Name = "upright"
    agEgoDir(2).Value = 2
    agEgoDir(3).Name = "right"
    agEgoDir(3).Value = 3
    agEgoDir(4).Name = "downright"
    agEgoDir(4).Value = 4
    agEgoDir(5).Name = "down"
    agEgoDir(5).Value = 5
    agEgoDir(6).Name = "downleft"
    agEgoDir(6).Value = 6
    agEgoDir(7).Name = "left"
    agEgoDir(7).Value = 7
    agEgoDir(8).Name = "upleft"
    agEgoDir(8).Value = 8
    
    'video modes
    agVideoMode(0).Name = "CGA"
    agVideoMode(0).Value = 0
    agVideoMode(1).Name = "RGB"
    agVideoMode(1).Value = 1
    agVideoMode(2).Name = "Hercules"
    agVideoMode(2).Value = 2
    agVideoMode(3).Name = "EGA"
    agVideoMode(3).Value = 3
    agVideoMode(4).Name = "VGA"
    agVideoMode(4).Value = 4
        
    agResDef(0).Name = "ego"
    agResDef(0).Value = "o0"
    agResDef(1).Name = "game_version_message"
    'agResDef(1).Value = vbNullString 'will be assigned by compiler
    agResDef(2).Name = "game_about_message"
    'agResDef(2).Value = vbNullString 'will be assigned by compiler
    agResDef(3).Name = "game_id"
    'agResDef(3).Value = vbNullString 'will be assigned by compiler
    agResDef(4).Name = "num_invobjects"
    'agResDef(4).Value = vbNullString 'will be assigned by compiler
    agResDef(5).Name = "input_prompt"
    agResDef(5).Value = "s0"
  End Select
  
  'set types
  For i = 0 To 26
    agResVar(i).Type = atVar
  Next i
  For i = 0 To 17
    agResFlag(i).Type = atFlag
  Next i
  For i = 0 To 4
    agEdgeCodes(i).Type = atNum
  Next i
  For i = 0 To 8
    agEgoDir(i).Type = atNum
  Next i
  For i = 0 To 4
    agVideoMode(i).Type = atNum
  Next i
  agResDef(0).Type = atSObj
  agResDef(1).Type = atDefStr
  agResDef(2).Type = atDefStr
  agResDef(3).Type = atDefStr
  agResDef(4).Type = atNum
  agResDef(5).Type = atStr
  
  'reset default
  agPreDefSyntax = NewSyntax
End Sub
Public Sub CorrectCommands(ByVal VerNum As Single)
' This procedure adjusts the logic commands for a given int. version

  'now adjust for version
  If VerNum <= 2.089 Then
    agCmds(134).ArgCount = 0  ' quit
  Else
    agCmds(134).ArgCount = 1
  End If
  
  If VerNum <= 2.4 Then
    agCmds(151).ArgCount = 3 ' print.at
    agCmds(152).ArgCount = 3 ' print.at.v
  Else
    agCmds(151).ArgCount = 4 ' print.at
    agCmds(152).ArgCount = 4 ' print.at.v
  End If
  
  If VerNum <= 3.002086 Then
    agCmds(176).ArgCount = 1
  Else
    agCmds(176).ArgCount = 0
  End If
  
  If VerNum <= 2.089 Then
    agNumCmds = 155
  ElseIf VerNum <= 2.272 Then
    agNumCmds = 161
  ElseIf VerNum <= 2.44 Then
    agNumCmds = 169
  ElseIf VerNum <= 2.917 Then
    agNumCmds = 173
  ElseIf VerNum <= 2.936 Then
    agNumCmds = 175
  ElseIf VerNum <= 3.002086 Then
    agNumCmds = 177
  Else
    agNumCmds = 181
  End If
End Sub
Public Sub GetGlobalDefines()

  Dim intFile As Integer
  Dim strLine As String, strSplitLine() As String
  Dim tdNewDefine As TDefine
  Dim fso As FileSystemObject
  Dim lngTest As Long, i As Long
  
  On Error GoTo ErrHandler

  agGlobalsSet = False
  
  'clear global list
  ReDim agGlobal(0)
  agGlobalCount = 0
  
  Debug.Assert agGameLoaded
  
  'look for global file
  If Not FileExists(agGameDir & "globals.txt") Then
    'exit
    Exit Sub
  End If
  
  'open file for input
  intFile = FreeFile()
  Open agGameDir & "globals.txt" For Input As intFile
  
  'read in globals
  Do Until EOF(intFile)
    'get line
    Line Input #intFile, strLine
    
    'ignore blanks and comments (// or ' or Rem)
    If LenB(strLine) <> 0 And Left$(strLine, 2) <> "//" And Left$(strLine, 1) <> Chr$(39) And Left$(strLine, 4) <> "Rem" Then
      'splitline into name and value
      strSplitLine = Split(strLine, vbTab)
      
      'if not exactly two elements
      If UBound(strSplitLine) <> 1 Then
        'not a valid global.txt; check for defines.txt
        If Left$(strLine, 8) = "#define " Then
          'set up splitline array
          ReDim strSplitLine(1)
          'strip off the define statement
          strLine = Right$(strLine, Len(strLine) - 8)
          'extract define name
          i = InStr(1, strLine, Chr$(32))
          If i <> 0 Then
            strSplitLine(0) = Left$(strLine, i - 1)
            strLine = Right$(strLine, Len(strLine) - i)
            strSplitLine(1) = Trim$(strLine)
          Else
            'invalid; reset splitline so this line
            'gets ignored
            ReDim strSplitLine(0)
          End If
        End If
      End If
      
      'if exactly two elements
      If UBound(strSplitLine) = 1 Then
        'strSplitLine(0) has name
        tdNewDefine.Name = Trim$(strSplitLine(0))
        'strSplitLine(1) has value
        tdNewDefine.Value = Trim$(strSplitLine(1))
        
        'validate define name
        lngTest = ValidateDefName(tdNewDefine.Name)
        Select Case lngTest
        Case 0, 8, 9, 10, 11, 12 'name is valid or is overriding a reserved define
          lngTest = ValidateDefValue(tdNewDefine)
          Select Case lngTest
          Case 0, 5, 6 'value is valid, or is overriding a reserved value
            'add it
            ReDim Preserve agGlobal(agGlobalCount)
            agGlobal(agGlobalCount) = tdNewDefine
            'increment count
            agGlobalCount = agGlobalCount + 1
          End Select
        End Select
      End If
    End If
  Loop
  
  'save crc for this file
  Set fso = New FileSystemObject
  'get datemodified property
  strLine = CStr(fso.GetFile(agGameDir & "globals.txt").DateLastModified)
  agGlobalCRC = CRC32(StrConv(strLine, vbFromUnicode))
  Set fso = Nothing
  
  Close intFile
Exit Sub

ErrHandler:
  Debug.Assert False
  
  'ensure file is closed
  Close intFile
  'return false
End Sub

Public Function ValidateDefName(DefName As String) As Long
  'validates that DefValue is a valid define value
  '
  'returns 0 if successful
  '
  'returns an error code on failure:
  '1 = no name
  '2 = name is numeric
  '3 = name is command
  '4 = name is test command
  '5 = name is a compiler keyword
  '6 = name is an argument marker
  '7 = name is already globally defined
  '8 = name is reserved variable name
  '9 = name is reserved flag name
  '10 = name is reserved number constant
  '11 = name is reserved object constant
  '12 = name is reserved message constant
  '13 = name contains improper character

  Dim i As Long, j As Long
  
  On Error GoTo ErrHandler
  
  'if no name, or no value,
  If LenB(DefName) = 0 Then
    ValidateDefName = 1
    Exit Function
  End If
  
  'name cant be numeric
  If IsNumeric(DefName) Then
    ValidateDefName = 2
    Exit Function
  End If
  
  'check against regular commands
  For i = 0 To UBound(agCmds)
    If DefName = agCmds(i).Name Then
      ValidateDefName = 3
      Exit Function
    End If
  Next i
  
  'check against test commands
  For i = 0 To UBound(agTestCmds)
    If DefName = agTestCmds(i).Name Then
      ValidateDefName = 4
      Exit Function
    End If
  Next i
  
  'check against keywords
  If (DefName = "if") Or (DefName = "else") Or (DefName = "goto") Or (DefName = "then") Then
    ValidateDefName = 5
    Exit Function
  End If
      
  'check against variable/flag/controller/string/message names
  Select Case AscW(LCase$(DefName))
  '     v    f    m    o    i    s    w    c
  Case 118, 102, 109, 111, 105, 115, 119, 99
    If IsNumeric(Right$(DefName, Len(DefName) - 1)) Then
      ValidateDefName = 6
      Exit Function
    End If
  End Select
  
  'check against current globals
  For i = 0 To agGlobalCount - 1
    If DefName = agGlobal(i).Name Then
      ValidateDefName = 7
      'dont exit so value can be validated
    End If
  Next i
  
  If agUseRes Then
    'check against reserved defines:
    'check against reserved variables
    For i = 0 To 26
      If DefName = agResVar(i).Name Then
        ValidateDefName = 8
        Exit Function
      End If
    Next i
    'check against reserved flags
    For i = 0 To 17
      If DefName = agResFlag(i).Name Then
        ValidateDefName = 9
        Exit Function
      End If
    Next i
    'check against other reserved constants
    For i = 0 To 4
      If DefName = agEdgeCodes(i).Name Then
        ValidateDefName = 10
        Exit Function
      End If
    Next i
    For i = 0 To 8
      If DefName = agEgoDir(i).Name Then
        ValidateDefName = 10
        Exit Function
      End If
    Next i
    For i = 0 To 4
      If DefName = agVideoMode(i).Name Then
        ValidateDefName = 10
        Exit Function
      End If
    Next i
    
    'check against other reserved defines
    If DefName = agResDef(4).Name Then
      ValidateDefName = 10
      Exit Function
    End If
    
    If DefName = agResDef(0).Name Then
      ValidateDefName = 11
      Exit Function
    End If
    If DefName = agResDef(5).Name Then
      ValidateDefName = 11
      Exit Function
    End If
    
    For i = 1 To 3
      If DefName = agResDef(i).Name Then
        ValidateDefName = 12
        Exit Function
      End If
    Next i
  End If
  
  'check name against improper character list
  For i = 1 To Len(DefName)
    Select Case AscW(Mid$(DefName, i))
    'control characters (1-31), space, and these characters: !"#$%&'()*+,-/:;<=>?@[\]^`{|}~
    Case 1 To 45, 47, 58 To 64, 91 To 94, 96, Is >= 123
      ValidateDefName = 13
      Exit Function
    End Select
  Next i
Exit Function

ErrHandler:
  'should never get an error
  Debug.Assert False
End Function

Public Function ValidateDefValue(TestDefine As TDefine) As Long
  'validates that TestDefine.Value is a valid define value
  '
  'returns 0 if successful
  '
  'returns an error code on failure:
  '1 = no value
  '2 = value is an invalid argument marker (not used anymore)
  '3 = value contains an invalid argument value
  '4 = value is not a string, number or argument marker
  '5 = value is already defined by a reserved name
  '6 = value is already defined by a global name
  
  Dim strVal As String
  Dim i As Long
  
  On Error GoTo ErrHandler
  
  If LenB(TestDefine.Value) = 0 Then
    ValidateDefValue = 1
    Exit Function
  End If
  
  'values must be a variable/flag/etc, string, or a number
  If Not IsNumeric(TestDefine.Value) Then
    'if value is an argument marker
    Select Case AscW(LCase$(TestDefine.Value))
    '     v    f    m    o    i    s    w    c
    Case 118, 102, 109, 111, 105, 115, 119, 99
      'if rest of value is numeric,
      strVal = Right$(TestDefine.Value, Len(TestDefine.Value) - 1)
      'if it is numeric
      If IsNumeric(strVal) Then
        'if value is not between 0-255
        If Val(strVal) < 0 Or Val(strVal) > 255 Then
          ValidateDefValue = 3
          Exit Function
        End If
        
        'verify that the value is not already assigned
        Select Case AscW(LCase$(TestDefine.Value))
        Case 118 'variable
          TestDefine.Type = atVar
          
          If agUseRes Then
            'if already defined as a reserved variable
            If Val(strVal) <= 26 Then
              ValidateDefValue = 5
              Exit Function
            End If
          End If
          
          'check defined globals
          For i = 0 To agGlobalCount - 1
            'if this define has same value
            If agGlobal(i).Value = TestDefine.Value Then
              ValidateDefValue = 6
              Exit Function
            End If
          Next i
          
        Case 102 'flag
          TestDefine.Type = atFlag
          
          If agUseRes Then
            'if already defined as a reserved flag
            If Val(strVal) <= 15 Then
              ValidateDefValue = 5
              Exit Function
            End If
          End If
          
          'check defined globals
          For i = 0 To agGlobalCount - 1
            'if this define has same value
            If agGlobal(i).Value = TestDefine.Value Then
              ValidateDefValue = 6
              Exit Function
            End If
          Next i
          
        Case 109 'message
          TestDefine.Type = atMsg
          
          'check defined globals
          For i = 0 To agGlobalCount - 1
            'if this define has same value
            If agGlobal(i).Value = TestDefine.Value Then
              ValidateDefValue = 6
              Exit Function
            End If
          Next i
          
        Case 111 'screen object
          TestDefine.Type = atSObj
          
          If agUseRes Then
            'can't be ego
            If TestDefine.Value = "o0" Then
              ValidateDefValue = 5
              Exit Function
            End If
          End If
          
          'check defined globals
          For i = 0 To agGlobalCount - 1
            'if this define has same value
            If agGlobal(i).Value = TestDefine.Value Then
              ValidateDefValue = 6
              Exit Function
            End If
          Next i
          
        Case 105 'inv object
          TestDefine.Type = atIObj
          
          'check defined globals
          For i = 0 To agGlobalCount - 1
            'if this define has same value
            If agGlobal(i).Value = TestDefine.Value Then
              ValidateDefValue = 6
              Exit Function
            End If
          Next i
          
        Case 115 'string
          TestDefine.Type = atStr
          
          'check defined globals
          For i = 0 To agGlobalCount - 1
            'if this define has same value
            If agGlobal(i).Value = TestDefine.Value Then
              ValidateDefValue = 6
              Exit Function
            End If
          Next i
          
        Case 119 'word
          TestDefine.Type = atWord
          
          'check defined globals
          For i = 0 To agGlobalCount - 1
            'if this define has same value
            If agGlobal(i).Value = TestDefine.Value Then
              ValidateDefValue = 6
              Exit Function
            End If
          Next i
          
        Case 99 'controller
          'controllers limited to 0-49
          If Val(strVal) < 0 Or Val(strVal) > 255 Then
            ValidateDefValue = 3
            Exit Function
          End If
          
          TestDefine.Type = atCtrl
          
          'check defined globals
          For i = 0 To agGlobalCount - 1
            'if this define has same value
            If agGlobal(i).Value = TestDefine.Value Then
              ValidateDefValue = 6
              Exit Function
            End If
          Next i
        End Select
        'value is ok
        Exit Function
      End If
    End Select
    
    'non-numeric, and most likely a string
    TestDefine.Type = atDefStr
    
    'check value for string delimiters in value
    If AscW(TestDefine.Value) <> 34 And AscW(Right$(TestDefine.Value, 1)) <> 34 Then
      ValidateDefValue = 4
    End If
  Else
  
    'must be numeric
    TestDefine.Type = atNum
  End If
  
Exit Function

ErrHandler:
  strError = Err.Description
  strErrSrc = Err.Source
  lngError = Err.Number
  
  On Error GoTo 0: Err.Raise vbObjectError + 660, strErrSrc, Replace(LoadResString(660), ARG1, CStr(lngError) & ":" & strError)
End Function

