VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AGIGame"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3E06727600AD"
'    WinAGI Game Engine
'    Copyright (C) 2005 - 2007 Andrew Korson
'
'    This program is free software; you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation; either version 2 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program; if not, write to the Free Software
'    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


'enums (have to put them in a class module so
'they will be visible throughout the project

Option Base 0
Option Explicit

Public Enum AGIResType
  rtLogic = 0
  rtPicture = 1
  rtSound = 2
  rtView = 3
  rtObjects = 4
  rtWords = 5
  rtLayout = 6
  rtMenu = 7
  rtGlobals = 8
  rtGame = 9
  rtText = 10
  rtNone = 255
End Enum

Public Enum AGIColors
  agBlack
  agBlue
  agGreen
  agCyan
  agRed
  agMagenta
  agBrown
  agLtGrey
  agDkGrey
  agLtBlue
  agLtGreen
  agLtCyan
  agLtRed
  agLtMagenta
  agYellow
  AGWHITE
  agNone
End Enum

Public Enum ObjDirection
  odStopped
  odUp
  odUpRight
  odRight
  odDownRight
  odDown
  odDownLeft
  odLeft
  odUpLeft
End Enum

Public Enum EPlotShape
  psCircle
  psRectangle
End Enum

Public Enum EPlotStyle
  psSolid
  psSplatter
End Enum
  
Public Enum DrawFunction
  dfEnableVis = &HF0    'Change picture colour and enable picture draw.
  dfDisableVis = &HF1   'Disable picture draw.
  dfEnablePri = &HF2    'Change priority colour and enable priority draw.
  dfDisablePri = &HF3   'Disable priority draw.
  dfYCorner = &HF4      'Draw a Y corner.
  dfXCorner = &HF5      'Draw an X corner.
  dfAbsLine = &HF6      'Absolute line (long lines).
  dfRelLine = &HF7      'Relative line (short lines).
  dfFill = &HF8         'Fill.
  dfChangePen = &HF9    'Change pen size and style.
  dfPlotPen = &HFA      'Plot with pen.
  dfEnd = &HFF          'end of drawing
End Enum

Public Enum LogicErrorLevel
  leHigh    'all compile/decompile problems are returned as errors
  leMedium  'only errors that prevent compilation/decompilation
            'are passed; warnings embedded in
            'source code on compilation
  leLow     'only errors that prevent compilation/decompiliation
            'are passed; no warnings are given
End Enum

Public Enum LogicSyntaxType
  lsUnknown = 0 'default
  lsVB
  lsAGI
End Enum

Public Enum ECStatus  'used to update editor as components are completed,
  csCompWords
  csCompObjects
  csAddResource
  csDoneAdding
  csCompileComplete
  csWarning
  csError
  csCanceled
End Enum

Public Enum SoundFormat
  sfUndefined
  sfAGI
  sfMIDI
  sfScript
End Enum

Public Type PenStatus
  VisColor As AGIColors
  PriColor As AGIColors
  PlotShape As EPlotShape
  PlotStyle As EPlotStyle
  PlotSize As Long
End Type

Public Type AGIWord
  WordText As String
  Group As Long
End Type

Public Type FreeSpaceInfo
  VOL As Byte
  Start As Long
  End As Long
End Type

'type used for defined names
Public Type TDefine
  Name As String
  Value As String
  Type As ArgTypeEnum
End Type

Private strErrSource As String


Public Sub CancelCompile()
  
  'if compiling
  If agCompGame Then
    'reset to force cancel
    agCompGame = False
    'set flag indicating cancellation
    agCancelComp = True
  End If
End Sub
Public Property Get Commands() As AGICommands

  Set Commands = agCmdCol
End Property

Public Property Let DefResDir(NewDir As String)

  'validate- cant have  \/:*?<>|
  
  NewDir = Trim$(NewDir)
  
  If LenB(NewDir) = 0 Then
    On Error GoTo 0: Err.Raise 380, strErrSource, "Invalid property value"
    Exit Property
  End If
  If InStrB(1, NewDir, "\") <> 0 Then
    On Error GoTo 0: Err.Raise 380, strErrSource, "Invalid property value"
    Exit Property
  End If
  If InStrB(1, NewDir, "/") <> 0 Then
    On Error GoTo 0: Err.Raise 380, strErrSource, "Invalid property value"
    Exit Property
  End If
  If InStrB(1, NewDir, ":") <> 0 Then
    On Error GoTo 0: Err.Raise 380, strErrSource, "Invalid property value"
    Exit Property
  End If
  If InStrB(1, NewDir, "*") <> 0 Then
    On Error GoTo 0: Err.Raise 380, strErrSource, "Invalid property value"
    Exit Property
  End If
  If InStrB(1, NewDir, "?") <> 0 Then
    On Error GoTo 0: Err.Raise 380, strErrSource, "Invalid property value"
    Exit Property
  End If
  If InStrB(1, NewDir, "<") <> 0 Then
    On Error GoTo 0: Err.Raise 380, strErrSource, "Invalid property value"
    Exit Property
  End If
  If InStrB(1, NewDir, ">") <> 0 Then
    On Error GoTo 0: Err.Raise 380, strErrSource, "Invalid property value"
    Exit Property
  End If
  If InStrB(1, NewDir, "|") <> 0 Then
    On Error GoTo 0: Err.Raise 380, strErrSource, "Invalid property value"
    Exit Property
  End If
  If InStrB(1, NewDir, " ") <> 0 Then
    On Error GoTo 0: Err.Raise 380, strErrSource, "Invalid property value"
    Exit Property
  End If
  
  'save new resdir name
  agDefResDir = NewDir
  
  SaveSetting sAPPNAME, "General", "DefResDir", agDefResDir
End Property

Public Property Get DefResDir() As String
  DefResDir = agDefResDir
End Property

Public Property Let EGAColor(ByVal Index As Integer, ByVal NewColor As Long)
  
  Dim bytRed As Byte, bytBlue As Byte, bytGreen As Byte
  
  'in API calls, colors are a four byte number:
  '         xxrrggbb
  '(perhaps because of way CopyMemory works?)
  '
  'in VB (and other languages?) colors are also four byte:
  '         xxbbggrr
  
  'validate index
  If Index < 0 Or Index > 15 Then
    On Error GoTo 0: Err.Raise 9, strErrSource, "Subscript out of range"
    Exit Property
  End If
  
  'store the new color
  lngEGACol(Index) = NewColor
  
  'now invert red and blue components for revcolor
  lngEGARevCol(Index) = (NewColor And &HFF000000) + (NewColor And &HFF) * &H10000 + (NewColor And &HFF00&) + (NewColor And &HFF0000) / &H10000
  

End Property

Public Property Get EGAColor(ByVal Index As Integer) As Long
  
  'in API calls, colors are a four byte number:
  '         xxrrggbb
  '(perhaps because of way CopyMemory works?)
  '
  'in VB (and other languages?) colors are also four byte:
  '         xxbbggrr
  
  'validate index
  If Index < 0 Or Index > 15 Then
    On Error GoTo 0: Err.Raise 9, strErrSource, "Subscript out of range"
    Exit Property
  End If
  
  EGAColor = lngEGACol(Index)
End Property

Public Property Get EGARevColor(ByVal Index As Integer) As Long

  'in API calls, colors are a four byte number:
  '         xxrrggbb
  '(perhaps because of way CopyMemory works?)
  '
  'in VB (and other languages?) colors are also four byte:
  '         xxbbggrr
  
  'validate index
  If Index < 0 Or Index > 15 Then
    On Error GoTo 0: Err.Raise 9, strErrSource, "Subscript out of range"
    Exit Property
  End If
  
  EGARevColor = lngEGARevCol(Index)
End Property


Public Property Let GameAbout(NewAbout As String)
  
  'limit to 4096 characters
  If Len(NewAbout) > 4096 Then
    agAbout = Left$(NewAbout, 4096)
  Else
    agAbout = NewAbout
  End If
  
  'force syntax to update
  agCurrentSyntax = lsUnknown
  
  'if a game is loaded,
  If agGameLoaded Then
    'write new property
    WriteProperty PC_GAMEABOUT, 0, 0, agAbout
  End If
End Property

Public Property Get GameAbout() As String
  
  'game about doesn't depend on game load status
  'just return what it is...
  GameAbout = agAbout
End Property

Public Property Let GameAuthor(NewAuthor As String)

  'limit author to 256 bytes
  If Len(NewAuthor) > 256 Then
    agAuthor = Left$(NewAuthor, 256)
  Else
    agAuthor = NewAuthor
  End If
  
  'if game loaded,
  If agGameLoaded Then
    'write property
    WriteProperty PC_GAMEAUTHOR, 0, 0, agAuthor
  End If
End Property


Public Property Get GameAuthor() As String
  
  'game about doesn't depend on game load status
  'just return what it is...
  GameAuthor = agAuthor
End Property

Public Property Let GameDescription(NewDescription As String)
  
  'comments limited to 4K
  If Len(NewDescription) > 4096 Then
    agDescription = Left$(NewDescription, 4096)
  Else
    agDescription = NewDescription
  End If
  
  'if a game is loaded
  If agGameLoaded Then
    'write new property
    WriteProperty PC_GAMEDESC, 0, 0, agDescription
  End If
End Property


Public Property Get GameDescription() As String
  
  'game about doesn't depend on game load status
  'just return what it is...
  GameDescription = agDescription
End Property

Public Property Let GameDir(NewDir As String)

  'changing directory is only allowed if a game
  'is loaded, but....
  '
  'changing gamedir directly may cause problems
  'because the game may not be able to find the
  'resource files it is looking for;
  'also, changing the gamedir directly does not
  'update the resource directory
  
  If agGameLoaded Then
    'validate gamedir
    If Not FileExists(cDir(NewDir), vbDirectory) Then
      'return error
      On Error GoTo 0: Err.Raise vbObjectError + 630, strErrSource, Replace(LoadResString(630), ARG1, NewDir)
      Exit Property
    End If
    
    agGameDir = cDir(NewDir)
  End If
End Property

Public Property Get GameEvents() As AGIGameEvents
  
  Set GameEvents = agGameEvents
End Property

Public Property Let GameExecutable(NewVal As String)
  
  'no validation required
  agGameExecutable = NewVal

  'if a game is loaded,
  If agGameLoaded Then
    'write new property
    WriteProperty PC_GAMEEXEC, 0, 0, agGameExecutable
  End If
End Property

Public Property Get GameExecutable() As String
  
  'return stored value
  GameExecutable = agGameExecutable
End Property

Public Property Get GameVersion() As String
  
  'game version doesn't depend on current load status;
  'just return what it is
  GameVersion = agGameVersion
End Property

Public Property Let GameVersion(NewVersion As String)
  
  'limit to 256 bytes
  If Len(NewVersion) > 256 Then
    agGameVersion = Left$(NewVersion, 256)
  Else
    agGameVersion = NewVersion
  End If
  
  'force syntax to update
  agCurrentSyntax = lsUnknown
  
  'if game loaded
  If agGameLoaded Then
    'write new property
    WriteProperty PC_GAMEVERSION, 0, 0, agGameVersion
  End If
End Property

Public Property Get GlobalDefines() As TDefine()

  Dim fso As FileSystemObject
  Dim strCRC As String
  
  On Error Resume Next
  'initialize global defines
  Set fso = New FileSystemObject
  'get datemodified property
  strCRC = CStr(fso.GetFile(agGameDir & "globals.txt").DateLastModified)
  Set fso = Nothing
  If CRC32(StrConv(strCRC, vbFromUnicode)) <> agGlobalCRC Then
    GetGlobalDefines
  End If
  
  GlobalDefines = agGlobal()
End Property

Public Property Get InterpreterVersion() As Single
  
  'if a game is loaded
  If agGameLoaded Then
    InterpreterVersion = agIntVersion
  Else
    'if no version yet
    If agIntVersion = 0 Then
'      'use 2.917
'      agIntVersion = 2.917
      InterpreterVersion = 2.917
    End If
'    InterpreterVersion = agIntVersion
  End If
End Property

Public Sub CloseGame()
  
  On Error GoTo ErrHandler
  
  'if no game is currently loaded
  If Not agGameLoaded Then
    'don't do anything
    Exit Sub
  End If
  
  'unload and remove all resources
  agViews.Clear
  agLogs.Clear
  agPics.Clear
  agSnds.Clear
  If agInvObj.Loaded Then
    agInvObj.Unload
  End If
  agInvObj.InGame = False
  If agVocabWords.Loaded Then
    agVocabWords.Unload
  End If
  agVocabWords.InGame = False
  
  On Error Resume Next
  'write default syntax
  WriteProperty PC_DEFSYNTAX, 0, 0, CStr(agMainLogSettings.DefaultSyntax)
  
  'write colors for palette
  WriteProperty PC_PALETTE, 0, 0, PaletteToString()
  RestoreDefaultColors
  
  'write useresname property
  WriteProperty PC_USERESNAMES, 0, 0, agUseRes
  
  'write lastdate of editing
  WriteProperty PC_GAMELAST, 0, 0, agLastDate
  
  'then clear it
  agLastDate = 0
  
  'clear out other properties
  agIntVersion = 0
  agIsVersion3 = False
  agDirExpanded = False
  agDescription = vbNullString
  agGameID = vbNullString
  agAuthor = vbNullString
  agGameVersion = vbNullString
  agAbout = vbNullString
  agResDirName = vbNullString
  agGameExecutable = vbNullString
  agGameFile = vbNullString
  
  'clear flag
  agGameLoaded = False
  
  'reset global CRC
  agGlobalCRC = 0
  
  'finally, reset directories
  agGameDir = cDir(CurDir$())
  agResDir = cDir(CurDir$())
Exit Sub

ErrHandler:
  strError = Err.Description
  strErrSrc = Err.Source
  lngError = Err.Number
  
  On Error GoTo 0: Err.Raise vbObjectError + 644, strErrSrc, Replace(LoadResString(644), ARG1, CStr(lngError) & ":" & strError)
End Sub

Public Sub CompileGame(ByVal RebuildOnly As Boolean, Optional ByVal NewGameDir As String)
  'compiles the game into NewGameDir
  '
  'if RebuildOnly is true, the VOL files are
  'rebuilt without recompiling all logics
  'and WORDS.TOK and OBJECT are not recompiled
  '
  'WARNING: if NewGameDir is same as current directory
  'this WILL overwrite current game files
  '

  Dim tmpLogic As AGILogic, tmpPicture As AGIPicture
  Dim tmpView As AGIView, tmpSound As AGISound
  Dim CurResType As AGIResType, CurResNum As Byte
  Dim tmpLoaded As Boolean, tmpSourceLoaded As Boolean
  Dim DirByte(0 To 2) As Byte, strID As String
  Dim i As Long, blnReplace As Boolean
  Dim intTmpDir As Integer, lngOffset As Long
  Dim NewIsV3 As Boolean


  On Error Resume Next
  
  'only loaded games can be compiled
  If Not agGameLoaded Then
    Exit Sub
  End If

  'set compiling flag
  agCompGame = True
  'reset cancel flag
  agCancelComp = False

  'if no directory passed,
  If LenB(NewGameDir) = 0 Then
    NewGameDir = agGameDir
  End If

  'validate new directory
  NewGameDir = cDir(NewGameDir)
  If LenB(Dir(NewGameDir, vbDirectory)) = 0 Then
    'this isn't a directory
    CompleteCancel True
    On Error GoTo 0: Err.Raise vbObjectError + 561, Replace(LoadResString(561), ARG1, NewGameDir)
    Exit Sub
  End If

  'set flag if game is being compiled in its current directory
  blnReplace = LCase$(NewGameDir) = LCase$(agGameDir)

  'save compile dir so rebuild method can access it
  agCompileDir = NewGameDir

  'set new game version
  If agChangeVersion Then
    NewIsV3 = Not agIsVersion3
  Else
    NewIsV3 = agIsVersion3
  End If

  'ensure switch flag is reset
  agChangeVersion = False

  'if version 3
  If NewIsV3 Then
    'version 3 ids limited to 5 characters
    If Len(agGameID) > 5 Then
      'truncate it
      strID = Left$(agGameID, 5)
      
      'rename wag and wal files
      On Error Resume Next
      Name agGameDir & agGameID & ".wag" As agGameDir & strID & ".wag"
      Name agGameDir & agGameID & ".wal" As agGameDir & strID & ".wal"
      'update agGameFile
      agGameFile = agGameDir & strID & ".wag"
      agGameID = strID
      
      'and save it
      WriteProperty PC_GAMEID, 0, 0, agGameID
    End If
    strID = agGameID
  Else
    strID = vbNullString
  End If

  'if not rebuildonly
  If Not RebuildOnly Then
    'set status
    agGameEvents.RaiseEvent_CompileStatus csCompWords, 0, 0, vbNullString
    'check for cancellation
    If Not agCompGame Then
      CompleteCancel
      Exit Sub
    End If

    'compile WORDS.TOK if dirty
    If agVocabWords.IsDirty Then
      agVocabWords.Save
    End If
    If Err.Number <> 0 Then
      'note it
      agGameEvents.RaiseEvent_CompileStatus csError, 0, 0, "Error during compilation of WORDS.TOK (" & Err.Description & ")"
      Err.Clear
      'check for cancellation
      If Not agCompGame Then
        CompleteCancel
        Exit Sub
      End If
    End If

    'if compiling to a different directory
    If Not blnReplace Then
      Kill NewGameDir & "WORDS.OLD"
      Name NewGameDir & "WORDS.TOK" As NewGameDir & "WORDS.OLD"
      'copy into new directory
      FileCopy agVocabWords.ResFile, NewGameDir & "WORDS.TOK"
    End If

    'clear errors
    Err.Clear

    'set status
    agGameEvents.RaiseEvent_CompileStatus csCompObjects, 0, 0, vbNullString
    'check for cancellation
    If Not agCompGame Then
      CompleteCancel
      Exit Sub
    End If

    'compile OBJECT file if dirty
    If agInvObj.IsDirty Then
      agInvObj.Save
    End If
    If Err.Number <> 0 Then
      'note it
      agGameEvents.RaiseEvent_CompileStatus csError, 0, 0, "Error during compilation of OBJECT (" & Err.Description & ")"
      'check for cancellation
      If Not agCompGame Then
        CompleteCancel
        Exit Sub
      End If
      Err.Clear
    End If

    'if compiling to a different directory
    If Not blnReplace Then
      Kill NewGameDir & "OBJECT.OLD"
      Name NewGameDir & "OBJECT" As NewGameDir & "OBJECT.OLD"
      'copy into new directory
      FileCopy agInvObj.ResFile, NewGameDir & "OBJECT"
    End If
  End If

  'ensure error object is cleared
  Err.Clear

  'reset game compiler variables
  lngCurrentVol = 0
  lngCurrentLoc = 0
  strNewDir = NewGameDir

  'create temp dir files
  If NewIsV3 Then
    'ensure temp dir file does not already exist
    Kill NewGameDir & agGameID & "DIR.NEW"
    If Err.Number <> 0 And Err.Number <> 53 Then
      strError = Err.Number
      strError = Err.Description
      strErrSrc = Err.Source
      lngError = Err.Number
      CompleteCancel True
      
      On Error GoTo 0: Err.Raise vbObjectError + 503, strErrSrc, Replace(LoadResString(503), ARG1, CStr(lngError) & ":" & strError)
      Exit Sub
    End If
    Err.Clear
    
    'open temp dir file
    intDirFile = FreeFile()
    Open NewGameDir & agGameID & "DIR.NEW" For Binary As intDirFile
    If Err.Number <> 0 Then
      strError = Err.Number
      strError = Err.Description
      strErrSrc = Err.Source
      lngError = Err.Number
      CompleteCancel True
      
      On Error GoTo 0: Err.Raise vbObjectError + 503, strErrSrc, Replace(LoadResString(503), ARG1, CStr(lngError) & ":" & strError)
      Exit Sub
    End If
    
    'add header (sets offsets to 8, 768+8, etc)
    Put intDirFile, 1, CLng(&H3080008)
    Put intDirFile, , CLng(&H9080608)
    'add data
    Put intDirFile, , String$(3072, &HFF)
  Else
    GetNextDir NewGameDir & "LOGDIR.NEW"
  End If
  
  'ensure temp vol files are removed
  Kill NewGameDir & "NEW_VOL.*"
  Err.Clear

  'open first new vol file
  intVolFile = FreeFile()
  Open NewGameDir & "NEW_VOL.0" For Binary As intVolFile
  If Err.Number <> 0 Then
    strError = Err.Number
    strError = Err.Description
    strErrSrc = Err.Source
    lngError = Err.Number
    CompleteCancel True
    
    On Error GoTo 0: Err.Raise vbObjectError + 503, strErrSrc, Replace(LoadResString(503), ARG1, CStr(lngError) & ":" & strError)
    Exit Sub
  End If

  'add all logic resources
  CompileResCol agLogs, rtLogic, RebuildOnly, NewIsV3
  'pass along any errors
  If Err.Number <> 0 Then
    lngError = Err.Number
    strError = Err.Description
    CompleteCancel True
    On Error GoTo 0: Err.Raise lngError, strErrSource, strError
    Exit Sub
  End If
  'check for cancellation
  If Not agCompGame Then
    Exit Sub
  End If

 If Not NewIsV3 Then
    'open picdir
    GetNextDir NewGameDir & "PICDIR.NEW"
    'pass along any errors
    If Err.Number <> 0 Then
      lngError = Err.Number
      strError = Err.Description
      CompleteCancel True
      On Error GoTo 0: Err.Raise lngError, strErrSource, strError
      Exit Sub
    End If
  End If

  'add picture resources
  CompileResCol agPics, rtPicture, RebuildOnly, NewIsV3
  'pass along any errors
  If Err.Number <> 0 Then
    lngError = Err.Number
    strError = Err.Description
    CompleteCancel True
    On Error GoTo 0: Err.Raise lngError, strErrSource, strError
    Exit Sub
  End If
  'check for cancellation
  If Not agCompGame Then
    Exit Sub
  End If

  If Not NewIsV3 Then
    'open viewdir
    GetNextDir NewGameDir & "VIEWDIR.NEW"
    'pass along any errors
    If Err.Number <> 0 Then
      lngError = Err.Number
      strError = Err.Description
      CompleteCancel True
      On Error GoTo 0: Err.Raise lngError, strErrSource, strError
      Exit Sub
    End If
  End If

  'add view resources
  CompileResCol agViews, rtView, RebuildOnly, NewIsV3
  'pass along any errors
  If Err.Number <> 0 Then
    lngError = Err.Number
    strError = Err.Description
    CompleteCancel True
    On Error GoTo 0: Err.Raise lngError, strErrSource, strError
    Exit Sub
  End If
  'check for cancellation
  If Not agCompGame Then
    Exit Sub
  End If

  If Not NewIsV3 Then
    'open snddir
    GetNextDir NewGameDir & "SNDDIR.NEW"
    'pass along any errors
    If Err.Number <> 0 Then
      lngError = Err.Number
      strError = Err.Description
      CompleteCancel True
      On Error GoTo 0: Err.Raise lngError, strErrSource, strError
      Exit Sub
    End If
  End If

  'add sound resources
  CompileResCol agSnds, rtSound, RebuildOnly, NewIsV3
  'pass along any errors
  If Err.Number <> 0 Then
    lngError = Err.Number
    strError = Err.Description
    CompleteCancel True
    On Error GoTo 0: Err.Raise lngError, strErrSource, strError
    Exit Sub
  End If
  'check for cancellation
  If Not agCompGame Then
    Exit Sub
  End If

  'close files
  Close intDirFile
  Close intVolFile

  'update status
  agGameEvents.RaiseEvent_CompileStatus csDoneAdding, 0, 0, vbNullString
  'check for cancellation
  If Not agCompGame Then
    CompleteCancel
    Exit Sub
  End If

  'remove any existing old dirfiles
  Kill NewGameDir & agGameID & "DIR.OLD"
  Kill NewGameDir & "LOGDIR.OLD"
  Kill NewGameDir & "PICDIR.OLD"
  Kill NewGameDir & "SNDDIR.OLD"
  Kill NewGameDir & "VIEWDIR.OLD"
  
  'remove any existing old vol files
  For i = 0 To 15
    Kill NewGameDir & "VOL." & CStr(i) & ".OLD"
    Kill NewGameDir & agGameID & "VOL." & CStr(i) & ".OLD"
  Next i
  Err.Clear
  
  'rename existing dir and vol files as .OLD
  Name NewGameDir & agGameID & "DIR" As NewGameDir & agGameID & "DIR.OLD"
  Name NewGameDir & "LOGDIR" As NewGameDir & "LOGDIR.OLD"
  Name NewGameDir & "PICDIR" As NewGameDir & "PICDIR.OLD"
  Name NewGameDir & "VIEWDIR" As NewGameDir & "VIEWDIR.OLD"
  Name NewGameDir & "SNDDIR" As NewGameDir & "SNDDIR.OLD"
  For i = 0 To 15
    'rename current vol files
    Name NewGameDir & strID & "VOL." & CStr(i) As NewGameDir & "VOL." & CStr(i) & ".OLD"
    Name NewGameDir & "VOL." & CStr(i) As NewGameDir & "VOL." & CStr(i) & ".OLD"
  Next i
  Err.Clear
  
  If NewIsV3 Then
    'rename temp dir file
    Name NewGameDir & agGameID & "DIR.NEW" As NewGameDir & agGameID & "DIR"
  Else
    'rename temp dir files
    Name NewGameDir & "LOGDIR.NEW" As NewGameDir & "LOGDIR"
    Name NewGameDir & "PICDIR.NEW" As NewGameDir & "PICDIR"
    Name NewGameDir & "VIEWDIR.NEW" As NewGameDir & "VIEWDIR"
    Name NewGameDir & "SNDDIR.NEW" As NewGameDir & "SNDDIR"
  End If

  Err.Clear
  For i = 0 To lngCurrentVol
    Name NewGameDir & "NEW_VOL." & CStr(i) As NewGameDir & strID & "VOL." & CStr(i)
  Next i

  'update status to indicate complete
  agGameEvents.RaiseEvent_CompileStatus csCompileComplete, 0, 0, vbNullString

  'ensure errors cleared
  Err.Clear

  'if replacing
  If blnReplace Then
    'update all resources with correct vol and loc positions
    If NewIsV3 Then
      'open new dir file
      intTmpDir = FreeFile()
      Open NewGameDir & agGameID & "DIR" For Binary As intTmpDir

      'step through logics
      For Each tmpLogic In agLogs
        'extract directory info
        Get intTmpDir, tmpLogic.Number * 3 + 9, DirByte 'offet is 8; add one because get is '1' based
        'extract volume and loc
        tmpLogic.Resource.Volume = DirByte(0) \ &H10
        tmpLogic.Resource.Loc = (DirByte(0) And &HF) * &H10000 + DirByte(1) * &H100& + DirByte(2)
      Next
      'step through pictures
      For Each tmpPicture In agPics
        'extract directory info
        Get intTmpDir, tmpPicture.Number * 3 + &H309, DirByte 'offet is &H308; add one because get is '1' based
        'extract volume and loc
        tmpPicture.Resource.Volume = DirByte(0) \ &H10
        tmpPicture.Resource.Loc = (DirByte(0) And &HF) * &H10000 + DirByte(1) * &H100& + DirByte(2)
      Next
      'step through sounds
      For Each tmpSound In agSnds
        'extract directory info
        Get intTmpDir, tmpSound.Number * 3 + &H909, DirByte 'offet is &H908; add one because get is '1' based
        'extract volume and loc
        tmpSound.Resource.Volume = DirByte(0) \ &H10
        tmpSound.Resource.Loc = (DirByte(0) And &HF) * &H10000 + DirByte(1) * &H100& + DirByte(2)
      Next
      'step through views
      For Each tmpView In agViews
        'extract directory info
        Get intTmpDir, tmpView.Number * 3 + &H609, DirByte 'offet is 8; add one because get is '1' based
        'extract volume and loc
        tmpView.Resource.Volume = DirByte(0) \ &H10
        tmpView.Resource.Loc = (DirByte(0) And &HF) * &H10000 + DirByte(1) * &H100& + DirByte(2)
      Next

      Close intTmpDir
    Else
      'open new logdir file
      intTmpDir = FreeFile()
      Open NewGameDir & "LOGDIR" For Binary As intTmpDir

      'step through logics
      For Each tmpLogic In agLogs
        'extract directory info
        Get intTmpDir, tmpLogic.Number * 3 + 1, DirByte
        'extract volume and loc
        tmpLogic.Resource.Volume = DirByte(0) \ &H10
        tmpLogic.Resource.Loc = (DirByte(0) And &HF) * &H10000 + DirByte(1) * &H100& + DirByte(2)
      Next
      'close logdir
      Close intTmpDir

      'open picdir
      intTmpDir = FreeFile()
      Open NewGameDir & "PICDIR" For Binary As intTmpDir
      'step through pictures
      For Each tmpPicture In agPics
        'extract directory info
        Get intTmpDir, tmpPicture.Number * 3 + 1, DirByte
        'extract volume and loc
        tmpPicture.Resource.Volume = DirByte(0) \ &H10
        tmpPicture.Resource.Loc = (DirByte(0) And &HF) * &H10000 + DirByte(1) * &H100& + DirByte(2)
      Next
      'close picdir
      Close intTmpDir

      'open snddir
      intTmpDir = FreeFile()
      Open NewGameDir & "SNDDIR" For Binary As intTmpDir
      'step through sounds
      For Each tmpSound In agSnds
        'extract directory info
        Get intTmpDir, tmpSound.Number * 3 + 1, DirByte
        'extract volume and loc
        tmpSound.Resource.Volume = DirByte(0) \ &H10
        tmpSound.Resource.Loc = (DirByte(0) And &HF) * &H10000 + DirByte(1) * &H100& + DirByte(2)
      Next
      'close snddir
      Close intTmpDir

      'open viewdir
      intTmpDir = FreeFile()
      Open NewGameDir & "VIEWDIR" For Binary As intTmpDir
      'step through views
      For Each tmpView In agViews
        'extract directory info
        Get intTmpDir, tmpView.Number * 3 + 1, DirByte
        'extract volume and loc
        tmpView.Resource.Volume = DirByte(0) \ &H10
        tmpView.Resource.Loc = (DirByte(0) And &HF) * &H10000 + DirByte(1) * &H100& + DirByte(2)
      Next
      'close viewdir
      Close intTmpDir
    End If
  End If

  'ensure error object is cleared
  Err.Clear

  'reset compiling flag
  agCompGame = False
End Sub


Public Property Let GameID(NewID As String)
  'limit gameID to 6 characters for v2 games and 5 characters for v3 games
  
  Dim strVolFile As String
  Dim strExtension() As String
  
  On Error GoTo ErrHandler
  
  'id is undefined if a game is not loaded
  If Not agGameLoaded Then
    On Error GoTo 0: Err.Raise vbObjectError + 682, strErrSource, LoadResString(682)
    Exit Property
  End If
  
  'version 3 games limited to 5 characters
  If agIsVersion3 Then
    If Len(NewID) > 5 Then
      NewID = Left$(NewID, 5)
    End If
  Else
    If Len(NewID) > 7 Then
      NewID = Left$(NewID, 6)
    End If
  End If
  
  'if no change
  If agGameID = NewID Then
    Exit Property
  End If
  
  'if version 3
  If agIsVersion3 Then
    'need to rename the dir file
    Name agGameDir & agGameID & "DIR" As agGameDir & NewID & "DIR"
    'and vol files
    strVolFile = Dir(agGameDir & agGameID & "VOL.*")
    
    Do Until LenB(strVolFile) = 0
      'get extension
      strExtension = Split(strVolFile, ".")
      'rename
      Name agGameDir & strVolFile As agGameDir & NewID & "VOL." & strExtension(1)
      'get next
      strVolFile = Dir()
    Loop
  End If
  
  'write new property
  WriteProperty PC_GAMEID, 0, 0, NewID
  
  'set new id
  agGameID = UCase$(NewID)
  
  'rename game property file
  On Error Resume Next
  Name agGameFile As agGameDir & NewID & ".wag"
  Err.Clear
  agGameFile = agGameDir & agGameID & ".wag"
Exit Property

ErrHandler:
  'file renaming or property writing are only sources of error
  strError = Err.Description
  strErrSrc = Err.Source
  lngError = Err.Number
  
  On Error GoTo 0: Err.Raise vbObjectError + 530, strErrSrc, Replace(LoadResString(530), ARG1, CStr(lngError) & ":" & strError)
End Property
Public Property Get GameID() As String
    
  'id is undefined if a game is not loaded
  If Not agGameLoaded Then
    On Error GoTo 0: Err.Raise vbObjectError + 677, strErrSource, LoadResString(677)
    Exit Property
  End If
  
  GameID = agGameID
End Property


Public Property Get GameLoaded() As Boolean
  
  'returns state of game load
  GameLoaded = agGameLoaded
End Property


Public Property Get LastDate() As Date
  
  'if game loaded,
  If agGameLoaded Then
    LastDate = agLastDate
  Else
    LastDate = Now()
  End If
End Property


Public Property Set LogicSourceSettings(NewLogSettings As AGILogicSourceSettings)

  Set agMainLogSettings = NewLogSettings
End Property

Public Property Get LogicSourceSettings() As AGILogicSourceSettings
  
  Set LogicSourceSettings = agMainLogSettings
End Property


Public Property Get MaxVol0Size() As Long
  
  MaxVol0Size = agMaxVol0
End Property

Public Property Let MaxVol0Size(ByVal NewSize As Long)
  
  'validate
  If NewSize < 32768 Then
    NewSize = 32768
  ElseIf NewSize > agMaxVolSize Then
    NewSize = agMaxVolSize
  End If
  
  agMaxVol0 = NewSize
End Property

Private Function PaletteToString() As String

  'convert the palette into a string so it can be saved as a property
  Dim i As Long
  Dim byte1 As Byte, byte2 As Byte
  Dim byte3 As Byte, byte4 As Byte
  
  On Error GoTo ErrHandler
  
  For i = 0 To 15
    'extract the four byte values
    byte1 = lngEGACol(i) \ &H1000000
    byte2 = (lngEGACol(i) And &HFF0000) \ &H10000
    byte3 = (lngEGACol(i) And &HFF00&) \ &H100&
    byte4 = (lngEGACol(i) And &HFF)
    
    PaletteToString = PaletteToString & Chr$(byte1) & Chr$(byte2) & Chr$(byte3) & Chr$(byte4)
  Next i
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function

Public Property Get Pictures() As AGIPictures
    
  Set Pictures = agPics
End Property





Public Property Let InterpreterVersion(NewVersion As Single)
  'attempts to set version to new value
  Dim i As Long
  Dim OldVersion As Single
  On Error Resume Next
  
  'validate new version
  Select Case ValidateVersion(NewVersion)
  Case -1
    'not a version 2 or 3 game
    On Error GoTo 0: Err.Raise vbObjectError + 597, strErrSource, LoadResString(597)
    Exit Property
  Case -2
    'unsupported version 2 or 3 game
    On Error GoTo 0: Err.Raise vbObjectError + 543, strErrSource, Replace(LoadResString(543), ARG1, CStr(NewVersion))
    Exit Property
  Case Else
  
    'if in a game, need to adjust resources
    'if necessary
    If agGameLoaded Then
      'if new version and old version are not same major version:
      If (NewVersion > 3 And agIntVersion < 3) Or (NewVersion < 3 And agIntVersion > 3) Then
        'set flag to switch version on rebuild
        agChangeVersion = True
        
        'use compiler to rebuild new vol and dir files
        '(it is up to calling program to deal with dirty and invalid resources)
        CompileGame True
        
        'check for errors, or cancellation
        If Err.Number <> 0 Then
          strError = Err.Description
          strErrSrc = Err.Source
          lngError = Err.Number
          
          'reset cancel flag
          agCancelComp = False
          'pass along the error
          On Error GoTo 0: Err.Raise vbObjectError + 641, strErrSrc, Replace(LoadResString(641), ARG1, CStr(lngError) & ":" & strError)
          Exit Property
        
        'if canceled,
        ElseIf agCancelComp Then
          'reset cancel flag
          agCancelComp = False
          Exit Property
        End If
      End If
      Err.Clear
      
      'write new version to file
      WriteProperty PC_INTVERSION, 0, 0, CStr(NewVersion)
    End If
    
    'set new version
    agIntVersion = NewVersion
    'set v3 flag
    agIsVersion3 = (agIntVersion > 3)
    
    'adjust commands
    CorrectCommands agIntVersion
  End Select
End Property
Public Property Get ResDir() As String
  
  'if a game is loaded,
  If agGameLoaded Then
    'use resdir property
    ResDir = agResDir
  Else
    'use current directory
    ResDir = cDir(CurDir$())
  End If
End Property


Public Property Get ResDirName() As String

  ResDirName = agResDirName
End Property
Public Property Let ResDirName(NewResDirName As String)

  'validate- cant have  \/:*?<>|
  
  NewResDirName = Trim$(NewResDirName)
  
  If LenB(NewResDirName) = 0 Then
    On Error GoTo 0: Err.Raise 380, strErrSource, "Invalid property value"
    Exit Property
  End If
  If InStrB(1, NewResDirName, "\") <> 0 Then
    On Error GoTo 0: Err.Raise 380, strErrSource, "Invalid property value"
    Exit Property
  End If
  If InStrB(1, NewResDirName, "/") <> 0 Then
    On Error GoTo 0: Err.Raise 380, strErrSource, "Invalid property value"
    Exit Property
  End If
  If InStrB(1, NewResDirName, ":") <> 0 Then
    On Error GoTo 0: Err.Raise 380, strErrSource, "Invalid property value"
    Exit Property
  End If
  If InStrB(1, NewResDirName, "*") <> 0 Then
    On Error GoTo 0: Err.Raise 380, strErrSource, "Invalid property value"
    Exit Property
  End If
  If InStrB(1, NewResDirName, "?") <> 0 Then
    On Error GoTo 0: Err.Raise 380, strErrSource, "Invalid property value"
    Exit Property
  End If
  If InStrB(1, NewResDirName, "<") <> 0 Then
    On Error GoTo 0: Err.Raise 380, strErrSource, "Invalid property value"
    Exit Property
  End If
  If InStrB(1, NewResDirName, ">") <> 0 Then
    On Error GoTo 0: Err.Raise 380, strErrSource, "Invalid property value"
    Exit Property
  End If
  If InStrB(1, NewResDirName, "|") <> 0 Then
    On Error GoTo 0: Err.Raise 380, strErrSource, "Invalid property value"
    Exit Property
  End If
  If InStrB(1, NewResDirName, " ") <> 0 Then
    On Error GoTo 0: Err.Raise 380, strErrSource, "Invalid property value"
    Exit Property
  End If
  
  'save new resdir name
  agResDirName = NewResDirName
  'update the actual resdir
  agResDir = agGameDir & agResDirName & "\"
  
  'save resdirname
  WriteProperty PC_RESDIR, 0, 0, NewResDirName
End Property


'FIXIT: Declare 'ResTypeName' with an early-bound data type                                FixIT90210ae-R1672-R1B8ZE
Public Property Get ResTypeName(ByVal ResType As AGIResType)
  
  'returns the resource name
  ResTypeName = agResTypeName(ResType)
End Property

Public Property Let TemplateDir(NewDir As String)

  'validate gamedir
  If Not FileExists(cDir(NewDir), vbDirectory) Then
    'return error
    On Error GoTo 0: Err.Raise vbObjectError + 630, strErrSource, Replace(LoadResString(630), ARG1, NewDir)
    Exit Property
  End If
  
  agTemplateDir = cDir(NewDir)
End Property

Public Property Get TemplateDir() As String
  
  TemplateDir = agTemplateDir
End Property


Public Property Get TestCommands() As AGITestCommands
  
  Set TestCommands = agTestCmdCol
End Property


Public Property Get Views() As AGIViews
    
  Set Views = agViews
End Property




Public Property Get Sounds() As AGISounds
    
  Set Sounds = agSnds
End Property





Public Property Get Logics() As AGILogics
    
  Set Logics = agLogs
End Property





Public Property Get GameDir() As String
  
  'if a game is loaded,
  If agGameLoaded Then
    'use resdir property
    GameDir = agGameDir
  Else
    'use current directory
    GameDir = cDir(CurDir$())
  End If
End Property
Public Property Get InventoryObjects() As AGIInventoryObjects
  'if nothing,
  If agInvObj Is Nothing Then
    Set InventoryObjects = Nothing
  Else
    Set InventoryObjects = agInvObj
  End If
End Property


Public Sub LoadGame(GameDir As String)
  'opens a WinAGI game file or a Sierra game directory
  'depending on format
  'returns true if no errors encountered
  'returns false if errors occurred
  
  Dim blnWarnings As Boolean
  Dim lngError As Long
  Dim fso As FileSystemObject
  Dim fldGame As Folder, fldRes As Folder
  
  On Error Resume Next
  
  'if a game is already open,
  If agGameLoaded Then
    'can't open a game if one is already open
    On Error GoTo 0: Err.Raise vbObjectError + 501, strErrSource, LoadResString(501)
    Exit Sub
  End If
  
  'set game directory
  agGameDir = cDir(GameDir)
  
  'look for a WinAGI property file
  agGameFile = Dir(agGameDir & "*.wag")
  'if a file was found
  If LenB(agGameFile) <> 0 Then
    'verify no other *.wag files
    If Dir() = vbNullString Then
      'add path
      agGameFile = agGameDir & agGameFile
      'get id from propfile
      agGameID = UCase$(ReadProperty(PC_GAMEID, 0, 0))
      If Err.Number = vbObjectError + 622 Then
        'invalid game file
      End If
      
      'get interpreter version from propfile
      agIntVersion = CSng(ReadProperty(PC_INTVERSION, 0, 0))
    Else
      'clear variables
      agGameDir = vbNullString
      'raise error
      On Error GoTo 0: Err.Raise vbObjectError + 508, strErrSource, LoadResString(508)
      Exit Sub
    End If
  End If
  
  'if no id
  If LenB(agGameID) = 0 Then
    'if this game is not a sierra AGI game
    '(which sets version 3 status flag)
    If Not IsSierraGameDir(agGameDir) Then
      'save dir as error string
      strError = agGameDir
      'clear game variables
      agGameDir = vbNullString
      agGameFile = vbNullString
      agGameID = vbNullString
      agIntVersion = 0
      agIsVersion3 = False
      'invalid game directory
      On Error GoTo 0
      On Error GoTo 0: Err.Raise vbObjectError + 541, strErrSource, Replace(LoadResString(541), ARG1, strError)
      Exit Sub
    End If
    'build default propfile name
    agGameFile = agGameDir & agGameID & ".wag"
  End If
  
  'if no version
  If agIntVersion = 0 Then
    'get version number (and set IsVersion3 flag)
    agIntVersion = GetIntVersion()
  End If
  
  'if not validated
  If agIntVersion < 0 Then
    'save version as error string
    strError = agIntVersion
    'clear game variables
    agGameDir = vbNullString
    agGameFile = vbNullString
    agGameID = vbNullString
    agIntVersion = 0
    agIsVersion3 = False
    'if invalid number found
    If agIntVersion = -1 Then
      'other invalid version number was found
      On Error GoTo 0: Err.Raise vbObjectError + 597, strErrSource, LoadResString(597)
    'if an unsupported version found
    Else 'If agIntVersion = -2 Then
      'a version 2 or 3 game was found that is not on list
      On Error GoTo 0: Err.Raise vbObjectError + 543, strErrSource, Replace(LoadResString(543), ARG1, strError)
    End If
    Exit Sub
  End If
  
  'set v3 flag
  agIsVersion3 = (agIntVersion > 3)

  'load resources
  blnWarnings = LoadResources()
  'if there was an error
  If Err.Number <> 0 Then
    'can't continue
    GoTo ErrHandler
  End If
  
  'load vocabulary word list
  Set agVocabWords = New AGIWordList
  agVocabWords.Init
  agVocabWords.Load agGameDir & "WORDS.TOK"
  'if there was an error,
  If Err.Number <> 0 Then
    'note the problem in the error log as a warning
    RecordLogEvent 1, "An error occurred while loading WORDS.TOK: " & Err.Description
    'reset warning flag
    blnWarnings = True
  End If
  
  'load inventory objects list
  Set agInvObj = New AGIInventoryObjects
  agInvObj.Init
  agInvObj.Load agGameDir & "OBJECT"
  'if there was an error,
  If Err.Number <> 0 Then
    'note the problem in the error log as a warning
    RecordLogEvent 1, "An error occurred while loading OBJECT: " & Err.Description
    'reset warning flag
    blnWarnings = True
  End If
  
  'assign commands
  AssignCommands
  'and adust commands based on AGI version
  CorrectCommands agIntVersion

  'clear other game properties
  agLastDate = 0
  agAuthor = vbNullString
  agDescription = vbNullString
  agGameVersion = vbNullString
  agAbout = vbNullString
  agGameExecutable = vbNullString
  
  'check for property file
  GetGameProperties
  
  'if errors
  If Err.Number <> 0 Then
    'record event
    RecordLogEvent 0, "Error while loading WAG file; some properties not loaded. (Error number: " & CStr(Err.Number) & ")"
    Err.Clear
    blnWarnings = True
  End If
  
  'force id reset
  blnSetIDs = False
  

  'we've established that the game can be opened
  'so set the loaded flag now
  agGameLoaded = True
  
  'if no resdir
  If LenB(agResDirName) = 0 Then
    'look for an existing directory
    Set fso = New FileSystemObject
    Set fldGame = fso.GetFolder(agGameDir)
    
    'is there only one subfolder?
    If fldGame.SubFolders.Count = 1 Then
      'assume it is resource directory
      For Each fldRes In fldGame.SubFolders
        ResDirName = fldRes.Name
      Next
    Else
      'either no subfolders, or more than one
      'so use default
      ResDirName = agDefResDir
    End If
    Set fldGame = Nothing
    Set fso = Nothing
  End If
  
  'ensure resource directory exists
  If Not FileExists(agGameDir & agResDirName, vbDirectory) Then
    MkDir agGameDir & agResDirName
    'if can't create the resources directory
    If Err.Number <> 0 Then
      'note the problem in the error log as a warning
      RecordLogEvent 0, "Can't create " & agResDir
      'use game directory
      agResDir = agGameDir
      'set warning
      blnWarnings = True
    End If
  End If
  
  'set current syntax to unknown so compiler will setup properly
  agCurrentSyntax = lsUnknown
  
  'if errors
  If blnWarnings Then
    On Error GoTo 0: Err.Raise vbObjectError + 636, strErrSource, LoadResString(636)
  End If
Exit Sub

ErrHandler:
    'save error information
    strError = Err.Description
    lngError = Err.Number
    
    'clear game variables
    agGameDir = vbNullString
    agGameFile = vbNullString
    agGameID = vbNullString
    agIntVersion = 0
    agIsVersion3 = False
    
    'reset collections & objects
    Set agLogs = Nothing
    Set agViews = Nothing
    Set agPics = Nothing
    Set agSnds = Nothing
    Set agInvObj = Nothing
    Set agVocabWords = Nothing
    Set agLogs = New AGILogics
    Set agViews = New AGIViews
    Set agPics = New AGIPictures
    Set agSnds = New AGISounds
    Set agInvObj = New AGIInventoryObjects
    Set agVocabWords = New AGIWordList
    
    'raise error
    On Error GoTo 0: Err.Raise lngError, strErrSource, strError
End Sub

Public Sub NewGame(NewID As String, NewAuthor As String, ByVal NewVersion As Single, NewDescription As String, NewGameDir As String, NewGameVersion As String, NewGameAbout As String, NewResDir As String, Optional ByVal TemplateDir As String = vbNullString)

  'creates a new game in NewGameDir
  'and sets initial game properties
  'if a template directory is passed,
  'use the resources from that template directory
  
  Dim strDirData As String, intFile As Integer
  Dim i As Long, fso As FileSystemObject
  Dim blnWarnings As Boolean
  
  On Error Resume Next
  
  'if a game is already open,
  If agGameLoaded Then
    'can't open a game if one is already open
    On Error GoTo 0: Err.Raise vbObjectError + 501, strErrSource, LoadResString(501)
    Exit Sub
  End If
  
  'if not a valid directory
  If Not FileExists(NewGameDir, vbDirectory) Then
    'raise error
    On Error GoTo 0: Err.Raise vbObjectError + 630, strErrSource, Replace(LoadResString(630), ARG1, NewGameDir)
    Exit Sub
  End If
  
  'if a game already exists
  If Dir(cDir(NewGameDir) & "*.wag") <> vbNullString Then
    'game file exists;
    On Error GoTo 0: Err.Raise vbObjectError + 687, strErrSource, LoadResString(687)
    Exit Sub
  
  ElseIf IsSierraGameDir(cDir(NewGameDir)) Then
    'game files exist;
    agGameDir = vbNullString
    agIsVersion3 = False
    On Error GoTo 0: Err.Raise vbObjectError + 687, strErrSource, LoadResString(687)
    Exit Sub
  End If
  
  'set game directory
  agGameDir = cDir(NewGameDir)
  
  'ensure resdir is valid
  If LenB(NewResDir) = 0 Then
    'if blank use default
    NewResDir = agDefResDir
  End If
  
  'if using template
  If LenB(TemplateDir) <> 0 Then
    'template should include dir files, vol files, logic
    'source, words and objects lists;
    'globals lists and layouts
    
    'copy all files from the templatedir into gamedir
    Set fso = New FileSystemObject
    'strip off trailing '\' so files are copied correctly
    fso.CopyFolder TemplateDir, Left$(agGameDir, Len(agGameDir) - 1)
    If Err.Number <> 0 Then
      On Error GoTo 0: Err.Raise vbObjectError + 683, strErrSource, Replace(LoadResString(683), ARG1, Err.Description)
        Exit Sub
    End If
    
    'open the game in gamedir
    LoadGame agGameDir
    If Err.Number <> 0 Then
      On Error GoTo 0: Err.Raise vbObjectError + 684, strErrSource, Replace(LoadResString(684), ARG1, Err.Description)
      Exit Sub
    End If
    
    'change gameid
    GameID = NewID
    If Err.Number <> 0 Then
      On Error GoTo 0: Err.Raise vbObjectError + 685, strErrSource, Replace(LoadResString(685), ARG1, Err.Description)
      Exit Sub
    End If
    
    'other properties
    GameDescription = NewDescription
    GameAuthor = NewAuthor
    GameVersion = NewGameVersion
    GameAbout = NewGameAbout
    ResDirName = NewResDir
    'ignore errors with other properties
    Err.Clear
    
    'did a resource dir get copied?
    If fso.GetFolder(agGameDir).SubFolders.Count > 0 Then
      Dim fResDir As Folder
      For Each fResDir In fso.GetFolder(agGameDir).SubFolders
        Exit For
      Next
      'assume first subdir is the resource file;
      'if it isn't blame the template creator ...
      'compare it to resource dir
      If fResDir.Name <> NewResDir Then
        'need to move the existing resdir to the
        'correct resdir
        fso.MoveFolder fResDir.Path, agGameDir & NewResDir
      End If
      Set fResDir = Nothing
    End If
    Set fso = Nothing
    
  'if not using template,
  Else
    'validate new version
    Select Case ValidateVersion(NewVersion)
    Case -1
      'not a version 2 or 3 game
      On Error GoTo 0: Err.Raise vbObjectError + 597, strErrSource, LoadResString(597)
      Exit Sub
    Case -2
      'unsupported version 2 or 3 game
      On Error GoTo 0: Err.Raise vbObjectError + 543, strErrSource, Replace(LoadResString(543), ARG1, CStr(NewVersion))
      Exit Sub
    Case Else
      'ok
      'set version
      agIntVersion = NewVersion
      'set version3 flag
      agIsVersion3 = (NewVersion > 3)
    End Select
      
    'set game id (limit to 7 characters for v2, and 5 characters for v3
    '(don't use the GameID property; gameloaded flag is not set yet
    'so using GameID property will cause error)
    If agIsVersion3 Then
      agGameID = UCase$(Left$(NewID, 5))
    Else
      agGameID = UCase$(Left$(NewID, 7))
    End If
    
    'create empty property file
    Kill agGameDir & agGameID & ".wag"
    Err.Clear
    agGameFile = agGameDir & agGameID & ".wag"
    'use get property method to force creation of new property file
    'if a property file doesn't exist, GetGameProperties will
    'create a new file that has the GameID and IntVersion properties
    GetGameProperties
    
    'save properties
    GameDescription = NewDescription
    GameAuthor = NewAuthor
    GameVersion = NewGameVersion
    GameAbout = NewGameAbout
    ResDirName = NewResDir
    'ignore errors with other properties
    Err.Clear
    
    'errors after this cause failure
    On Error GoTo ErrHandler
    
    'create default resource directories
    strDirData = String$(768, &HFF)
    If agIsVersion3 Then
      intFile = FreeFile()
      Open agGameDir & agGameID & "DIR" For Binary As intFile
      Put intFile, 1, Chr$(8) & Chr$(0) & Chr$(8) & Chr$(3) & Chr$(8) & Chr$(6) & Chr$(8) & Chr$(9)
      Put intFile, , strDirData
      Put intFile, , strDirData
      Put intFile, , strDirData
      Put intFile, , strDirData
      Close intFile
    Else
      intFile = FreeFile()
      Open agGameDir & "LOGDIR" For Binary As intFile
      Put intFile, 1, strDirData
      Close intFile
      
      intFile = FreeFile()
      Open agGameDir & "PICDIR" For Binary As intFile
      Put intFile, 1, strDirData
      Close intFile
      
      intFile = FreeFile()
      Open agGameDir & "SNDDIR" For Binary As intFile
      Put intFile, 1, strDirData
      Close intFile
      
      intFile = FreeFile()
      Open agGameDir & "VIEWDIR" For Binary As intFile
      Put intFile, 1, strDirData
      Close intFile
    End If
  
    'set flag indicating directories expanded
    agDirExpanded = True
    
    'create default vocabulary word list
    Set agVocabWords = New AGIWordList
    'use loaded argument to force load of the new wordlist
    agVocabWords.Init True
    agVocabWords.AddWord "a", 0
    agVocabWords.AddWord "anyword", 1
    agVocabWords.AddWord "rol", 9999
    agVocabWords.Save
    
    'create inventory objects list
    Set agInvObj = New AGIInventoryObjects
    'use loaded argument to force load of new inventory list
    agInvObj.Init True
    agInvObj.Add "?", 0
    agInvObj.Save
    
    'assign and adust commands based on AGI version
    AssignCommands
    CorrectCommands agIntVersion
  
    'force id reset
    blnSetIDs = False
    
    'set open flag, so properties can be updated
    agGameLoaded = True
  End If
  
  'set resource directory
  Debug.Assert LenB(agResDirName) <> 0
  agResDir = agGameDir & agResDirName & "\"
  
  On Error Resume Next
  'ensure resource directory exists
  If Not FileExists(agGameDir & agResDirName, vbDirectory) Then
    MkDir agGameDir & agResDirName
    'if can't create the resources directory
    If Err.Number <> 0 Then
      'note the problem in the error log as a warning
      RecordLogEvent 0, "Can't create " & agResDir
      'use main directory
      agResDir = agGameDir
      'set warning flag
      blnWarnings = True
    End If
  End If
  
  'if errors
  If blnWarnings Then
    On Error GoTo 0: Err.Raise vbObjectError + 637, strErrSource, LoadResString(637)
  End If
Exit Sub

ErrHandler:
  strError = Err.Description
  strErrSrc = Err.Source
  lngError = Err.Number
  
  'reset collections & objects
  Set agLogs = Nothing
  Set agViews = Nothing
  Set agPics = Nothing
  Set agSnds = Nothing
  Set agInvObj = Nothing
  Set agVocabWords = Nothing
  Set agLogs = New AGILogics
  Set agViews = New AGIViews
  Set agPics = New AGIPictures
  Set agSnds = New AGISounds
  Set agInvObj = New AGIInventoryObjects
  Set agVocabWords = New AGIWordList
  
  On Error GoTo 0: Err.Raise vbObjectError + 631, strErrSrc, Replace(LoadResString(631), ARG1, CStr(lngError) & ":" & strError)
End Sub

Public Property Get VocabularyWords() As AGIWordList
  
  Set VocabularyWords = agVocabWords
End Property
Private Sub Class_Initialize()
  Dim rtn As Long
  
  On Error GoTo ErrHandler
  
  'save copy of this object to allow internal access
  Set agMainGame = Me
  
  'set events object
  Set agGameEvents = New AGIGameEvents
  
  'initialize arrays that serve as constants
  InitializeAGI
  
  'set collections
  Set agLogs = New AGILogics
  Set agPics = New AGIPictures
  Set agSnds = New AGISounds
  Set agViews = New AGIViews
  Set agInvObj = New AGIInventoryObjects
  Set agVocabWords = New AGIWordList
  
  'initialize logic source settings object and command info
  Set agMainLogSettings = New AGILogicSourceSettings
  Set agCmdCol = New AGICommands
  Set agTestCmdCol = New AGITestCommands
  'assign commands
  AssignCommands
  
  strErrSource = "agiGame"
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub



Private Sub Class_Terminate()

  'release objects
  Set agLogs = Nothing
  Set agPics = Nothing
  Set agSnds = Nothing
  Set agViews = Nothing
  
  Set agInvObj = Nothing
  Set agVocabWords = Nothing

  Set agGameEvents = Nothing
  Set agMainGame = Nothing
  
  'save max volsize
  SaveSetting sAPPNAME, "General", "VolSize", agMaxVolSize \ 1024

End Sub


