VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AGILogicSourceSettings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3E24FD28034A"
Option Explicit
'local variable(s) to hold property value(s)


Private strErrSource As String


Private agDefaultSyntax As LogicSyntaxType
Private agElseAsGoto As Boolean
Private agErrorLevel As LogicErrorLevel
Private agShowMsgs As Boolean
Private agSpecialSyntax As Boolean

Public Property Let ErrorLevel(NewLevel As LogicErrorLevel)
  
  agErrorLevel = NewLevel
End Property

Public Property Get ErrorLevel() As LogicErrorLevel
  
  ErrorLevel = agErrorLevel
End Property

Public Property Get ArgTypePrefix(ByVal Index As Byte) As String
  'validate index
  If Index < 0 Or Index > 8 Then
    On Error GoTo 0: Err.Raise 9, strErrSource, "Subscript out of range"
  End If
  
  ArgTypePrefix = agArgTypPref(Index)

End Property


Public Property Get ArgTypeName(ByVal Index As Byte) As String
  'validate index
  If Index < 0 Or Index > 8 Then
    On Error GoTo 0: Err.Raise 9, strErrSource, "Subscript out of range"
  End If
  
  ArgTypeName = agArgTypName(Index)
End Property


Public Property Get ReservedDefines(ByVal ArgType As ArgTypeEnum, Optional ByVal Syntax As LogicSyntaxType = lsUnknown) As TDefine()
  'returns the reserved defines that match this argtype as a string array
  
  Dim i As Long
  Dim tmpDefines() As TDefine
  
  On Error GoTo ErrHandler
  
  'if no syntax is specified,
  If Syntax = lsUnknown Then
    'if reserved defines aren't correct syntax
    If agPreDefSyntax <> agDefaultSyntax Then
      AssignReservedDefines agDefaultSyntax
    End If
  Else
    'force define type
    If agPreDefSyntax <> Syntax Then
      AssignReservedDefines Syntax
    End If
  End If
  
  Select Case ArgType
  Case atNum
    'return all numerical reserved defines
    ReDim tmpDefines(19)
    For i = 0 To 4
      tmpDefines(i) = agEdgeCodes(i)
    Next i
    For i = 0 To 8
      tmpDefines(i + 5) = agEgoDir(i)
    Next i
    For i = 0 To 4
      tmpDefines(i + 14) = agVideoMode(i)
    Next i
    tmpDefines(19).Name = agResDef(4).Name
    'if a game is not loaded
    If Not agMainGame.GameLoaded Then
      tmpDefines(19).Value = 0
    Else
      tmpDefines(19).Value = agInvObj.Count
    End If
    
  Case atVar
    'return all variable reserved defines
    ReDim tmpDefines(26)
    tmpDefines = agResVar
    
  Case atFlag
    'return all flag reserved defines
    ReDim tmpDefines(17)
    tmpDefines = agResFlag
    
  Case atMsg
    'none
    ReDim tmpDefines(0)
    
  Case atSObj
    'return all screen object reserved defines
    ReDim tmpDefines(0)
    tmpDefines(0).Name = agResDef(0).Name
    tmpDefines(0).Value = agResDef(0).Value
    tmpDefines(0).Type = atSObj
    
  Case atIObj
    'none
    ReDim tmpDefines(0)
    
  Case atStr
    'one
    ReDim tmpDefines(0)
    tmpDefines(0).Name = agResDef(5).Name
    tmpDefines(0).Value = agResDef(5).Value
    tmpDefines(0).Type = atStr
    
  Case atWord
    'none
    ReDim tmpDefines(0)
    
  Case atCtrl
    'none
    ReDim tmpDefines(0)
    
  Case atDefStr
    'return all reserved string defines
    ReDim tmpDefines(2)
    tmpDefines(0).Name = agResDef(1).Name
    tmpDefines(0).Value = agMainGame.GameVersion
    tmpDefines(0).Type = atDefStr
    tmpDefines(1).Name = agResDef(2).Name
    tmpDefines(1).Value = agMainGame.GameAbout
    tmpDefines(1).Type = atDefStr
    tmpDefines(2).Name = agResDef(3).Name
    If agGameLoaded Then
      tmpDefines(2).Value = agMainGame.GameID
    Else
      tmpDefines(2).Value = vbNullString
    End If
    tmpDefines(2).Type = atDefStr
    
  Case atVocWrd
    'none
    ReDim tmpDefines(0)
    
  End Select

  'return the defines
  ReservedDefines = tmpDefines
Exit Property

ErrHandler:
  Debug.Assert False
  'should never get an error
End Property
Public Property Let ReservedAsText(ByVal NewState As Boolean)
    
    agResAsText = NewState
End Property



Public Property Get ReservedAsText() As Boolean
    
    ReservedAsText = agResAsText
End Property
Public Property Let SourceExt(NewExt As String)

  'must start with a period
  If AscW(NewExt) <> 46 Then
    agSrcExt = "." & NewExt
  Else
    agSrcExt = NewExt
  End If
End Property
Public Property Get SourceExt() As String
  
  SourceExt = agSrcExt
End Property

Public Property Get UseReservedNames() As Boolean

  UseReservedNames = agUseRes
End Property
Public Property Let UseReservedNames(ByVal NewValue As Boolean)

  agUseRes = NewValue
End Property
Public Property Let DefaultSyntax(ByVal NewState As LogicSyntaxType)
    
  'can never be lsUnknown
  If NewState = lsUnknown Then
    agDefaultSyntax = lsVB
  Else
    agDefaultSyntax = NewState
  End If
End Property



Public Property Get DefaultSyntax() As LogicSyntaxType
    
    DefaultSyntax = agDefaultSyntax
End Property




Public Property Let SpecialSyntax(ByVal NewState As Boolean)
    
    agSpecialSyntax = NewState
End Property



Public Property Get SpecialSyntax() As Boolean
    
    SpecialSyntax = agSpecialSyntax
End Property




Public Property Let ElseAsGoto(ByVal NewState As Boolean)
    
    agElseAsGoto = NewState
End Property


Public Property Get ElseAsGoto() As Boolean
    
    ElseAsGoto = agElseAsGoto
End Property




Public Property Let ShowAllMessages(ByVal NewState As Boolean)
    
    agShowMsgs = NewState
End Property



Public Property Get ShowAllMessages() As Boolean
    
    ShowAllMessages = agShowMsgs
End Property




Private Sub Class_Initialize()

  strErrSource = "WinAGI.agiLogicSourceSettings"
  'set default logic syntax
  agDefaultSyntax = lsAGI
  
  'set default source extension
  agSrcExt = ".lgc"
  
  'assign arg type info
  agArgTypPref(0) = vbNullString
  agArgTypPref(1) = "v"
  agArgTypPref(2) = "f"
  agArgTypPref(3) = "m"
  agArgTypPref(4) = "o"
  agArgTypPref(5) = "i"
  agArgTypPref(6) = "s"
  agArgTypPref(7) = "w"
  agArgTypPref(8) = "c"
  
  agArgTypName(0) = "number"
  agArgTypName(1) = "variable"
  agArgTypName(2) = "flag"
  agArgTypName(3) = "message"
  agArgTypName(4) = "object"
  agArgTypName(5) = "inventory item"
  agArgTypName(6) = "string"
  agArgTypName(7) = "word"
  agArgTypName(8) = "controller"

End Sub


