Attribute VB_Name = "AGIObjects"
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3E0671810195"
Option Explicit

'variables needed across all objects in the
'game system

'version used by save/load games
'be sure to pad it to be 16 characters long!!
'constants for loading/saving game & resource properties
Public Const SP_SEPARATOR = 128 '???separator???
Public Const PC_GAMEDESC = 129
Public Const PC_GAMEAUTHOR = 130
Public Const PC_GAMEID = 131
Public Const PC_INTVERSION = 132
Public Const PC_GAMELAST = 133
Public Const PC_GAMEVERSION = 134
Public Const PC_GAMEABOUT = 135
Public Const PC_GAMEEXEC = 136
Public Const PC_RESDIR = 137
Public Const PC_DEFSYNTAX = 138
Public Const PC_INVOBJDESC = 144
Public Const PC_VOCABWORDDESC = 160
Public Const PC_PALETTE = 172
Public Const PC_USERESNAMES = 180
Public Const PC_LOGIC = 192
Public Const PC_PICTURE = 208
Public Const PC_SOUND = 224
Public Const PC_VIEW = 240
Public Const PT_ID = 0
Public Const PT_DESC = 1
Public Const PT_SYNTAX = 2
Public Const PT_CRC32 = 3
Public Const PT_KEY = 4
Public Const PT_INST0 = 5
Public Const PT_INST1 = 6
Public Const PT_INST2 = 7
Public Const PT_MUTE0 = 8
Public Const PT_MUTE1 = 9
Public Const PT_MUTE2 = 10
Public Const PT_MUTE3 = 11
Public Const PT_TPQN = 12
Public Const PT_ROOM = 13
Public Const PT_VIS0 = 14
Public Const PT_VIS1 = 15
Public Const PT_VIS2 = 16
Public Const PT_VIS3 = 17
Public Const PT_ALL = 255

Public agMainGame As AGIGame
Public agMainLogSettings As AGILogicSourceSettings
Public agCmdCol As AGICommands
Public agTestCmdCol As AGITestCommands
Public agGameEvents As AGIGameEvents

'status of game load
Public agGameLoaded As Boolean

'game compile variables
Public agCompGame As Boolean
Public agCancelComp As Boolean
Public agChangeVersion As Boolean

'local variable(s) to hold property value(s)
'for game properties which need to be accessible
'from all objects in the game system
Public agLogs As AGILogics
Public agSnds As AGISounds
Public agViews As AGIViews
Public agPics As AGIPictures
Public agInvObj As AGIInventoryObjects
Public agVocabWords As AGIWordList

Public agGameDir As String
Public agResDir As String
Public agResDirName As String
Public agDefResDir As String
Public agTemplateDir As String
Public agGameID As String
Public agAuthor As String
Public agLastDate As Date
Public agDescription As String
Public agIntVersion As Single
Public agIsVersion3 As Boolean
Public agAbout As String
Public agGameVersion As String
Public agGameFile As String
Public agMaxVol0 As Long
Public agMaxVolSize As Long
Public agCompileDir As String
Public agDirExpanded As Boolean
Public agGameExecutable As String
Public agSrcExt As String

'error number and string to return error values
'from various functions/subroutines
Public lngError As Long
Public strError As String
Public strErrSrc As String

'arrays which will be treated as constants
'rev colors have red and blue components switched
'so api functions using colors work correctly
Public lngEGARevCol(15) As Long
Public lngEGACol(15) As Long
Public agColor(15) As AGIColors
Public bytEncryptKey(10) As Byte ' = "Avis Durgan"
Public ResTypeAbbrv(3) As String '("LOG", "PIC", "VIEW, "SND"
Public agResTypeName(3) As String '("Logic", "Picture", "View", "Sound")
Public agVersion(15) As Single '(2.917, etc)

'game constants
Public Const MAX_RES_SIZE = 65530
Public Const MAX_LOOPS = 16
Public Const MAX_CELS = 32
Public Const MAX_ITEMS = 256
Public Const MAX_VOL_FILES = 65
Public Const MAX_CEL_WIDTH = 160
Public Const MAX_CEL_HEIGHT = 168
Public Const MAX_GROUP_NUM = 65535
Public Const MAX_WORD_GROUPS = 10000
'Public Const MAX_VOLSIZE = 1047552  '= 1024 * 1023
Public Const WORD_SEPARATOR As String = " | "

'constants used to build bitmaps
Public Const BI_RGB = 0&
Public Const DIB_RGB_COLORS = 0
Public Const DIB_PAL_COLORS = 1
Public Const FLOODFILLBORDER = 0
Public Const FLOODFILLSURFACE = 1
Public Const SRCCOPY = &HCC0020

'types used in building bitmaps
Public Type BITMAPINFOHEADER  '40 bytes
  biSize As Long
  biWidth As Long
  biHeight As Long
  biPlanes As Integer
  biBitCount As Integer
  biCompression As Long
  biSizeImage As Long
  biXPelsPerMeter As Long
  biYPelsPerMeter As Long
  biClrUsed As Long
  biClrImportant As Long
End Type

Public Type RGBQUAD
  rgbBlue As Byte
  rgbGreen As Byte
  rgbRed As Byte
  rgbReserved As Byte
End Type

Public Type BitmapInfo
  bmiHeader As BITMAPINFOHEADER
  bmiColor(16) As RGBQUAD
End Type

'api's for bitmap creation/manipulation
Public Declare Function GetTickCount Lib "kernel32" () As Long
Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Public Declare Function CreateDIBSection Lib "gdi32" (ByVal hDC As Long, pBitmapInfo As BitmapInfo, ByVal un As Long, lplpVoid As Long, ByVal handle As Long, ByVal dw As Long) As Long
Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Public Declare Function StretchBlt Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrWidth As Long, ByVal nSrHeight As Long, ByVal dwRop As Long) As Long
Public Declare Function GetLastError Lib "kernel32" () As Long
Public Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Public Declare Function SetPixelV Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal Y As Long, ByVal crColor As Long) As Long
Public Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal Y As Long) As Long
Public Declare Function ExtFloodFill Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal Y As Long, ByVal crColor As Long, ByVal wFillType As Long) As Long
Public Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Public Declare Function SetBkColor Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long) As Long

Public Function ReadProperty(ByVal PropCode As Byte, ByVal PropType As Byte, ByVal ResNum As Byte, Optional ByVal DefaultVal As String = vbNullString) As String
  'if a game is loaded, returns the property for the given code, type and resnum
  
  'properties use the following format for the property file:
  ' CPRLL<data>
  'where C= PropCode, P=PropNum, R=ResNum, LL=length of data (as integer)
  '      <data>= property data
  'last line of file should be version code
  
  Dim intFile As Integer
  Dim bytData() As Byte
  Dim lngCount As Long, lngPos As Long
  Dim strValue As String
  Dim i As Long
  Dim TestNum As Byte, TestType As Byte
  Dim TestCode As Byte, PropSize As Long
  
  On Error Resume Next
  
  'check for game file
  If Not FileExists(agGameFile) Then
    'no file; return empty string
    ReadProperty = vbNullString
    Exit Function
  End If
  
  'open file
  intFile = FreeFile()
  Open agGameFile For Binary As intFile
  If Err.Number <> 0 Then
    strError = Err.Description
    strErrSrc = Err.Source
    lngError = Err.Number
    
    On Error GoTo 0: Err.Raise vbObjectError + 675, strErrSrc, Replace(LoadResString(675), ARG1, CStr(lngError) & ":" & strError)
    Exit Function
  End If
  
  On Error GoTo ErrHandler
  
  'verify version
  strValue = String$(16, 0)
  'adjust position to compensate for length of variable
  '(and fact that get is '1' based): LOF - 16 + 1
  Get intFile, LOF(intFile) - 15, strValue
  
  'if version is incompatible
  Select Case strValue
  Case WINAGI_VERSION_1
    'ok
  Case WINAGI_VERSION_BETA
    'ok
  Case Else
    Close intFile
    'raise error
    On Error GoTo 0
    On Error GoTo 0: Err.Raise vbObjectError + 622, "AGIObjects.ReadProperty", LoadResString(622)
    Exit Function
  End Select
  
  'don't copy version line into buffer
  lngCount = LOF(intFile) - 16
  If lngCount > 0 Then
    ReDim bytData(lngCount - 1)
    Get intFile, 1, bytData
  Else
    'set to zero
    lngCount = 0
  End If
  Close intFile
  lngPos = 0
  
   
  'get code
  Do Until lngPos >= lngCount
    'reset propval
    strValue = vbNullString
    'retrieve next set of property info
    TestCode = bytData(lngPos)
    TestType = bytData(lngPos + 1)
    TestNum = bytData(lngPos + 2)
    PropSize = bytData(lngPos + 3) + 256 * bytData(lngPos + 4)
    'if this is the one
    If (TestCode = PropCode) And (TestType = PropType) And (TestNum = ResNum) Then
      Exit Do
    End If
    
    'add offset to next code (length +5)
    lngPos = lngPos + PropSize + 5
  Loop
  
  'if not found
  If lngPos >= lngCount Then
    'return default
    ReadProperty = DefaultVal
  Else
    'build the property
    For i = 1 To PropSize
      strValue = strValue & Chr$(bytData(lngPos + 4 + i))
    Next i
    'return the value
    ReadProperty = strValue
  End If
Exit Function

ErrHandler:
  'other error
  strError = Err.Description
  strErrSrc = Err.Source
  lngError = Err.Number
  
  On Error GoTo 0: Err.Raise vbObjectError + 664, strErrSrc, Replace(LoadResString(664), ARG1, CStr(lngError) & ":" & strError)
End Function

Public Sub RemoveProperty(ByVal PropCode As Byte, ByVal PropType As Byte, ByVal ResNum As Byte)

  'removes the property from the sierra.wag file
  
  Dim intFile As Integer
  Dim bytBuffer() As Byte
  Dim lngCount As Long, lngPos As Long
  Dim i As Long, j As Long
  Dim lngLen As Long
  Dim blnPropFound As Boolean
  Dim TempFile As String
  
  On Error Resume Next
  
  'open the file;
  intFile = FreeFile()
  Open agGameFile For Binary As intFile
  
  'check for error
  If Err.Number <> 0 Then
    'raise error
    strError = Err.Description
    strErrSrc = Err.Source
    lngError = Err.Number
    
    On Error GoTo 0: Err.Raise vbObjectError + 675, strErrSrc, Replace(LoadResString(675), ARG1, CStr(lngError) & ":" & strError)
    Exit Sub
  End If
  
  'verify version
  TempFile = String$(16, 0)
  'adjust position to compensate for length of variable
  '(and fact that get is '1' based): LOF - 16 + 1
  Get intFile, LOF(intFile) - 15, TempFile
  'if version is incompatible
  If TempFile <> WINAGI_VERSION_1 Then
    Close intFile
    'raise error
    On Error GoTo 0: Err.Raise vbObjectError + 622, "ResourceFunctions.RemoveProperty", LoadResString(622)
    Exit Sub
  End If
  
  'don't copy version line into buffer
  lngCount = LOF(intFile) - 16
  If lngCount > 0 Then
    ReDim bytBuffer(lngCount - 1)
    Get intFile, 1, bytBuffer
  Else
    'nothing in file; set count to zero
    lngCount = 0
  End If
  Close intFile
  
  lngPos = 0
  
  'step through all property items
  Do Until lngPos >= lngCount
    'calculate size of this property
    lngLen = bytBuffer(lngPos + 3) + bytBuffer(lngPos + 4) * 256
    
    'if this property is for this resource and number,
    If bytBuffer(lngPos) = PropCode And bytBuffer(lngPos + 2) = ResNum Then
      'if removing this property or all properties
      If (PropType = bytBuffer(lngPos + 1)) Or (PropType = PT_ALL) Then
        'remove this property
        'remove it by moving data upward
        For i = lngPos + lngLen + 5 To lngCount - 1
          bytBuffer(i - lngLen - 5) = bytBuffer(i)
        Next i
        lngCount = lngCount - lngLen - 5
        'if not doing all
        If PropType <> PT_ALL Then
          'exit
          Exit Do
        End If
      Else
        'try next
        lngPos = lngPos + lngLen + 5
      End If
    Else
      'add offset to next code (length +5)
      lngPos = lngPos + lngLen + 5
    End If
    'check for error
    If Err.Number <> 0 Then
      'raise error
      On Error GoTo 0: Err.Raise vbObjectError + 622, "ResourceFunctions.RemoveProperty", LoadResString(622)
      Exit Sub
    End If
  Loop
  
  'open temp file
  TempFile = TempFileName()
  intFile = FreeFile()
  Open TempFile For Binary As intFile
  
  'if not first entry,
  If lngCount > 0 Then
    'drop any removed data
    ReDim Preserve bytBuffer(lngCount - 1)
    'write buffer
    Put intFile, 1, bytBuffer
    'add version
    Put intFile, , WINAGI_VERSION_1
  Else
    'add just the version
    Put intFile, 1, WINAGI_VERSION_1
  End If
  
  'close the file
  Close intFile
  
  'copy temp file to original agGameFile
  Kill agGameFile
  FileCopy TempFile, agGameFile
  Kill TempFile
  Err.Clear
End Sub



Public Function ValidateVersion(ByVal NewVersion As Single) As Long
  'checks NewVersion against list of supported versions
  'returns 0 if ok
  'returns -1 if not version 2 or 3
  'returns -2 if unsupported version 2 or version 3
  
  Dim i As Long
  
  'if version <2 or >=4
  If NewVersion < 2 Or NewVersion >= 4 Then
    ValidateVersion = -1
  Else
    'validate against list of numbers
    For i = 0 To UBound(agVersion)
      If NewVersion = agVersion(i) Then
        'ok- return 0 (which is default)
        Exit Function
      End If
    Next i
    'loop exited normally- not a valid v2 or v3
    ValidateVersion = -2
  End If
End Function

Public Sub WriteProperty(ByVal PropCode As Byte, ByVal PropType As Byte, ByVal ResNum As Byte, ByVal PropVal As String)

  'compares current property to saved value, and updates if necessary
  'depends on the following format for the property file:
  ' CPRLL<data>
  'where C= PropCode, P=PropNum, R=ResNum, LL=length of data (as integer)
  '      <data>= property data
  'last line of file should be version code
  'PropNum and ResNum only apply to resources
  
  Dim intFile As Integer
  Dim bytBuffer() As Byte
  Dim bytBuffEnd() As Byte
  Dim lngCount As Long, lngPos As Long
  Dim i As Long, j As Long
  Dim intPropLen As Integer
  Dim strOldProp As String
  Dim blnPropFound As Boolean
  Dim TempFile As String
  
  On Error Resume Next
  
  'on game load, properties are extracted from the wag file;
  'in this case, calls to WriteProperty should just be
  'ignored
  If Not agGameLoaded Then
    Exit Sub
  End If
  
  'check for game file
  If Not FileExists(agGameFile) Then
    'no file;
    On Error GoTo 0: Err.Raise 524, "AGIObjects.WriteProperty", Replace(LoadResString(524), ARG1, agGameFile)
    Exit Sub
  End If
  
  'open the file;
  intFile = FreeFile()
  Open agGameFile For Binary As intFile
  
  'check for error
  If Err.Number <> 0 Then
    strError = Err.Description
    strErrSrc = Err.Source
    lngError = Err.Number
  
    Close intFile
    'raise error
    On Error GoTo 0: Err.Raise vbObjectError + 675, strErrSrc, Replace(LoadResString(675), ARG1, CStr(lngError) & ":" & strError)
    Exit Sub
  End If
  
  'verify version
  TempFile = String$(16, 0)
  'adjust position to compensate for length of variable
  '(and fact that get is '1' based): LOF - 16 + 1
  Get intFile, LOF(intFile) - 15, TempFile
  'if version is incompatible
  Select Case TempFile
  Case WINAGI_VERSION_1
    'ok
  Case WINAGI_VERSION_BETA
    'change to match current version
    TempFile = WINAGI_VERSION_1
    Put intFile, LOF(intFile) - 15, TempFile
  Case Else
    Close intFile
    'raise error
    On Error GoTo 0: Err.Raise vbObjectError + 622, "ResourceFunctions.WriteProperty", LoadResString(622)
    Exit Sub
  End Select
  
  'don't copy version line into buffer
  lngCount = LOF(intFile) - 16
  If lngCount > 0 Then
    ReDim bytBuffer(lngCount - 1)
    Get intFile, 1, bytBuffer
  Else
    'set to zero
    lngCount = 0
  End If
  Close intFile
  lngPos = 0
  
  'find current code
  Do Until lngPos >= lngCount
    'if this byte is correct code
    If bytBuffer(lngPos) = PropCode Then
      'if property is for a numbered resource,
      If PropCode >= PC_LOGIC Then
        'need to verify property number and resource number
        If bytBuffer(lngPos + 1) = PropType And bytBuffer(lngPos + 2) = ResNum Then
          'this is the one;
          blnPropFound = True
          Exit Do
        End If
      Else
        'this is the one;
        blnPropFound = True
        Exit Do
      End If
    End If
    'add offset to next code (length +5)
    lngPos = lngPos + bytBuffer(lngPos + 3) + bytBuffer(lngPos + 4) * 256 + 5
    'check for error
    If Err.Number <> 0 Then
      'raise error
      On Error GoTo 0: Err.Raise vbObjectError + 622, "ResourceFunctions.WriteProperty", LoadResString(622)
      Exit Sub
    End If
  Loop
  
  'if property found
  If blnPropFound Then
    'get the property
    intPropLen = bytBuffer(lngPos + 3) + 256 * bytBuffer(lngPos + 4)
    For i = 1 To intPropLen
      strOldProp = strOldProp + Chr$(bytBuffer(lngPos + 4 + i))
    Next i
  
    'copy data AFTER this property entry to end buffer
    j = lngPos + 5 + intPropLen
    'if any data left at end,
    If lngCount - j > 0 Then
      'create end buffer to hold data after this property entry
      ReDim bytBuffEnd(lngCount - j - 1)
      For i = j To lngCount - 1
        bytBuffEnd(i - j) = bytBuffer(i)
      Next i
    End If
    
    'drop all data AFTER this property from front end buffer
    If lngPos > 0 Then
      ReDim Preserve bytBuffer(lngPos - 1)
    End If
  End If
  
  'if no change,
  If strOldProp = PropVal Then
    'no action needed,
    Exit Sub
  End If
  
  'if not changing date
  If PropCode <> PC_GAMELAST Then
    'change lastdate
    agLastDate = Now()
  End If
  
  'if changing resource ID,
  If (PropCode >= PC_LOGIC) And (PropType = PT_ID) Then
    'create default name
    Select Case PropCode
    Case PC_LOGIC
      strOldProp = "Logic" & CStr(ResNum)
    Case PC_PICTURE
      strOldProp = "Picture" & CStr(ResNum)
    Case PC_SOUND
      strOldProp = "Sound" & CStr(ResNum)
    Case PC_VIEW
      strOldProp = "View" & CStr(ResNum)
    End Select
    
    'if new ID matches default ID
    If PropVal = strOldProp Then
      'if property was found
      If blnPropFound Then
        'remove it instead of adding it
        RemoveProperty PropCode, PropType, ResNum
      End If
      'and exit
      Exit Sub
    End If
  End If
  
  'open temp file
  TempFile = TempFileName()
  intFile = FreeFile()
  Open TempFile For Binary As intFile
  
  'if not first entry,
  If lngPos > 0 Then
    'write front buffer
    Put intFile, 1, bytBuffer
  End If
  
  'write property entry
  Put intFile, , PropCode
  Put intFile, , PropType
  Put intFile, , ResNum
  Put intFile, , CInt(Len(PropVal))
  Put intFile, , PropVal
  
  'if end buffer has data (pointer not past total count)
  If lngCount - j > 0 Then
    'write end buffer
    Put intFile, , bytBuffEnd
  End If
  
  'add version
  Put intFile, , WINAGI_VERSION_1
  
  'close the file
  Close intFile
  
  'need to check for errors
  'copy temp file to original agGameFile
  Kill agGameFile
  FileCopy TempFile, agGameFile
  Kill TempFile
  Err.Clear
End Sub
Public Function GetGameProperties() As Boolean
  'assumes a game has just been loaded
  'if a game property file does not exist, one is created
  'if a game property file already exists, it is opened, and
  'resource properties are adjusted to match the game file
  
  'properties use the following format for the property file:
  ' CPRLL<data>
  'where C= PropCode, P=PropNum, R=ResNum, LL=length of data (as integer)
  '      <data>= property data
  'last line of file should be version code
  
  'should remove any properties that no longer refer to valid objects?
  Dim intFile As Integer
  Dim bytData() As Byte
  Dim lngCount As Long, lngPos As Long
  Dim strValue As String
  Dim i As Long
  Dim ResNum As Byte, PropType As Byte
  Dim PropCode As Byte, PropSize As Long
  Dim blnFoundID As Boolean, blnFoundVer As Boolean
  
  On Error GoTo ErrHandler
  
  'check for game file
  If Not FileExists(agGameFile) Then
    'no file; create a default one
    intFile = FreeFile()
    Open agGameFile For Binary As #intFile
    'write the game ID
    Put intFile, 1, CByte(PC_GAMEID)
    Put intFile, , CByte(0)
    Put intFile, , CByte(0)
    Put intFile, , CInt(Len(agGameID))
    Put intFile, , agGameID
      
    'write the interpreter version
    Put intFile, , CByte(PC_INTVERSION)
    Put intFile, , CByte(0)
    Put intFile, , CByte(0)
    Put intFile, , CInt(Len(CStr(agIntVersion)))
    Put intFile, , CStr(agIntVersion)
    
    'write this date as edit date
    Put intFile, , CByte(PC_GAMELAST)
    Put intFile, , CByte(0)
    Put intFile, , CByte(0)
    Put intFile, , CInt(Len(CStr(Now)))
    Put intFile, , CStr(Now)
    'write the property file version
    Put #intFile, , WINAGI_VERSION_1
    'close the file
    Close intFile
    'set last edit date
    agLastDate = Now()
    Exit Function
  End If
  
  'open file
  intFile = FreeFile()
  Open agGameFile For Binary As intFile
  
  'verify version
  strValue = String$(16, 0)
  'adjust position to compensate for length of variable
  '(and fact that get is '1' based): LOF - 16 + 1
  Get intFile, LOF(intFile) - 15, strValue
  
  'if version is incompatible
  Select Case strValue
  Case WINAGI_VERSION_1
    'ok
  Case WINAGI_VERSION_BETA
    'ok
  Case Else
    Close intFile
    'raise error
    On Error GoTo 0: Err.Raise vbObjectError + 622, "AGIObjects.GetGameProperties", LoadResString(622)
    Exit Function
  End Select
  
  'don't copy version line into buffer
  lngCount = LOF(intFile) - 16
  If lngCount > 0 Then
    ReDim bytData(lngCount - 1)
    Get intFile, 1, bytData
  Else
    'set to zero
    lngCount = 0
  End If
  Close intFile
  lngPos = 0
  
   
  'get codes
  Do Until lngPos >= lngCount
    'reset propval
    strValue = vbNullString
    'get prop code
    PropCode = bytData(lngPos)
    PropType = bytData(lngPos + 1)
    ResNum = bytData(lngPos + 2)
    PropSize = bytData(lngPos + 3) + 256 * bytData(lngPos + 4)
    For i = 1 To PropSize
      strValue = strValue & Chr$(bytData(lngPos + 4 + i))
    Next i
      
    Select Case PropCode
    Case Is >= PC_LOGIC
      Select Case PropCode
      Case PC_LOGIC
        Select Case PropType
        Case PT_ID
          agLogs(ResNum).FriendID = strValue
        Case PT_DESC
          agLogs(ResNum).Description = strValue
        Case PT_SYNTAX
          'ignore on game load;
          'syntax property retrieved as needed
          'when source code is loaded
        Case PT_CRC32
          agLogs(ResNum).CompiledCRC = CLng("&H" & strValue)
        Case PT_ROOM
          If ResNum <> 0 Then
            agLogs(ResNum).IsRoom = CBool(strValue)
          End If
        Case Else
          'unknown code; ignore it
        
        End Select
        
        'reset dirty flag
        agLogs(ResNum).IsDirty = False
        agLogs(ResNum).WritePropState = False
      
      Case PC_PICTURE
        Select Case PropType
        Case PT_ID
          agPics(ResNum).FriendID = strValue
        Case PT_DESC
          agPics(ResNum).Description = strValue
        End Select
        
        'reset dirty flag
        agPics(ResNum).IsDirty = False
        agPics(ResNum).WritePropState = False
        
      Case PC_SOUND
        Select Case PropType
        Case PT_ID
          agSnds(ResNum).FriendID = strValue
        Case PT_DESC
          agSnds(ResNum).Description = strValue
        End Select
        
        'reset dirty flag
        agSnds(ResNum).IsDirty = False
        agSnds(ResNum).WritePropState = False
        
      Case PC_VIEW
        Select Case PropType
        Case PT_ID
          agViews(ResNum).FriendID = strValue
        Case PT_DESC
          agViews(ResNum).Description = strValue
        End Select
        
        'reset dirty flag
        agViews(ResNum).IsDirty = False
        agViews(ResNum).WritePropState = False
      End Select
      
    Case PC_GAMEDESC
      agDescription = strValue
      
    Case PC_GAMEAUTHOR
      agAuthor = strValue
      
    Case PC_GAMEID
      'if id matches
      blnFoundID = (UCase$(agGameID) = UCase$(strValue))
      
    Case PC_INTVERSION
      blnFoundVer = (agIntVersion = CDbl(strValue))
      
    Case PC_GAMEABOUT
      agAbout = strValue
    
    Case PC_GAMEVERSION
      agGameVersion = strValue
    
    Case PC_RESDIR
      agResDirName = strValue
      
    Case PC_GAMELAST
      agLastDate = CDate(strValue)
      
    Case PC_INVOBJDESC
      agInvObj.Description = strValue
      
    Case PC_VOCABWORDDESC
      agVocabWords.Description = strValue
      
    Case PC_GAMEEXEC
      agGameExecutable = strValue
    
    Case PC_DEFSYNTAX
      agMainLogSettings.DefaultSyntax = CLng(strValue)
      
    Case PC_PALETTE
      'convert strvalue into 16 4 byte numbers
      '(actually it's more efficient to use the
      'data array and extract the numbers directly)
      For i = 0 To 15
        lngEGACol(i) = &H1000000 * bytData(lngPos + 5 + 4 * i) + _
                       &H10000 * bytData(lngPos + 6 + 4 * i) + _
                       &H100& * bytData(lngPos + 7 + 4 * i) + _
                       bytData(lngPos + 8 + 4 * i)
        'switch bytes 2 & 4 for reverse color
        lngEGARevCol(i) = &H1000000 * bytData(lngPos + 5 + 4 * i) + _
                          bytData(lngPos + 6 + 4 * i) + _
                          &H100& * bytData(lngPos + 7 + 4 * i) + _
                          &H10000 * bytData(lngPos + 8 + 4 * i)
      Next i
        
    Case PC_USERESNAMES
      agUseRes = CBool(strValue)
      
    Case Else
      'error
    End Select
    
    'add offset to next code (length +5)
    lngPos = lngPos + PropSize + 5
  Loop
  
  'if no lastedit date,
  If agLastDate = 0 Then
    'game was decompiled; set last date to now
    agLastDate = Now()
  End If
  
  'if id, version, or resdir was not found,
  If Not blnFoundID Then
    'add it
    WriteProperty PC_GAMEID, 0, 0, agGameID
  End If
  If Not blnFoundVer Then
    WriteProperty PC_INTVERSION, 0, 0, CStr(agIntVersion)
  End If
  If LenB(agResDirName) = 0 Then
    WriteProperty PC_RESDIR, 0, 0, agDefResDir
    agResDirName = agDefResDir
  End If
  
  'create full resdir from name
  agResDir = agGameDir & agResDirName & "\"
Exit Function

ErrHandler:
  'if error is due to non-existent resource,
  If Err.Number = vbObjectError + 617 Then
    Err.Clear
    'need to delete this property
    RemoveProperty PropCode, PT_ALL, ResNum
    'continue
    Resume Next
  Else
    'other error
    'pass along error so opengame function can make a note of the problem
    strError = Err.Description
    strErrSrc = Err.Source
    lngError = Err.Number
    
    On Error GoTo 0: Err.Raise vbObjectError + 666, strErrSrc, Replace(LoadResString(666), ARG1, CStr(lngError) & ":" & strError)
    Exit Function
  End If
End Function

Public Function IsSierraGameDir(strDir As String) As Boolean

  'this function will determine if the strDir is a
  'valid sierra AGI game directory
  'it also sets the gameID, if one is found and the version3 flag
  
  Dim strFilename As String
  Dim intFile As Integer, strChunk As String
  
  'search for 'DIR' files
  strFilename = UCase$(Dir(strDir & "*DIR"))
    
  'if files named '*DIR' exist,
  If LenB(strFilename) <> 0 Then
    'this is an AGI game directory-
    IsSierraGameDir = True
    'check for existence of a version three gameid:
    If FileExists(strDir & Left$(strFilename, InStr(1, strFilename, "DIR") - 1) & "VOL.0") Then
      'set gameID
      agGameID = UCase$(Left$(strFilename, InStr(1, strFilename, "DIR") - 1))
      'set version3 flag
      agIsVersion3 = True
    Else
      'if errors occur, exit without setting ID
      On Error GoTo ErrHandler
      
      'clear version3 flag
      agIsVersion3 = False
      'clear ID
      agGameID = vbNullString
      'look for loader file to find ID
      strFilename = UCase$(Dir(strDir & "*.COM"))
      Do Until LenB(strFilename) = 0
        'open file and get chunk
        strChunk = String$(6, 32)
        intFile = FreeFile()
        Open strDir & strFilename For Binary As intFile
        Get intFile, 4, strChunk
        Close intFile
        'if this is a Sierra loader
        If strChunk = "LOADER" Then
          'if not SIERRA.COM
          If strFilename <> "SIERRA.COM" Then
            'use this filename as ID
            agGameID = UCase$(Left$(strFilename, Len(strFilename) - 4))
            Exit Do
          End If
        End If
        'get next file
        strFilename = UCase$(Dir())
      Loop
      'if no loader file found,
      If LenB(agGameID) = 0 Then
        'use default
        agGameID = "AGI"
      End If
    End If
  End If
Exit Function

ErrHandler:
  Err.Clear
  'clear ID
  agGameID = vbNullString
End Function


Function GetIntVersion() As Single
  'this function gets the version number of a Sierra AGI game
  'if found, it is validated against list of versions
  'that WinAGI recognizes
  '
  'returns version number for a valid number
  'returns -1 for a version <2 or >=4
  'returns -2 for a version 2 or 3 that is not on list
  
  'this code adapted from AGIver by Jeremy Hayes

  Dim VersionNumBuffer As String * 9
  Dim strFilename As String
  Dim bytBuffer() As Byte
  Dim ISVerNum As Boolean
  Dim i As Long
  Dim VerLen As Byte
  Dim VerNumText As String
  Dim VerNum As Double
  Dim code As Integer
  Dim ResPos As Integer
  Dim intFile As Integer
  
  On Error GoTo ErrHandler
  
  strFilename = agGameDir & "AGIDATA.OVL"
  VersionNumBuffer = "A_CDE_GHI"
  
  If FileExists(strFilename) Then
    'open AGIDATA.OVL, coy to buffer, and close
    intFile = FreeFile()
    Open strFilename For Binary As intFile
    ReDim bytBuffer(LOF(intFile))
    Get intFile, 1, bytBuffer()
    Close intFile
  Else
    'no agidata.ovl
    'if version3 is set
    If agIsVersion3 Then
      'use default v3
      GetIntVersion = 3.002149 'most common version 3
    Else
      'use default version  2.917
      GetIntVersion = 2.917
    End If
    Exit Function
  End If

  ResPos = 0
  VerLen = 0
  Do While (ResPos < UBound(bytBuffer)) And (VerLen = 0)
    VersionNumBuffer = Mid$(VersionNumBuffer, 2, 8) & Chr$(bytBuffer(ResPos))
    ResPos = ResPos + 1
    ISVerNum = True
    If Mid$(VersionNumBuffer, 2, 1) = "." Then
      If (Not (Mid$(VersionNumBuffer, 1, 1) >= "0" And Mid$(VersionNumBuffer, 1, 1) <= "9")) Then
        ISVerNum = False
      End If
      For i = 3 To 5
        If (Not (Mid$(VersionNumBuffer, i, 1) >= "0" And Mid$(VersionNumBuffer, i, 1) <= "9")) Then
          ISVerNum = False
        End If
      Next i
      If ISVerNum And (Mid$(VersionNumBuffer, 1, 1) <= "2") Then
        VerLen = 5 ' 2.xxx format
      End If
      If Mid$(VersionNumBuffer, 6, 1) <> "." Then
        ISVerNum = False
      End If
      For i = 7 To 9  ' 3.xxx.xxx format
        If (Not (Mid$(VersionNumBuffer, i) >= "0" And Mid$(VersionNumBuffer, i) <= "9")) Then
          ISVerNum = False
        End If
      Next i
      If ISVerNum Then
        VerLen = 9
      End If
    Else
      ISVerNum = False
    End If
    
    If VerLen > 0 Then
    
      If Mid$(VersionNumBuffer, 6, 1) = "." Then
        VerNumText = Mid$(VersionNumBuffer, 1, 5) + Mid$(VersionNumBuffer, 7, 3) ' remove second '.'
      Else
        VerNumText = Mid$(VersionNumBuffer, 1, VerLen)
      End If
      
      VerNum = Val(VerNumText)
      
      'validate version number
      i = ValidateVersion(VerNum)
      
      'if validated
      If i = 0 Then
        GetIntVersion = VerNum
      Else
        'return validation error code
        GetIntVersion = i
      End If
      Exit Function
    End If
  Loop
  
  'if version info not found in AGIDATA.OVL;
  
  'check for version 3:
  If LenB(Dir(agGameDir & agGameID & "DIR")) <> 0 And LenB(Dir(agGameDir & agGameID & "VOL.*")) <> 0 Then
    'use default version 3
    agIsVersion3 = True
    GetIntVersion = 3.002149 'most common version 3?
  Else
    agIsVersion3 = False
    GetIntVersion = 2.917  ' This is what we use if we can't find the version number.
                                  ' Version 2.917 is the most common interpreter and
                                  ' the one that all the "new" AGI games should be based on.
  End If
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function

Public Sub InitializeAGI()

  'this function loads all the 'constant' arrays
  'with their values
  
  Dim i As Integer, j As Integer
  Dim rtn As Long
  
  'get reference to temporary directory
  rtn = GetTempPath(1&, strTempDir)
  'if successful,
  If rtn <> 0 Then
    'call function again with correct length
    strTempDir = String$(rtn, " ")
    rtn = GetTempPath(rtn, strTempDir)
    'if successful,
    If rtn <> 0 Then
      'strip null char off end
      strTempDir = Left$(strTempDir, Len(strTempDir) - 1)
    Else
      'if tempdir not found, use current directory
      strTempDir = CurDir$()
    End If
  Else
    'if tempdir not found, use current directory
    strTempDir = CurDir$()
  End If
  
  'get default resource dir name
  agDefResDir = Trim$(GetSetting(sAPPNAME, "General", "DefResDir", "src"))
    
  'validate directory
  If agDefResDir = vbNullString Then
    agDefResDir = "src"
  Else
    For i = 1 To Len(agDefResDir)
      Select Case AscW(Mid$(agDefResDir, i))
      Case 32, 92, 47, 58, 42, 63, 34, 60, 62, 124
        'invalid character; reset to default
        agDefResDir = "src"
        Exit For
      End Select
    Next i
  End If
  
  'build crc table
  CRC32Setup
  
  'get max vol size
  agMaxVolSize = GetSetting(sAPPNAME, "General", "VolSize", 1023)
  'validate size
  If agMaxVolSize > 1023 Then agMaxVolSize = 1023
  If agMaxVolSize < 64 Then agMaxVolSize = 64
  agMaxVolSize = agMaxVolSize * 1024&
  
  'set max vol0 size
  agMaxVol0 = agMaxVolSize
  
  'abbreviations for version 2 directory files
  ResTypeAbbrv(rtLogic) = "LOG"
  ResTypeAbbrv(rtPicture) = "PIC"
  ResTypeAbbrv(rtSound) = "SND"
  ResTypeAbbrv(rtView) = "VIEW"
  'abbreviations for resource file names
  agResTypeName(rtLogic) = "Logic"
  agResTypeName(rtPicture) = "Picture"
  agResTypeName(rtSound) = "Sound"
  agResTypeName(rtView) = "View"
  
  'colors
  RestoreDefaultColors
  agColor(0) = agBlack
  agColor(1) = agBlue
  agColor(2) = agGreen
  agColor(3) = agCyan
  agColor(4) = agRed
  agColor(5) = agMagenta
  agColor(6) = agBrown
  agColor(7) = agLtGrey
  agColor(8) = agDkGrey
  agColor(9) = agLtBlue
  agColor(10) = agLtGreen
  agColor(11) = agLtCyan
  agColor(12) = agLtRed
  agColor(13) = agLtMagenta
  agColor(14) = agYellow
  agColor(15) = AGWHITE
 
 'encryption key values
  bytEncryptKey(0) = 65 'Asc("A")
  bytEncryptKey(1) = 118 'Asc("v")
  bytEncryptKey(2) = 105 'Asc("i")
  bytEncryptKey(3) = 115 'Asc("s")
  bytEncryptKey(4) = 32 'Asc(" ")
  bytEncryptKey(5) = 68 'Asc("D")
  bytEncryptKey(6) = 117 'Asc("u")
  bytEncryptKey(7) = 114 'Asc("r")
  bytEncryptKey(8) = 103 'Asc("g")
  bytEncryptKey(9) = 97 'Asc("a")
  bytEncryptKey(10) = 110 'Asc("n")
  'load versions
  agVersion(0) = 2.089
  agVersion(1) = 2.272
  agVersion(2) = 2.411
  agVersion(3) = 2.425
  agVersion(4) = 2.426
  agVersion(5) = 2.435
  agVersion(6) = 2.439
  agVersion(7) = 2.44
  agVersion(8) = 2.915
  agVersion(9) = 2.917
  agVersion(10) = 2.936
  agVersion(11) = 3.002086
  agVersion(12) = 3.002098
  agVersion(13) = 3.002102
  agVersion(14) = 3.002107
  agVersion(15) = 3.002149
End Sub

Public Sub RestoreDefaultColors()

  '(note that reverse colors  are in RRGGBB format)
  lngEGARevCol(0) = 0&         'black
  lngEGARevCol(1) = &HA0&      'blue
  lngEGARevCol(2) = &HA000&    'green
  lngEGARevCol(3) = &HA0A0&    'cyan
  lngEGARevCol(4) = &HA00000   'red
  lngEGARevCol(5) = &H8000A0   'magenta
  lngEGARevCol(6) = &HA05000   'brown
  lngEGARevCol(7) = &HA0A0A0   'light grey
  lngEGARevCol(8) = &H505050   'dark grey
  lngEGARevCol(9) = &H5050FF   'light blue
  lngEGARevCol(10) = &HFF50&   'light green
  lngEGARevCol(11) = &H50FFFF  'light cyan
  lngEGARevCol(12) = &HFF5050  'light red
  lngEGARevCol(13) = &HFF50FF  'light magenta
  lngEGARevCol(14) = &HFFFF50  'yellow
  lngEGARevCol(15) = &HFFFFFF  'white
  'note regular colors are 'bbggrr' format
  lngEGACol(0) = 0&         'black
  lngEGACol(1) = &HA00000   'blue
  lngEGACol(2) = &HA000&    'green
  lngEGACol(3) = &HA0A000     'cyan
  lngEGACol(4) = &HA0&   'red
  lngEGACol(5) = &HA00080   'magenta
  lngEGACol(6) = &H50A0     'brown
  lngEGACol(7) = &HA0A0A0   'light grey
  lngEGACol(8) = &H505050   'dark grey
  lngEGACol(9) = &HFF5050   'light blue
  lngEGACol(10) = &H50FF00    'light green
  lngEGACol(11) = &HFFFF50  'light cyan
  lngEGACol(12) = &H5050FF  'light red
  lngEGACol(13) = &HFF50FF  'light magenta
  lngEGACol(14) = &H50FFFF  'yellow
  lngEGACol(15) = &HFFFFFF  'white
End Sub
Public Sub RecordLogEvent(intType As Integer, ByRef strMessage As String)
  'open the log file and write the message
  'intType =0 means warning
  'inttype =1 means error
  Dim intLogFile As Integer
  Dim strType As String
  
  On Error GoTo ErrHandler
  
  intLogFile = FreeFile()
  
  'set type of msg
  If intType = 0 Then
    strType = "WARNING: "
  Else
    strType = "ERROR: "
  End If
    
  Open agGameDir & "errlog.txt" For Append As intLogFile
'FIXIT: Print method has no Visual Basic .NET equivalent and will not be upgraded.         FixIT90210ae-R7593-R67265
  Print #intLogFile, Format$(Now(), "Medium Date") & ": " & strType & strMessage
  Close intLogFile
  Err.Clear
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


