Attribute VB_Name = "ResMan"
Option Explicit

  'constants
  Public Const MaxViewEditors = 16
  Public Const MaxPicEditors = 16
  Public Const MaxSoundEditors = 16
  Public Const MaxLogicEditors = 32
  Public Const PI As Double = 3.14159265358979
  Public Const TickWidth = 6
  
  'default setting values
  Public Const DEFAULT_SHOWSPLASHSCREEN As Boolean = True
  Public Const DEFAULT_SKIPPRINTWARNING As Boolean = False
  Public Const DEFAULT_USELE As Boolean = True
  Public Const DEFAULT_LEPAGES As Boolean = True
  Public Const DEFAULT_LEWARNDELETE As Boolean = True
  Public Const DEFAULT_LEUSEGRID As Boolean = True
  Public Const DEFAULT_LEGRID As Single = 0.1
  Public Const DEFAULT_WARNCOMPILE As Boolean = True
  Public Const DEFAULT_WARNDUPGNAME As Boolean = True
  Public Const DEFAULT_WARNDUPGVAL As Boolean = True
  Public Const DEFAULT_WARNRESOVRD As Boolean = True
  
  Public Const DEFAULT_WARNDUPOBJ As Boolean = True
  Public Const DEFAULT_SHOWPREVIEW As Boolean = True
  Public Const DEFAULT_SHIFTPREVIEW As Boolean = True
  Public Const DEFAULT_SHOWTREE As Boolean = True
  Public Const DEFAULT_AUTOOPEN As Boolean = False
  Public Const DEFAULT_AUTOEXPORT As Boolean = False
  Public Const DEFAULT_ASKEXPORT As Boolean = True
''  Public Const DEFAULT_AUTOUPDATEOBJECTS = 0
''  Public Const DEFAULT_AUTOUPDATEWORDS = 0
  Public Const DEFAULT_SHOWRESNUM  As Boolean = False
  Public Const DEFAULT_INCLUDERESNUM As Boolean = False
  
  Public Const DEFAULT_MAXSO As Long = 16
  Public Const DEFAULT_HILITETEXT As Boolean = False
  
  Public Const DEFAULT_LOGICTABWIDTH As Long = 4
  Public Const DEFAULT_MAXIMIZELOGICS As Long = True
  Public Const DEFAULT_AUTOQUICKINFO As Boolean = True
  Public Const DEFAULT_USETXT As Boolean = False
  
  'Public Const DEFAULT_EFONTNAME As String = "Courier New"
  Public DEFAULT_EFONTNAME As String
  Public Const DEFAULT_EFONTSIZE As Long = 10
  'Public Const DEFAULT_PFONTNAME As String = "Courier New"
  Public DEFAULT_PFONTNAME As String
  Public Const DEFAULT_PFONTSIZE As Long = 10
  Public Const DEFAULT_HCCOMMENT As Long = &H8000&
  Public Const DEFAULT_HCIDENTIFIER As Long = &H40&
  Public Const DEFAULT_HCKEYWORD As Long = &H7F0000
  Public Const DEFAULT_HCNORMAL As Long = &H0&
  Public Const DEFAULT_HCSTRING As Long = &H5050&
  Public Const DEFAULT_OPENONERR As Long = 0
  Public Const DEFAULT_SAVEONCOMP As Long = 0
  Public Const DEFAULT_COMPONRUN As Long = 0
  Public Const DEFAULT_LOGICUNDO As Long = -1
  Public Const DEFAULT_WARNMSGS As Long = 0
  
  Public Const DEFAULT_PICSCALE_EDIT As Long = 2
  Public Const DEFAULT_PICSCALE_PREVIEW As Long = 1
  Public Const DEFAULT_PICTEST_HORIZON As Long = 36
  Public Const DEFAULT_PICTEST_OBJSPEED As Long = 1
  Public Const DEFAULT_PICTEST_OBJPRIORITY As Long = 16 'automatic
  Public Const DEFAULT_PICTEST_OBJRESTRICTION As Long = 0 'none
  Public Const DEFAULT_PICTEST_IGNOREHORIZON  As Boolean = False
  Public Const DEFAULT_PICTEST_IGNOREBLOCKS  As Boolean = False
  Public Const DEFAULT_PICTEST_CYCLEATREST  As Boolean = False
  Public Const DEFAULT_PICUNDO As Long = -1
  Public Const DEFAULT_SHOWBANDS  As Boolean = True
  Public Const DEFAULT_SPLITWINDOW As Boolean = True
  
  Public Const DEFAULT_SHOWKYBD As Boolean = True
  Public Const DEFAULT_SHOWNOTES As Boolean = True
  Public Const DEFAULT_SNDUNDO As Long = -1
  Public Const DEFAULT_SNDZOOM As Long = 2
  Public Const DEFAULT_NOMIDI As Boolean = False
  Public Const DEFAULT_DEFINST As Byte = 0
  Public Const DEFAULT_DEFMUTE As Boolean = False
  
  Public Const DEFAULT_VIEWSCALE_EDIT As Long = 6
  Public Const DEFAULT_VIEWSCALE_PREVIEW As Long = 3
  Public Const DEFAULT_VIEWALIGNH As Long = 0
  Public Const DEFAULT_VIEWALIGNV As Long = 0
  Public Const DEFAULT_VIEWUNDO As Long = -1
  Public Const DEFAULT_DEFCELH As Long = 32
  Public Const DEFAULT_DEFCELW As Long = 16
  Public Const DEFAULT_DEFVCOLOR1 As Long = agBlack
  Public Const DEFAULT_DEFVCOLOR2 As Long = AGWHITE
  
  Public Const DEFAULT_NAMECASE As Long = vbProperCase
  Public Const DEFAULT_NUMFORMAT As String = "000"
  Public Const DEFAULT_SEPARATOR As String = "."
  
  Public Const DEFAULT_LEROOM_EDGE As Long = &H55AA
  Public Const DEFAULT_LEROOM_FILL As Long = &H55FFFF
  Public Const DEFAULT_LETRANSPT_EDGE As Long = &HAAAA00
  Public Const DEFAULT_LETRANSPT_FILL As Long = &HFFFF55
  Public Const DEFAULT_LEERR_EDGE As Long = &HAA&
  Public Const DEFAULT_LEERR_FILL As Long = &H5555FF
  Public Const DEFAULT_LECMT_EDGE As Long = &HAA00&
  Public Const DEFAULT_LECMT_FILL As Long = &H55FF55
  Public Const DEFAULT_LEEXIT_EDGE As Long = &HAA0000
  Public Const DEFAULT_LEEXIT_OTHERS As Long = &HFF55FF
  Public Const DEFAULT_LEZOOM As Long = 6
  
  Public Const DEFAULT_SHOWALLMSGS As Boolean = True
  Public Const DEFAULT_ELSEASGOTO  As Boolean = False
  Public Const DEFAULT_SPECIALSYNTAX As Boolean = True
  Public Const DEFAULT_SYNTAX As Long = lsAGI
  Public Const DEFAULT_SHOWRESVARS  As Boolean = True
  Public Const DEFAULT_USERESERVED As Boolean = True
  Public Const DEFAULT_ERRORLEVEL As Long = leMedium
  
  'string constants
  Public Const sLOGED As String = "Logic Editor - "
  Public Const sPICED As String = "Picture Editor - "
  Public Const sSNDED As String = "Sound Editor - "
  Public Const SVIEWED As String = "View Editor - "
  Public Const sDM As String = "* "   'dirty file marker'
  Public Const sGENERAL As String = "General"
  Public Const sLOGICS As String = "Logics"
  Public Const sPICTURES As String = "Pictures"
  Public Const sSOUNDS As String = "Sounds"
  Public Const sVIEWS As String = "Views"
  Public Const sLAYOUT As String = "Layout"
  Public Const sPOSITION As String = "Position"
  Public Const sMRULIST As String = "MRUList"
  Public Const sTOOLS As String = "Tools"
  Public Const sOPENFILTER As String = "OpenFilter"
  Public Const sSAVEFILTER As String = "SaveFilter"
  Public Const sEXPFILTER As String = "ExportFilter"
  
  'various constants
  Public Const PropRowHeight = 17 'in pixels
  Public Const LtGrey = &HC0C0C0
  Public Const DkGrey = &HD8E9EC
  Public Const SelBlue = &HC56A31
  'Public Const PropSplitLoc = 65
  Public PropSplitLoc As Long
  
  'enums
  Public Enum UndoNameID
    UID_UNKNOWN = 0
    UID_TYPING = 1
    UID_DELETE = 2
    UID_DRAGDROP = 3
    UID_CUT = 4
    UID_PASTE = 5
  End Enum
  
  Public Enum ReplaceMode
    rpYes
    rpYesToAll
    rpNo
    rpNoToAll
  End Enum
      
  Public Enum EGetRes
    grAddNew
    grRenumber
    grOpen
    grTestView
    grAddLayout
    grShowRoom
    grMenu
    grImport
  End Enum
  
  Public Enum GameSettingFunction
    gsEdit
    gsNew
  End Enum
  
  Public Enum UpDateModeType
    umTree = 1
    umProperty = 2
    umPreview = 4
  End Enum
  
  Public Enum ViewEditMode
    vmBitmap
    vmView
    vmLoop
    vmCel
  End Enum
  
  Public Enum ELogicFormMode
    fmLogic
    fmText
  End Enum
  
  Public Enum FindDirection
    fdAll
    fdDown
    fdUp
  End Enum
  
  Public Enum FindLocation
    flCurrent
    flOpen
    flAll
  End Enum
  
  Public Enum FindFormFunction
    ffFindWord
    ffReplaceWord
    ffFindObject
    ffReplaceObject
    ffFindLogic
    ffReplaceLogic
  End Enum
  
  Public Enum FindFormAction
    faFind
    faReplace
    faReplaceAll
    faCancel
  End Enum
  
  Public Enum TPicToolTypeEnum
    ttNone
    ttSetPen
    ttLine
    ttRelLine
    ttCorner
    ttFill
    ttPlot
    ttRectangle
    ttTrapezoid
    ttEllipse
    ttEdit
    ttMove
  End Enum
  
  Public Enum EPicMode
    pmEdit
    pmTest
  End Enum
  
  Public Enum EButtonFace
    bfNone
    bfDown
    bfOver
    bfDialog
  End Enum
  
  Public Enum ENoteTone
    ntNone
    ntNatural
    ntSharp
    ntFlat
  End Enum
  
  Public Enum ELSelection
    lsNone
    lsRoom
    lsExit
    lsTransPt
    lsComment
    lsErrPt
    lsMultiple
  End Enum
  
  Public Enum ELLeg
    llNoTrans   '  0 means no trans pt
    llFirst     '  1 means first leg of trans pt
    llSecond    '  2 means second leg of trans pt
  End Enum
  
  Public Enum ELTwoWay
    ltwSingle    '  0 means a single direction exit
    ltwOneWay    '  1 means a two way exit but only one way selected
    ltwBothWays  '  2 means a two way exit and both are considered 'selected'
  End Enum
  
  Public Enum ELayoutTool
    ltNone
    ltSelect
    ltEdge1
    ltEdge2
    ltOther
    ltRoom
    ltComment
  End Enum
  
  Public Enum EEReason
    erNone
    erHorizon
    erRight
    erBottom
    erLeft
    erOther
    erUnknown
  End Enum
  
  Public Enum EEStatus
    esOK
    esNew
    esChanged
    esDeleted
  End Enum
  
  Public Enum EArgListType
    alAll = -1
    alByte = 0
    alVar = 1
    alFlag = 2
    alMsg = 3
    alSObj = 4
    alIObj = 5
    alStr = 6
    alWord = 7
    alCtl = 8
    alDefStr = 9
    alVocWrd = 10
    alLogic = 11
    alSound = 12
    alView = 13
  End Enum
  
  Public Type tResource
    NameCase As VbStrConv
    Separator As String
    NumFormat As String
  End Type
  
  Public Type tDefaultScale
    Edit As Integer
    Preview As Integer
  End Type
  
  Public Type tDisplayNote
    Pos As Long
    Tone As ENoteTone
  End Type
  
  'need to define type here so it is available publicly
  Public Type TPicTest
    ObjSpeed As Long
    ObjPriority As Long '16 means auto; 4-15 correspond to priority bands
    ObjRestriction As Long '0 = no restriction
                                '1 = restrict to water
                                '2 = restrict to land
    Horizon As Long
    IgnoreHorizon As Boolean
    IgnoreBlocks As Boolean
    TestLoop As Long
    TestCel As Long
    CycleAtRest As Boolean
  End Type

  Public Type LEObjColor
    Edge As Long
    Fill As Long
  End Type
  
  Public Type TLEColors
    Room As LEObjColor
    ErrPt As LEObjColor
    TransPt As LEObjColor
    Cmt As LEObjColor
    Edge As Long
    Other As Long
  End Type
  
  Public Type agiSettings
    ShowSplashScreen As Boolean
    SkipPrintWarning As Boolean
    UseLE As Boolean
    LEPages As Boolean
    LEWarnDelete As Boolean
    LEUseGrid As Boolean
    LEGrid As Single
    WarnCompile As Boolean
    WarnDupGName As Boolean
    WarnDupGVal As Boolean
    WarnResOvrd As Boolean
    WarnDupObj As Boolean
    ShowPreview As Boolean
    ShiftPreview As Boolean
    ShowTree As Boolean
    AutoOpen As Boolean
    AutoExport As Boolean
    AskExport As Boolean
''    AutoUpdateWords As Long '0 = ask; 1 = no; 2 = yes
''    AutoUpdateObjects As Long '0 = ask; 1 = no; 2 = yes
    ShowResNum As Boolean
    IncludeResNum As Boolean
    MaxSO As Long
    HighlightText As Boolean
    
    LogicTabWidth As Long
    MaximizeLogics As Boolean
    AutoQuickInfo As Boolean
    UseTxt As Boolean
    EFontName As String
    EFontSize As Long
    PFontName As String
    PFontSize As Long
    HCComment As Long
    HCIdentifier As Long
    HCKeyword As Long
    HCNormal As Long
    HCString As Long
    OpenOnErr As Long '0 = ask; 1 = no; 2 = yes
    SaveOnCompile As Long '0 = ask; 1 = no; 2 = yes
    CompileOnRun As Long '0 = ask; 1 = no; 2 = yes
    LogicUndo As Long
    WarnMsgs As Long  '0 = ask; 1 = keep all; 2 = keep only used
    
    PicScale As tDefaultScale
    PicTest As TPicTest
    PicUndo As Long
    ShowBands As Boolean
    SplitWindow As Boolean
    
    ShowKybd As Boolean
    ShowNotes As Boolean
    SndUndo As Long
    SndZoom As Long
    NoMIDI As Boolean
    DefInst0 As Byte
    DefInst1 As Byte
    DefInst2 As Byte
    DefMute0 As Boolean
    DefMute1 As Boolean
    DefMute2 As Boolean
    DefMute3 As Boolean
    
    ViewScale As tDefaultScale
    ViewAlignH As Integer
    ViewAlignV As Integer
    ViewUndo As Long
    DefCelH As Byte
    DefCelW As Byte
    DefVColor1 As Long
    DefVColor2 As Long
    
    MaxVol0Size As Long
    
    ResFormat As tResource
    
    LEColors As TLEColors
    LEZoom As Long
    
    ShowAllMessages As Boolean
    ElseAsGoto As Boolean
    SpecialSyntax As Boolean
    DefaultSyntax As Long
    ReservedAsText As Boolean
    UseReservedNames As Boolean
    ErrorLevel As Long
  End Type
  
  Public Type LCoord
    x As Single
    y As Single
  End Type

  Public Type PT
    x As Byte
    y As Byte
  End Type
  
  'global variables
  Public CurResType As AGIResType
  Public ProgramDir As String
  Public Settings As agiSettings
  Public PreviewWin As frmPreview
  Public MainStatusBar As StatusBar
  Public MainDialog As CommonDialog
  Public MainSaveDlg As SaveDialog
  Public CompStatusWin As frmCompStatus
  Public NotePictures As PictureBox
  Public SelResNum As Long, SelResType As AGIResType
  Public WinVer As OSVERSIONINFO
  Public SettingError As Boolean
  Public WinAGIHelp As String
  
  'editor variables
  Public LogicEditors As Collection
  Public LogCount As Long
  Public PictureEditors As Collection
  Public PicCount As Long
  Public SoundEditors As Collection
  Public SoundCount As Long
  Public ViewEditors As Collection
  Public ViewCount As Long
  Public LayoutEditor As frmLayout
  Public LEInUse As Boolean
  Public MenuEditor As frmMenuEdit
  Public MEInUse As Boolean
  Public ObjectEditor As frmObjectEdit
  Public OEInUse As Boolean
  Public ObjCount As Long
  Public WordEditor As frmWordsEdit
  Public WEInUse As Boolean
  Public WrdCount As Long
  Public GlobalsEditor As frmGlobals
  Public GEInUse As Boolean
  
  'mru variables
  Public strMRU(4) As String

  'clipboard variables
  Public SoundClipboard As AGINotes
  Public SoundCBMode As Long
  Public ClipViewLoop As AGILoop
  Public ClipViewCel As AGICel
  Public PicClipBoardObj As PictureUndo
  Public ViewCBMode As ViewEditMode
  Public ViewClipboard As PictureBox
  Public WordsClipboard As WordsUndo
  Public DroppingWord As Boolean
  
  'local copy of ega colors, to speed color matching
  Public lngEGACol(15) As Long
  
  'find/replace variables
  Public FindForm As frmFind
  Public SearchForm As Form
  Public SearchFindDir As FindDirection
  Public SearchFindText As String
  Public SearchReplaceText As String
  Public SearchMatchWord As Boolean
  Public SearchMatchCase As Boolean
  Public LogicSearchLoc As FindLocation
  Public SearchStartPos As Long
  Public SearchStartLog As Long
  Public SearchType As AGIResType
  Public StartPos As Long
  Public StartWord As Long
  Public StartGrp As Long
  Public FirstFind As Boolean
  Public ResetSearch As Boolean
  Public ClosedLogics As Boolean
  Public ReplaceCount As Long
  
  'property window variables
  Public DropDownDC As Long
  Public DropOverDC As Long
  Public DropDlgDC As Long
  
  'array component names
  Public Const COLORNAME = 1000
  Public Const KEYSIGNATURE = 1100
  Public Const VIEWUNDOTEXT = 1200
  Public Const PICUNDOTEXT = 1300
  Public Const SNDUNDOTEXT = 1400
  Public Const WORDSUNDOTEXT = 1500
  Public Const OBJUNDOTEXT = 1600
  Public Const PICTOOLTYPETEXT = 1800
  Public Const VIEWTOOLTYPETEXT = 1700
  Public Const DRAWFUNCTIONTEXT = 1900
  Public Const STOPREASONTEXT = 2000
  Public Const INSTRUMENTNAMETEXT = 3000
  Public Const ALPHACMDTEXT = 4000
  
  'others
  Public HelpParent As Long
  
  'printer variables
  Public NoPrinter As Boolean
  Public PMLeft As Long, PMTop As Long
  Public PMRight As Long, PMBottom As Long
  Public PHeight As Long, PWidth As Long
  Public PDPIx As Long, PDPIy As Long
  Public NoColor As Boolean
  
  'workaround to force selection pt to update
  'after showing find form...
  Public FixSel As Boolean
Public Function CheckLogics() As Boolean

  'checks all logics; if any found that are dirty
  'allow user to recompile game if desired before
  'running
  
  Dim tmpLogic As AGILogic, i As Long
  Dim rtn As VbMsgBoxResult, blnDontAsk As Boolean
  Dim blnLoaded As Boolean, blnSrcLoaded As Boolean
  
  On Error GoTo ErrHandler
  
  'assume ok
  CheckLogics = True
  
  'if not requiring recompile
  If Settings.CompileOnRun = 1 Then
    'don't even need to check
    'just exit
    Exit Function
  End If
  
  'step through all logics
  For Each tmpLogic In Logics
    blnLoaded = tmpLogic.Loaded
    If Not blnLoaded Then
      tmpLogic.Load
    End If
    blnSrcLoaded = tmpLogic.SourceCode.Loaded
    If Not blnSrcLoaded Then
      tmpLogic.SourceCode.Load
    End If
    If Not tmpLogic.Compiled Then
      'not ok; skip checking and
      'determine if recompiling is appropriate
      CheckLogics = False
      'dont' forget to unload!!
      If Not blnSrcLoaded Then
        tmpLogic.SourceCode.Unload
      End If
      If Not blnLoaded Then
        tmpLogic.Unload
      End If

      Exit For
    End If
    If Not blnSrcLoaded Then
      tmpLogic.SourceCode.Unload
    End If
    If Not blnLoaded Then
      tmpLogic.Unload
    End If
  Next
  
  'if no dirty logics found, check any existing logics that are being edited
  If CheckLogics = True Then
    For i = 1 To LogicEditors.Count
      If LogicEditors(i).FormMode = fmLogic Then
        If LogicEditors(i).rtfLogic.Dirty Then
          'one dirty logic found
          CheckLogics = False
          Exit For
        End If
      End If
    Next i
  End If
  
  'if still no dirty logics found
  If CheckLogics = True Then
    'just exit
    Exit Function
  End If
  
  'if CompileOnRun is in ask mode or yes mode, get user choice
  Select Case Settings.CompileOnRun
  Case 0 'ask for user input
    'get user's response
    rtn = MsgBoxEx("One or more logics have changed since you last compiled." & vbNewLine & _
                   "Do you want to compile them before running?", vbQuestion + vbYesNoCancel, "Compile Before Running?", , , "Always take this action when compiling a game.", blnDontAsk)
    If blnDontAsk Then
      If rtn = vbYes Then
        Settings.CompileOnRun = 2
      ElseIf rtn = vbNo Then
        Settings.CompileOnRun = 1
      End If
    End If
    
  Case 1  'no
    rtn = vbNo
    
  Case 2 ' yes
      rtn = vbYes
  End Select
  
  Select Case rtn
  Case vbCancel
    'return false, so run cmd is canceled
    CheckLogics = False
    
  Case vbNo
    'ok to exit; check is complete
    CheckLogics = True
  Case vbYes
    'if dirtylogics successfully compiled
    CheckLogics = CompileDirtyLogics(True)
  End Select
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function

Public Sub CheckShortcuts(ByRef KeyCode As Integer, ByRef Shift As Integer)

  'check for game-wide shortcut keys
  Select Case Shift
  Case 3 'vbCtrlMask + vbShiftMask
    Select Case KeyCode
    Case vbKeyN 'new game from blank
      If frmMDIMain.mnuGNBlank.Enabled Then
        'create new blank game
        NewAGIGame False
        KeyCode = 0
      End If
      
    Case vbKeyB 'compile to
      If frmMDIMain.mnuGCompileTo.Enabled Then
        'compile game to directory of user's choice
        CompileAGIGame
        KeyCode = 0
      End If
      
    Case vbKeyR 'rebuild VOL
      If frmMDIMain.mnuGRebuild.Enabled Then
        'rebuild volfiles only
        CompileAGIGame GameDir, True
        KeyCode = 0
      End If
    
    Case vbKeyD 'compile dirty logics
      If frmMDIMain.mnuGCompDirty.Enabled Then
        CompileDirtyLogics
        KeyCode = 0
      End If
    End Select
    
  Case vbCtrlMask + vbAltMask
    'import resources
    With frmMDIMain
      'but only if import menu is enabled
      If .mnuRImport.Enabled Then
        Select Case KeyCode
        Case vbKey1
          .RILogic
        Case vbKey2
          .RIPicture
        Case vbKey3
          .RISound
        Case vbKey4
          .RIView
        Case vbKey5
          .RIObjects
        Case vbKey6
          .RIWords
        End Select
      End If
    End With
    
  Case vbCtrlMask
    Select Case KeyCode
    Case vbKey1
      frmMDIMain.RNLogic
    Case vbKey2
      frmMDIMain.RNPicture
    Case vbKey3
      frmMDIMain.RNSound
    Case vbKey4
      frmMDIMain.RNView
    Case vbKey5
      frmMDIMain.RNObjects
    Case vbKey6
      frmMDIMain.RNWords
    Case vbKey7
      frmMDIMain.RNText
    End Select
    
  Case vbAltMask
    Select Case KeyCode
    Case vbKey1
      frmMDIMain.ROLogic
    Case vbKey2
      frmMDIMain.ROPicture
    Case vbKey3
      frmMDIMain.ROSound
    Case vbKey4
      frmMDIMain.ROView
    Case vbKey5
      frmMDIMain.ROObjects
    Case vbKey6
      frmMDIMain.ROWords
    Case vbKey7
      frmMDIMain.ROText
      
    Case vbKeyX 'close game
      If frmMDIMain.mnuGClose.Enabled Then
        frmMDIMain.mnuGClose_Click
        KeyCode = 0
      End If
      
    Case vbKeyN 'renumber
      If frmMDIMain.mnuRRenumber.Enabled Then
        frmMDIMain.mnuRRenumber_Click
        KeyCode = 0
      End If
      
    Case vbKeyF1  'logic command help
      'select commands start page
      HtmlHelp HelpParent, WinAGIHelp, HH_HELP_CONTEXT, 1001
      KeyCode = 0
    End Select
    
  Case 0 'no mask
  End Select
End Sub


Public Function CmdInfo(rtfLogic As RichEditAGI) As String

  Dim rtn As Long, tmpRange As RichEdAGI.Range
  Dim lngCmdPos As Long
  Dim strLine As String
  
  On Error GoTo ErrHandler
  
  'set cmd start pos
  lngCmdPos = rtfLogic.Selection.Range.EndPos
  
    'get line where enter was pressed
    rtn = SendMessage(rtfLogic.hWnd, EM_LINEFROMCHAR, rtfLogic.Selection.Range.StartPos, 0)
    'get the start of this line
    rtn = SendMessage(rtfLogic.hWnd, EM_LINEINDEX, rtn, 0)
    Set tmpRange = rtfLogic.Range(rtn, rtn)
    tmpRange.Expand (reLine)
    strLine = Left$(tmpRange.Text, Len(tmpRange.Text) - 1)
    Set tmpRange = Nothing
    CmdInfo = strLine
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function

Public Function FindPrevCmd(ByRef strText As String, ByRef lngStartPos As Long, ByRef lngArgCount As Long, ByVal TextSyntax As LogicSyntaxType, Optional ByVal blnInQuote As Boolean = False, Optional ByVal blnPrev As Boolean = False) As String

  'searches backwards through strText and returns the command currently being
  'edited; null string if there isn't one
  '
  'cmd is found by looking for an open parenthesis "("; the word
  'in front of this parenthesis is the cmd of interest
  '
  'stop looking when:
  ' - a cmd is found (a word separator is found in front of
  '    the char string that precedes the parenthesis)
  ' - beginning of logic is reached
  ' - cursor moves to previous line
  '    for lsAGI, that's a semicolon ";" or bracket "{" or "}"
  '    for lsVB, it's a carriage return
  '      that does not have a continuation marker
  '
  'commas determine argcount
  '
  'if quotes are found, ignore all chars inside as they are
  'part of a string declaration
  
  Dim lngPos As Long, i As Long
  Dim strLine As String, intChar As Integer
  Dim strCmd As String, blnSpace As Boolean
  Dim strPrevCmd As String, lngPrevPos As Long
  
  On Error GoTo ErrHandler
  
  Dim blnCmdFound As Boolean
  
  lngArgCount = 0
  lngPos = lngStartPos
  
  Do While lngPos >= 1
    intChar = AscW(Mid$(strText, lngPos))
    
    'check this character
    Select Case intChar
    Case 40 '(
      'if NOT in a quote
      If Not blnInQuote Then
        'if already have cmd of interest
        If blnPrev Then
          'just exit
          Exit Do
        End If
        
        'the cmd in front of this char is the one of interest
        blnPrev = True
      End If
      
      'always ignore this char, whether in a quote or not
      intChar = 0
      
    Case 13 'bumping up a line
      'should never be in a string
      Debug.Assert Not blnInQuote
      'if it is, just exit...
      If blnInQuote Then
        Exit Do
      End If
      
      'if building the cmd of interest, just exit; commands
      'will never be on separate lines
      If blnPrev Then
        Exit Do
      End If
      
      'check if this previous line is commented out
      
      'first, get the entire line by finding
      'a carriage return
      If lngPos > 1 Then
        i = InStrRev(strText, vbCr, lngPos - 1)
        If i = 0 Then i = 1
      Else
        i = 1
      End If
      strLine = Mid$(strText, i, lngPos - i + 1)
      
      'if this line ends as a comment
      'then can't find a command; just exit
      If CheckLine(strLine, TextSyntax) Then
        Exit Do
      End If
      
      'for vb syntax only, exit if the line is NOT a continuation
      If TextSyntax = lsVB Then
        If lngPos > 2 Then
          If Mid$(strText, lngPos - 2, 2) <> " _" Then
            Exit Do
          End If
        End If
      End If
      
      'always ignore this char, whether in a quote or not
      intChar = 0
      
    Case 59 'semi-colon
      If Not blnInQuote Then
        'for agi syntax, always stop here
        If TextSyntax = lsAGI Then
          Exit Do
        End If
        
        'if prev word is of interest
        If blnPrev Then
          'exit
          Exit Do
        End If
      End If
      
      'always ignore this char, whether in a quote or not
      intChar = 0
      
    Case 47 'slash; to check for a block comment end
      If Not blnInQuote Then
        'if prev word is of interest
        If blnPrev Then
          'exit
          Exit Do
        End If
        
        If TextSyntax = lsAGI Then
          'is previous char an asterisk?
          If lngPos > 1 Then
            If AscW(Mid$(strText, lngPos - 1)) = 42 Then
              Exit Do
            End If
          End If
        End If
      End If
      
      'always ignore this char, whether in a quote or not
      intChar = 0
      
    Case 34 'a quote
      If Not blnInQuote Then
        'if prev word is of interest
        If blnPrev Then
          'exit
          Exit Do
        End If
        
        'toggle inqoute flag to true
        blnInQuote = True
      Else
        'check if this is NOT an embedded quote (check for preceding backslash)
        'then toggle the inquote flag back to false
        If lngPos > 1 Then
          If AscW(Mid$(strText, lngPos - 1)) <> 92 Then
            blnInQuote = False
          End If
        End If
      End If
      
      'always ignore this char, whether in a quote or not
      intChar = 0
      
    Case 44 'comma
      If Not blnInQuote Then
        'if prev word is of interest
        If blnPrev Then
          'exit
          Exit Do
        End If
        
        'increment argument count
        lngArgCount = lngArgCount + 1
      End If
    
      'always ignore this char, whether in a quote or not
      intChar = 0
      
    Case 9, 32 'space (or tab)
      If Not blnInQuote Then
        'if prev word is of interest
        If blnPrev Then
          'exit
          Exit Do
        End If
      End If
      
      'always ignore this char, whether in a quote or not
      intChar = 0
      
    Case 123, 125 '{ and }
      'in AGI syntax, exit on brackets
      If Not blnInQuote Then
        If TextSyntax = lsAGI Then
          Exit Do
        End If
      End If
      
      'always ignore this char, whether in a quote or not
      intChar = 0
    
    'check for other token separators
    Case 33, 35, 38, 39, 41, 42, 43, 45, 47, 58, 60, 61, 62, 63, 91, 92, 93, 94, 96, 124, 126
      If Not blnInQuote Then
        Exit Do
      End If
      
      'always ignore this char, whether in a quote or not
      intChar = 0
          
    End Select
    
    'ignore characters that don't matter
    If intChar And blnPrev Then
      strCmd = ChrW$(intChar) & strCmd
    End If
    
    lngPos = lngPos - 1
  Loop
  
  
  FindPrevCmd = strCmd
  lngStartPos = lngPos + Len(strCmd)

Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function
Public Function CheckLine(ByRef strLine As String, TextSyntax As LogicSyntaxType, Optional ByRef blnInQuote As Boolean = False) As Boolean

  'this function will examine a line of text to see if the
  'end pos is either in a comment or in a string
  
  Dim lngPos As Long
  Dim rtn As Long, i As Long
  Dim blnInComment As Boolean
  
  On Error GoTo ErrHandler
  
  'length
  rtn = Len(strLine)
  i = 1
  
  Do Until i > rtn
    'is this a string character or comment character?
    Select Case AscB(Mid$(strLine, i))
    Case 34 'double quote mark
      'if not already in a quote
      If Not blnInQuote Then
        'now we are...
        blnInQuote = True
      Else
        'MAYBE this is an embedded quote?
        '(dont need to error check ASC function
        'since we know i>1 because quote flag can
        'only be true if a quote was previously found
        'and i will already have been incremented
        If Asc(Mid$(strLine, i - 1)) <> 92 Then
          'this is NOT an embedded quote
          blnInQuote = False
        End If
      End If
    
    Case 47 'slash, to check for '//'
      'if not in a quote AND agi syntax
      If TextSyntax = lsAGI And Not blnInQuote Then
        'check for dbl slash
        If i < Len(strLine) Then
          If AscB(Mid$(strLine, i + 1)) = 47 Then
            'this is line is a comment
            blnInComment = True
            Exit Do
          End If
        End If
      End If
     
    Case 91 'open square bracket
      'if not in a quote AND vb syntax
      If TextSyntax = lsAGI And Not blnInQuote Then
        'this line is a comment
        blnInComment = True
        Exit Do
      End If
    
    Case 39 'single quote
      'if not in a quote AND vb syntax
      If TextSyntax = lsVB And Not blnInQuote Then
        'this line is a comment
        blnInComment = True
        Exit Do
      End If
      
    Case 82, 114 'R/r to check for Rem/rem
      'if not in a quote AND vb syntax
      If TextSyntax = lsVB And Not blnInQuote Then
        'check for word 'rem '
        If LCase$(Mid$(strLine, i, 4)) = "rem " Then
          'this line is a comment
          blnInComment = True
          Exit Do
        End If
      End If
      
    End Select
    
    i = i + 1
  Loop
  
  If blnInComment Then
    Debug.Print "in comment!"
  ElseIf blnInQuote Then
    Debug.Print "in quote!"
  End If
  
  'if in a quote or in a comment, just exit
  If blnInQuote Or blnInComment Then
    CheckLine = True
    Exit Function
  End If
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function
Public Function InBlockComment(ByVal strText As String, ByVal lngPos As Long) As Boolean

  'to check for block comment, start at beginning, move until at curpos
  'search for first start(/*), setting block level to one; then loop;
  'looking for starts and ends; for each start that occurs before an
  'end(*/), increment block level; for each end that occurs before a
  'start, decrement block level(but never less than zero)
  'if block level is >0 at curpos, then cursor is in a comment block
  
  
  Dim i As Long, lngStart As Long, lngEnd As Long
  Dim lngDepth As Long
  
  On Error GoTo ErrHandler
  
  i = InStr(1, strText, "/*")
  If i <> 0 And i < lngPos Then
    'a block quote is started
    lngDepth = lngDepth + 1
  End If
  
  Do Until i = 0 Or i >= lngPos
    'is there another starting marker?
    lngStart = InStr(i + 1, strText, "/*")
    'is there an end marker?
    lngEnd = InStr(i + 1, strText, "*/")
    
    'zero means not found; convert it to max to facilitate comparisons
    If lngStart = 0 Then
      lngStart = &H7FFFFFFF
    End If
    If lngEnd = 0 Then
      lngEnd = &H7FFFFFFF
    End If
    
    'if both are past endpos
    If (lngStart >= lngPos And lngEnd >= lngPos) Then
      'done
      Exit Do
    End If
    
    'if start marker is first,
    If lngStart < lngEnd Then
      'increment block depth
      lngDepth = lngDepth + 1
      i = lngStart
    Else
      'end marker must be first
      lngDepth = lngDepth - 1
      'can't go negative
      If lngDepth < 0 Then
        lngDepth = 0
      End If
      i = lngEnd
    End If
  Loop
  
  InBlockComment = (lngDepth > 0)
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function

Public Sub LastForm(ThisForm As Form)
  
  'checks if this is last visible form; if so, resets menus
  
  Dim tmpForm As Form
  
  On Error GoTo ErrHandler
  
  For Each tmpForm In Forms
    If Not (tmpForm Is ThisForm) Then
      If tmpForm.Name <> "frmMDIMain" Then
        If tmpForm.MDIChild Then
          'another open form found
          Exit Sub
        End If
      End If
    End If
  Next
  
  'no other form found; this is last form
  AdjustMenus rtNone, False, False, False
  
  'disable windows menu (done here, because no other easy way
  'to tell if no forms are left)
  frmMDIMain.mnuWindow.Enabled = False
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Public Function LogicCmd(strCmd As String) As Long

  'returns the command number of the string
  'if strCmd matches an AGI command
  
  Dim i As Long, j As Long, k As Long
  
  If LenB(strCmd) = 0 Then
    LogicCmd = -1
    Exit Function
  End If
  
  'index based on first letter
  Select Case Asc(strCmd)
  Case 97, 65 'a
    i = 0
    j = 7
  Case 98, 66 'b
    i = 8
    j = 8
  Case 99, 67 'c
    i = 9
    j = 20
  Case 100, 68 'd
    i = 21
    j = 34
  Case 101, 69 'e
    i = 35
    j = 39
  Case 102, 70 'f
    i = 40
    j = 43
  Case 103, 71 'g
    i = 44
    j = 53
  Case 104, 72 'h
    i = 54
    j = 54
  Case 105, 73 'i
    i = 55
    j = 60
  Case 108, 76 'l
    i = 61
    j = 72
  Case 109, 77 'm
    i = 73
    j = 77
  Case 110, 78 'n
    i = 78
    j = 82
  Case 111, 79 'o
    i = 83
    j = 92
  Case 112, 80 'p
    i = 93
    j = 102
  Case 113, 81 'q
    i = 103
    j = 103
  Case 114, 82 'r
    i = 104
    j = 115
  Case 115, 83 's
    i = 116
    j = 153
  Case 116, 84 't
    i = 154
    j = 156
  Case 119, 87 'w
    i = 157
    j = 158
  Case Else
    'not a command
    LogicCmd = -1
    Exit Function
  End Select
  
  For k = i To j
    If StrComp(strCmd, LoadResString(ALPHACMDTEXT + k), vbTextCompare) = 0 Then
      LogicCmd = k
      Exit Function
    End If
  Next k

  'not found
  LogicCmd = -1
End Function

Public Sub BuildCmdTip(picTip As PictureBox, ByVal Syntax As LogicSyntaxType, ByVal CmdIndex As Long, ByVal ArgIndex As Long)

  Dim strArgs() As String
  Dim i As Long
  
  On Error GoTo ErrHandler
  
  With picTip
    'split into array to get different args
    strArgs = Split(LoadResString(5000 + CmdIndex), ",")
    
    'if this is agi syntax
    If Syntax = lsAGI Then
      'add parentheses
      .Width = .Width + .TextWidth("()")
      picTip.Print "(";
    Else
      'add space
      .Width = .Width + .TextWidth(" ")
      picTip.Print " ";
    End If
    
    'if first arg is selected
    If ArgIndex = 0 Then
      picTip.FontBold = True
    End If
    
    'add first arg
    .Width = .Width + .TextWidth(strArgs(0))
    picTip.Print strArgs(0);
  
    'reset bold
    picTip.FontBold = False
    
    'add rest of args
    For i = 1 To UBound(strArgs())
      'add comma
      .Width = .Width + .TextWidth(",")
      picTip.Print ",";
      
      'if this arg is currently selected
      If i = ArgIndex Then
        picTip.FontBold = True
      End If
      
      'add the arg
      .Width = .Width + .TextWidth(strArgs(i))
      picTip.Print strArgs(i);
      
      'reset bold
      .FontBold = False
    Next i
    
    'if syntax is agi
    If Syntax = lsAGI Then
      'add closing parentheses
      picTip.Print ")"
    End If
  End With
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Public Sub RedrawCmdTipBox(picTip As PictureBox, strTipCmd As String, LogicSyntax As LogicSyntaxType, ByVal lngTipCmd As Long, ByVal lngCurArg As Long)
  
  With picTip
    'disable redraw to reduce flicker
    SendMessage .hWnd, WM_SETREDRAW, 0, 0
    
    .Cls
    .FontBold = False
    
    'add command
    .Width = .TextWidth(strTipCmd & " ")
    picTip.Print strTipCmd;
    'build arg list
    BuildCmdTip picTip, LogicSyntax, lngTipCmd, lngCurArg
    
    'reenable updating
    SendMessage .hWnd, WM_SETREDRAW, 1, 0
    .Refresh
  End With
End Sub

Public Sub SetLogicCompiledStatus(ByVal ResNum As Byte, ByVal Compiled As Boolean)

  Dim tmpNode As Node
  
  Set tmpNode = frmMDIMain.tvwResources.Nodes(2).Child
  
  Do Until tmpNode.Tag = ResNum
    Set tmpNode = tmpNode.Next
  Loop
    
  'set compiled status
  If Compiled Then
    tmpNode.ForeColor = vbBlack
  Else
    tmpNode.ForeColor = vbRed
  End If
  
  Set tmpNode = Nothing
End Sub

Public Sub UpdateSelection(ByVal ResType As AGIResType, ByVal ResNum As Long, ByVal UpDateMode As UpDateModeType)

  'updates the resource tree, property box, and preview window for a given resource
  Dim tmpNode As Node
  
  On Error GoTo ErrHandler
  
  If ResNum < 0 Or ResNum > 255 Then
    Exit Sub
  End If
  
  'if updating tree, OR if updating a logic
  If ((UpDateMode And umTree) And Settings.ShowTree) Or ResType = rtLogic Then
    'find the node for this resource
    Select Case ResType
    Case rtLogic
      Set tmpNode = frmMDIMain.tvwResources.Nodes(2).Child
    Case rtPicture
      Set tmpNode = frmMDIMain.tvwResources.Nodes(3).Child
    Case rtSound
      Set tmpNode = frmMDIMain.tvwResources.Nodes(4).Child
    Case rtView
      Set tmpNode = frmMDIMain.tvwResources.Nodes(5).Child
    End Select
    
    Do Until tmpNode.Tag = ResNum
      Set tmpNode = tmpNode.Next
    Loop
    
    'change text for this node to match the resource name
    Select Case ResType
    Case rtLogic
      tmpNode.Text = ResourceName(Logics(ResNum), True)
      'also set compiled status
      Dim blnLoaded As Boolean
      blnLoaded = Logics(ResNum).Loaded
      If Not blnLoaded Then
        Logics(ResNum).Load
      End If
      Dim blnSrcLoaded As Boolean
      blnSrcLoaded = Logics(ResNum).SourceCode.Loaded
      If Not blnSrcLoaded Then
        Logics(ResNum).SourceCode.Load
      End If
      If Not Logics(ResNum).Compiled Then
        tmpNode.ForeColor = vbRed
      Else
        tmpNode.ForeColor = vbBlack
      End If
      If Not blnSrcLoaded Then
        Logics(ResNum).SourceCode.Unload
      End If
      If Not blnLoaded Then
        Logics(ResNum).Unload
      End If
    Case rtPicture
      tmpNode.Text = ResourceName(Pictures(ResNum), True)
    Case rtSound
      tmpNode.Text = ResourceName(Sounds(ResNum), True)
    Case rtView
      tmpNode.Text = ResourceName(Views(ResNum), True)
    End Select
  End If
  
  'if the selected item matches the update item
  If SelResType = ResType And SelResNum = ResNum Then
    'if updating properties OR updating tree AND tree is visible
    If ((UpDateMode And umProperty) Or (UpDateMode And umTree)) And Settings.ShowTree Then
      'redraw property window
      frmMDIMain.PaintPropertyWindow
    End If
    
    'if updating preview
    If (UpDateMode And umPreview) And Settings.ShowPreview Then
      'redraw the preview
      PreviewWin.LoadPreview ResType, ResNum
    End If
  End If
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Public Sub SetError(ByVal lngErrLine As Long, strErrMsg As String, ByVal LogicNumber As Long, strModule As String, Optional ByVal blnWarning As Boolean = False)
  'this procedure uses errinfo to open the file
  'with the error, if possible,
  'highlights the line with the error,
  'and displays the error message in the status bar
  
  Dim i As Integer
  Dim rtn As Long, lng1st As Long
  Dim lngStart As Long, lngLength As Long
  Dim lngLineCount As Long
  Dim frmTemp As Form
  
  On Error GoTo ErrHandler
  
  'if an include module filename is passed,
  If strModule <> vbNullString Then
    'module info contains name- attempt to open include file
    
    'if not  max number of editors
    If LogicEditors.Count < MaxLogicEditors Then
      OpenTextFile strModule, True
      'set focus to this file
      For i = 1 To LogicEditors.Count
        If LogicEditors(i).FormMode = fmText Then
          'if this is the form we are looking for
          If LogicEditors(i).FileName = strModule Then
            Set frmTemp = LogicEditors(i)
            Exit For
          End If
        End If
      Next i
    End If
    
    'if text editor not found,
    If frmTemp Is Nothing Then
      'if just warning, exit
      If blnWarning Then
        Exit Sub
      End If
      
      'set error line to zero
      lngErrLine = 0
      'set error msg to indicate include file not opened
      strErrMsg = strErrMsg & " (in INCLUDE file)"
    End If
  End If
  
  'if no editor assigned yet,
  If frmTemp Is Nothing Then
    'check if logic is already open
    For i = 1 To LogicEditors.Count
      If LogicEditors(i).FormMode = fmLogic Then
        If LogicEditors(i).LogicNumber = LogicNumber Then
          'this is it
          Set frmTemp = LogicEditors(i)
          Exit For
        End If
      End If
    Next i
    
    'if not found
    If frmTemp Is Nothing Then
      'open a new one, if possible
      OpenLogic LogicNumber, True
      
      'now try to find the newly opened editor
       For i = 1 To LogicEditors.Count
        If LogicEditors(i).FormMode = fmLogic Then
          If LogicEditors(i).LogicNumber = LogicNumber Then
            'this is it
            Set frmTemp = LogicEditors(i)
            Exit For
          End If
        End If
      Next i
    End If
  End If
  
  'if still nothing
  If frmTemp Is Nothing Then
    'if just a warning
    If blnWarning Then
      Exit Sub
    End If
    
    'try a message box instead
    MsgBox "ERROR in line " & CStr(lngErrLine + 1) & ": " & strErrMsg, vbOKOnly + vbCritical, "Compile Logic Error"
    Exit Sub
  End If
  
  If frmTemp.Enabled Then
    'set focus to this editor NOT WORKING!!!
    frmTemp.SetFocus
  Else
    frmTemp.ZOrder
  End If
  
  'get number of lines in this editor
  lngLineCount = SendMessage(frmTemp.rtfLogic.hWnd, EM_GETLINECOUNT, 0&, 0&)
  'get character position of first error line
  lngStart = SendMessage(frmTemp.rtfLogic.hWnd, EM_LINEINDEX, lngErrLine - 1, 0&)
  frmTemp.rtfLogic.Selection.Range.StartPos = lngStart
  'if past end of input
  If lngErrLine >= lngLineCount Then
    'set length to select to end of input
    lngLength = Len(frmTemp.rtfLogic.Text) - lngStart
    frmTemp.rtfLogic.Selection.Range.EndPos = frmTemp.rtfLogic.Selection.Range.StartPos + lngLength
  Else
    'get character position of line immediately below last error line
    lngLength = SendMessage(frmTemp.rtfLogic.hWnd, EM_LINEINDEX, lngErrLine, 0&) - lngStart
    frmTemp.rtfLogic.Selection.Range.EndPos = frmTemp.rtfLogic.Selection.Range.StartPos + lngLength
    'move cursor back one character to put it at end of last error line
    SendKeys "+{LEFT}"
  End If
  
  'scroll so this line is visible four lines from top:
  'get currently visible first line
  lng1st = SendMessage(frmTemp.rtfLogic.hWnd, EM_GETFIRSTVISIBLELINE, 0&, 0&)
  'determine amount of scrolling to do
  rtn = SendMessage(frmTemp.rtfLogic.hWnd, EM_LINESCROLL, 0&, lngErrLine - 2 - lng1st)
  'refresh the screen
  frmTemp.rtfLogic.Refresh
  
  'if not a warning
  If Not blnWarning Then
    'set status bar
    MainStatusBar.Panels("Status").Text = "ERROR in line " & CStr(lngErrLine) & ": " & strErrMsg
    SettingError = True
  End If
  
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Public Function FindNextToken(strText As String, ByRef lngPos As Long, ByVal Syntax As LogicSyntaxType, Optional ByRef strFindCmd As String = vbNullString, Optional ByVal UpdatePos As Boolean = True, Optional ByVal ValidCmds As Boolean = False) As Long
  'this function returns the starting position of the
  'next instance of strFindCmd, and optionally adjusts lngPos to the
  'end of the token
  '
  'tokens are comprised of token elements, and separated by element separators
  'token elements include:
  '  characters a-z, A-Z, numbers 0-9, and:  #$%.@_
  '  NOTE: inside quotations, ALL characters, including spaces
  '  are considered token elements
  '
  'element separators include:
  '  space, !"&'()*+,-/:;<=>?[\]^`{|}~
  '
  'for compiling, element separators other than space are normally returned
  'as a single character token with some exceptions; this method
  'is only used to find word-type tokens, so no checks are made
  'for non-alphanumeric multiple character tokens
      '  !=, &&, *=, ++, +=, --, -=, /=, //, <=, <>, =<, ==, =>, >=, ><, ||
      '
  'when a token starts with a quote, the function returns
  'after a closing quote is found, regardless of characters
  'inbetween the quotes
  '
  'if strFindCmd not found, it returns 0
  'if strFindCmd is the keyphrase "##LE", find next LE exit marker
  
  'comments are returned as tokens; assumption is that starting
  'point (lngPos) is NOT within a commment (either a line or a block) to start with
  
  'this search is NOT case sensitive
  
  Dim intChar As Integer, blnContinue As Boolean
  Dim blnEmbed As Boolean, blnInQuotes As Boolean
  Dim lngBlock As Long, strToken As String
  Dim lngLen As Long, blnNextToken As Boolean
  Dim lngTknPos As Long
  
  'use local copy of position
  lngTknPos = lngPos
  
  'if no search string passed, return next cmd
  blnNextToken = (LenB(strFindCmd) = 0)
  
  'quick check for a search string
  If Not blnNextToken Then
    If InStrB(lngTknPos + 1, strText, strFindCmd, vbTextCompare) = 0 Then
      'not found
      If UpdatePos Then
        lngPos = 0
      End If
      Exit Function
    End If
  End If
  
  'convert string length into variable for speed
  lngLen = Len(strText)
  
  'step through cmds until a match is found
  Do
    'find next non-blank character
    intChar = NextChar(strText, vbNullString, lngTknPos, Syntax)
    'if at end of input,
    If lngTknPos = 0 Then
      'not found; just exit
      If UpdatePos Then
        lngPos = 0
      End If
      FindNextToken = 0
      Exit Function
    End If
    
    On Error GoTo ErrHandler
    
    'assume this position begins a token
    FindNextToken = lngTknPos
    
    'extract the token at this point
    
    'if character is a special character
    Select Case intChar
    Case 34 '"
      'special case; quote means start of a string
      blnInQuotes = True
    
    Case 39   ''
      'special case; ChrW$(39) marks beginning of comment in VB syntax
      If Syntax = lsVB Then
        'move to end of line
        lngTknPos = InStr(lngTknPos, strText, vbCr) - 1
        If lngTknPos = -1 Then
          lngTknPos = lngLen
        End If
      End If
      
    Case 47 '/
      'special case; "//" and "/*" mark beginning of comments in agi syntax
      If Syntax <> lsVB Then
        'if next char is a "/"
        If Mid$(strText, lngTknPos + 1, 1) = "/" Then
          'move to end of line
          lngTknPos = InStr(lngTknPos, strText, vbCr) - 1
          If lngTknPos = -1 Then
            lngTknPos = lngLen
          End If
        'if next char is a "*"
        ElseIf Mid$(strText, lngTknPos + 1, 1) = "*" Then
          lngTknPos = lngTknPos + 1
          lngBlock = 1
        End If
      End If
    
    Case 91 '[
      'special case; "[" marks beginning of comment in agi syntax
      If Syntax <> lsVB Then
        'move to end of line
        lngTknPos = InStr(lngTknPos, strText, vbCr) - 1
        If lngTknPos = -1 Then
          lngTknPos = lngLen
        End If
      End If
      
    Case 95 '_
      'special case; ' _{cr}' is a line continuation in vb syntax
      If Syntax = lsVB Then
        'cant be first character
        If lngTknPos > 1 Then
          'only ok if preceding character is a space
          If Asc(Mid$(strText, lngTknPos - 1, 1)) = 32 Then
            'if there is another character
            If lngTknPos <> lngLen Then
              'and following character is {cr}
              If Asc(Mid$(strText, lngTknPos + 1, 1)) = 13 Then
                blnContinue = True
                'increment position so the {cr} is skipped
                lngTknPos = lngTknPos + 1
              End If
            End If
          End If
        End If
      End If
    End Select
    
    'if a string was found (inquotes is true)
    If blnInQuotes Then
      'process a string
      
      'add characters until another true quote is found, a cr is found, or EOL is reached
      Do
        'increment position
        lngTknPos = lngTknPos + 1
        'check for end of line
        If lngTknPos > lngLen Then
          'end  reached
          lngTknPos = lngLen
          'exit
          Exit Do
        End If
          
        'get next character
        intChar = Asc(Mid$(strText, lngTknPos, 1))
        
        Select Case intChar
        Case 13  'end of line
          'readjust lngpos
          lngTknPos = lngTknPos - 1
          Exit Do
        Case 34 'if the next character is a quotation mark,
          If Not blnEmbed Then
            'reset quote flag
            blnInQuotes = False
          End If
        End Select
        
        'if this character is slash,
        'next character could be an embedded quote
        blnEmbed = (intChar = 92)
      Loop While blnInQuotes
      
    ElseIf lngBlock <> 0 Then
    'process comment block
      
      'reset inquote flag
      blnInQuotes = False
      Do
        'if in a quote,
        If blnInQuotes Then
          'add characters until another true quote is found, or EOL is reached
          Do
            'increment position
            lngTknPos = lngTknPos + 1
            'check for end of line
            If lngTknPos > lngLen Then
              'end  reached
              lngTknPos = lngLen
              'exit
              Exit Do
            End If
            
            'get next character
            intChar = Asc(Mid$(strText, lngTknPos, 1))
            
            Select Case intChar
            Case 13  'end of line
              'force quote marker to false
              blnInQuotes = False
              Exit Do
            Case 34 'if the next character is a quotation mark,
              If Not blnEmbed Then
                'reset quote flag
                blnInQuotes = False
              End If
            End Select
            
            'if this character is slash,
            'next character could be an embedded quote
            blnEmbed = (intChar = 92)
          Loop While blnInQuotes
        Else
          lngTknPos = lngTknPos + 1
          intChar = Asc(Mid$(strText, lngTknPos, 1))
          'look for block end, or block start, or quote
          Select Case intChar
          Case 34 '"
            'another quote is found
            blnInQuotes = True
          Case 42 '*
            'if prevchar was a slash
            If Asc(Mid$(strText, lngTknPos - 1, 1)) = 47 Then
              'block start
              lngBlock = lngBlock + 1
            End If
          Case 47 '/
            'if prevchar was an asterisk
            If Asc(Mid$(strText, lngTknPos - 1, 1)) = 42 Then
              'block end
              lngBlock = lngBlock - 1
            End If
          End Select
        End If
      Loop Until lngBlock = 0
      
    ElseIf Not blnContinue Then
      'single character cmds need to be returned as individual cmds
      Select Case intChar
      Case 13, 39, 40, 41, 44, 58, 59, 63, 91, 92, 93, 94, 96, 123, 125, 126 '  '(),:;?[\]^`{}~
        'single character tokens
      
      Case 61 '=
        'special case; "=", "=<" and "=>" returned as separate tokens
        Select Case Mid$(strText, lngTknPos + 1, 1)
        Case "<", ">"
          'increment pointer
          lngTknPos = lngTknPos + 1
        
        Case "=" '"==" only returned if using c++ syntax
          If Syntax = lsAGI Then
            'increment pointer
            lngTknPos = lngTknPos + 1
          End If
        End Select
        
      Case 43 '+
        'special case; "+", "++" and "+=" returned as separate tokens
        If Syntax = lsAGI Then
          If Mid$(strText, lngTknPos + 1, 1) = "+" Or Mid$(strText, lngTknPos + 1, 1) = "=" Then
            'increment pointer
            lngTknPos = lngTknPos + 1
          End If
        End If
    
      Case 45 '-
        'special case; "-", "--" and "-=" returned as separate tokens
        If Syntax = lsAGI Then
          If Mid$(strText, lngTknPos + 1, 1) = "-" Or Mid$(strText, lngTknPos + 1, 1) = "=" Then
            'increment pointer
            lngTknPos = lngTknPos + 1
          End If
        End If
        
      Case 33 '!
        'special case; "!" and "!=" returned as separate tokens
        If Syntax = lsAGI Then
          If Mid$(strText, lngTknPos + 1, 1) = "=" Then
            'increment pointer
            lngTknPos = lngTknPos + 1
          End If
        End If
        
      Case 60 '<
        'special case; "<", "<=" and "<>" returned as separate tokens
        If Mid$(strText, lngTknPos + 1, 1) = "=" Or Mid$(strText, lngTknPos + 1, 1) = ">" Then
          'increment pointer
          lngTknPos = lngTknPos + 1
        End If
    
      Case 62 '>
        'special case; ">", ">=" and "><" returned as separate tokens
        If Mid$(strText, lngTknPos + 1, 1) = "=" Or Mid$(strText, lngTknPos + 1, 1) = "<" Then
          'increment pointer
          lngTknPos = lngTknPos + 1
        End If
    
      Case 42 '*
        'special case; "*" and "*=" returned as separate tokens;
        If Syntax = lsAGI Then
          If Mid$(strText, lngTknPos + 1, 1) = "=" Then
            'increment pointer
            lngTknPos = lngTknPos + 1
          End If
        End If
    
      Case 47 '/
        'special case; "/" and "/=" returned as separate tokens
        If Syntax = lsAGI Then
          If Mid$(strText, lngTknPos + 1, 1) = "=" Then
            lngTknPos = lngTknPos + 1
          End If
        End If
    
      Case 124 '|
        'special case; "|" and "||" returned as separate tokens
        If Syntax = lsAGI Then
          If Mid$(strText, lngTknPos + 1, 1) = "|" Then
            'increment pointer
            lngTknPos = lngTknPos + 1
          End If
        End If
    
      Case 38 '&
        'special case; "&" and "&&" returned as separate tokens
        If Syntax = lsAGI Then
          If Mid$(strText, lngTknPos + 1, 1) = "&" Then
            'increment pointer
            lngTknPos = lngTknPos + 1
          End If
        End If
        
      Case Else
        'continue adding characters until element separator or EOL is reached
        Do
          'increment position
          lngTknPos = lngTknPos + 1
          'check for end of line
          If lngTknPos > lngLen Then
            'end  reached
            lngTknPos = lngLen
            'exit
            Exit Do
          End If
            
          'get next character
          intChar = Asc(Mid$(strText, lngTknPos, 1))
          
          Select Case intChar
          Case 13, 32, 33, 34, 38 To 45, 47, 58 To 63, 91 To 94, 96, 123 To 126
            '  space, !"&'()*+,-/:;<=>?[\]^`{|}~
            'end of token text found;
            'readjust lngpos
            lngTknPos = lngTknPos - 1
            Exit Do
          End Select
        Loop While True
      End Select
    End If
    
    'if no continuation
    If Not blnContinue Then
      'get the cmd for comparison
      strToken = Mid$(strText, FindNextToken, lngTknPos - FindNextToken + 1)
      
      'need to check for "rem" comment marker, if vb syntax
      If Syntax = lsVB Then
        If StrComp(strToken, "rem", vbTextCompare) = 0 Then
          'move to end of line
          lngTknPos = InStr(lngTknPos, strText, vbCr) - 1
          If lngTknPos = -1 Then
            lngTknPos = lngLen
          End If
          strToken = Mid$(strText, FindNextToken, lngTknPos - FindNextToken + 1)
        End If
      End If
      
      'if not searching for a specific cmd
      If blnNextToken Then
        'if only valid cmds
        If ValidCmds Then
          If Syntax = lsVB Then
            'skip comments
            If StrComp(Left$(strToken, 3), "rem", vbTextCompare) <> 0 Then
              If Asc(strToken) <> 39 Then
                'return the cmd that was found
                strFindCmd = strToken
                If UpdatePos Then
                  lngPos = lngTknPos
                End If
                Exit Function
              End If
            End If
          Else
            'skip comments and cr
            Select Case Left$(strToken, 2)
            Case "[", "//", "/*", vbCr
            Case Else
              'return the cmd that was found
              strFindCmd = strToken
              If UpdatePos Then
                lngPos = lngTknPos
              End If
              Exit Function
            End Select
          End If
        Else
          'return the cmd that was found
          strFindCmd = strToken
          If UpdatePos Then
            lngPos = lngTknPos
          End If
          Exit Function
        End If
      End If
      
      'if searching for a LE marker,
      If StrComp(strFindCmd, "##LE", vbTextCompare) = 0 Then
        'if the comment is a layout editor exit marker
        If lngTknPos - FindNextToken = 8 Then
          strToken = Mid$(strText, FindNextToken, 4)
          If strToken = "##LE" Then
            'found
            If UpdatePos Then
              lngPos = lngTknPos
            End If
            Exit Function
          End If
        End If
      End If
      
      'does this cmd match the search?
      If LenB(strToken) = LenB(strFindCmd) Then
        If StrComp(strToken, strFindCmd, vbTextCompare) = 0 Then
          'this is it
          If UpdatePos Then
            lngPos = lngTknPos
          End If
          Exit Function
        End If
      End If
    Else
      'reset flag
      blnContinue = False
    End If
  Loop While True
  
  'loop should never be exited normally
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function

Private Function NextChar(strText As String, strCmd As String, ByRef lngPos As Long, ByVal Syntax As LogicSyntaxType) As Long
  'returns the ascii code for, and sets the position of the next
  'non-space character (tabs, and lf are considered 'spaces'; a cr is not)
  
  Dim lngLen As Long
  
  On Error GoTo ErrHandler
  
  'if already at end of input
  lngLen = Len(strText)
  If lngPos = lngLen Then
    'exit
    NextChar = 0
    lngPos = 0
    Exit Function
  End If
  
  Do
    'first, increment position
    lngPos = lngPos + 1
    
    NextChar = Asc(Mid$(strText, lngPos, 1))
    Select Case NextChar
    Case 9, 10, 32
      'get next character
    Case Else
      'this is a non-space character
      Exit Function
    End Select
    
  'keep going, until end of input is reached
  Loop Until lngPos = lngLen
  
  'end reached; reset character and position
  NextChar = 0
  lngPos = 0
Exit Function

ErrHandler:
  Resume Next
End Function
Public Function ConcatenateString(ByRef StringIn As String, ByVal Syntax As LogicSyntaxType) As Boolean

  'verify that the passed string is a valid string, including possible concatenation
  'for vb syntax, string must be of the format "text" or "text1" & "text2"
  'for agi syntax, string must be of the format "text" or "text1" "text2"
  
  Dim blnInQuotes As Boolean, blnEmbed As Boolean
  Dim blnAmp As Boolean
  Dim lngPos As Long, intChar As Integer
  Dim strIn As String, strOut As String
  
  'start with input string
  strIn = Trim$(StringIn)
  
  'if nothing,
  If Len(strIn) < 2 Then
    'not valid
    ConcatenateString = False
    Exit Function
  End If
  
  'starting char should be quote
  If Asc(strIn) <> 34 Then
    'not valid
    ConcatenateString = False
    Exit Function
  End If
  
  'begin check
  blnInQuotes = True
  lngPos = 2
  Do
    intChar = Asc(Mid$(strIn, lngPos, 1))
    
    'if not in quotes,
    If Not blnInQuotes Then
      'if agi syntax
      If Syntax = lsAGI Then
        'only spaces or another quote is allowed
        Select Case intChar
        Case 34
          'toggle flag
          blnInQuotes = True
        Case 32
          'ignore blanks
        Case Else
          'error
          Exit Function
        End Select
      Else
        'looking for an ampersand, then another quote
        Select Case intChar
        Case 34
          'only ok if ampesand found
          If blnAmp Then
            blnAmp = False
            blnInQuotes = True
          Else
            'error
            Exit Function
          End If
          
        Case 38
          If Not blnAmp Then
            blnAmp = True
          Else
            'error
            Exit Function
          End If
        Case 32
          'ignore blanks
        Case Else
          'error
          Exit Function
        End Select
      End If
          
    Else
      'if a quote, need to ensure it is a real quote
      If intChar = 34 And Not blnEmbed Then
        'no longer in quotes
        blnInQuotes = False
        blnEmbed = False
      Else
        'add the character
        strOut = strOut & ChrW$(intChar)
      End If
      
      'check for embed code
      blnEmbed = (intChar = 92)
    End If
    
    lngPos = lngPos + 1
  Loop Until lngPos > Len(StringIn)
  
  'should end up being NOT in quotes and NOT expecting ampersand
  If blnInQuotes Or blnAmp Then
    'error
    Exit Function
  End If
  
  'return the concatenated string, with surrounding quotes
  StringIn = QUOTECHAR & strOut & QUOTECHAR
  ConcatenateString = True
Exit Function

ErrHandler:
  Resume Next
End Function


Public Function ExtractExits(ThisLogic As AGILogic) As AGIExits
  
  'analyzes a logic to find 'new.room' commands
  'builds a new exits object that contains the
  'exit info for this logic
  '
  'NOTE: this analyzes an existing SAVED logic source; not
  'a source that is being edited
  '
  '
  'if the exit id for an exit is new or has changed,
  'the source code is updated, and saved
  '
  'transpt info is not addressed by the extractdexits method
  'the calling method must deal with transpts on its own
  
  Dim blnSrcLoad As Boolean, blnLogLoad As Boolean
  Dim strLogic As String, tmpSyntax As LogicSyntaxType
  Dim RoomExits As AGIExits, lngCmdLoc As Long
  Dim i As Long, j As Long
  Dim strLine As String, lngID As Long
  Dim blnIDOK As Boolean, blnSave As Boolean
  Dim tmpExit As AGIExit, lngLastPos As Long
  
  'lngCmdLoc is location of 1st character of 'new.room' command
  
  On Error GoTo ErrHandler
  
  'ensure source is loaded
  blnLogLoad = ThisLogic.Loaded
  If Not blnLogLoad Then
    ThisLogic.Load
  End If
  blnSrcLoad = ThisLogic.SourceCode.Loaded
  If Not blnSrcLoad Then
    ThisLogic.SourceCode.Load
  End If
  
  'get source code
  strLogic = ThisLogic.SourceCode.Text
  'and syntax
  tmpSyntax = ThisLogic.SourceCode.Syntax
  
  'create new room object
  Set RoomExits = New AGIExits
  
  'locate first instance of new.room command
  lngCmdLoc = FindNextToken(strLogic, 0, tmpSyntax, "new.room")
  
  'loop through exit extraction until all new.room commands are processed
  Do Until lngCmdLoc = 0
    'get exit info
    Set tmpExit = AnalyzeExit(strLogic, tmpSyntax, lngCmdLoc, lngLastPos)
    
    'find end of line by searching for crlf
    j = InStr(lngCmdLoc, strLogic, vbNewLine)
    If j = 0 Then j = Len(strLogic)
    'get rest of line (to check against existing exits)
    strLine = Trim$(Mid$(strLogic, lngCmdLoc, j - lngCmdLoc))
    
    'check line for a le marker
    If tmpSyntax = lsVB Then
      If Left$(strLine, 5) = "'##LE" Then
        'strip off leader to expose exit id number
        strLine = Right$(strLine, Len(strLine) - 5)
      Else
        'not an exit marker; reset the string
        strLine = vbNullString
      End If
    Else
      If Left$(strLine, 6) = "//##LE" Then
        'strip off leader to expose esit id number
        strLine = Right$(strLine, Len(strLine) - 6)
      Else
        'not an exit marker; reset the string
        strLine = vbNullString
      End If
    End If
    
    'if a valid id value was found
    If LenB(strLine) <> 0 Then
      'an id may exist
      'assum ok until proven otherwise
      blnIDOK = True
      'get the id number
      lngID = CLng(Val(strLine))
      'check for this marker among current exits
      For i = 0 To RoomExits.Count - 1
        If Val(Right$(RoomExits(i).ID, 3)) = CStr(lngID) Then
          'this ID has already been added by the editor;
          'it needs to be reset
          blnIDOK = False
          Exit For
        End If
      Next i
    Else
      'no previous marker; assign id automatically
      blnIDOK = False
    End If
      
    'if previous ID needs updating (or one not found)
    If Not blnIDOK Then
      'get next available id number
      lngID = 0
      i = 0
      Do
        lngID = lngID + 1
        For i = 0 To RoomExits.Count - 1
          If CLng(Right$(RoomExits(i).ID, 3)) = lngID Then
            Exit For
          End If
        Next i
      Loop Until i = RoomExits.Count
    End If
    
    'add exit to logic, and flag as in game and ok
    RoomExits.Add(lngID, tmpExit.Room, tmpExit.Reason, tmpExit.Style).Status = esOK
    
    'if id is new or changed,
    If Not blnIDOK Then
      'lngCmdLoc marks end of commands on this line
      
      'find end of line with 'new.room' command
      j = InStr(lngCmdLoc, strLogic, ChrW$(13))
      'use end of logic, if on last line (i=0)
      If j = 0 Then j = Len(strLogic)
      
      'insert exit info into logic source
      If tmpSyntax = lsAGI Then
        strLogic = Left$(strLogic, lngCmdLoc) & " //##LE" & format$(lngID, "000") & "##" & Right$(strLogic, Len(strLogic) - j + 1)
      Else
        strLogic = Left$(strLogic, lngCmdLoc) & " '##LE" & format$(lngID, "000") & "##" & Right$(strLogic, Len(strLogic) - j + 1)
      End If
      
      'set save flag
      blnSave = True
    End If
    
    'get next new.room cmd
    lngLastPos = lngCmdLoc
    lngCmdLoc = FindNextToken(strLogic, lngCmdLoc, tmpSyntax, "new.room")
  Loop
  
  'if changes made to exit ids
  If blnSave Then
    'replace sourcecode
    ThisLogic.SourceCode.Text = strLogic
    'remember that logics that are being edited appear to be
    'not in a game, which causes the ID to be changed to match the filename
    'since only ingame logics can be rebuilt, need to check for ID change,
    'and change it back
    If Not ThisLogic.Resource.InGame Then
      'save id
      strLogic = ThisLogic.ID
    End If
    ThisLogic.SourceCode.Save
    If Not ThisLogic.Resource.InGame Then
      ThisLogic.ID = strLogic
    End If
  End If
  
  'unload if necessary
  If Not blnSrcLoad Then
    ThisLogic.SourceCode.Unload
  End If
  If Not blnLogLoad And ThisLogic.Loaded Then
    ThisLogic.Unload
  End If
  
  'return the new exit list
  Set ExtractExits = RoomExits
Exit Function

ErrHandler:
  Resume Next
End Function


Public Function ReplaceGlobal(TextIn As String) As String

  'open the global file; check for existence of this item;
  'if found, replace it with correct value;
  'if not found, return original value
  
  Dim intFile As Integer
  Dim strLine As String, strSplitLine() As String
  
  'default to original value
  ReplaceGlobal = TextIn
  
  'check for existence of globals file
  If Not FileExists(GameDir & "globals.txt") Then
    'no global list
    Exit Function
  End If
  
  'open the list
  On Error GoTo ErrHandler
  
  intFile = FreeFile
  
  Open GameDir & "globals.txt" For Input As intFile
  
  Do Until EOF(intFile)
    Line Input #intFile, strLine
    'trim it
    strLine = Trim$(strLine)
      
    'ignore blanks and comments (// or ' or Rem)
    If LenB(strLine) <> 0 And Left$(strLine, 2) <> "//" And Left$(strLine, 1) <> ChrW$(39) And Left$(strLine, 4) <> "Rem" Then
      'splitline into name and value
      strSplitLine = Split(strLine, vbTab)
      
      'if exactly two elements,
      If UBound(strSplitLine) = 1 Then
        'check it against input
        If TextIn = Trim$(strSplitLine(0)) Then
          ReplaceGlobal = Trim$(strSplitLine(1))
          Close intFile
          Exit Function
        End If
      End If
    End If
 Loop
 
  'not found; exit
  Close intFile
 
Exit Function

ErrHandler:
  'just clear error and return input text
  Err.Clear
End Function

Public Sub ExportAll()

  'exports all logic, picture, sound and view resources into the resource directory
  'overwriting where necessary
  
  Dim tmpLog As AGILogic, tmpPic As AGIPicture
  Dim tmpSnd As AGISound, tmpView As AGIView
  Dim blnLoaded As Boolean, blnSource As Boolean
  Dim blnRepeat As Boolean, rtn As VbMsgBoxResult
  
  On Error GoTo ErrHandler
  
  'use progress form to track progress
  Load frmProgress
  With frmProgress
    .Caption = "Exporting All Resources"
    .pgbStatus.max = Logics.Count + Pictures.Count + Sounds.Count + Views.Count
    .pgbStatus.Value = 0
    .lblProgress = "Exporting..."
    .Show
    .Refresh
    
    For Each tmpLog In Logics
      .lblProgress.Caption = "Exporting " & tmpLog.ID
      .pgbStatus.Value = .pgbStatus.Value + 1
      .Refresh
      
      blnLoaded = tmpLog.Loaded
      If Not blnLoaded Then
        tmpLog.Load
      End If
      
      'if sourcefile already exists,
      If FileExists(tmpLog.SourceCode.SourceFile) Then
        'file exists; ask if it should be replaced
        If Not blnRepeat Then
          'ask if should be replaced?
          rtn = MsgBoxEx("A source code file for " & tmpLog.ID & " already exists." & vbNewLine & "Do you want to replace it with the decompiled logic source?", vbQuestion + vbYesNo, "Export Logic", , , "Repeat this answer for all remaining logic resources", blnRepeat)
        End If
        
        'if replacing (rtn = vbYes)
        If rtn = vbYes Then
          'kill existing file
          Kill tmpLog.SourceCode.SourceFile
          'unload to force refresh
          tmpLog.SourceCode.Unload
          'now reload
          tmpLog.SourceCode.Load
          'now save it
          tmpLog.SourceCode.Save
        End If
      Else
        'export source
        blnSource = tmpLog.SourceCode.Loaded
        If Not blnSource Then
          tmpLog.SourceCode.Load
        End If
        tmpLog.SourceCode.Save
        If Not blnSource Then
          tmpLog.SourceCode.Unload
        End If
      End If
      
      If Not blnLoaded Then
        tmpLog.Unload
      End If
    Next
    
    For Each tmpPic In Pictures
      .lblProgress.Caption = "Exporting " & tmpPic.ID
      .pgbStatus.Value = .pgbStatus.Value + 1
      .Refresh
      blnLoaded = tmpPic.Loaded
      If Not blnLoaded Then
        tmpPic.Load
      End If
      tmpPic.Export ResDir & tmpPic.ID & ".agp"
      If Not blnLoaded Then
        tmpPic.Unload
      End If
    Next
    
    For Each tmpSnd In Sounds
      .lblProgress.Caption = "Exporting " & tmpSnd.ID
      .pgbStatus.Value = .pgbStatus.Value + 1
      .Refresh
      blnLoaded = tmpSnd.Loaded
      If Not blnLoaded Then
        tmpSnd.Load
      End If
      tmpSnd.Export ResDir & tmpSnd.ID & ".ags"
      If Not blnLoaded Then
        tmpSnd.Unload
      End If
    Next
    
    For Each tmpView In Views
      .lblProgress.Caption = "Exporting " & tmpView.ID
      .pgbStatus.Value = .pgbStatus.Value + 1
      .Refresh
      blnLoaded = tmpView.Loaded
      If Not blnLoaded Then
        tmpView.Load
      End If
      tmpView.Export ResDir & tmpView.ID & ".agv"
      If Not blnLoaded Then
        tmpView.Unload
      End If
    Next
  End With
  
  'done with progress form
  Unload frmProgress
Exit Sub

ErrHandler:
  'ignore the system bitmap error for pictures, since it doesn't affect exporting
  If Err.Number = vbObjectError + 610 Then
    Err.Clear
    Resume Next
  End If
  
  Debug.Assert False
  Resume Next
End Sub

Public Function ExportObjects(ThisObjectsFile As AGIInventoryObjects, ByVal InGame As Boolean) As Boolean

  Dim strFilename As String
  Dim rtn As VbMsgBoxResult
  
  On Error GoTo ErrHandler
  
  'set up commondialog
  With MainSaveDlg
    If InGame Then
      .DialogTitle = "Export Inventory Objects File"
    Else
      .DialogTitle = "Save Inventory Objects File As"
    End If
    'if objectlist has a filename
    If LenB(ThisObjectsFile.ResFile) <> 0 Then
      'use it
      .FullName = ThisObjectsFile.ResFile
    Else
      'use default name
      .FullName = ResDir & "OBJECT"
    End If
    .Filter = "WinAGI Inventory Objects Files (*.ago)|*.ago|OBJECT file|OBJECT|All files (*.*)|*.*"
    If LCase$(Right$(.FullName, 4)) = ".ago" Then
      .FilterIndex = 1
    Else
      .FilterIndex = 2
    End If
    .DefaultExt = vbNullString
    .Flags = cdlOFNHideReadOnly Or cdlOFNPathMustExist Or cdlOFNExplorer
    .hWndOwner = frmMDIMain.hWnd
  End With
  
  Do
    On Error Resume Next
    MainSaveDlg.ShowSaveAs
    'if canceled,
    If Err.Number = cdlCancel Then
      'exit without doing anything
      Exit Function
    End If
    On Error GoTo ErrHandler
    
    'get filename
    strFilename = MainSaveDlg.FullName
    
    'if file exists,
    If FileExists(strFilename) Then
      'verify replacement
      rtn = MsgBox(MainSaveDlg.FileName & " already exists. Do you want to overwrite it?", vbYesNoCancel + vbQuestion, "Overwrite file?")
      
      If rtn = vbYes Then
        Exit Do
      ElseIf rtn = vbCancel Then
        Exit Function
      End If
    Else
      Exit Do
    End If
  Loop While True
  
  'set mouse pointer
  frmMDIMain.MousePointer = vbHourglass
  
  If LCase$(Right$(MainSaveDlg.FullName, 4)) = ".ago" Then
    'export with new filename
    ThisObjectsFile.Export strFilename, 1, Not InGame
  Else
    'export with new filename
    ThisObjectsFile.Export strFilename, 0, Not InGame
  End If

  'reset mouse pointer
  frmMDIMain.MousePointer = vbDefault
  
  'if error,
  If Err.Number <> 0 Then
    MsgBox "An error occurred while exporting this file:" & vbNewLine & vbNewLine & Err.Description, vbCritical + vbOKOnly, "Export File Error"
  End If
  
  ExportObjects = True
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function
Public Function ExportPicture(ThisPicture As AGIPicture, ByVal InGame As Boolean) As Boolean

  'exports this picture
  
  Dim strFilename As String
  Dim rtn As VbMsgBoxResult
  
  On Error GoTo ErrHandler
  
  'set up commondialog
  With MainSaveDlg
    If InGame Then
      .DialogTitle = "Export Picture"
    Else
      .DialogTitle = "Save Picture As"
    End If
    .Filter = "WinAGI Picture Files (*.agp)|*.agp|All files (*.*)|*.*"
    .FilterIndex = GetSetting(sAPPNAME, sEXPFILTER, sPICTURES, 1)
    If .FilterIndex = 1 Then
      .DefaultExt = "agp"
    End If
    
    .Flags = cdlOFNHideReadOnly Or cdlOFNPathMustExist Or cdlOFNExplorer
    
    'if Picture has a filename
    If LenB(ThisPicture.Resource.ResFile) <> 0 Then
      'use it
      .FullName = ThisPicture.Resource.ResFile
    Else
      'use default name
      .FullName = ResDir & ThisPicture.ID
      If .FilterIndex = 1 Then
        .FullName = .FullName & ".agp"
      End If
    End If
    .hWndOwner = frmMDIMain.hWnd
  End With
  
  Do
    On Error Resume Next
    MainSaveDlg.ShowSaveAs
    'if canceled,
    If Err.Number = cdlCancel Then
      'exit without doing anything
      Exit Function
    End If
    On Error GoTo ErrHandler
    'save filterindex
    SaveSetting sAPPNAME, sEXPFILTER, sPICTURES, MainSaveDlg.FilterIndex
    'get filename
    strFilename = MainSaveDlg.FullName
    
    'if file exists,
    If FileExists(strFilename) Then
      'verify replacement
      rtn = MsgBox(MainSaveDlg.FileName & " already exists. Do you want to overwrite it?", vbYesNoCancel + vbQuestion, "Overwrite file?")
      
      If rtn = vbYes Then
        Exit Do
      ElseIf rtn = vbCancel Then
        Exit Function
      End If
    Else
      Exit Do
    End If
  Loop While True
  
  'set mouse pointer
  frmMDIMain.MousePointer = vbHourglass
  
  'export the resource
  ThisPicture.Export strFilename, Not InGame
  
  'reset mouse pointer
  frmMDIMain.MousePointer = vbDefault
  
  'if error,
  If Err.Number <> 0 Then
    MsgBox "An error occurred while exporting this file." & vbNewLine & vbNewLine & Err.Description, vbCritical + vbOKOnly, "Export File Error"
  End If
  
  ExportPicture = True
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function
Public Function ExportSound(ThisSound As AGISound, ByVal InGame As Boolean) As Boolean

  'exports this Sound
  
  Dim strFilename As String
  Dim rtn As VbMsgBoxResult
  
  On Error GoTo ErrHandler
  
  'set up commondialog
  With MainSaveDlg
    If InGame Then
      .DialogTitle = "Export Sound"
    Else
      .DialogTitle = "Save Sound As"
    End If
    .Filter = "WinAGI Sound Files (*.ags)|*.ags|MIDI Files (*.mid)|*.mid|AGI Sound Script Files (*.ass)|*.ass|All files (*.*)|*.*"
    'if Sound has a filename
    If LenB(ThisSound.Resource.ResFile) <> 0 Then
      'use it
      .FullName = ThisSound.Resource.ResFile
    Else
      'id should be filename
      .FullName = ResDir & ThisSound.ID
    End If
    
    'set filter index
    .FilterIndex = GetSetting(sAPPNAME, sEXPFILTER, sSOUNDS, 1)
      
    'now set default extension
    Select Case .FilterIndex
    Case 1
      .DefaultExt = "ags"
    Case 2
      .DefaultExt = "mid"
    Case 3
      .DefaultExt = "ass"
    Case Else
      .DefaultExt = vbNullString
    End Select
    
    .Flags = cdlOFNHideReadOnly Or cdlOFNPathMustExist Or cdlOFNExplorer
    .hWndOwner = frmMDIMain.hWnd
  End With
  
  
  Do
    On Error Resume Next
    MainSaveDlg.ShowSaveAs
    'if canceled,
    If Err.Number = cdlCancel Then
      'exit without doing anything
      Exit Function
    End If
    On Error GoTo ErrHandler
    
    'save default filter index
    SaveSetting sAPPNAME, sEXPFILTER, sSOUNDS, MainSaveDlg.FilterIndex
    
    'get filename
    strFilename = MainSaveDlg.FullName
      
    'if file exists,
    If FileExists(strFilename) Then
      'verify replacement
      rtn = MsgBox(MainSaveDlg.FileName & " already exists. Do you want to overwrite it?", vbYesNoCancel + vbQuestion, "Overwrite file?")
      
      If rtn = vbYes Then
        Exit Do
      ElseIf rtn = vbCancel Then
        Exit Function
      End If
    Else
      Exit Do
    End If
  Loop While True
  
  'set mouse pointer
  frmMDIMain.MousePointer = vbHourglass
  
  'export the resource
  ThisSound.Export strFilename, MainSaveDlg.FilterIndex, Not InGame
  
  'reset mouse pointer
  frmMDIMain.MousePointer = vbDefault
  
  'if error,
  If Err.Number <> 0 Then
    MsgBox "An error occurred while exporting this file." & vbNewLine & vbNewLine & Err.Description, vbCritical + vbOKOnly, "Export File Error"
  End If
  
  ExportSound = True
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function
Public Function ExportView(ThisView As AGIView, ByVal InGame As Boolean) As Boolean

  'exports this view
  
  Dim strFilename As String
  Dim rtn As VbMsgBoxResult
  
  On Error GoTo ErrHandler
  
  'set up commondialog
  With MainSaveDlg
    If InGame Then
      .DialogTitle = "Export View"
    Else
      .DialogTitle = "Save View As"
    End If
    .Filter = "WinAGI View Files (*.agv)|*.agv|All files (*.*)|*.*"
    .FilterIndex = GetSetting(sAPPNAME, sEXPFILTER, sVIEWS, 1)
    If .FilterIndex = 1 Then
      .DefaultExt = "agv"
    End If
    
    .Flags = cdlOFNHideReadOnly Or cdlOFNPathMustExist Or cdlOFNExplorer
    
    'if view has a filename
    If LenB(ThisView.Resource.ResFile) <> 0 Then
      'use it
      .FullName = ThisView.Resource.ResFile
    Else
      'use default name
      .FullName = ResDir & ThisView.ID
      'add extension, if necessary
      If .FilterIndex = 1 Then
        .FullName = .FullName & ".agv"
      End If
    End If
    .hWndOwner = frmMDIMain.hWnd
  End With
  
  Do
    On Error Resume Next
    MainSaveDlg.ShowSaveAs
    'if canceled,
    If Err.Number = cdlCancel Then
      'exit without doing anything
      Exit Function
    End If
    On Error GoTo ErrHandler
    
    'save default filter index
    SaveSetting sAPPNAME, sEXPFILTER, sVIEWS, MainSaveDlg.FilterIndex
    'get filename
    strFilename = MainSaveDlg.FullName
    
    'if file exists,
    If FileExists(strFilename) Then
      'verify replacement
      rtn = MsgBox(MainSaveDlg.FileName & " already exists. Do you want to overwrite it?", vbYesNoCancel + vbQuestion, "Overwrite file?")
      
      If rtn = vbYes Then
        Exit Do
      ElseIf rtn = vbCancel Then
        Exit Function
      End If
    Else
      Exit Do
    End If
  Loop While True
  
  'set mouse pointer
  frmMDIMain.MousePointer = vbHourglass
  
  'export the resource
  ThisView.Export strFilename, Not InGame
  
  'reset mouse pointer
  frmMDIMain.MousePointer = vbDefault
  
  'if error,
  If Err.Number <> 0 Then
    MsgBox "An error occurred while exporting this file." & vbNewLine & vbNewLine & Err.Description, vbCritical + vbOKOnly, "Export File Error"
    Exit Function
  End If
  ExportView = True
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function
Public Function ExportWords(ThisWordList As AGIWordList, ByVal InGame As Boolean) As Boolean

  Dim strFilename As String
  Dim rtn As VbMsgBoxResult
  
  On Error GoTo ErrHandler
  
  'set up commondialog
  With MainSaveDlg
    If InGame Then
      .DialogTitle = "Export Word List"
    Else
      .DialogTitle = "Save Word List As"
    End If
    'if the list has a filename
    If LenB(ThisWordList.ResFile) <> 0 Then
      'use it
      .FullName = ThisWordList.ResFile
    Else
      'use default name
      .FullName = ResDir & "WORDS.TOK"
    End If
    .Filter = "WinAGI Word List Files (*.agw)|*.agw|WORDS.TOK file|*.TOK|All files (*.*)|*.*"
    If LCase$(Right$(.FullName, 4)) = ".agw" Then
      .FilterIndex = 1
    Else
      .FilterIndex = 2
    End If
    .DefaultExt = vbNullString
    .Flags = cdlOFNHideReadOnly Or cdlOFNPathMustExist Or cdlOFNExplorer
    .hWndOwner = frmMDIMain.hWnd
  End With
  
  Do
    On Error Resume Next
    MainSaveDlg.ShowSaveAs
    'if canceled,
    If Err.Number = cdlCancel Then
      'exit without doing anything
      Exit Function
    End If
    On Error GoTo ErrHandler
    
    'get filename
    strFilename = MainSaveDlg.FullName
    
    'if file exists,
    If FileExists(strFilename) Then
      'verify replacement
      rtn = MsgBox(MainSaveDlg.FileName & " already exists. Do you want to overwrite it?", vbYesNoCancel + vbQuestion, "Overwrite file?")
      
      If rtn = vbYes Then
        Exit Do
      ElseIf rtn = vbCancel Then
        Exit Function
      End If
    Else
      Exit Do
    End If
  Loop While True
  
  'set mouse pointer
  frmMDIMain.MousePointer = vbHourglass
  
  If LCase$(Right$(MainSaveDlg.FullName, 4)) = ".agw" Then
    'save with new filename
    ThisWordList.Export strFilename, 1, Not InGame
  Else
    ThisWordList.Export strFilename, 0, Not InGame
  End If
  
  'reset mouse pointer
  frmMDIMain.MousePointer = vbDefault
  
  'if error,
  If Err.Number <> 0 Then
    MsgBox "An error occurred while exporting this file:" & vbNewLine & vbNewLine & Err.Description, vbCritical + vbOKOnly, "Export File Error"
    Exit Function
  End If

  ExportWords = True
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function
Public Function NewObjects() As Boolean

  'creates a new object file
  
  Dim frmNew As frmObjectEdit
  
  On Error GoTo ErrHandler
  
  'create a new file
  Set frmNew = New frmObjectEdit
  Load frmNew
  
  frmNew.NewObjects
    
  frmNew.Show
Exit Function

ErrHandler:
  Resume Next
End Function

Public Sub OpenGlobals()

  Dim strFilename As String
  Dim intFile As Integer
  Dim frmNew As frmGlobals, tmpForm As Form
  
  On Error GoTo ErrHandler
  
  'if a game is loaded and editor NOT yet opened
  If GameLoaded And Not GEInUse Then
    'load it
    'use the game's default globals file
    strFilename = GameDir & "globals.txt"
    'look for global file
    If Not FileExists(strFilename) Then
      'look for a defines.txt file in the resource directory
      If FileExists(ResDir & "defines.txt") Then
        'copy it to globals.txt
        On Error Resume Next
        FileCopy ResDir & "defines.txt", strFilename
        On Error GoTo ErrHandler
      End If
    End If
    
    'now check again for globals file
    If Not FileExists(strFilename) Then
      'create blank file
      intFile = FreeFile()
      Open strFilename For Binary As intFile
      Close intFile
    End If
    
    'load it
    Set GlobalsEditor = New frmGlobals
    Load GlobalsEditor
    
    'set ingame status first, so caption will indicate correctly
    GlobalsEditor.InGame = True
    'loading function will handle any errors
    GlobalsEditor.LoadGlobalDefines strFilename
    GlobalsEditor.Show
    'mark editor as in use
    GEInUse = True
  Else
  'either a game is NOT loaded, OR we are forcing a load from file
  
    'get a globals file
    With MainDialog
      .Flags = cdlOFNHideReadOnly
      .DialogTitle = "Open Global Defines File"
      .DefaultExt = "txt"
      .Filter = "Text files (*.txt)|*.txt|All files (*.*)|*.*"
      .FilterIndex = GetSetting(sAPPNAME, sOPENFILTER, "Global", 1)
      .FileName = vbNullString
      
      .ShowOpen
      
      strFilename = .FileName
      
      'save filter
      SaveSetting sAPPNAME, sOPENFILTER, "Global", .FilterIndex
    End With
  
    'check if already open
    For Each tmpForm In Forms
      If tmpForm.Name = "frmGlobals" Then
        If tmpForm.FileName = strFilename And Not tmpForm.InGame Then
          'just shift focus
          tmpForm.SetFocus
          Exit Sub
        End If
      End If
    Next
    
    'not open yet; create new form
    'and open this file into it
    Set frmNew = New frmGlobals
    
    'open this file
    Load frmNew
    'loading function will handle any errors
    frmNew.LoadGlobalDefines strFilename
    frmNew.Show
  End If
Exit Sub

ErrHandler:
  'if user canceled the dialogbox,
  If Err.Number = cdlCancel Then
    Exit Sub
  End If
  
  Debug.Assert False
  Resume Next
End Sub

Public Function UpdatePrinterCaps(ByVal Orientation As Long) As Boolean

  Dim rtn As Long
  
  'enable error trapping
  On Error GoTo ErrHandler
  
  'set printer flag
  NoPrinter = (Printers.Count = 0)
  If NoPrinter Then
    Exit Function
  End If
  
  'send endoc command to reset printer object and get new handle
  Printer.EndDoc
  
  'reset orientation
  Printer.Orientation = Orientation
  
  'reset printer scale mode so print area is measured in pixels
  Printer.ScaleMode = vbPixels
  
  'get printer offset values (in pixels)
  PMLeft = GetDeviceCaps(Printer.hdc, PHYSICALOFFSETX)
  PMTop = GetDeviceCaps(Printer.hdc, PHYSICALOFFSETY)
  
  'get physical page dimensions (in pixels)
  PMRight = GetDeviceCaps(Printer.hdc, PHYSICALWIDTH)
  PMBottom = GetDeviceCaps(Printer.hdc, PHYSICALHEIGHT)
  
  'right margin is page width minus left margin, minus printable width of page
  PMRight = PMRight - PMLeft - Printer.ScaleWidth
  
  'bottom margin is page height minus top margin minus printable height of page
  PMBottom = PMBottom - PMTop - Printer.ScaleHeight
  
  'determine if printer supports color
  If GetDeviceCaps(Printer.hdc, BITSPIXEL) = 1 Then
    'this is a black and white printer
    NoColor = True
  Else
    NoColor = False
  End If

  PDPIx = 1440 / Printer.TwipsPerPixelX
  PDPIy = 1440 / Printer.TwipsPerPixelY
  PWidth = Printer.Width / 1440 * PDPIx
  PHeight = Printer.Height / 1440 * PDPIy
  
  UpdatePrinterCaps = True
Exit Function

ErrHandler:
  'some printers don't allow landscape printing
  If Err.Number = 380 Then
    MsgBox "The selected printer does not support the selected orientation." & vbNewLine & "Your output may not be formatted correctly.", vbCritical + vbInformation, "Printer Capability Error"
    Exit Function
  Else
    MsgBox "An unhandled printer error occurred (" & Err.Number & "). Print feature may not" & vbNewLine & "work correctly.", vbInformation + vbOKOnly, "Printer Error"
    Resume Next
  End If
End Function

Public Sub UpdateResFile(ByVal ResType As AGIResType, ByVal ResNum As Byte, ByVal OldFileName As String)
    
  'updates ingame id for resource files and the resource tree
  Dim tmpNode As Node
  
  On Error GoTo ErrHandler
  
  Select Case ResType
  Case rtLogic
    If LenB(OldFileName) <> 0 Then
      On Error Resume Next
      Kill ResDir & Logics(ResNum).ID & LogicSourceSettings.SourceExt
      Name OldFileName As ResDir & Logics(ResNum).ID & LogicSourceSettings.SourceExt
    End If
    'if logiceditor is open
    If LEInUse Then
      'redraw to ensure correct ID is displayed
      LayoutEditor.DrawLayout
    End If
    
  Case rtPicture
    'if autoexporting
    If Settings.AutoExport And LenB(OldFileName) <> 0 Then
      'rename resource file, if it exists
      Name OldFileName As ResDir & Pictures(ResNum).ID & ".agp"
    End If
    
  Case rtSound
    'if autoexporting
    If Settings.AutoExport And LenB(OldFileName) <> 0 Then
      'rename resource file, if it exists
      Name OldFileName As ResDir & Sounds(ResNum).ID & ".ags"
    End If
    
  Case rtView
    'if autoexporting
    If Settings.AutoExport And LenB(OldFileName) <> 0 Then
      'rename resource file, if it exists
      Name OldFileName As ResDir & Views(ResNum).ID & ".agv"
    End If
  End Select
      
  'update property window and tree
  UpdateSelection ResType, ResNum, umProperty Or umTree
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Public Sub ChangeResDescription(ByVal ResType As AGIResType, ByVal ResNum As Byte, ByVal Description As String)
    
  'updates ingame description
  'for resource objects and the resource tree
  
  On Error GoTo ErrHandler
  
  Select Case ResType
  Case rtObjects
    InventoryObjects.Description = Description
    InventoryObjects.Save
  
  Case rtWords
    VocabularyWords.Description = Description
    VocabularyWords.Save
    
  Case rtLogic
    Logics(ResNum).Description = Description
    Logics(ResNum).Save
    
  Case rtPicture
    Pictures(ResNum).Description = Description
    Pictures(ResNum).Save
    
  Case rtSound
    Sounds(ResNum).Description = Description
    Sounds(ResNum).Save
    
  Case rtView
    Views(ResNum).Description = Description
    Views(ResNum).Save
  End Select
  
  'update prop window
  UpdateSelection ResType, ResNum, umProperty
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Public Function GetNewResID(ByVal ResType As AGIResType, ByVal ResNum As Long, ByRef ResID As String, ByRef Description As String, ByVal InGame As Boolean, Optional ByVal FirstProp As Long = 1) As Boolean
  
  Dim strOldVal As String
  
  On Error GoTo ErrHandler
  Debug.Assert ResNum <= 256
  
  'if ingame,
  If InGame Then
    'need to save current ressource filename
    Select Case ResType
    Case rtLogic
      'save old sourcefile name
      strOldVal = ResDir & Logics(ResNum).ID & LogicSourceSettings.SourceExt
    Case rtPicture
      strOldVal = ResDir & Pictures(ResNum).ID & ".agp"
    Case rtSound
      strOldVal = ResDir & Sounds(ResNum).ID & ".ags"
    Case rtView
      strOldVal = ResDir & Views(ResNum).ID & ".agv"
    End Select
  End If
  
  'if restype is word or object
  If ResType = rtWords Or ResType = rtObjects Then
    'force prop to description
    FirstProp = 2
  Else
    Debug.Assert ResNum >= 0
  End If
  
  'should never get here with other restypes
  Select Case ResType
  Case rtGame, rtLayout, rtMenu, rtGlobals, rtGame, rtText, rtNone
    Debug.Assert False
  End Select
  
  With frmEditDescription
    'set current values
    .SetMode ResType, ResID, Description, InGame, FirstProp
    
    Do
      On Error GoTo ErrHandler
      
      'get new values
      .Show vbModal
      
      'if canceled,
      If .Canceled Then
        'just exit
        Unload frmEditDescription
        Exit Function
      End If
    
      'validate return results
      Select Case ResType
      Case rtObjects, rtWords
        Exit Do
        
      Case Else
        'if in a game,
        If InGame Then
          On Error Resume Next
          'update ID for the ingame resource
          Select Case ResType
          Case rtLogic
            Logics(ResNum).ID = .txtID.Text
          Case rtPicture
            Pictures(ResNum).ID = .txtID.Text
          Case rtSound
            Sounds(ResNum).ID = .txtID.Text
          Case rtView
            Views(ResNum).ID = .txtID.Text
          End Select
          
          'if ok (no error)
          If Err.Number = 0 Then
            'update ingame description too
            Select Case ResType
            Case rtLogic
              Logics(ResNum).Description = .txtDescription.Text
            Case rtPicture
              Pictures(ResNum).Description = .txtDescription.Text
            Case rtSound
              Sounds(ResNum).Description = .txtDescription.Text
            Case rtView
              Views(ResNum).Description = .txtDescription.Text
            End Select
            Exit Do
          End If
          
          'error means ID is not unique
          MsgBox "Resource IDs must be unique.  '" & .txtID.Text & ChrW$(39) & " is already in use.", vbInformation, "Change Resource ID"
          .txtID.SelStart = 0
          .txtID.SelLength = Len(.txtID.Text)
        Else
          'for resources not in a game, any ID change is acceptable
          Exit Do
        End If
      End Select
    Loop While True
    
    On Error GoTo ErrHandler
    
    'id change is acceptable;
    'return new id and description
    ResID = .txtID.Text
    Description = .txtDescription.Text
    GetNewResID = True
  End With
  
  'unload the form
  Unload frmEditDescription
      
  'for ingame resources, update resource objects, files and the treelist
  If InGame Then
    Select Case ResType
    Case rtLogic, rtPicture, rtSound, rtView
      UpdateResFile ResType, ResNum, strOldVal
    Case rtWords
      VocabularyWords.Description = Description
      'update property window and tree
      UpdateSelection ResType, ResNum, umProperty
      
    Case rtObjects
      InventoryObjects.Description = Description
      'update property window and tree
      UpdateSelection ResType, ResNum, umProperty
    
    End Select
  End If
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function


Public Sub AddNewLogic(ByVal NewLogicNumber As Long, NewLogic As AGILogic, ByVal blnTemplate As Boolean, ByVal Importing As Boolean)

  Dim tmpNode As Node, tmpRel As TreeRelationshipConstants
  Dim strLogic As String
  
  On Error GoTo ErrHandler
  'add to logic collection in game
  Logics.Add NewLogicNumber, NewLogic
    
  If Err.Number <> 0 Then
    'Debug.Print "why the heck doesn't the !@#$ error handler work???"
    GoTo ErrHandler
  End If
  
  With Logics(NewLogicNumber)
    'if not importing, we need to add boilerplate text
    If Not Importing Then
      'if using template,
      If blnTemplate Then
        'add template text to logic source
        If LogicSourceSettings.DefaultSyntax = lsAGI Then
          strLogic = LoadResString(117)
        Else
          strLogic = LoadResString(118)
        End If
        strLogic = Replace(strLogic, "TB", Space$(Settings.LogicTabWidth))
        strLogic = Replace(strLogic, "%id", Logics(NewLogicNumber).ID)
        strLogic = Replace(strLogic, "%h", Settings.PicTest.Horizon)
        .Load
      Else
        'add default text
        If LogicSourceSettings.DefaultSyntax = lsAGI Then
          strLogic = "//" & vbNewLine & "// " & Logics(NewLogicNumber).ID & vbNewLine & "//" & vbNewLine & vbNewLine & "return();" & vbNewLine & vbNewLine & "// messages"
        Else
          strLogic = "'" & vbNewLine & "' " & Logics(NewLogicNumber).ID & vbNewLine & "'" & vbNewLine & vbNewLine & "return()" & vbNewLine & vbNewLine & "' Messages"
        End If
      End If
      .SourceCode.Text = strLogic
      .SourceCode.Save
    End If
    
    'set isroom status based on template
    If NewLogicNumber <> 0 Then
      .IsRoom = blnTemplate
    End If
    .Save
  End With
  
  'add to treelist
  Set tmpNode = frmMDIMain.tvwResources.Nodes(2)
  'if no logics
  If tmpNode.Children = 0 Then
    'add it as first logic
    tmpRel = tvwChild
  Else
    'find place to insert this logic
    Set tmpNode = tmpNode.Child
    tmpRel = tvwPrevious
    Do Until tmpNode.Tag > NewLogicNumber
      If tmpNode.Next Is Nothing Then
        tmpRel = tvwNext
        Exit Do
      End If
      Set tmpNode = tmpNode.Next
    Loop
  End If
  
  'add to tree
  Set tmpNode = frmMDIMain.tvwResources.Nodes.Add(tmpNode.Index, tmpRel, "l" & CStr(NewLogicNumber), ResourceName(Logics(NewLogicNumber), True))
  tmpNode.Tag = NewLogicNumber
  Debug.Assert Logics(NewLogicNumber).SourceCode.Loaded
  If Not Logics(NewLogicNumber).Compiled Then
    tmpNode.ForeColor = vbRed
  End If
  
  'last index is no longer accurate; reset
  frmMDIMain.LastIndex = -1
Exit Sub

ErrHandler:
  Resume Next
End Sub

Public Function NextMsg(strText As String, ByRef lngLoc As Long, ByVal Syntax As LogicSyntaxType) As String

  'starting at position lngPos, step through cmds until a match is found for
  'a cmd that has a msg argument:
    'log(m#)
    'print(m#)
    'display(#,#,m#)
    'get.num(m#, v#)
    'print.at(m#, #, #, #)
    'set.menu(m#)
    'set.string(s#, m#)
    'get.string(s#, m#, #, #, #)
    'set.game.id(m#)
    'set.menu.item(m#, c#)
    'set.cursor.char(m#)
    
  'returns the message argument, and updates lngLoc
  
  Dim strCmd As String, lngArg As Long
  Dim strNext As String, lngNext As Long
  
  On Error GoTo ErrHandler
  
  'get next cmd
  FindNextToken strText, lngLoc, Syntax, strCmd, True, True
  Do Until lngLoc = 0
    'assume not found
    lngArg = -1
    
    'check against list of cmds with msg arguments:
    Select Case Len(strCmd)
    Case 3  'check for log
      If StrComp(strCmd, "log", vbTextCompare) = 0 Then
        'get arg 0
        lngArg = 0
      End If
    
    Case 5 'check for print
      If StrComp(strCmd, "print", vbTextCompare) = 0 Then
        'get arg 0
        lngArg = 0
      End If
    
    Case 7  'display or get.num
      If StrComp(strCmd, "display", vbTextCompare) = 0 Then
        lngArg = 2
      ElseIf StrComp(strCmd, "get.num", vbTextCompare) = 0 Then
        lngArg = 0
      End If
    
    Case 8  'print.at or set.menu
      If StrComp(strCmd, "print.at", vbTextCompare) = 0 Then
        lngArg = 0
      ElseIf StrComp(strCmd, "set.menu", vbTextCompare) = 0 Then
        lngArg = 0
      End If
    
    Case 10 'set.string
      If StrComp(strCmd, "set.string", vbTextCompare) = 0 Then
        lngArg = 1
      ElseIf StrComp(strCmd, "get.string", vbTextCompare) = 0 Then
        lngArg = 1
      End If
    
    Case 11 'set.game.id
      If StrComp(strCmd, "set.game.id") = 0 Then
        lngArg = 0
      End If
      
    Case 13 'set.menu.item
      If StrComp(strCmd, "set.menu.item", vbTextCompare) = 0 Then
        lngArg = 0
      End If
      
    Case 15 'set.cursor.char
      If StrComp(strCmd, "set.cursor.char") = 0 Then
        lngArg = 0
      End If
    End Select
    
    'if a cmd was found (lngArg<>-1)
    If lngArg <> -1 Then
      'syntax expected will be
      ' (arg0, arg1, ...
      'BUT for vb, the first parenthesis is optional
      strCmd = vbNullString
      FindNextToken strText, lngLoc, Syntax, strCmd, True, True
      If lngLoc = 0 Then
        Exit Do
      End If
      
      If strCmd = "(" Then
        'next one is arg0
        strCmd = vbNullString
        FindNextToken strText, lngLoc, Syntax, strCmd, True, True
        If lngLoc = 0 Then
          Exit Do
        End If
      Else
        'if not VB syntax
        If Syntax <> lsVB Then
          'not a valid cmd
          lngArg = -1
        End If
      End If
    End If
    
    'if not getting arg0
    If lngArg > 0 Then
      Do
        'nex cmd is a comment
        strCmd = vbNullString
        FindNextToken strText, lngLoc, Syntax, strCmd, True, True
        If lngLoc = 0 Then
          Exit Do
        End If
        
        If strCmd <> "," Then
          lngArg = -1
          Exit Do
        End If
        'now get next arg
        strCmd = vbNullString
        FindNextToken strText, lngLoc, Syntax, strCmd, True, True
        'decrement count
        lngArg = lngArg - 1
      Loop Until lngArg <= 0
      If lngLoc = 0 Then
        Exit Do
      End If
    End If
    
    'if still valid
    If lngArg <> -1 Then
      'strcmd is now the argument we are looking for
      'check for concatenation
      If Syntax = lsVB Then
        lngNext = lngLoc
        Do
          strNext = vbNullString
          FindNextToken strText, lngNext, Syntax, strNext, True, True
          'if next cmd is an ampersand,
          If strNext = "&" Then
            'next cmd should be another string
            strNext = vbNullString
            FindNextToken strText, lngNext, Syntax, strNext, True, True
            If Asc(strNext) = 34 And Right$(strNext, 1) = QUOTECHAR Then
              strCmd = Left$(strCmd, Len(strCmd) - 1) & Right$(strNext, Len(strNext) - 1)
            Else
              'invalid concatenation;
              'just exit with existing string
              lngNext = 0
            End If
          Else
            'no more concatenation
            lngNext = 0
          End If
        Loop Until lngNext = 0
      Else
        lngNext = lngLoc
        Do
          strNext = vbNullString
          FindNextToken strText, lngNext, Syntax, strNext, True, True
          'next cmd may be another string
          If Asc(strNext) = 34 And Right$(strNext, 1) = QUOTECHAR Then
            strCmd = Left$(strCmd, Len(strCmd) - 1) & Right$(strNext, Len(strNext) - 1)
          Else
            'no concatenation;
            'just exit with existing string
            lngNext = 0
          End If
        Loop Until lngNext = 0
      End If
      
      'validate that it is a string value
      If Asc(strCmd) = 34 And Right$(strCmd, 1) = QUOTECHAR Then
        'return this string
        NextMsg = strCmd
        Exit Function
      End If
    End If
    
    'get next cmd
    strCmd = vbNullString
    FindNextToken strText, lngLoc, Syntax, strCmd, True, True
  Loop
Exit Function

ErrHandler:
  Resume Next
End Function
Public Function ReadMsgs(strText As String, Messages() As String, MsgUsed() As Boolean, ByVal KeepAll As Boolean, ByVal TextSyntax As LogicSyntaxType) As Boolean

  'all valid message declarations in strText are
  'put into the Messages() array; if unused messages
  'are to be kept (KeepAll is True) the MsgUsed array
  'is used to keep flags for each message added
  
  'if an error in the logic is detected that would
  'make it impossible to accurately update the message
  'section, the function returns false, and Messages(0)
  'is populated with the error description, Messages(1)
  'is populated with the line where the error was found,
  'and subsequent elements are populated with any
  'additional information regarding the error
  
  Dim intMsgNum As Integer, lngPos As Long
  Dim strMsgMarker As String, lngMsgStart As Long
  Dim lngConcat As Long, strCmd As String
  Dim blnConcat As Boolean
  
  On Error GoTo ErrHandler
  
  'marker that defines msgs depends on syntax
  If TextSyntax = lsVB Then
    strMsgMarker = "Message"
  Else
    strMsgMarker = "#message"
  End If
  
  'get first message marker position
  FindNextToken strText, lngPos, TextSyntax, strMsgMarker
  
  Do Until lngPos = 0
    'vb syntax uses parentheses
    If TextSyntax = lsVB Then
      'next cmd should be '('
      strCmd = vbNullString
      FindNextToken strText, lngPos, lsVB, strCmd
      If strCmd <> "(" Then
        ' '(' expected after message keyword
        Messages(0) = "1"
        Messages(1) = CStr(lngPos)
        Exit Function
      End If
    End If
    
    'next cmd should be msg number
    strCmd = vbNullString
    FindNextToken strText, lngPos, lsVB, strCmd
    
    'validate msg number
    If Val(strCmd) < 1 Or Val(strCmd) > 255 Then
      'invalid msg number
      Messages(0) = "2"
      Messages(1) = CStr(lngPos)
      Exit Function
    End If
    
    intMsgNum = CInt(Val(strCmd))
    If Val(strCmd) <> intMsgNum Then
      'invalid msg number
      Messages(0) = "2"
      Messages(1) = CStr(lngPos)
      Exit Function
    End If
    
    'if msg is already assigned
    If LenB(Messages(intMsgNum)) <> 0 Then
      'user needs to fix message section first;
      'return false, and use the Message structure to indicate
      'what the problem is, and on which line it occurred
      Messages(0) = "3" '"duplicate msg number"
      Messages(1) = CStr(lngPos)
      Messages(2) = CStr(intMsgNum)
      Exit Function
    End If
        
    'vb syntax uses parentheses
    If TextSyntax = lsVB Then
      'next cmd should be ')'
      strCmd = vbNullString
      FindNextToken strText, lngPos, lsVB, strCmd
      If strCmd <> ")" Then
        ' ')' expected after msgnum
        Messages(0) = "4"
        Messages(1) = CStr(lngPos)
        Exit Function
      End If
    End If
    
    'vb syntax uses equal sign for assignment
    If TextSyntax = lsVB Then
      'next cmd should be '='
      strCmd = vbNullString
      FindNextToken strText, lngPos, lsVB, strCmd
      If strCmd <> "=" Then
        ' '=' expected
        Messages(0) = "5"
        Messages(1) = CStr(lngPos)
        Exit Function
      End If
    End If
    
    'next cmd should be a string
    strCmd = vbNullString
    FindNextToken strText, lngPos, TextSyntax, strCmd
    If Asc(strCmd) <> 34 Then
      'msgval should be string
      Messages(0) = "6"
      Messages(1) = CStr(lngPos)
      Exit Function
    End If
    If Len(strCmd) < 2 Then
      'msgval should be string
      Messages(0) = "6"
      Messages(1) = CStr(lngPos)
      Exit Function
    End If
    If Right$(strCmd, 1) <> QUOTECHAR Then
      'missing quote after string
      Messages(0) = "7"
      Messages(1) = CStr(lngPos)
      Exit Function
    End If
    
    'copy string cmd
    Messages(intMsgNum) = strCmd
    
    'check for end of line/concatenation
    blnConcat = False
    lngConcat = lngPos
    Do
      strCmd = vbNullString
      FindNextToken strText, lngConcat, TextSyntax, strCmd
      'if end of input
      If lngConcat = 0 Then
        'if expecting concatenation
        If blnConcat And TextSyntax = lsVB Then
          'msgval should be string
          Messages(0) = "6"
          Messages(1) = CStr(lngConcat)
          Exit Function
        End If
        'otherwise, exit the loop since no more text left to process
        Exit Do
      End If
      
      If TextSyntax = lsVB Then
        If blnConcat Then
          'must be a string
          If Asc(strCmd) <> 34 Then
            'msgval should be string
            Messages(0) = "6"
            If strCmd = vbCr Then
              lngConcat = lngConcat - 1
            End If
            Messages(1) = CStr(lngConcat)
            Exit Function
          End If
          If Len(strCmd) < 2 Then
            'msgval should be string
            Messages(0) = "6"
            If strCmd = vbCr Then
              lngConcat = lngConcat - 1
            End If
            Messages(1) = CStr(lngConcat)
            Exit Function
          End If
          If Right$(strCmd, 1) <> QUOTECHAR Then
            'missing quote after string
            Messages(0) = "7"
            If strCmd = vbCr Then
              lngConcat = lngConcat - 1
            End If
            Messages(1) = CStr(lngConcat)
            Exit Function
          End If
          
          'add string
          Messages(intMsgNum) = Left$(Messages(intMsgNum), Len(Messages(intMsgNum)) - 1) & Right$(strCmd, Len(strCmd) - 1)
          
          'toggle concat flag
          blnConcat = False
        Else
          'must be an ampersand OR {cr} OR comment
          If strCmd = "&" Then
            'toggle concat flag
            blnConcat = True
          ElseIf strCmd = vbCr Then
            'end of line found; no more concatenation
            Exit Do
          ElseIf Asc(strCmd) = 39 Or (StrComp(Left$(strCmd, 3), "rem", vbTextCompare) = 0) Then
            'comment; ignore
          Else
            'stuff not allowed on line after msg declaration
            Messages(0) = "8"
            If strCmd = vbCr Then
              lngConcat = lngConcat - 1
            End If
            Messages(1) = CStr(lngConcat)
            Exit Function
          End If
        End If
        
      Else
      'agi syntax
      
        If blnConcat Then
          'concatenation is optional; if string is found,
          'then concatenate it; if not, we're done
          If Asc(strCmd) = 34 Then
            'validate string
            If Len(strCmd) < 2 Then
              'msgval should be string
              Messages(0) = "6"
              Messages(1) = CStr(lngConcat)
              Exit Function
            End If
            If Right$(strCmd, 1) <> QUOTECHAR Then
              'missing quote after string
              Messages(0) = "7"
              Messages(1) = CStr(lngConcat)
              Exit Function
            End If
          
            'add string
            Messages(intMsgNum) = Left$(Messages(intMsgNum), Len(Messages(intMsgNum)) - 1) & Right$(strCmd, Len(strCmd) - 1)
            
            'toggle concat flag
            blnConcat = False
          Else
            'any other command means no concatenation needed
            Exit Do
          End If
        Else
          'only carriage return, or comments allowed after a string
          If strCmd = vbCr Or Left$(strCmd, 2) = "//" Or Left$(strCmd, 2) = "/*" Or Asc(strCmd) = 91 Then
            blnConcat = True
          Else
            'stuff not allowed on line after msg declaration
            Messages(0) = "8"
            Messages(1) = CStr(lngConcat)
            Exit Function
          End If
        End If
      End If
    Loop While True
    
    'check for end of input
    If lngPos = 0 Then
      Exit Do
    End If
    
    'set flag for msg if keeping all
    If KeepAll Then
      MsgUsed(intMsgNum) = True
    End If
    
    'get next msg marker
    FindNextToken strText, lngPos, TextSyntax, strMsgMarker
  Loop
  
  'success
  ReadMsgs = True
Exit Function

ErrHandler:
  Resume Next
End Function

Public Sub AddNewPicture(ByVal NewPictureNumber As Long, NewPicture As AGIPicture)

  Dim tmpNode As Node, tmpRel As TreeRelationshipConstants
  
  'add picture to game collection
  Pictures.Add NewPictureNumber, NewPicture
  
  'add to treelist
  Set tmpNode = frmMDIMain.tvwResources.Nodes(3)
  'if no sounds
  If tmpNode.Children = 0 Then
    'add it as first picture
    tmpRel = tvwChild
  Else
    'find place to insert this picture
    Set tmpNode = tmpNode.Child
    tmpRel = tvwPrevious
    Do Until tmpNode.Tag > NewPictureNumber
      If tmpNode.Next Is Nothing Then
        tmpRel = tvwNext
        Exit Do
      End If
      Set tmpNode = tmpNode.Next
    Loop
  End If
    
  'add it to tree
  frmMDIMain.tvwResources.Nodes.Add(tmpNode.Index, tmpRel, "p" & CStr(NewPictureNumber), ResourceName(Pictures(NewPictureNumber), True)).Tag = NewPictureNumber
  
  'last index is no longer accurate; reset
  frmMDIMain.LastIndex = -1
End Sub

Public Sub AddNewSound(ByVal NewSoundNumber As Long, NewSound As AGISound)

  Dim tmpNode As Node, tmpRel As TreeRelationshipConstants
  
  'add sound to game collection
  Sounds.Add NewSoundNumber, NewSound
  
  'add to treelist
  Set tmpNode = frmMDIMain.tvwResources.Nodes(4)
  'if no sounds
  If tmpNode.Children = 0 Then
    'add it as first sound
    tmpRel = tvwChild
  Else
    'find place to insert this sound
    Set tmpNode = tmpNode.Child
    tmpRel = tvwPrevious
    Do Until tmpNode.Tag > NewSoundNumber
      If tmpNode.Next Is Nothing Then
        tmpRel = tvwNext
        Exit Do
      End If
      Set tmpNode = tmpNode.Next
    Loop
  End If
  
  'add it to tree
  frmMDIMain.tvwResources.Nodes.Add(tmpNode.Index, tmpRel, "s" & CStr(NewSoundNumber), ResourceName(Sounds(NewSoundNumber), True)).Tag = NewSoundNumber
  
  'last index is no longer accurate; reset
  frmMDIMain.LastIndex = -1
End Sub
Public Sub AddNewView(ByVal NewViewNumber As Long, NewView As AGIView)

  Dim tmpNode As Node, tmpRel As TreeRelationshipConstants
  
  On Error GoTo ErrHandler
  
  'add view to game collection
  Views.Add NewViewNumber, NewView
  
  'add to treelist
  Set tmpNode = frmMDIMain.tvwResources.Nodes(5)
  'if no views
  If tmpNode.Children = 0 Then
    'add it as first view
    tmpRel = tvwChild
  Else
    'find place to insert this view
    Set tmpNode = tmpNode.Child
    tmpRel = tvwPrevious
    Do Until tmpNode.Tag > NewViewNumber
      If tmpNode.Next Is Nothing Then
        tmpRel = tvwNext
        Exit Do
      End If
      Set tmpNode = tmpNode.Next
    Loop
  End If
  
  'add it to tree
  frmMDIMain.tvwResources.Nodes.Add(tmpNode.Index, tmpRel, "v" & CStr(NewViewNumber), ResourceName(Views(NewViewNumber), True)).Tag = NewViewNumber
  
  'last index is no longer accurate; reset
  frmMDIMain.LastIndex = -1
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Public Function MsgBoxEx(ByVal Prompt As String, Optional ByVal Buttons As VbMsgBoxStyle = vbOKOnly, Optional Title, Optional ByVal HelpFile As String, Optional ByVal Context As Long, Optional ByVal CheckString As String = vbNullString, Optional ByRef Checked As Boolean) As VbMsgBoxResult
  
  Dim lngButtonCount As Long
  Dim lngBW As Long, lngWidth1 As Long, lngWidth2 As Long
  
  'show custom msgbox
'vbOKOnly =              0 1
'vbOKCancel =            1 1-2
'vbAbortRetryIgnore =    2 1-2-3
'vbYesNoCancel =         3 1-2-3
'vbYesNo =               4 1-2
'vbRetryCancel =         5 1-2

'vbApplicationModal =     0
'vbSystemModal =     &H1000

'vbDefaultButton1 =       0
'vbDefaultButton2 =   &H100
'vbDefaultButton3 =   &H200
'vbDefaultButton4 =   &H300

'vbCritical =          &H10
'vbQuestion =          &H20
'vbExclamation =       &H30
'vbInformation =       &H40

'vbMsgBoxHelpButton =     &H4000
'vbMsgBoxSetForeground = &H10000  '?
'vbMsgBoxRight =         &H80000  'right align the msg text
'vbMsgBoxRtlReading =   &H100000  '?
  
  
  Load frmDialog
  With frmDialog
    'pass along help info
    .HelpFile = HelpFile
    .HelpID = Context
    
    'need to account for border
    lngBW = .Width - .ScaleWidth
    
    'if showing help button...
    .cmdHelp.Visible = (Buttons And vbMsgBoxHelpButton)
    
    If (Buttons And vbSystemModal) Then
'      .StartUpPosition = vbStartUpScreen
    Else
'      .StartUpPosition = vbStartUpOwner
    End If
    
    'set title
    If IsMissing(Title) Then
      .Caption = App.Title
    Else
      .Caption = CStr(Title)
    End If
    
    'set message box width so the prompt text and
    'the checkstring (if visible) fit
    If .TextWidth(Prompt) > .TextWidth(CheckString) + 360 Then
      .Message.Width = .TextWidth(Prompt)
    Else
      .Message.Width = .TextWidth(CheckString) + 360
    End If
    
    'set height of msg prompt
    .Message.Height = .TextHeight(Prompt)
    
    'add icons (if requested)
    If ((Buttons \ &H10&) And &H7&) > 0 And ((Buttons \ &H10&) And &H7&) <= 4 Then
      'load associated image
      Set .Image1.Picture = .ImageList1.ListImages((Buttons \ &H10&) And &H7&).Picture
      .Image1.Visible = True
      
      'adjust label position to account for icon
      .Message.Left = .Message.Left + 705
      
      'if text height of msg is <height of image,
      If .Message.Height < .Image1.Height Then
        'center it
        .Message.Top = .Message.Top + ((.Image1.Height - .Message.Height) / 2 \ Screen.TwipsPerPixelX) * Screen.TwipsPerPixelX
        
        'buttons are below icon
        .Button1.Top = .Image1.Top + .Image1.Height + 255
      Else
        'buttons are below msg
        .Button1.Top = .Message.Top + .Message.Height + 255
      End If
      
    Else
      'no icon; buttons are below msg
      .Button1.Top = .Message.Top + .Message.Height + 255
    End If
    
    'now set height
    .Height = (.Height - .ScaleHeight) + .Button1.Top + .Button1.Height + 165
    
    'save width based on msg size
    'so it can be compared to button size
    lngWidth1 = lngBW + .Message.Left + .Message.Width + 105
    
    'if checkmark is needed
    If LenB(CheckString) <> 0 Then
      'position checkbox under msg
      .Check1.Left = .Message.Left
      .Check1.Top = .Button1.Top + 180
      
      'move buttons down to account for checkbox
      .Button1.Top = .Button1.Top + 600
      'adjust dialog height to account for checkbox
      .Height = .Height + 600
      
      'set check properties based on passed parameters
      .Check1.Width = .TextWidth(CheckString) + 600
      .Check1.Caption = CheckString
      .Check1.Value = (vbChecked And Checked)
      
      'finally, show the checkbox
      .Check1.Visible = True
    End If
    
    'move other buttons to correct height
    .Button2.Top = .Button1.Top
    .Button3.Top = .Button1.Top
    .cmdHelp.Top = .Button1.Top
    
    'set message text
    .Message.Caption = Prompt
    
    'set button captions
    Select Case Buttons And &H7&
    Case vbOKOnly
      .Button1.Caption = "OK"
      .Button1.Default = True
      
      lngButtonCount = 1
            
    Case vbOKCancel
      .Button1.Caption = "OK"
      .Button2.Caption = "Cancel"
      .Button2.Visible = True
      .Button2.Cancel = True
      
      .Button2.Default = (Buttons And vbDefaultButton2)
      
      lngButtonCount = 2
      
    Case vbAbortRetryIgnore
      .Button1.Caption = "&Abort"
      .Button2.Caption = "&Retry"
      .Button2.Visible = True
      .Button3.Caption = "&Ignore"
      .Button3.Visible = True
      
      .Button3.Default = (Buttons And vbDefaultButton3)
      .Button2.Default = (Buttons And vbDefaultButton2)
     
      lngButtonCount = 3
            
    Case vbYesNoCancel
      .Button1.Caption = "&Yes"
      .Button2.Caption = "&No"
      .Button2.Visible = True
      .Button3.Caption = "Cancel"
      .Button3.Cancel = True
      .Button3.Visible = True
      
      .Button3.Default = (Buttons And vbDefaultButton3)
      .Button2.Default = (Buttons And vbDefaultButton2)
      
      lngButtonCount = 3
      
    Case vbYesNo
      .Button1.Caption = "&Yes"
      .Button2.Caption = "&No"
      .Button2.Visible = True
      
      .Button2.Default = (Buttons And vbDefaultButton2)
           
      lngButtonCount = 2
      
    Case vbRetryCancel
      .Button1.Caption = "&Retry"
      .Button2.Caption = "Cancel"
      .Button2.Cancel = True
      .Button2.Visible = True
      
      .Button2.Default = (Buttons And vbDefaultButton2)
      
      lngButtonCount = 2
    End Select
    
    'if help button is visible,
    If (Buttons And vbMsgBoxHelpButton) Then
      lngButtonCount = lngButtonCount + 1
    End If
    
    'width needs to be wide enough for all buttons
    lngWidth2 = lngButtonCount * 1215 + 345

    'if width needed for buttons is wider than
    'width needed for text
    If lngWidth2 > lngWidth1 Then
      .Width = lngWidth2
      'button1 is right where it needs to be
    Else
      .Width = lngWidth1
      'move button1 to correct position based on button count
      .Button1.Left = ((.Width - lngBW - (1125 + (lngButtonCount - 1) * 1215)) / 2 \ Screen.TwipsPerPixelX) * Screen.TwipsPerPixelX
    End If
    
    'move other buttons based on button1 pos
    .Button2.Left = .Button1.Left + .Button1.Width + 90
    .Button3.Left = .Button2.Left + .Button2.Width + 90
    
    'if showing help button
    If (Buttons And vbMsgBoxHelpButton) Then
      'position it relative to button1, using button count
      'to determine offset
      .cmdHelp.Left = .Button1.Left + (lngButtonCount - 1) * (.Button1.Width + 90)
    End If
    
    'show it (if system modal, owning form is desktop?
    frmDialog.Show vbModal ', frmMDIMain.hwnd
    
    'get result
    MsgBoxEx = frmDialog.Result
    'get check box status
    Checked = (frmDialog.Check1.Value = vbChecked)
    
    'unload the form
    Unload frmDialog
  End With
End Function

Public Sub UpdateLayoutFile(ByVal LogicNumber As Long, NewExits As AGIExits, Optional ByVal RemoveRoom As Boolean = False)

  'updates the layout file to accurately show/hide
  'this room; the file entry uses the update code (U)
  'instead of the room code (R) so the layout editor
  'knows that the room needs to have its exits
  'refreshed based on the update
  'when hiding a room, must make sure it is visible
  'before adding update line; if room is not visible
  'adding an update line will cause an error when
  'the file is opened.
  
  Dim intFile As Integer, stlLayout As StringList
  Dim strLine As String, strTempFile As String
  Dim i As Long, blnRoomVis As Boolean
  Dim lngRoomLine As Long, lngUpdateLine As Long
  
  Dim lngCode As Long, lngNum As Long
  
  On Error GoTo ErrHandler
  
  'if no layout file
  If Not FileExists(GameDir & GameID & ".wal") Then
    Exit Sub
  End If
  
  'open layout file for input
  intFile = FreeFile()
  Open GameDir & GameID & ".wal" For Binary As intFile
  'get all the text
  strLine = String$(LOF(intFile), 0)
  Get intFile, 1, strLine
  'done with the file
  Close intFile
  
  'assign to stringlist
  Set stlLayout = New StringList
  stlLayout.Assign strLine
  
  lngRoomLine = -1
  lngUpdateLine = -1
  
  'locate any existing room or update lines for this room
  For i = 0 To stlLayout.Count - 1
    If LenB(stlLayout(i)) <> 0 Then
      If Asc(stlLayout(i)) = 85 And Val(Mid$(stlLayout(i), 3)) = LogicNumber Then 'asc("U") = 85
        'this is the update line
        lngUpdateLine = i
      End If
      If Asc(stlLayout(i)) = 82 And Val(Mid$(stlLayout(i), 3)) = LogicNumber Then 'asc("R") = 82
        'this is the room line
        lngRoomLine = i
        'determine if room is visible
        strLine = Right$(stlLayout(i), Len(stlLayout(i)) - 2) 'strip off 'R|'
        strLine = Right$(strLine, Len(strLine) - InStr(1, strLine, "|")) 'strip off number
        'test remainder of line for 'T' or 'F'
        blnRoomVis = (Asc(strLine) = 84)
      End If
    End If
  Next i
  
  
  'should NEVER have room come before update
  If lngRoomLine <> -1 And lngUpdateLine <> -1 Then
    Debug.Assert lngUpdateLine > lngRoomLine
  End If
  
  'ALWAYS delete update line, if there is one
  If lngUpdateLine <> -1 Then
    'remove the line
    stlLayout.Delete lngUpdateLine
  End If
  
  'if removing room there won't be an object to query for IsRoom status
  If RemoveRoom Then
    'if there is NOT a visible room
    If Not blnRoomVis Then
      'dont need to update, cuz room is already hidden
      Exit Sub
    End If
    
    'create the new update line
    strLine = "U|" & CStr(LogicNumber) & "|" & CStr(False)
  Else
    'if hiding room
    If Not Logics(LogicNumber).IsRoom Then
      'if room is already hidden,
      If Not blnRoomVis Then
        'don't need to update; cuz room is already hidden
        Exit Sub
      End If
    End If
    
    'if room is already visible,  add update anyway;
    'the layout editor handles it
    
    'create the new update line
    strLine = "U|" & CStr(LogicNumber) & "|" & CStr(Logics(LogicNumber).IsRoom)
    
    'if logic is a room (room is visible on layout)
    If Logics(LogicNumber).IsRoom And Not NewExits Is Nothing Then
      'add exits
      For i = 0 To NewExits.Count - 1
        With NewExits(i)
          strLine = strLine & "|" & Right$(.ID, 3) & ":" & .Room & ":" & .Reason & ":" & .Style
        End With
      Next i
    End If
  End If
  
  'add tne new update line
  stlLayout.Add strLine
  
  'create temp file
  strTempFile = TempFileName()
  
  'open temp file for output
  intFile = FreeFile()
  Open strTempFile For Binary As intFile
  
  'write data to the file
  Put intFile, 1, Join(stlLayout.AllLines, vbNewLine)
  'done with file
  Close intFile
  
  'kill old file, copy new
  On Error Resume Next
  Debug.Assert GameID <> vbNullString
  Kill GameDir & GameID & ".wal"
  FileCopy strTempFile, GameDir & GameID & ".wal"
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Public Sub UpdateLayoutRenumber(ByVal OldLogic As Long, ByVal NewLogic As Long)

  'updates the layout file to indicate a room has changed its number
  'a file entry using the update code (N)
  'instead of the room code (R) indicates to the layout editor
  'that the room has changed
  
  Dim intFile As Integer, stlLayout As StringList
  Dim strLine As String, strTempFile As String
  Dim i As Long
  
  Dim lngCode As Long, lngNum As Long
  
  On Error GoTo ErrHandler
  
  'if no layout file
  If Not FileExists(GameDir & GameID & ".wal") Then
    Exit Sub
  End If
  
  'open layout file for input
  intFile = FreeFile()
  Open GameDir & GameID & ".wal" For Binary As intFile
  'get all the text
  strLine = String$(LOF(intFile), 0)
  Get intFile, 1, strLine
  'done with the file
  Close intFile
  
  'assign to stringlist
  Set stlLayout = New StringList
  stlLayout.Assign strLine
  
  'add the update line
  strLine = "N|" & CStr(OldLogic) & "|" & CStr(NewLogic) & "|"
  
  'add tne new update line
  stlLayout.Add strLine
  
  'create temp file
  strTempFile = TempFileName()
  
  'open temp file for output
  intFile = FreeFile()
  Open strTempFile For Binary As intFile
  
  'write data to the file
  Put intFile, 1, Join(stlLayout.AllLines, vbNewLine)
  'done with file
  Close intFile
  
  'kill old file, copy new
  On Error Resume Next
  Debug.Assert GameID <> vbNullString
  Kill GameDir & GameID & ".wal"
  FileCopy strTempFile, GameDir & GameID & ".wal"
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Public Function AnalyzeExit(strSource As String, ByVal lsSyntax As LogicSyntaxType, ByRef lngLoc As Long, Optional ByVal StartPos As Long = 0) As AGIExit

  'analyzes the exit info associated with the 'new.room' command
  'located at lngLoc in strSource
  'StartPos is a verified valid starting point to begin search for
  ''if' commands; usually set to end of the most recent 'new.room'
  'command; this adds efficiency to the search by not requiring
  'the 'if' search to have to start at beginning for each exit being
  'analyzed
  '
  'returns an agiexit object with exit info
  '
  'lngLoc is also changed to point to the end of the 'new.room' command
  'to allow insertion of layouteditor marker
  
  Dim pos1 As Long, pos2 As Long, pos3 As Long
  Dim i As Long, j As Long, lngEnd As Long
  Dim intRoom As Integer, eReason As EEReason
  Dim intStyle As Integer
  Dim strLine As String
  
  'lngLoc is location of 'new.room'
  'pos1 is location of 'if'
  'pos2 is location of 'then' or ')'
  'pos3 is location of '{'
  
  On Error GoTo ErrHandler
  
  'get room value first
  
  'get next cmd pos
  i = lngLoc + 7
  FindNextToken strSource, i, lsSyntax, strLine
  
  'regardless of syntax, if a parenthesis is found
  If strLine = "(" Then
    'ok; next cmd should be the value we are looking for
    strLine = vbNullString
    FindNextToken strSource, i, lsAGI, strLine
  Else
    'no parenthesis is OK for vb
    If lsSyntax <> lsVB Then
      'for agi, if no parenthesis, set room arg to zero
      strLine = "0"
    End If
  End If
  
  intRoom = CInt(Val(Logics.ConvertArg(Trim$(strLine), atNum, lsSyntax)))
  
  'validate room
  If intRoom < 0 Or intRoom > 255 Then
    intRoom = 0
  End If
  
  'get end of this command by finding a comment or cr
  Do
    strLine = vbNullString
    lngEnd = FindNextToken(strSource, i, lsSyntax, strLine)
    If lsSyntax = lsVB Then
      If LCase$(Left$(strLine, 3)) = "rem" Then
        Exit Do
      End If
      If Asc(strLine) = 13 Or Asc(strLine) = 39 Then
        Exit Do
      End If
    Else
      Select Case Left$(strLine, 2)
      Case vbCr, "[", "//", "/*"
        Exit Do
      End Select
    End If
  Loop While True
  'i marks end of new.room command
  
  'locate the 'then' that precedes this "new.room(" cmd
  'and determine style of exit (complex or simple)
  pos2 = StartPos
  Do
    'beginning at pos2; step through 'if' cmds until
    'the one that precedes lngLoc is found
    '
    'use pos2 as cmdpointer, pos3 as next 'if' loc
    'pos1 as final 'if' loc
    Do
      pos3 = FindNextToken(strSource, pos2, lsSyntax, "if")
      'if this pos is not past new.room cmd
      If pos3 < lngLoc And pos3 <> 0 Then
        'update final 'if' loc
        pos1 = pos3 + 1
      Else
        'done search
        Exit Do
      End If
    'if no 'if' found, exit the loop
    Loop Until pos3 = 0
    
    'if no 'if' found,
    If pos1 = 0 Then
      'this is a complex unknown
      intStyle = 1
      eReason = erUnknown
      Exit Do
    End If
    
    'now examine the 'if' statement to determine exit type
    'based on syntax:
    If lsSyntax = lsVB Then
      'expected vb syntax
      'If {test} Then
      '  new.room(##)
      '
      'comments could exist at end of any lines
      'other commands could exist between 'Then and 'new.room'
    
    
      'expecting 'v2'
      strLine = vbNullString
      FindNextToken strSource, pos1, lsVB, strLine, True, True
      If Logics.ConvertArg(Trim$(strLine), atVar, lsVB) <> "v2" Then
        'unknown
        intStyle = 1
        eReason = erUnknown
        Exit Do
      End If
      
      'expecting '='
      strLine = vbNullString
      FindNextToken strSource, pos1, lsVB, strLine, True, True
      If strLine <> "=" Then
        'unknown
        intStyle = 1
        eReason = erUnknown
        Exit Do
      End If
    
      'expecting valid exit reason
      strLine = vbNullString
      FindNextToken strSource, pos1, lsVB, strLine, True, True
      i = Val(Logics.ConvertArg(Trim$(strLine), atNum, lsVB))
      If i > 0 And i < 5 Then
        eReason = i
      End If
      
      'expecting "then"
      strLine = vbNullString
      FindNextToken strSource, pos1, lsVB, strLine, True, True
      If LCase$(strLine) <> "then" Then
        'unknown
        intStyle = 1
        eReason = erUnknown
        Exit Do
      End If
      
      'expecting {cr}
      strLine = vbNullString
      FindNextToken strSource, pos1, lsVB, strLine, True, True
      If strLine <> vbCr Then
        'unknown
        intStyle = 1
        eReason = erUnknown
        Exit Do
      End If
      
      'expecting 'new.room'
      strLine = vbNullString
      FindNextToken strSource, pos1, lsVB, strLine, True, True
      If strLine <> "new.room" Then
        'complex
        intStyle = 1
        'get next 'new.room' cmd
        FindNextToken strSource, pos1, lsVB, "new.room"
      End If
      
    Else
      'expected syntax:
      ' if ({test}) {new.room(##)
      '
      '(agi syntax allows cr's inbetween any of the elements)
      'comments could also exist between any elements either as
      'line comments in conjunction with a cr, or as a block comment
      'other commands could exist between '{' and 'new.room'
        
      'expecting '('
      strLine = vbNullString
      FindNextToken strSource, pos1, lsAGI, strLine, True, True
      If strLine <> "(" Then
        'unknown
        intStyle = 1
        eReason = erUnknown
        Exit Do
      End If
      
      'expecting 'v2'
      strLine = vbNullString
      FindNextToken strSource, pos1, lsAGI, strLine, True, True
      If Logics.ConvertArg(Trim$(strLine), atVar, lsAGI) <> "v2" Then
        'unknown
        intStyle = 1
        eReason = erUnknown
        Exit Do
      End If
      
      'expecting '=='
      strLine = vbNullString
      FindNextToken strSource, pos1, lsAGI, strLine, True, True
      If strLine <> "==" Then
        'unknown
        intStyle = 1
        eReason = erUnknown
        Exit Do
      End If
    
      'expecting valid exit reason
      strLine = vbNullString
      FindNextToken strSource, pos1, lsAGI, strLine, True, True
      i = Val(Logics.ConvertArg(Trim$(strLine), atNum, lsAGI))
      If i > 0 And i < 5 Then
        eReason = i
      End If
      
      'expecting ')'
      strLine = vbNullString
      FindNextToken strSource, pos1, lsAGI, strLine, True, True
      If strLine <> ")" Then
        'unknown
        intStyle = 1
        eReason = erUnknown
        Exit Do
      End If
      
      'expecting "{"
      strLine = vbNullString
      FindNextToken strSource, pos1, lsAGI, strLine, True, True
      If strLine <> "{" Then
        'unknown
        intStyle = 1
        eReason = erUnknown
        Exit Do
      End If
      
      'expecting 'new.room'
      strLine = vbNullString
      FindNextToken strSource, pos1, lsAGI, strLine, True, True
      If strLine <> "new.room" Then
        'complex
        intStyle = 1
        'get next 'new.room' cmd
        FindNextToken strSource, pos1, lsAGI, "new.room"
      End If
    End If
      
    'verify this new.room is same as one that started the analysis
    If lngLoc <> pos1 - 7 Then
      eReason = erUnknown
    End If
    
  'always exit loop
  Loop Until True
  
  'return exit object
  Set AnalyzeExit = New AGIExit
  With AnalyzeExit
    .Reason = eReason
    .Room = intRoom
    .Style = intStyle
    .Status = esOK
  End With
  
  'adjust lngLoc
  lngLoc = lngEnd - 1
Exit Function

ErrHandler:
  Resume Next
End Function

Public Function ExitInfoFromFile(ByVal LogicNumber As Long) As AGIExits
    
  Dim intFile As Integer, strLine As String
  
  On Error GoTo ErrHandler
  
  'open existing file for input
  intFile = FreeFile()
  Open GameDir & GameID & ".wal" For Input As intFile
  
  'retrieve lines, one at a time
  Do While Not EOF(intFile)
    Line Input #intFile, strLine
    
    'if this line has room data, (starts with 'R')
    If Asc(strLine) = 82 Then
      'if room number matches
      If Val(Mid$(strLine, 3, 3)) = LogicNumber Then
        'parse existing exit info
        Set ExitInfoFromFile = ParseExits(strLine)
        Exit Do
      End If
    End If
  Loop
  
ErrHandler:
  'if not found
  If ExitInfoFromFile Is Nothing Then
    'use an empty collection
    Set ExitInfoFromFile = New AGIExits
  End If
  
  Close intFile
End Function

Public Sub NewWords()
  
  'creates a new word list file
  
  Dim frmNew As frmWordsEdit
  
  On Error GoTo ErrHandler
  
  'create new file
  Set frmNew = New frmWordsEdit
  Load frmNew
  
  frmNew.NewWords
  frmNew.Show
Exit Sub

ErrHandler:
  Resume Next
End Sub
Public Function NoteToFreq(ByVal NoteIn As Long) As Long
  'converts a midinote into a freqdivisor value
  
  'valid range of NoteIn is 45-127
  'note that 121, 124, 126 NoteIn values will actually return same freqdivisor
  'values as 120, 123, 127 respectively (due to loss of resolution in freq
  'values at the high end)
    
  Dim sngFreq As Single
  
  'validate input
  If NoteIn < 45 Then
    NoteIn = 45
  ElseIf NoteIn > 127 Then
    NoteIn = 127
  End If
  
  sngFreq = 111860# / 10 ^ ((NoteIn + 36.5) * dblLogConst)
  
  NoteToFreq = CLng(sngFreq)
End Function

Public Function MIDILength(ByVal lngDuration As Long, ByVal lngTPQN As Long) As String
  'returns a string representation of midi note length
  
  Dim sngNoteLen As Single
  
  sngNoteLen = (lngDuration / lngTPQN) * 4
  
  Select Case sngNoteLen
  Case 1
    MIDILength = "1/16"
  Case 2
    MIDILength = "1/8"
  Case 3
    MIDILength = "1/8*"
  Case 4
    MIDILength = "1/4"
  Case 5
    MIDILength = "1/4 + 1/16"
  Case 6
    MIDILength = "1/4*"
  Case 7
    MIDILength = "1/4**"
  Case 8
    MIDILength = "1/2"
  Case 9
    MIDILength = "1/2 + 1/16"
  Case 10
    MIDILength = "1/2 + 1/8"
  Case 11
    MIDILength = "1/2 + 1/8*"
  Case 12
    MIDILength = "1/2*"
  Case 13
    MIDILength = "1/2* + 1/16"
  Case 14
    MIDILength = "1/2**"
  Case 15
    MIDILength = "1/2** + 1/16"
  Case 16
    MIDILength = "1"
  Case Else
    MIDILength = "<undefined>"
  End Select
End Function

Public Function MIDINote(ByVal lngFreq As Long) As Long
  'converts AGI freq offset into a MIDI note
  Dim dblRawNote As Double
  
  'middle C is 261.6 HZ; from midi specs,
  'middle C is a note with a value of 60
  'this requires a shift in freq of approx. 36.376
  'however, this offset results in crappy sounding music;
  'empirically, 36.5 seems to work best
  
  'note that since freq divisor is in range of 0 - 1023
  'resulting midinotes are in range of 45 - 127
  'and that midinotes of 126, 124, 121 are not possible (no corresponding freq divisor)
  
  
  'if freq divisor is 0
  If lngFreq <= 0 Then
    'set note to max
    MIDINote = 127
  Else
  
    MIDINote = CLng((Log10(111860# / CDbl(lngFreq)) / dblLogConst) - 36.5)
    
    'validate
    If MIDINote < 0 Then
      MIDINote = 0
    End If
    'in case note is too high,
    If MIDINote > 127 Then
      MIDINote = 127
    End If
  End If
End Function

Public Function NoteName(ByVal MIDINote As Byte, Optional ByVal Key As Long = 0) As String
  'returns a string character representing the midi note
  
  Dim lngOctave As Long
  Dim lngNote As Long
  
  Select Case MIDINote
'  Case 0
'    'zero
'    NoteName = "OFF"
  Case Is < 0
    'invalid low
    NoteName = "OFF" '"ERR_LO"
  Case Is > 127
    'invalid high
    NoteName = "ERR_HI"
  Case Else
    'get octave and note value
    lngOctave = MIDINote \ 12 - 1
    lngNote = MIDINote Mod 12
    
    Select Case lngNote
    Case 0
      NoteName = "C"
    Case 1
      NoteName = IIf(Sgn(Key) = -1, "Db", "C#")
    Case 2
      NoteName = "D"
    Case 3
      NoteName = IIf(Sgn(Key) = -1, "Eb", "D#")
    Case 4
      NoteName = "E"
    Case 5
      NoteName = "F"
    Case 6
      NoteName = IIf(Sgn(Key) = -1, "Gb", "F#")
    Case 7
      NoteName = "G"
    Case 8
      NoteName = IIf(Sgn(Key) = -1, "Ab", "G#")
    Case 9
      NoteName = "A"
    Case 10
      NoteName = IIf(Sgn(Key) = -1, "Bb", "A#")
    Case 11
      NoteName = "B"
    End Select
  End Select
End Function


Public Function DisplayNote(ByVal MIDINote As Byte, ByVal Key As Long) As tDisplayNote
  'returns a note position, relative to middle c
  'as either a positive or negative value (negative meaning higher tone)
  '
  'the value is the offset needed to draw the note correctly
  'on the staff; one unit is a half the distance between staff lines
  '
  'the returned value is adjusted based on the key
  
  Dim lngOctave As Long
  Dim lngNote As Long
  
  If MIDINote < 0 Or MIDINote > 127 Then
    Exit Function
  End If
  
  'get octave and note value
  lngOctave = MIDINote \ 12 - 1
  lngNote = MIDINote - ((lngOctave + 1) * 12)
  
  Select Case lngNote
  Case 0 ' "-C"
    If Key = 7 Then
      DisplayNote.Pos = 1
      DisplayNote.Tone = ntNone
    Else
      DisplayNote.Pos = 0
      If (Key >= -5 And Key <= 1) Then
        DisplayNote.Tone = ntNone
      Else
        DisplayNote.Tone = ntNatural
      End If
    End If
    
  
  Case 1 ' "-C#"
  If Key >= 0 Then
    DisplayNote.Pos = 0
  Else
    DisplayNote.Pos = -1
  End If
  Select Case Key
  Case 0, 1
    DisplayNote.Tone = ntSharp
  Case -1, -2, -3
    DisplayNote.Tone = ntFlat
  Case Else
    DisplayNote.Tone = ntNone
  End Select
  
  Case 2 ' "-D"
    DisplayNote.Pos = -1
    Select Case Key
    Case Is > 3, Is < -3
      DisplayNote.Tone = ntNatural
    Case Else
      DisplayNote.Tone = ntNone
    End Select
    
  Case 3 ' "-D#"
    If Key >= 0 Then
      DisplayNote.Pos = -1
    Else
      DisplayNote.Pos = -2
    End If
    Select Case Key
    Case 0 To 3
      DisplayNote.Tone = ntSharp
    Case -1
      DisplayNote.Tone = ntFlat
    Case Else
      DisplayNote.Tone = ntNone
    End Select
    
  Case 4 ' "-E"
    If Key = -7 Then
      DisplayNote.Pos = -3
      DisplayNote.Tone = ntNone
    Else
      DisplayNote.Pos = -2
      If Key >= -1 And Key <= 5 Then
        DisplayNote.Tone = ntNone
      Else
        DisplayNote.Tone = ntNatural
      End If
    End If
    
  Case 5 ' "-F"
    If Key >= 6 Then
      DisplayNote.Pos = -2
      DisplayNote.Tone = ntNone
    Else
      DisplayNote.Pos = -3
      If Key <= 0 And Key >= -6 Then
        DisplayNote.Tone = ntNone
      Else
        DisplayNote.Tone = ntNatural
      End If
    End If
    
  Case 6 ' "-F#"
    If Key >= 0 Then
      DisplayNote.Pos = -3
    Else
      DisplayNote.Pos = -4
    End If
    Select Case Key
    Case 0
      DisplayNote.Tone = ntSharp
    Case -4 To -1
      DisplayNote.Tone = ntFlat
    Case Else
      DisplayNote.Tone = ntNone
    End Select
  
  Case 7 ' "-G"
    DisplayNote.Pos = -4
    If Key >= 3 Or Key <= -5 Then
      DisplayNote.Tone = ntNatural
    Else
      DisplayNote.Tone = ntNone
    End If
    
  Case 8 ' "-G#"
    If Key >= 0 Then
      DisplayNote.Pos = -4
    Else
      DisplayNote.Pos = -5
    End If
    Select Case Key
    Case 0 To 2
      DisplayNote.Tone = ntSharp
    Case -1, -2
      DisplayNote.Tone = ntFlat
    Case Else
      DisplayNote.Tone = ntNone
    End Select
    
  Case 9 ' "-A"
    DisplayNote.Pos = -5
    If Key >= 5 Or Key <= -3 Then
      DisplayNote.Tone = ntNatural
    Else
      DisplayNote.Tone = ntNone
    End If
    
  Case 10 ' "-A#"
    If Key >= 0 Then
      DisplayNote.Pos = -5
    Else
      DisplayNote.Pos = -6
    End If
    Select Case Key
    Case 0 To 4
      DisplayNote.Tone = ntSharp
    Case Else
      DisplayNote.Tone = ntNone
    End Select
    
  Case 11 ' "-B"
    If Key <= -6 Then
      DisplayNote.Pos = -7
      DisplayNote.Tone = ntNone
    Else
      DisplayNote.Pos = -6
      If Key <= -1 Or Key = 7 Then
        DisplayNote.Tone = ntNatural
      Else
        DisplayNote.Tone = ntNone
      End If
    End If
  End Select
  
  'adust for octave
  DisplayNote.Pos = DisplayNote.Pos + (4 - lngOctave) * 7
End Function
Public Sub DrawProp(picProps As PictureBox, ByVal PropID As String, ByVal PropValue As String, ByVal RowNum As Long, ByVal CanSelect As Boolean, ByVal SelectedProp As Long, ByVal PropScroll As Long, ByVal PropEnabled As Boolean, Optional ByVal ButtonFace As EButtonFace = bfNone)
                      
  Dim lngForeColor As Long
  Dim rtn As Long, blnIsSelected As Boolean
  
  'determine if this prop is selected
  blnIsSelected = (CanSelect And (SelectedProp = RowNum))
  
  RowNum = RowNum - PropScroll
  
  'if rownum is out of bounds
  If RowNum < 1 Or RowNum > (picProps.ScaleHeight - 2) / PropRowHeight Then
    Exit Sub
  End If
  
  'set forecolor depending on whether or not properties are enabled
  lngForeColor = IIf(PropEnabled, vbBlack, RGB(&H80, &H80, &H80))
   
  'strip off any multilines
  If InStrB(1, PropValue, vbCr) <> 0 Then
    PropValue = Left$(PropValue, InStr(1, PropValue, vbCr))
  End If
  If InStrB(1, PropValue, vbLf) <> 0 Then
    PropValue = Left$(PropValue, InStr(1, PropValue, vbLf))
  End If
  
  With picProps
    If blnIsSelected Then
     picProps.Line (1, PropRowHeight * RowNum)-(PropSplitLoc - 1, PropRowHeight * RowNum + PropRowHeight - 2), SelBlue, BF
    End If
  
    .CurrentX = 3
    .CurrentY = PropRowHeight * RowNum + 1
    .ForeColor = IIf(blnIsSelected, vbWhite, vbBlack)
    picProps.Print PropID;
    
    picProps.Line (PropSplitLoc, PropRowHeight * RowNum)-(picProps.Width, (RowNum + 1) * PropRowHeight), vbWhite, BF
    .CurrentY = PropRowHeight * RowNum + 1
    .CurrentX = PropSplitLoc + 3
    .ForeColor = lngForeColor
    picProps.Print PropValue
  
    'if this is selected property,
    If blnIsSelected Then
      Select Case ButtonFace
      Case 1  'drop down
        rtn = BitBlt(.hdc, .ScaleWidth - 17, RowNum * PropRowHeight, 17, 17, DropDownDC, 0, 0, SRCCOPY)
      Case 2  'drop over
        rtn = BitBlt(.hdc, .ScaleWidth - 17, RowNum * PropRowHeight, 17, 17, DropOverDC, 0, 0, SRCCOPY)
      Case 3  'drop dialog
        rtn = BitBlt(.hdc, .ScaleWidth - 17, RowNum * PropRowHeight, 17, 17, DropDlgDC, 0, 0, SRCCOPY)
      End Select
    End If
  End With
End Sub



Public Sub ChangeIntVersion(ByVal NewVersion As Single)

  Dim rtn As VbMsgBoxResult
  Dim strTemp As String
  Dim intFile As Integer
  
  'inline error checking
  On Error Resume Next
  
  'if change is major
  If NewVersion < 3 And InterpreterVersion > 3 Or _
     NewVersion > 3 And InterpreterVersion < 3 Then
    'ask for confirmation
    rtn = MsgBox("Changing the interpreter version may create problems with your logic resources," & _
          "due to changes in the number of commands, and their argument counts." & vbNewLine & vbNewLine & _
          "Also, your DIR and VOL files will need to be rebuilt to make a major version change. " & _
          vbNewLine & vbNewLine & "Continue with version change?", vbQuestion + vbYesNo, _
          "Change Interpreter Version")
    
    If rtn = vbNo Then
      'exit
      Exit Sub
    End If
    
    'disable form until compile complete
    frmMDIMain.Enabled = False
    frmMDIMain.MousePointer = vbHourglass
    
    'set up compile form
    Set CompStatusWin = New frmCompStatus
    CompStatusWin.SetMode 1 'rebuild only
    CompStatusWin.Show
    
    'change the version
    InterpreterVersion = NewVersion
    
    'if major error,
    If Err.Number <> 0 Then
      'display error message
      MsgBox "Error during version change: " & vbNewLine & vbNewLine & Err.Description & vbNewLine & vbNewLine & _
             "Original version has been restored.", vbCritical, "Change Interpreter Version"
       GoTo ErrHandler
    End If
    
    'check for cancel
    If CompStatusWin.CompCanceled Then
      GoTo ErrHandler
    End If
    
    'check for errors and warnings
    If CLng(CompStatusWin.lblErrors.Caption) + CLng(CompStatusWin.lblWarnings.Caption) > 0 Then
      'build error/warning text string
      strTemp = CompStatusWin.StatusResults
      
      If LogicEditors.Count < MaxLogicEditors Then
        'open text editor
        NewTextFile
        'assign error/warning text to editor
        frmMDIMain.ActiveForm.rtfLogic.HighlightSyntax = False
        frmMDIMain.ActiveForm.rtfLogic.Text = Replace(Replace(strTemp, "~", vbCr), "|", vbCr & "    ")
        'msgbox to user
        MsgBox "Errors and/or warnings were generated during game compile.", vbInformation + vbOKOnly, "Compile Game Error"
      Else
        'save as error/warning file
        Kill GameDir & GameID & " Compile Errors and Warnings.txt"
        intFile = FreeFile()
        Open GameDir & GameID & " Compile Errors and Warnings.txt" For Binary As intFile
        Put intFile, 1, Replace(Replace(strTemp, "~", vbNewLine), "|", vbNewLine & "    ")
        Close intFile
      
        'msgbox to user
        MsgBox "Errors and/or warnings were generated during game . See '" & _
        GameID & " Rebuild Errors and " & "Warnings.txt ' in your game directory.", _
        vbInformation + vbOKOnly, "Compile Game Error"
      End If
      
      'if errors
      If CLng(CompStatusWin.lblErrors.Caption) > 0 Then
        'reuild resource list
        BuildResourceTree GameID
      End If
    Else
      'everything is ok
      MsgBox "Version change and rebuild completed successfully.", _
             vbInformation + vbOKOnly, "Change Interpreter Version"
    End If
    
    'unload the compile staus form
    Unload CompStatusWin
    Set CompStatusWin = Nothing
    
    'restore form state
    frmMDIMain.Enabled = True
    frmMDIMain.MousePointer = vbDefault
  Else
    'ask for confirmation
    rtn = MsgBox("Changing the interpreter version may create problems with your logic resources," & _
          "due to changes in the number of commands, and their argument counts." & vbNewLine & vbNewLine & _
          "Continue with version change?", vbQuestion + vbYesNo, "Change Interpreter Version")
    
    If rtn = vbNo Then
      'exit
      Exit Sub
    End If
    'just change the version
    InterpreterVersion = NewVersion
  End If
Exit Sub

ErrHandler:
  'unload the compile staus form
  Unload CompStatusWin
  Set CompStatusWin = Nothing

  'restore form state
  frmMDIMain.Enabled = True
  frmMDIMain.MousePointer = vbDefault
  
  'clean up any leftover files
  If NewVersion >= 3 Then
    Kill GameDir & GameID & "DIR.NEW"
  Else
    Kill GameDir & "LOGDIR.NEW"
    Kill GameDir & "PICDIR.NEW"
    Kill GameDir & "SNDDIR.NEW"
    Kill GameDir & "VIEWDIR.NEW"
  End If
  Kill GameDir & "NEW_VOL.*"
  
  'clear errors
  Err.Clear
End Sub

Public Sub CompileAGIGame(Optional ByVal CompGameDir As String = vbNullString, Optional ByVal RebuildOnly As Boolean = False)

  Dim rtn As VbMsgBoxResult
  Dim strTemp As String
  Dim intFile As Integer
  Dim i As Long, blnDontAsk As Boolean
  
  On Error GoTo ErrHandler
  
  'if no game is loaded,
  If Not GameLoaded Then
    Exit Sub
  End If
  
  'check for any open resources
  For i = 1 To LogicEditors.Count
    If LogicEditors(i).FormMode = fmLogic Then
      If LogicEditors(i).rtfLogic.Dirty Then
        'saveoncompile is in ask mode or yes mode
        If Settings.SaveOnCompile <> 1 Then
          'if not automatic,
          If Settings.SaveOnCompile = 0 Then
            LogicEditors(i).SetFocus
            'get user's response
            rtn = MsgBoxEx("Do you want to save this logic before compiling?", vbQuestion + vbYesNoCancel, "Update " & ResourceName(LogicEditors(i).LogicEdit, True, True) & "?", , , "Always take this action when compiling a game.", blnDontAsk)
            If blnDontAsk Then
              If rtn = vbYes Then
                Settings.SaveOnCompile = 2
              Else
                Settings.SaveOnCompile = 1
              End If
            End If
          Else
            'if on automatic, always say yes
            rtn = vbYes
          End If
          
          Select Case rtn
          Case vbCancel
            Exit Sub
          Case vbYes
            'save it
            LogicEditors(i).MenuClickSave
          End Select
        End If
      End If
    End If
  Next i
  
  For i = 1 To PictureEditors.Count
    If PictureEditors(i).PicEdit.IsDirty Then
      'saveoncompile is in ask mode or yes mode
      If Settings.SaveOnCompile <> 1 Then
        'if not automatic,
        If Settings.SaveOnCompile = 0 Then
          PictureEditors(i).SetFocus
          'get user's response
          rtn = MsgBoxEx("Do you want to save this picture before compiling?", vbQuestion + vbYesNoCancel, "Update " & ResourceName(PictureEditors(i).PicEdit, True, True) & "?", , , "Always take this action when compiling a game.", blnDontAsk)
          If blnDontAsk Then
            If rtn = vbYes Then
              Settings.SaveOnCompile = 2
            Else
              Settings.SaveOnCompile = 1
            End If
          End If
        Else
          'if on automatic, always say yes
          rtn = vbYes
        End If
      
        Select Case rtn
        Case vbCancel
          Exit Sub
        Case vbYes
          'save it
          PictureEditors(i).MenuClickSave
        End Select
      End If
    End If
  Next
  
  For i = 1 To SoundEditors.Count
    If SoundEditors(i).SoundEdit.IsDirty Then
      'saveoncompile is in ask mode or yes mode
      If Settings.SaveOnCompile <> 1 Then
        'if not automatic,
        If Settings.SaveOnCompile = 0 Then
          SoundEditors(i).SetFocus
          'get user's response
          rtn = MsgBoxEx("Do you want to save this Sound before compiling?", vbQuestion + vbYesNoCancel, "Update " & ResourceName(SoundEditors(i).SoundEdit, True, True) & "?", , , "Always take this action when compiling a game.", blnDontAsk)
          If blnDontAsk Then
            If rtn = vbYes Then
              Settings.SaveOnCompile = 2
            Else
              Settings.SaveOnCompile = 1
            End If
          End If
        Else
          'if on automatic, always say yes
          rtn = vbYes
        End If
      
        Select Case rtn
        Case vbCancel
          Exit Sub
        Case vbYes
          'save it
          SoundEditors(i).MenuClickSave
        End Select
      End If
    End If
  Next
  
  For i = 1 To ViewEditors.Count
    If ViewEditors(i).ViewEdit.IsDirty Then
      'saveoncompile is in ask mode or yes mode
      If Settings.SaveOnCompile <> 1 Then
        'if not automatic,
        If Settings.SaveOnCompile = 0 Then
          ViewEditors(i).SetFocus
          'get user's response
          rtn = MsgBoxEx("Do you want to save this View before compiling?", vbQuestion + vbYesNoCancel, "Update " & ResourceName(ViewEditors(i).ViewEdit, True, True) & "?", , , "Always take this action when compiling a game.", blnDontAsk)
          If blnDontAsk Then
            If rtn = vbYes Then
              Settings.SaveOnCompile = 2
            Else
              Settings.SaveOnCompile = 1
            End If
          End If
        Else
          'if on automatic, always say yes
          rtn = vbYes
        End If
      
        Select Case rtn
        Case vbCancel
          Exit Sub
        Case vbYes
          'save it
          ViewEditors(i).MenuClickSave
        End Select
      End If
    End If
  Next
      
  'set default to replace any existing game files
  rtn = vbYes
  
  Do
    'if no directory was passed to the function
    If LenB(CompGameDir) = 0 Then
      'get a new dir
      CompGameDir = GetNewDir(frmMDIMain.hWnd, "Choose target directory for compiled game:")
      
      'if not canceled
      If LenB(CompGameDir) <> 0 Then
        'if directory already contains game files,
        If Dir(cDir(CompGameDir) & "*VOL.*") <> vbNullString Then
          'verify
          rtn = MsgBox("This directory already contains AGI game files. Existing files will be renamed so they will not be lost. Continue with compile?", vbQuestion + vbYesNoCancel, "Compile Game")
          'if user said no
          If rtn = vbNo Then
            'reset directory
            CompGameDir = vbNullString
          End If
        End If
      Else
        rtn = vbCancel
      End If
    End If
  Loop While rtn = vbNo
  
  'if canceled
  If rtn = vbCancel Then
    'exit
    Exit Sub
  End If
  
  'disable form until compile complete
  frmMDIMain.MousePointer = vbHourglass
  frmMDIMain.Enabled = False
  
  'set up compile form
  Set CompStatusWin = New frmCompStatus
  CompStatusWin.MousePointer = vbArrow
  If RebuildOnly Then
    CompStatusWin.SetMode 1
  Else
    CompStatusWin.SetMode 0 '0 means full compile
  End If
  CompStatusWin.Show
  
  'ensure dir has trailing backslash
  CompGameDir = cDir(CompGameDir)
  
  'compile the game
  On Error Resume Next
  CompileGame RebuildOnly, CompGameDir
  
  'if major error,
  If Err.Number <> 0 Then
    'display error message
    MsgBox "Error during " & IIf(RebuildOnly, "rebuild: ", "compile: ") & _
    vbNewLine & vbNewLine & Err.Description, vbCritical, IIf(RebuildOnly, "Rebuild VOL Files", "Compile Game Error")
    
    'unload the compile staus form
    Unload CompStatusWin
    Set CompStatusWin = Nothing
  
    'restore form state
    frmMDIMain.Enabled = True
    frmMDIMain.MousePointer = vbDefault
    
    'clean up any leftover files
    If InterpreterVersion >= 3 Then
      Kill CompGameDir & GameID & "DIR.NEW"
    Else
      Kill CompGameDir & "LOGDIR.NEW"
      Kill CompGameDir & "PICDIR.NEW"
      Kill CompGameDir & "SNDDIR.NEW"
      Kill CompGameDir & "VIEWDIR.NEW"
    End If
    Kill CompGameDir & "NEW_VOL.*"
    
    'clear errors
    Err.Clear
    'exit
    Exit Sub
  End If
  
  'check for cancel
  If CompStatusWin.CompCanceled Then
  'need to only restore words/object if
  'compile was to another directory AND not just rebuilding
    On Error Resume Next
    If CompGameDir <> GameDir And Not RebuildOnly Then
      'delete any new files
      Kill CompGameDir & "WORDS.TOK"
      Kill CompGameDir & "OBJECT"
      'restore old files
      Name CompGameDir & "WORDS.OLD" As CompGameDir & "WORDS.TOK"
      Name CompGameDir & "OBJECT.OLD" As CompGameDir & "OBJECT"
    End If
    'clean up any leftover files
    If InterpreterVersion >= 3 Then
      Kill CompGameDir & GameID & "DIR.NEW"
    Else
      Kill CompGameDir & "LOGDIR.NEW"
      Kill CompGameDir & "PICDIR.NEW"
      Kill CompGameDir & "SNDDIR.NEW"
      Kill CompGameDir & "VIEWDIR.NEW"
    End If
    Kill CompGameDir & "NEW_VOL.*"
    'clear errors
    Err.Clear
    
    'unload the compile staus form
    Unload CompStatusWin
    Set CompStatusWin = Nothing
  
    'restore form state
    frmMDIMain.Enabled = True
    frmMDIMain.MousePointer = vbDefault
    
    'exit
    Exit Sub
  End If
  
  'check for errors and warnings
  If CLng(CompStatusWin.lblErrors.Caption) + CLng(CompStatusWin.lblWarnings.Caption) > 0 Then
    'build error/warning text string
    strTemp = CompStatusWin.StatusResults
    
    CompStatusWin.lblStatus = "Generating list of compiler warnings; please wait..."
    CompStatusWin.Refresh
    
    If LogicEditors.Count < MaxLogicEditors Then
      'open text editor
      NewTextFile
      'assign error/warning text to editor
      frmMDIMain.ActiveForm.rtfLogic.HighlightSyntax = False
      frmMDIMain.ActiveForm.rtfLogic.Text = Replace(Replace(strTemp, "~", vbCr), "|", vbCr & "    ")
      frmMDIMain.ActiveForm.IsOutput = True
      'msgbox to user
      MsgBox "Errors and/or warnings were generated during game compile.", vbInformation + vbOKOnly, "Compile Game"
    Else
      'save as error/warning file
      Kill GameDir & GameID & IIf(RebuildOnly, "Rebuild", "Compile") & " Errors and Warnings.txt"
      intFile = FreeFile()
      Open GameDir & GameID & IIf(RebuildOnly, "Rebuild", "Compile") & " Errors and Warnings.txt" For Binary As intFile
      Put intFile, 1, Replace(Replace(strTemp, "~", vbNewLine), "|", vbNewLine & "    ")
      Close intFile
    
      'msgbox to user
      MsgBox "Errors and/or warnings were generated during game " & _
             IIf(RebuildOnly, "rebuild", "compile") & ". See '" & GameID & vbNewLine & _
             " " & IIf(RebuildOnly, "Rebuild", "Compile") & " Errors and " & _
             "Warnings.txt' in your game directory.", vbInformation + vbOKOnly, _
             "Compile Game"
    End If
    
    'if errors
    If CLng(CompStatusWin.lblErrors.Caption) > 0 Then
      'rebuild resource list
      BuildResourceTree GameID
    End If
  Else
    'everything is ok
    MsgBox IIf(RebuildOnly, "Rebuild", "Compile") & " completed successfully.", _
           vbInformation + vbOKOnly, IIf(RebuildOnly, "Rebuild VOL Files", "Compile Game")
  End If
  
  'unload the compile staus form
  Unload CompStatusWin
  Set CompStatusWin = Nothing
  
  UpdateSelection rtLogic, SelResNum, umPreview Or umProperty
  
  'restore form state
  frmMDIMain.Enabled = True
  frmMDIMain.MousePointer = vbDefault
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Public Function CompileDirtyLogics(Optional ByVal NoMsg As Boolean = False) As Boolean

  Dim rtn As VbMsgBoxResult
  Dim blnDirtyResources As Boolean
  Dim i As Long, tmpLogic As AGILogic
  Dim tmpNode As Node, strTemp As String
  Dim blnLoaded As Boolean, blnSrcLoaded As Boolean
  Dim ErrString As String, strErrInfo() As String
  Dim blnDontAsk As Boolean, intFile As Integer
  
  On Error GoTo ErrHandler
  
  'if no game is loaded,
  If Not GameLoaded Then
    Exit Function
  End If
  
  'check for any open logic resources
  For i = 1 To LogicEditors.Count
    If LogicEditors(i).FormMode = fmLogic Then
      If LogicEditors(i).rtfLogic.Dirty Then
        Select Case Settings.SaveOnCompile
        Case 0  'ask user for input
          LogicEditors(i).SetFocus
          'get user's response
          rtn = MsgBoxEx("Do you want to save this logic before compiling?", vbQuestion + vbYesNoCancel, "Update " & ResourceName(LogicEditors(i).LogicEdit, True, True) & "?", , , "Always take this action when compiling a game.", blnDontAsk)
          If blnDontAsk Then
            If rtn = vbYes Then
              Settings.SaveOnCompile = 2
            ElseIf rtn = vbNo Then
              Settings.SaveOnCompile = 1
            End If
          End If
        
        Case 1  'no
          rtn = vbNo
          
        Case 2  'yes
          rtn = vbYes
        End Select
        
        Select Case rtn
        Case vbCancel
          Exit Function
        Case vbYes
          'save it
          LogicEditors(i).MenuClickSave
        End Select
      End If
    End If
  Next i
  
  'disable form until compile complete
  frmMDIMain.MousePointer = vbHourglass
  frmMDIMain.Enabled = False
  
  'set up compile form
  Set CompStatusWin = New frmCompStatus
  CompStatusWin.MousePointer = vbArrow
  CompStatusWin.SetMode 2
  CompStatusWin.Show
  
  'compile the logics
  Set tmpNode = frmMDIMain.tvwResources.Nodes(2).Child
  Do Until tmpNode Is Nothing
    'get the logic, and load it and its source code
    Set tmpLogic = Logics(tmpNode.Tag)
    blnLoaded = tmpLogic.Loaded
    If Not blnLoaded Then
      tmpLogic.Load
    End If
    blnSrcLoaded = tmpLogic.SourceCode.Loaded
    If Not blnSrcLoaded Then
      tmpLogic.SourceCode.Load
    End If
    
    On Error Resume Next
    If Not tmpLogic.Compiled Then
      'compile this logic
      tmpLogic.Compile
      
      'check for error
      Select Case Err.Number
      Case 0    'no error
      
      Case vbObjectError + 636 'warning
        'get warning string
        ErrString = Err.Description
        Err.Clear
        
        With CompStatusWin
          .lblStatus.Caption = "Resource warning"
          'need to increment warning counter, and store warning info
          .lblWarnings.Caption = .lblWarnings.Caption + 1
          .StatusResults = .StatusResults & "~[" & ResourceName(tmpLogic, True, True) & "]~  Logic Compile Warnings:|" & ErrString & "~"
        End With
      
      'compiler error
      Case vbObjectError + 635
        'get error string
        ErrString = Err.Description
        Err.Clear
        
        With CompStatusWin
          .lblStatus.Caption = "Compile error"
          'need to increment error counter, and store this error
          .lblErrors.Caption = .lblErrors.Caption + 1
          
          .StatusResults = .StatusResults & "~[" & ResourceName(tmpLogic, True, True) & "]~ Game Compiler Error: " & ErrString & "~"
        End With
                
        'if a logic error, and openonerror is in ask mode or yes mode
        If Settings.OpenOnErr <> 1 Then
          'if not automatic,
          If Settings.OpenOnErr = 0 Then
            'get user's response
            rtn = MsgBoxEx("An error occurred while attempting to compile " & ResourceName(tmpLogic, True, True) & ":" & vbNewLine & vbNewLine _
                     & ErrString & vbNewLine & vbNewLine & "Do you want to open the logic at the location of the error?", vbQuestion + vbYesNo, "Update Logics?", , , "Always take this action when a compile error occurs.", blnDontAsk)
            If blnDontAsk Then
              If rtn = vbYes Then
                Settings.OpenOnErr = 2
              Else
                Settings.OpenOnErr = 1
              End If
            End If
          Else
            rtn = vbYes
          End If
        
          'if yes,
          If rtn = vbYes Then
            'set error info for this file
            'extract error info
            strErrInfo = Split(ErrString, "|")
            'set error info
            SetError CLng(strErrInfo(0)), strErrInfo(2), tmpLogic.Number, strErrInfo(1)
          End If
        End If
      
        'unload the logic
        If Not blnSrcLoaded Then
          tmpLogic.SourceCode.Unload
        End If
        If Not blnLoaded Then
          tmpLogic.Unload
        End If
        GoTo Cleanup
      
      Case Else
        'some other error
        MsgBox "Error occurred during compilation. " & vbCr & vbCr & CStr(Err.Number) & ": " & Err.Description, , "Compile Error"
      End Select
      Err.Clear
    End If
    On Error GoTo ErrHandler
    
    'reset dirty status in treelist
    tmpNode.ForeColor = vbBlack
    
    'unload the logic
    If Not blnSrcLoaded Then
      tmpLogic.SourceCode.Unload
    End If
    If Not blnLoaded Then
      tmpLogic.Unload
    End If
    
    'next logic
    CompStatusWin.pgbStatus.Value = CompStatusWin.pgbStatus.Value + 1
    CompStatusWin.Refresh
    Set tmpNode = tmpNode.Next
  Loop
  
  
  'check for errors and warnings
  If CLng(CompStatusWin.lblErrors.Caption) + CLng(CompStatusWin.lblWarnings.Caption) > 0 Then
    'build error/warning text string
    strTemp = CompStatusWin.StatusResults
    
    CompStatusWin.lblStatus = "Generating list of compiler warnings; please wait..."
    CompStatusWin.Refresh
    
    If LogicEditors.Count < MaxLogicEditors Then
      'open text editor
      NewTextFile
      'assign error/warning text to editor
      frmMDIMain.ActiveForm.rtfLogic.HighlightSyntax = False
      frmMDIMain.ActiveForm.rtfLogic.Text = Replace(Replace(strTemp, "~", vbCr), "|", vbCr & "    ")
      frmMDIMain.ActiveForm.IsOutput = True
      'msgbox to user
      MsgBox "Errors and/or warnings were generated during logic compilation.", vbInformation + vbOKOnly, "Compile Logics"
    Else
      'save as error/warning file
      Kill GameDir & GameID & " Compile Errors and Warnings.txt"
      intFile = FreeFile()
      Open GameDir & GameID & " Compile Errors and Warnings.txt" For Binary As intFile
      Put intFile, 1, Replace(Replace(strTemp, "~", vbNewLine), "|", vbNewLine & "    ")
      Close intFile
    
      'msgbox to user
      MsgBox "Errors and/or warnings were generated during logic compiliation. See '" & GameID & vbNewLine & _
             "Compile Errors and Warnings.txt' in your game directory.", vbInformation + vbOKOnly, _
             "Compile Game"
    End If
    
    'if errors
    If CLng(CompStatusWin.lblErrors.Caption) > 0 Then
      'rebuild resource list
      BuildResourceTree GameID
    End If
  Else
    'update previewwin, if being used
    If Settings.ShowPreview Then
      If SelResType = rtLogic Then
        'redraw the preview
        PreviewWin.LoadPreview rtLogic, SelResNum
      End If
    End If
    
    'everything is ok
    If Not NoMsg Then
      MsgBox "All logics compiled successfully.", vbInformation + vbOKOnly, "Compile Dirty Logics"
    End If
    
    'return true
    CompileDirtyLogics = True
  End If

Cleanup:
  'unload the compile staus form
  Unload CompStatusWin
  Set CompStatusWin = Nothing
  
  'restore form state
  frmMDIMain.Enabled = True
  frmMDIMain.MousePointer = vbDefault
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function

Public Function CompileLogic(LogicEditor As frmLogicEdit, ByVal LogicNumber As Long) As Boolean
  'compiles an ingame logic
  'assumes calling function has validated
  'the logic is in fact in a game
  
  Dim intFile As Integer
  Dim strTemp As String
  Dim strErrInfo() As String
  
  On Error Resume Next
  
  If Not LogicEditor Is Nothing Then
    Debug.Assert frmMDIMain.ActiveForm Is LogicEditor
    
    'if source is not clean,
    If LogicEditor.rtfLogic.Dirty Then
      'first, save the source
      LogicEditor.MenuClickSave
    End If
  
    'copy back to game logic
    Logics(LogicNumber).SetLogic LogicEditor.LogicEdit
  End If
  
  'compile this logic
  Logics(LogicNumber).Compile
  
  'check for error
  Select Case Err.Number
  Case 0    'no error
    If Not LogicEditor Is Nothing Then
      MainStatusBar.Panels("Status").Text = ResourceName(Logics(LogicNumber), True, True) & " successfully compiled."
    End If
    'return true
    CompileLogic = True
  
  Case vbObjectError + 636 'warning
    'get warning string
    strTemp = Err.Description
      
    'if there is room to open a text editor
    If LogicEditors.Count < MaxLogicEditors Then
      'open text editor
      NewTextFile
      frmMDIMain.ActiveForm.IsOutput = True
      frmMDIMain.ActiveForm.Tag = LogicNumber
      frmMDIMain.ActiveForm.Caption = ResourceName(Logics(LogicNumber), True, True) & " Compiler Warnings"
      'assign warning text to editor
      With frmMDIMain.ActiveForm.rtfLogic
        .HighlightSyntax = False
        .Text = Replace(strTemp, "|", vbCr)
        .ActiveForm.rtfLogic.Dirty = False
      End With
      
      'msgbox to user
      MsgBox "Warnings were generated during compile.", vbInformation + vbOKOnly, "Compile Logic"
    Else
      'save as warning file
      Kill GameDir & Logics(LogicNumber).ID & " warnings.txt"
      intFile = FreeFile()
      Open GameDir & Logics(LogicNumber).ID & " warnings.txt" For Binary As intFile
      Put intFile, 1, Replace(strTemp, "|", vbCr)
      Close intFile
      
      'msgbox to user
      MsgBox "Warnings were generated during compile. See '" & Logics(LogicNumber).ID & " warnings.txt' in your game directory.", vbInformation + vbOKOnly, "Compile Logic"
    End If
    MainStatusBar.Panels("Status").Text = ResourceName(Logics(LogicNumber), True, True) & " successfully compiled."
    'return true
    CompileLogic = True

  Case vbObjectError + 635
    'extract error info
    strErrInfo = Split(Err.Description, "|")
    'set error info
    SetError CLng(strErrInfo(0)), strErrInfo(2), Logics(LogicNumber).Number, strErrInfo(1)
    Err.Clear
    'sound a tone
    Beep
  
  Case vbObjectError + 618 'not in a game
    'should NEVER get here, but...
    MsgBox "Only logics that are in a game can be compiled.", vbInformation + vbOKOnly, "Compile Error"
  
  Case vbObjectError + 546  'no data to compile
    MsgBox "Nothing to compile!", vbInformation + vbOKOnly, "Compile Error"
    
  Case Else
    'some other error
    MsgBox "Error occurred during compilation. " & vbCr & vbCr & CStr(Err.Number) & ": " & Err.Description, , "Compile Error"
  End Select
  Err.Clear
  
  If Not LogicEditor Is Nothing Then
    'copy it back
    LogicEditor.LogicEdit.SetLogic Logics(LogicNumber)
  End If
End Function
Public Function SaveSourceAs(ThisLogic As AGILogic, ByVal InGame As Boolean) As Boolean
  'save source as
  
  Dim rtn As VbMsgBoxResult
  Dim strFilename As String
  
  On Error GoTo ErrHandler
  
  'set up commondialog
  With MainSaveDlg
    If InGame Then
      .DialogTitle = "Export Source"
    Else
      .DialogTitle = "Save Source"
    End If
     'if logic already has a filename,
    If LenB(ThisLogic.SourceCode.SourceFile) <> 0 Then
      'use it
      .FullName = ThisLogic.SourceCode.SourceFile
    Else
      'use default
      'if this is a filename,
      If InStrB(1, ThisLogic.ID, ".") <> 0 Then
        .FullName = ResDir & Left$(ThisLogic.ID, InStrRev(ThisLogic.ID, ".") - 1) & LogicSourceSettings.SourceExt
      Else
        .FullName = ResDir & ThisLogic.ID & LogicSourceSettings.SourceExt
      End If
    End If
    .Filter = "WinAGI Logic Source Files (*.lgc)|*.lgc|Text files (*.txt)|*.txt|All files (*.*)|*.*"
    If LCase$(Right$(.FullName, 4)) = ".txt" Then
       .FilterIndex = 2
     Else
       .FilterIndex = 1
     End If
    .DefaultExt = Right$(LogicSourceSettings.SourceExt, Len(LogicSourceSettings.SourceExt) - 1)
    .Flags = cdlOFNHideReadOnly Or cdlOFNPathMustExist Or cdlOFNExplorer
    .hWndOwner = frmMDIMain.hWnd
  End With
  
  Do
    On Error Resume Next
    MainSaveDlg.ShowSaveAs
    
    'if canceled,
    If Err.Number = cdlCancel Then
      'exit without doing anything
      Exit Function
    End If
    On Error GoTo ErrHandler
    
    'get filename
    strFilename = MainSaveDlg.FullName
    
    'if file exists,
    If FileExists(strFilename) Then
      'verify replacement
      rtn = MsgBox(MainSaveDlg.FileName & " already exists. Do you want to overwrite it?", vbYesNoCancel + vbQuestion, "Overwrite file?")
      
      If rtn = vbYes Then
        Exit Do
      ElseIf rtn = vbCancel Then
        Exit Function
      End If
    Else
      Exit Do
    End If
  Loop While True
  
  'set mouse pointer
  frmMDIMain.MousePointer = vbHourglass
  
  'save the source
  ThisLogic.SourceCode.Save strFilename
  
  'reset mouse pointer
  frmMDIMain.MousePointer = vbDefault
  
  'if error,
  If Err.Number <> 0 Then
    MsgBox "An error occurred while saving this source file.", vbCritical + vbOKOnly, "Save File Error"
    Exit Function
  End If
  
  SaveSourceAs = True
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function

Public Function ExportLogic(ByVal LogicNumber As Byte) As Boolean
  'exports this logic
  
  'Logics are different from other resources in that
  'they can only be exported if they are in a game;
  'therefore, the passed argument is the resource number of
  'the logic to be exported, NOT the actual logic itself
  
  Dim strFilename As String
  Dim rtn As VbMsgBoxResult
  
  On Error GoTo ErrHandler
  
  With MainSaveDlg
    'set cmndlg properties for logic source file
    .DialogTitle = "Export Logic File"
    .Filter = "Logic Files (*.agl)|*.agl|Text Files (*.txt)|*.txt|All files (*.*)|*.*"
    .FilterIndex = GetSetting(sAPPNAME, sEXPFILTER, sLOGICS, 1)
    'set default name
    If .FilterIndex = 2 Then
      .DefaultExt = "txt"
      .FullName = ResDir & Logics(LogicNumber).ID & ".txt"
    Else
      .DefaultExt = "agl"
      .FullName = ResDir & Logics(LogicNumber).ID & ".agl"
    End If
    
    .Flags = cdlOFNHideReadOnly Or cdlOFNPathMustExist Or cdlOFNExplorer
    .hWndOwner = frmMDIMain.hWnd
  End With
  
  Do
    MainSaveDlg.ShowSaveAs
    'if canceled
    If Err.Number = cdlCancel Then
      'exit without doing anything
      Exit Function
    End If
    
    'save default filter index
    SaveSetting sAPPNAME, sEXPFILTER, sLOGICS, MainSaveDlg.FilterIndex
    
    'get file name
    strFilename = MainSaveDlg.FullName
    
    'if file exists,
    If FileExists(strFilename) Then
      'verify replacement
      rtn = MsgBox(MainSaveDlg.FileName & " already exists. Do you want to overwrite it?", vbYesNoCancel + vbQuestion, "Overwrite file?")
      
      If rtn = vbYes Then
        Exit Do
      ElseIf rtn = vbCancel Then
        Exit Function
      End If
    Else
      Exit Do
    End If
  Loop While True
    
  'export the resource
  Logics(LogicNumber).Export strFilename
  
  'if error,
  If Err.Number <> 0 Then
    MsgBox "An error occurred while exporting this file." & vbNewLine & vbNewLine & Err.Description, vbCritical + vbOKOnly, "Export File Error"
    Exit Function
  End If
  
  ExportLogic = True
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function


Public Sub AddToMRU(ByVal NewDir As String)

  'if NewDir is already in the list,
  'it is moved to the top;
  'otherwise, it is added to the top, and other
  'dirs are moved down
  
  Dim i As Long, j As Long
  Dim strTemp As String
  
  For i = 1 To 4
    If NewDir = strMRU(i) Then
      'move others down
      For j = i To 2 Step -1
        strMRU(j) = strMRU(j - 1)
        frmMDIMain.Controls("mnuGMRU" & CStr(j)).Caption = CompactPath(strMRU(j))
      Next j
      'move to top of list
      strMRU(1) = NewDir
      frmMDIMain.mnuGMRU1.Caption = CompactPath(NewDir)
      'we're done
      Exit Sub
    End If
  Next i
  
  'not found;
  
  'move all entries down
  For j = 4 To 2 Step -1
    strMRU(j) = strMRU(j - 1)
    'if this entry is valid
    If LenB(strMRU(j)) <> 0 Then
      'update menu
      frmMDIMain.Controls("mnuGMRU" & CStr(j)).Caption = CompactPath(strMRU(j))
      frmMDIMain.Controls("mnuGMRU" & CStr(j)).Visible = True
    Else
      'hide it
      frmMDIMain.Controls("mnuGMRU" & CStr(j)).Visible = False
    End If
  Next j
  'add new item 1
  strMRU(1) = NewDir
  frmMDIMain.mnuGMRU1.Caption = CompactPath(NewDir)
  frmMDIMain.mnuGMRU1.Visible = True
  'ensure bar is visible
  frmMDIMain.mnuGMRUBar.Visible = True
End Sub

Public Sub BuildResourceTree(OpenGameID As String)
  'builds the resource tree list
  'for the game that was just opened
  
  Dim i As Long, tmpNode As Node
  
  On Error GoTo ErrHandler
  
  'clear the treelist
  frmMDIMain.ClearResourceTree
  
  On Error Resume Next
  'add the base nodes
  With frmMDIMain.tvwResources
    'if a game id was passed
    If LenB(OpenGameID) <> 0 Then
      'update root
      .Nodes(1).Text = OpenGameID
      
      'add logics
      If Logics.Count > 0 Then
        For i = 0 To 255
          'if a valid resource
          If Logics(i).Loaded Then
          End If
          'if no error
          If Err.Number = 0 Then
            Set tmpNode = .Nodes.Add(sLOGICS, tvwChild, "l" & CStr(i), ResourceName(Logics(i), True))
            tmpNode.Tag = i
            'load source to set compiled status
            Logics(i).Load
            Logics(i).SourceCode.Load
            If Logics(i).Compiled Then
              tmpNode.ForeColor = vbBlack
            Else
              tmpNode.ForeColor = vbRed
            End If
            Logics(i).SourceCode.Unload
            Logics(i).Unload
          Else
            'clear error
            Err.Clear
          End If
        Next i
      End If
      
      If Pictures.Count > 0 Then
        For i = 0 To 255
          'if a valid resource
          If Pictures(i).Loaded Then
          End If
          'if no error
          If Err.Number = 0 Then
            .Nodes.Add(sPICTURES, tvwChild, "p" & CStr(i), ResourceName(Pictures(i), True)).Tag = i
          Else
            'clear error
            Err.Clear
          End If
        Next i
      End If
      
      If Sounds.Count > 0 Then
        For i = 0 To 255
          'if a valid resource
          If Sounds(i).Loaded Then
          End If
          'if no error
          If Err.Number = 0 Then
            .Nodes.Add(sSOUNDS, tvwChild, "s" & CStr(i), ResourceName(Sounds(i), True)).Tag = i
          Else
            'clear error
            Err.Clear
          End If
        Next i
      End If
      
      If Views.Count > 0 Then
        For i = 0 To 255
          'if a valid resource
          If Views(i).Loaded Then
          End If
          'if no error
          If Err.Number = 0 Then
            .Nodes.Add(sVIEWS, tvwChild, "v" & CStr(i), ResourceName(Views(i), True)).Tag = i
          Else
            'clear error
            Err.Clear
          End If
        Next i
      End If
    End If
  End With
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Public Sub ChangeGameDir(strNewGameDir As String)
  'changes the game directory
  'strNewDir is validated prior to calling this method
  
  Dim fso As FileSystemObject
  Dim fsFolder As Folder
  Dim fsFile As File
  
  Dim blnOverwrite As Boolean
  
  Set fso = New FileSystemObject
  
  'check for files in destination
  If fso.FolderExists(strNewGameDir) Then
    'check for files in this folder
    If fso.GetFolder(strNewGameDir).Files.Count > 0 Then
      'ask user if overwrite is ok
      If MsgBox("Overwrite files in this directory?", vbYesNo + vbQuestion, "Change Game Directory") = vbNo Then
        'exit
        Exit Sub
      End If
    End If
  Else
    'create it
    fso.CreateFolder strNewGameDir
  End If
  
  'set cursor
  frmMDIMain.MousePointer = vbHourglass
  
  'catch any errors
  On Error GoTo ErrHandler
  
  'copy files and resources from current directory to new directory
  For Each fsFile In fso.GetFolder(GameDir).Files
    fsFile.Copy strNewGameDir & fsFile.Name
  Next
  For Each fsFolder In fso.GetFolder(GameDir).SubFolders
    fsFolder.Copy strNewGameDir
  Next
  
 'reset browser start dir to this dir
  BrowserStartDir = strNewGameDir
  
  'change gamedir property
  GameDir = strNewGameDir
  
  'restore cursor
  frmMDIMain.MousePointer = vbDefault
Exit Sub

ErrHandler:
  'warn user
  MsgBox "Error occured during file copy: " & Err.Description, vbCritical + vbOKOnly, "Change Game Directory"
  Resume Next
  
End Sub

Public Function FindInClosedLogics(ByVal FindText As String, ByVal FindDir As FindDirection, ByVal MatchWord As Boolean, _
                ByVal MatchCase As Boolean, Optional ByVal SearchType As AGIResType = rtNone) As Long

  'find next closed logic that has search text in it;
  'if found, return the logic number
  'if not found, return -1
  
  Dim i As Long
  Static LogNum As Long
  Dim FoundPos As Long
  Dim vbcComp As VbCompareMethod
  Dim blnLoaded As Boolean, blnSrcLoaded As Boolean
  
  On Error GoTo ErrHandler
  
  'if this is first time through
  If Not ClosedLogics Then
    'start with first logic (which sets ClosedLogics flag)
    LogNum = NextClosedLogic(-1)
    frmProgress.pgbStatus.max = Logics.Count
    frmProgress.pgbStatus.Value = LogicEditors.Count
  Else
    LogNum = NextClosedLogic(LogNum)
  End If
  
  'show progress form
  With frmProgress
    .Caption = "Find"
    .lblProgress.Caption = "Searching..."
    .Show vbModeless, frmMDIMain
    .Refresh
  End With
  Debug.Assert frmMDIMain.MousePointer <> vbDefault
  
  'set comparison method for string search,
  vbcComp = CLng(MatchCase) + 1 ' CLng(True) + 1 = 0 = vbBinaryCompare; Clng(False) + 1 = 1 = vbTextCompare
  
  Do Until LogNum = -1
    'if not loaded,
    blnLoaded = Logics(LogNum).Loaded
    If Not blnLoaded Then
      Logics(LogNum).Load
    End If
    blnSrcLoaded = Logics(LogNum).SourceCode.Loaded
    If Not blnSrcLoaded Then
      Logics(LogNum).SourceCode.Load
    End If
    
    'if searching up,
    'if direction is up,
    If FindDir = fdUp Then
      If MatchWord Then
        If FindWholeWord(1, Logics(LogNum).SourceCode.Text, FindText, vbcComp, True, SearchType, Logics(LogNum).SourceCode.Syntax) <> 0 Then
          Exit Do
        End If
      Else
        If InStrRev(Logics(LogNum).SourceCode.Text, FindText, -1, vbcComp) <> 0 Then
          Exit Do
        End If
      End If
    Else
      If MatchWord Then
        If FindWholeWord(1, Logics(LogNum).SourceCode.Text, FindText, vbcComp, False, SearchType, Logics(LogNum).SourceCode.Syntax) <> 0 Then
          Exit Do
        End If
      Else
        If InStrB(1, Logics(LogNum).SourceCode.Text, FindText, vbcComp) <> 0 Then
          Exit Do
        End If
      End If
    End If
    
    'if found,
    If FoundPos > 0 Then
      Exit Do
    End If
    
    'not found-unload this logic
    If Not blnSrcLoaded Then
      Logics(LogNum).SourceCode.Unload
    End If
    If Not blnLoaded Then
      Logics(LogNum).Unload
    End If
    
    'try next logic
    LogNum = NextClosedLogic(LogNum)
    frmProgress.pgbStatus.Value = frmProgress.pgbStatus.Value + 1
    frmProgress.Refresh
    
  'loop is exited by finding the searchtext or reaching end of search area
  Loop
  
  'if not found,
  If LogNum = -1 Then
    'just exit
    FindInClosedLogics = LogNum
    'hide progress form
    frmProgress.Hide
    Exit Function
  End If
  
  If Not blnSrcLoaded Then
    Logics(LogNum).SourceCode.Unload
  End If
  If Not blnLoaded Then
    Logics(LogNum).Unload
  End If
    
  'if too many windows open,
  If LogicEditors.Count = MaxLogicEditors Then
    MsgBox QUOTECHAR & FindText & QUOTECHAR & " was found in logic " & CStr(LogNum) & " but too many editors are open to show it. Close some logic editors and try the search again.", vbInformation, "Find In Logic"
    'return -1
    FindInClosedLogics = -1
    'hide progress form
    frmProgress.Hide
    Exit Function
  End If
          
  'open editor, if able
  OpenLogic LogNum, True
  
  'now locate this window
  For i = LogicEditors.Count To 1 Step -1
    If LogicEditors(i).FormMode = fmLogic Then
      If LogicEditors(i).LogicEdit.Number = LogNum Then
        Exit For
      End If
    End If
  Next i
  
  'if not found (i = 0)
  If i = 0 Then
    'must have been an error
    MsgBox QUOTECHAR & FindText & QUOTECHAR & " was found in logic " & CStr(LogNum) & " but an error occurred while opening the file. Try opening the logic manually and then try the search again.", vbInformation, "Find In Logic"
    'unload logic
    Logics(LogNum).Unload
    'return -1
    FindInClosedLogics = -1
    'hide progress form
    frmProgress.Hide
    Exit Function
  End If
  
  'hide progress form
  frmProgress.Hide
  
  'return this window number
  FindInClosedLogics = i
  
Exit Function

ErrHandler:
  Resume Next
End Function

Public Sub NewAGIGame(ByVal UseTemplate As Boolean)
  
  Dim blnClosed As Boolean
  Dim blnNoErrors As Boolean
  Dim lngErr As Long, strErr As String
  Dim sngVer As Single, strDescription As String
  Dim strTemplateDir As String, i As Long
  
  On Error GoTo ErrHandler
  
  'if using a template
  If UseTemplate Then
    'have user choose a template
    Load frmTemplate
    With frmTemplate
      .SetForm
      'if no templates available,
      If .lstTemplates.ListCount = 0 Then
        MsgBox "There are no templates available. Unable to create new game.", vbCritical + vbOKOnly, "No Templates Available"
        Unload frmTemplate
        Exit Sub
      End If
      
      .Show vbModal, frmMDIMain
      If .Canceled Then
        Unload frmTemplate
        Exit Sub
      End If
      strTemplateDir = App.Path & "\Templates\" & .lstTemplates.Text
      strDescription = .txtDescription.Text
      sngVer = CSng(.lblVersion.Caption)
      Unload frmTemplate
    End With
  End If
  
  Load frmGameProperties
  With frmGameProperties
    'show new game form
    .WindowFunction = gsNew
    .SetForm
    
    'if using template
    If UseTemplate Then
      'version is preset based on template
      For i = 0 To .cmbVersion.ListCount - 1
        If Val(.cmbVersion.List(i)) = sngVer Then
          .cmbVersion.ListIndex = i
          Exit For
        End If
      Next i
      .cmbVersion.Enabled = False
      'default description
      .txtGameDescription.Text = strDescription
    End If
    
    .Show vbModal, frmMDIMain
  
    'if canceled
    If .Canceled Then
      'unload it
      Unload frmGameProperties
      'exit
      Exit Sub
    End If
    
    'if a game is currently open,
    If GameLoaded Then
      'close game, if user allows
      If Not CloseThisGame() Then
        Exit Sub
      End If
    End If
    
    'if word or Objects Editor open
    If WEInUse Then
      Unload WordEditor
      
      'if user canceled,
      If WEInUse Then
        Exit Sub
      End If
    End If
    If OEInUse Then
      Unload ObjectEditor
      If OEInUse Then
        Exit Sub
      End If
    End If
  
    'set cursor to wait
    frmMDIMain.MousePointer = vbHourglass

    'inline error checking
    On Error Resume Next
    
    'create new game
     NewGame .txtGameID.Text, .txtGameAuthor.Text, _
             CSng(.cmbVersion.Text), .txtGameDescription.Text, _
             .DisplayDir, .txtGameVersion.Text, .txtGameAbout.Text, _
             .txtResDir.Text, strTemplateDir
    
    'check for errors or warnings
    lngErr = Err.Number
    strErr = Err.Description
    
    On Error GoTo ErrHandler
    If lngErr = 0 Or lngErr = vbObjectError + 637 Then
      'created ok; maybe with warning
      frmMDIMain.Caption = "WinAGI GDS - " & GameID
      
      'if there is a layout file
      If LenB(Dir(GameDir & "\*.wal")) <> 0 Then
        Name GameDir & Dir(GameDir & "\*.wal") As GameDir & GameID & ".wal"
      End If
      
      If Settings.ShowPreview Then
        PreviewWin.ClearPreviewWin
      End If
      
      'build resource treelist
      BuildResourceTree GameID
      
      'select root
      frmMDIMain.tvwResources.Nodes(1).Selected = True
      'force update
      frmMDIMain.SelectResourceFromTree frmMDIMain.tvwResources.SelectedItem.Index
      
      'set default directory
      BrowserStartDir = GameDir
  
      'add to mru
      AddToMRU GameDir
      
      'adjust menus
      AdjustMenus rtGame, True, False, False
      
      'show preview window and resource pane
      If Settings.ShowPreview Then
        PreviewWin.Show
      End If
      If Settings.ShowTree Then
        frmMDIMain.picResources.Visible = True
        frmMDIMain.picSplitH.Visible = True
        frmMDIMain.picSplitV.Visible = True
      End If
      
      'if warnings
      If lngErr = vbObjectError + 637 Then
        'warn about errors
        MsgBox "Some minor errors occurred during game creation. See errlog.txt in the game directory for details.", vbInformation, "Errors During Load"
      End If
    Else
      MsgBox "Unable to create new game due to an error: " & vbNewLine & vbNewLine & strErr, vbInformation + vbOKOnly, "New AGI Game Error"
    End If
    
    'unload game properties form
    Unload frmGameProperties
    
    'reset cursor
    frmMDIMain.MousePointer = vbDefault
  End With
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Function NextClosedLogic(ByVal OldLogNum As Long) As Long

  Static LogWin() As Long
  Static WinCount As Long
  Dim Found As Boolean
  Dim i As Long
  
  On Error GoTo ErrHandler
  
  'if this is first time through
  If Not ClosedLogics Then
    'build list of windows
    WinCount = LogicEditors.Count
    ReDim LogWin(WinCount)
    For i = 1 To WinCount
      'assume this window is not a logic in a game
      LogWin(i) = -1
      'if a logic editor
      If LogicEditors(i).FormMode = fmLogic Then
        'if in a game
        If LogicEditors(i).InGame Then
          'store this number
          LogWin(i) = LogicEditors(i).LogicNumber
        End If
      End If
    Next i
    'set flag
    ClosedLogics = True
  End If
  
  'use do loop to find next closed logic
  Do
    'increment old log number
    OldLogNum = OldLogNum + 1
    
    On Error Resume Next
    'attempt to access logic to validate it
    i = Logics(OldLogNum).Number
    
    'if no error
    If Err.Number = 0 Then
      'check to see if logic is not already open
      For i = 1 To WinCount
        'if this is a closed logic,
        If LogWin(i) = OldLogNum Then
          Exit For
        End If
      Next i
      'closed logic found if loop exited normally (i=WinCount+1)
      Found = (i = WinCount + 1)
    End If
  'try again until a closed logic found, or end of logics reached
  Loop Until Found Or OldLogNum = 256
  
  On Error GoTo ErrHandler
  'if end reached,
  If OldLogNum = 256 Then
    'return end code (-1)
    NextClosedLogic = -1
  Else
    'return the number
    NextClosedLogic = OldLogNum
  End If
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function

Public Sub OpenLayout()
  
  If Not GameLoaded Then
    Exit Sub
  End If
  
  'if layout editor is currently open
  If LEInUse Then
    'just bring it in focus
    LayoutEditor.SetFocus
  Else
    'open the layout for the current game
    Set LayoutEditor = New frmLayout
    LayoutEditor.LoadLayout
  End If
End Sub

Public Sub OpenMRUGame(ByVal Index As Long)
  
  Dim i As Long
  
  'if a game is currently open,
  If GameLoaded Then
    'close game, if user allows
    If Not CloseThisGame() Then
      Exit Sub
    End If
  End If
  
  'attempt to open this game
  OpenAGIGame strMRU(Index)
  
  'if not successful
  If Not GameLoaded Then
    'step through previous mru's
    For i = Index + 1 To 4
      'move this mru entry up
      strMRU(i - 1) = strMRU(i)
      'if blank
      If LenB(strMRU(i)) = 0 Then
        'hide this mru item
        frmMDIMain.Controls("mnuGMRU" & CStr(i - 1)).Visible = False
      Else
        'change this mru item
        frmMDIMain.Controls("mnuGMRU" & CStr(i - 1)).Caption = CompactPath(strMRU(i))
      End If
    Next i
    'remove last entry
    strMRU(4) = vbNullString
    frmMDIMain.mnuGMRU4.Visible = False
    
    'if none left
    If LenB(strMRU(1)) = 0 Then
      'hide bar too
      frmMDIMain.mnuGMRUBar.Visible = False
    End If
  Else
    'reset browser start dir to this dir
    BrowserStartDir = strMRU(Index)
  End If
End Sub

Public Function OpenWords(Optional ByVal InGame As Boolean = True) As Boolean

  Dim strFilename As String
  Dim intFile As Integer
  Dim frmNew As frmWordsEdit, tmpForm As Form
  
  On Error GoTo ErrHandler
  
  'if a game is loaded AND looking for ingame editor
  If GameLoaded And InGame Then
    'if it is in use,
    If WEInUse Then
      'just switch to it
      WordEditor.SetFocus
    Else
      'load it
      WEInUse = True
      Set WordEditor = New frmWordsEdit
      Load WordEditor
      'set ingame status first, so caption will indicate correctly
      WordEditor.InGame = True
      
      On Error Resume Next
      WordEditor.LoadWords VocabularyWords.ResFile
      If Err.Number <> 0 Then
        Set WordEditor = Nothing
        WEInUse = False
        Exit Function
      End If
      On Error GoTo ErrHandler
      WordEditor.Show
    End If
  Else
  'either a game is NOT loaded, OR we are forcing a load from file
    
    'get an word file
    With MainDialog
      .Flags = cdlOFNHideReadOnly
      .DialogTitle = "Import Words File"
      .Filter = "AGI Word file|WORDS.TOK|WinAGI Words file (*.agw)|*.agw|All files (*.*)|*.*"
      .DefaultExt = vbNullString
      .FilterIndex = GetSetting(sAPPNAME, sOPENFILTER, "Words", 1)
      .FileName = vbNullString
      
      .ShowOpen
      strFilename = .FileName
      'save filter
      SaveSetting sAPPNAME, sOPENFILTER, "Words", .FilterIndex

    End With
    
    'check if already open
    For Each tmpForm In Forms
      If tmpForm.Name = "frmWordsEdit" Then
        If tmpForm.WordsEdit.ResFile = strFilename And Not tmpForm.InGame Then
          'just shift focus
          tmpForm.SetFocus
          OpenWords = True
          Exit Function
        End If
      End If
    Next
    
    'not open yet; create new form
    'and open this form into it
    Set frmNew = New frmWordsEdit
    
    Load frmNew
    On Error Resume Next
    frmNew.LoadWords strFilename
    If Err.Number <> 0 Then
      Set frmNew = Nothing
      Exit Function
    Else
      frmNew.Show
    End If
  End If
  
  OpenWords = True
Exit Function

ErrHandler:
  'if user canceled the dialogbox,
  If Err.Number = cdlCancel Then
    Exit Function
  End If
  
  Debug.Assert False
  Resume Next
End Function

Public Function OpenObjects(Optional ByVal InGame As Boolean = True) As Boolean

  Dim strFilename As String
  Dim intFile As Integer
  Dim frmNew As frmObjectEdit, tmpForm As Form
  
  On Error GoTo ErrHandler
  
  'if a game is loaded AND looking for ingame editor
  If GameLoaded And InGame Then
    'if it is in use,
    If OEInUse Then
      'just switch to it
      ObjectEditor.SetFocus
    Else
      'load it
      OEInUse = True
      Set ObjectEditor = New frmObjectEdit
      Load ObjectEditor
      ObjectEditor.InGame = True
      
      'set ingame status first, so caption will indicate correctly
      On Error Resume Next
      ObjectEditor.LoadObjects InventoryObjects.ResFile
      If Err.Number <> 0 Then
        Set ObjectEditor = Nothing
        OEInUse = False
        Exit Function
      End If
      On Error GoTo ErrHandler
      ObjectEditor.Show
      ObjectEditor.fgObjects.SetFocus
    End If
  Else
  'either a game is NOT loaded, OR we are forcing a load from file
    
    'get an object file
    With MainDialog
      .Flags = cdlOFNHideReadOnly
      .DialogTitle = "Import Object File"
      .Filter = "WinAGI Objects file (*.ago)|*.ago|AGI OBJECT file|OBJECT|All files (*.*)|*.*"
      .DefaultExt = vbNullString
      .FilterIndex = GetSetting(sAPPNAME, sOPENFILTER, "Objects", 2)
      .FileName = vbNullString
      
      .ShowOpen
      
      strFilename = .FileName
      
      'save filter
      SaveSetting sAPPNAME, sOPENFILTER, "Objects", .FilterIndex
      
    End With
    
    'check if already open
    For Each tmpForm In Forms
      If tmpForm.Name = "frmObjectEdit" Then
        If tmpForm.ObjectsEdit.ResFile = strFilename And Not tmpForm.InGame Then
          'just shift focus
          tmpForm.SetFocus
          OpenObjects = True
          Exit Function
        End If
      End If
    Next
    
    'not open yet; create new form
    'and open this form into it
    Set frmNew = New frmObjectEdit
    
    Load frmNew
    On Error Resume Next
    frmNew.LoadObjects strFilename
    If Err.Number <> 0 Then
      Set frmNew = Nothing
      Exit Function
    Else
      frmNew.Show
      frmNew.fgObjects.SetFocus
    End If
  End If
  
  OpenObjects = True
Exit Function

ErrHandler:
  'if user canceled the dialogbox,
  If Err.Number = cdlCancel Then
    Exit Function
  End If
  
  Resume Next
End Function


Public Sub RemoveLogic(ByVal LogicNum As Byte)
  
  'removes a logic from the game, and updates
  'preview and resource windows
  '
  'it also updates layout editor, if it is open
  Dim i As Long
  Dim tmpNode As Node
  
  'remove it from game
  Logics.Remove LogicNum
  
  'if layout editor is open
  If Settings.UseLE Then
    'update layout editor and layout data file to show this room is now gone
    UpdateExitInfo LogicNum, Nothing
    'if editor is open
    If LEInUse Then
      'refresh layout so change is visible
      LayoutEditor.DrawLayout True
    End If
  End If
  
  'remove it from resource list
  Set tmpNode = frmMDIMain.tvwResources.Nodes(2).Child
  Do Until CByte(tmpNode.Tag) = LogicNum
    Set tmpNode = tmpNode.Next
  Loop
  frmMDIMain.tvwResources.Nodes.Remove tmpNode.Index
  
  'call nodeclick to update preview window
  frmMDIMain.LastIndex = -1
  frmMDIMain.SelectResourceFromTree frmMDIMain.tvwResources.SelectedItem.Index
  
  'if an editor is open
  For i = 1 To LogicEditors.Count
    If LogicEditors(i).FormMode = fmLogic Then
      If LogicEditors(i).InGame And LogicEditors(i).LogicNumber = LogicNum Then
        'set number to -1 to force close
        LogicEditors(i).LogicNumber = -1
        'close it
        Unload LogicEditors(i)
        Exit For
      End If
    End If
  Next i
  
End Sub

Public Sub InitializeResMan()
  
  Dim i As Long
  Dim blnCourier As Boolean, blnArial As Boolean
  Dim blnTimes As Boolean
  
  'set default font
  On Error Resume Next
  
  'use courier new, if it is available
  For i = 0 To Screen.FontCount - 1
    If Screen.Fonts(i) = "Courier New" Then
      blnCourier = True
    End If
    If Screen.Fonts(i) = "Arial" Then
      blnArial = True
    End If
    If Screen.Fonts(i) = "Times New Roman" Then
      blnTimes = True
    End If
  Next i
  
  If blnCourier Then
    DEFAULT_PFONTNAME = "Courier New"
  ElseIf blnArial Then
    DEFAULT_PFONTNAME = "Arial"
  ElseIf blnTimes Then
    DEFAULT_PFONTNAME = "Times New Roman"
  Else
    'use first font in list
    DEFAULT_PFONTNAME = Screen.Fonts(0)
  End If
  
  DEFAULT_EFONTNAME = DEFAULT_PFONTNAME
  Settings.EFontName = DEFAULT_EFONTNAME
  Settings.PFontName = DEFAULT_PFONTNAME
  
  'local copy of colors, to speed up color matching
  For i = 0 To 15
    lngEGACol(i) = EGAColor(i)
  Next i
End Sub
Public Function InstrumentName(ByVal bytInstrument As Byte) As String
  'returns a string value of an instrument
  'if too big
  Debug.Assert bytInstrument <= 127
    
  InstrumentName = LoadResString(INSTRUMENTNAMETEXT + bytInstrument)
End Function


Public Sub NewSound(Optional ImportSoundFile As String)
  'creates a new sound editor with a sound that is
  'not attached to a game
  
  Dim frmNew As frmSoundEdit, blnInGame As Boolean
  Dim tmpSound As AGISound
  
  On Error GoTo ErrHandler
  
  'if max number already open
  If SoundEditors.Count = MaxPicEditors Then
    MsgBox "Too many editors already open. Close some of them and try again.", vbInformation, "Can't Open Sound Editor"
    Exit Sub
  End If
  
  'create temporary sound
  Set tmpSound = New AGISound
  'set default instrument settings;
  'if a sound is being imported, these may be overridden...
  With tmpSound
    .Track(0).Instrument = Settings.DefInst0
    .Track(1).Instrument = Settings.DefInst1
    .Track(2).Instrument = Settings.DefInst2
    .Track(0).Muted = Settings.DefMute0
    .Track(1).Muted = Settings.DefMute1
    .Track(2).Muted = Settings.DefMute2
    .Track(3).Muted = Settings.DefMute3
  End With
  
  'if an import filename was passed
  If LenB(ImportSoundFile) <> 0 Then
    'import the sound
    '(and check for error)
    On Error Resume Next
    tmpSound.Import ImportSoundFile
    If Err.Number <> 0 Then
      'something wrong
      MsgBox "An unhandled error occurred:" & vbNewLine & vbNewLine & Err.Number & ":" & Err.Description, vbCritical + vbOKOnly, "WinAGI GDS Error"
      Exit Sub
    End If
    On Error GoTo ErrHandler
  End If
  
  'if a game is loaded
  If GameLoaded Then
    'get sound number
    'show add resource form
    Load frmGetResourceNum
    With frmGetResourceNum
      .ResType = rtSound
      If LenB(ImportSoundFile) <> 0 Then
        .WindowFunction = grImport
      Else
        .WindowFunction = grAddNew
      End If
      .Show vbModal, frmMDIMain
    
      'if user wants sound added to current game
      '(meaning cancel was NOT clicked)
      If Not .Canceled Then
        'add new id and description
        tmpSound.ID = .txtID.Text
        tmpSound.Description = .txtDescription.Text
      
        'add sound
        AddNewSound .NewResNum, tmpSound
        'reset tmpSound to point to the new game sound
        Set tmpSound = Nothing
        Set tmpSound = Sounds(.NewResNum)
        
        'set flag
        blnInGame = True
      End If
    End With
    Unload frmGetResourceNum
  End If
    
  'set main form mousepointer to hourglass
  frmMDIMain.MousePointer = vbHourglass
    
  'open a new sound editing window
  Set frmNew = New frmSoundEdit
    
  'pass the sound to the editor
  If frmNew.EditSound(tmpSound) Then
    'show form
    frmNew.Show
    'add to collection
    SoundEditors.Add frmNew
  Else
    'error
    Set frmNew = Nothing
  End If
  
  'if added to a game
  If blnInGame Then
    'unload it
    Sounds(tmpSound.Number).Unload
  End If
  
  'restore main form mousepointer and exit
  frmMDIMain.MousePointer = vbDefault
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Public Sub NewTextFile()
  'opens a new text editor
  
  Dim frmNew As frmTextEdit
  
  On Error GoTo ErrHandler
  
  'if too many editors already open,
  If LogicEditors.Count = 20 Then
    MsgBox "Too many editors already open. Close some of them and try again."
    Exit Sub
  End If

  'set main form mousepointer to hourglass
  frmMDIMain.MousePointer = vbHourglass
  
  'open a new text editing window
  Set frmNew = New frmTextEdit
  
  With frmNew
    'set caption
    .Caption = "New Text File"
    'set syntax to default syntax
    .rtfLogic.HighlightSyntax = Settings.HighlightText
    .rtfLogic.Syntax = Settings.DefaultSyntax
    .TextSyntax = LogicSourceSettings.DefaultSyntax
    'clear undo buffer
    .rtfLogic.EmptyUndo
    'reset dirty flag
    .rtfLogic.Dirty = False
  
    'show the form
    .Show
  
    'maximize, if that's the current setting
    If Settings.MaximizeLogics Then
      .WindowState = vbMaximized
    End If
  End With
  
  'add form to collection
  LogicEditors.Add frmNew
  
  'restore main form mousepointer and exit
  frmMDIMain.MousePointer = vbDefault
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Public Sub NewLogic(Optional ImportLogicFile As String)
  'creates a new logic resource and opens an editor
  
  Dim frmNew As frmLogicEdit, blnInGame As Boolean
  Dim tmpLogic As AGILogic
  Dim intFile As Integer, strFile As String
  Dim blnSource As Boolean, blnImporting As Boolean
  
  On Error GoTo ErrHandler
  
  'if too many editors already open,
  If LogicEditors.Count = MaxLogicEditors Then
    MsgBox "Too many editors already open. Close some of them and try again.", vbInformation, "Can't Open Logic Editor"
    Exit Sub
  End If

  'create temporary logic
  Set tmpLogic = New AGILogic
  
  'if an import filename passed,
  If LenB(ImportLogicFile) <> 0 Then
    blnImporting = True
    
    'open file to see if it is sourcecode or compiled logic
    intFile = FreeFile()
    Open ImportLogicFile For Binary As intFile
    strFile = String$(LOF(intFile), 32)
    Get intFile, 1, strFile
    Close intFile
    
    'if logic appears to be compiled logic:
    '(check for existence of characters <8)
    If InStrB(1, strFile, ChrW$(0)) <> 0 Then
      blnSource = False
    ElseIf InStrB(1, strFile, ChrW$(1)) <> 0 Then
      blnSource = False
    ElseIf InStrB(1, strFile, ChrW$(2)) <> 0 Then
      blnSource = False
    ElseIf InStrB(1, strFile, ChrW$(3)) <> 0 Then
      blnSource = False
    ElseIf InStrB(1, strFile, ChrW$(4)) <> 0 Then
      blnSource = False
    ElseIf InStrB(1, strFile, ChrW$(5)) <> 0 Then
      blnSource = False
    ElseIf InStrB(1, strFile, ChrW$(6)) <> 0 Then
      blnSource = False
    ElseIf InStrB(1, strFile, ChrW$(7)) <> 0 Then
      blnSource = False
    Else
      'probably source code
      blnSource = True
    End If
    
    'import the logic
    '(and check for error)
    On Error Resume Next
    tmpLogic.Import ImportLogicFile, blnSource
    'if a compile error occurred,
    If Err.Number = vbObjectError + 567 Then
      'can't open this resource
      MsgBox "An error occurred while trying to decompile this logic resource:" & vbNewLine & vbNewLine & _
                  vbTab & Err.Description & vbNewLine & vbNewLine & "Unable to open this logic.", _
                  vbInformation + vbOKOnly, "Invalid Logic Resource"
      Exit Sub
      
    ElseIf Err.Number <> 0 Then
      'maybe we assumed source status incorrectly- try again
      Err.Clear
      tmpLogic.Import ImportLogicFile, Not blnSource
      
      'if STILL error
      If Err.Number <> 0 Then
        'something wrong
        MsgBox "Unable to load this logic resource. It can't be decompiled, and does not appear to be a text file.", _
                    vbInformation + vbOKOnly, "Invalid Logic Resource"
        Exit Sub
      End If
    End If
    On Error GoTo ErrHandler
  End If
  
  'syntax of this logic needs to be manually determined
  'because the file import function can't properly set it
  tmpLogic.SourceCode.Syntax = GuessSyntax(tmpLogic.SourceCode.Text, Settings.DefaultSyntax)
  
  'if a game is loaded,
  If GameLoaded Then
    'get logic number
    'show add resource form
    Load frmGetResourceNum
    With frmGetResourceNum
      .ResType = rtLogic
      If blnImporting Then
        .WindowFunction = grImport
      Else
        .WindowFunction = grAddNew
      End If
      .Show vbModal, frmMDIMain
    
      'if user wants logic added to current game
      '(meaning cancel was NOT clicked)
      If Not .Canceled Then
        'add ID and description to tmpLogic
        tmpLogic.ID = .txtID.Text
        tmpLogic.Description = .txtDescription.Text
        
        'add Logic
        AddNewLogic .NewResNum, tmpLogic, (.chkIncludePic.Value = vbChecked), blnImporting
        'reset tmplogic to point to the new game logic
        Set tmpLogic = Nothing
        Set tmpLogic = Logics(.NewResNum)
        
        'if using layout editor
        If Settings.UseLE Then
          'update editor and data file to show this room is now in the game
          UpdateExitInfo .NewResNum, Logics(.NewResNum)
          'if layout editor is open
          If LEInUse Then
            'refresh so change is visible
            LayoutEditor.DrawLayout True
          End If
        End If
        
        'if including picture
        If .chkIncludePic.Value = vbChecked Then
          AddNewPicture .NewResNum, Nothing
        End If
        
        'set ingame flag
        blnInGame = True
      End If
    End With
    Unload frmGetResourceNum
  End If
  
  'set main form mousepointer to hourglass
  frmMDIMain.MousePointer = vbHourglass
  
  'open a new logic editing window
  Set frmNew = New frmLogicEdit
  
  'pass the logic to the editor
  If frmNew.EditLogic(tmpLogic) Then
    'show the form
    frmNew.Show
    'add form to collection
    LogicEditors.Add frmNew
  Else
    Set frmNew = Nothing
  End If
  
  'if logic was added to game
  If blnInGame Then
    'unload it
    Logics(tmpLogic.Number).Unload
  End If
  
  'restore main form mousepointer and exit
  frmMDIMain.MousePointer = vbDefault
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Public Sub NewPicture(Optional ImportPictureFile As String)
  'creates a new picture resource and opens an editor
  
  Dim frmNew As frmPictureEdit, blnInGame As Boolean
  Dim tmpPic As AGIPicture
  
  On Error GoTo ErrHandler
  
  'if max number already open
  If PictureEditors.Count = MaxPicEditors Then
    MsgBox "Too many editors already open. Close some of them and try again.", vbInformation, "Can't Open Picture Editor"
    Exit Sub
  End If
  
  'create temporary picture
  Set tmpPic = New AGIPicture
  
  'if an import filename was passed
  If LenB(ImportPictureFile) <> 0 Then
    'import the picture
    '(and check for error)
    On Error Resume Next
    tmpPic.Import ImportPictureFile
    If Err.Number <> 0 Then
      'something wrong
      MsgBox "An unhandled error occurred:" & vbNewLine & vbNewLine & Err.Number & ":" & Err.Description, vbCritical + vbOKOnly, "WinAGI GDS Error"
      Exit Sub
    End If
    On Error GoTo ErrHandler
  End If
  
  'if a game is loaded
  If GameLoaded Then
    'get picture number
    'show add resource form
    Load frmGetResourceNum
    With frmGetResourceNum
      .ResType = rtPicture
      If LenB(ImportPictureFile) = 0 Then
        .WindowFunction = grAddNew
      Else
        .WindowFunction = grImport
      End If
      .Show vbModal, frmMDIMain
      
      'if user wants picture added to current game
      '(meaning cancel was NOT clicked)
      If Not .Canceled Then
        'add new id and description
        tmpPic.ID = .txtID.Text
        tmpPic.Description = .txtDescription.Text
      
        'add picture
        AddNewPicture .NewResNum, tmpPic
        'reset tmpPic to point to the new game picture
        Set tmpPic = Nothing
        Set tmpPic = Pictures(.NewResNum)
        
        'set flag
        blnInGame = True
      End If
    End With
    Unload frmGetResourceNum
  End If
    
  'set main form mousepointer to hourglass
  frmMDIMain.MousePointer = vbHourglass
    
  'open a new picture editing window
  Set frmNew = New frmPictureEdit
    
  'pass the picture to the editor
  If frmNew.EditPicture(tmpPic) Then
    'show form
    frmNew.Show
    'add to collection
    PictureEditors.Add frmNew
  Else
    'error
    Set frmNew = Nothing
  End If
  
  'if added to a game
  If blnInGame Then
    'unload it
    Pictures(tmpPic.Number).Unload
  End If
  
  'restore main form mousepointer and exit
  frmMDIMain.MousePointer = vbDefault
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Public Sub NewView(Optional ImportViewFile As String)
  'creates a new view editor with a view that is
  'not attached to a game
  
  Dim frmNew As frmViewEdit, blnInGame As Boolean
  Dim tmpView As AGIView
  
  On Error GoTo ErrHandler
  
  'if max number already open
  If ViewEditors.Count = MaxPicEditors Then
    MsgBox "Too many editors already open. Close some of them and try again.", vbInformation, "Can't Open View Editor"
    Exit Sub
  End If
  
  'create temporary view
  Set tmpView = New AGIView
  'set first cel to default height/width
  tmpView.Loops(0).Cels(0).Height = Settings.DefCelH
  tmpView.Loops(0).Cels(0).Width = Settings.DefCelW
  
  'if an import filename was passed
  If LenB(ImportViewFile) <> 0 Then
    'import the view
    '(and check for error)
    On Error Resume Next
    tmpView.Import ImportViewFile
    If Err.Number <> 0 Then
      'something wrong
      MsgBox "An unhandled error occurred:" & vbNewLine & vbNewLine & Err.Number & ":" & Err.Description, vbCritical + vbOKOnly, "WinAGI GDS Error"
      Exit Sub
    End If
    On Error GoTo ErrHandler
  End If
  
  'if a game is loaded
  If GameLoaded Then
    'get view number
    'show add resource form
    Load frmGetResourceNum
    With frmGetResourceNum
      .ResType = rtView
      If LenB(ImportViewFile) <> 0 Then
        .WindowFunction = grImport
      Else
        .WindowFunction = grAddNew
      End If
      .Show vbModal, frmMDIMain
      
      'if user wants view added to current game
      '(meaning cancel was NOT clicked)
      If Not .Canceled Then
        'add new id and description
        tmpView.ID = .txtID.Text
        tmpView.Description = .txtDescription.Text
        
        'add view
        AddNewView .NewResNum, tmpView
        'reset tmpView to point to the new game view
        Set tmpView = Nothing
        Set tmpView = Views(.NewResNum)
        'set ingame flag
        blnInGame = True
      End If
    End With
    Unload frmGetResourceNum
  End If
  
  'open the newly added view
  
  'set main form mousepointer to hourglass
  frmMDIMain.MousePointer = vbHourglass
    
  'open a new view editing window
  Set frmNew = New frmViewEdit
    
  'pass the view to the editor
  If frmNew.EditView(tmpView) Then
    'show form
    frmNew.Show
    'add to collection
    ViewEditors.Add frmNew
  Else
    'error
    Set frmNew = Nothing
  End If
  
  'if added to game
  If blnInGame Then
    'unload the game resource
    Views(tmpView.Number).Unload
  End If
  
  'restore main form mousepointer and exit
  frmMDIMain.MousePointer = vbDefault
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Public Sub OpenAGIGame(Optional OpenGameDir As String)

  Dim strError As String
  Dim blnWarnings As Boolean, blnFirstOpen As Boolean
  Dim lngErr As Long, i As Long
  
  On Error GoTo ErrHandler
  
  'if no game directory passed,
  If LenB(OpenGameDir) = 0 Then
    'get a directory from which to load a game
    OpenGameDir = GetNewDir(frmMDIMain.hWnd, "Select the directory of the game you wish to open:")
  End If
  
  'if still nothing (user canceled),
  If LenB(OpenGameDir) = 0 Then
    'user canceled
    Exit Sub
  End If
  
  'ensure trailing backslash
  OpenGameDir = cDir(OpenGameDir)
  
  'if a game is currently open,
  If GameLoaded Then
    'close game, if user allows
    If Not CloseThisGame() Then
      Exit Sub
    End If
  End If
  
  'all resource editors should now be closed
  Debug.Assert Not WEInUse
  Debug.Assert Not OEInUse
  Debug.Assert Not MEInUse
  Debug.Assert Not GEInUse
      
  'set cursor to wait
  frmMDIMain.MousePointer = vbHourglass
  'show loading msg in status bar
  MainStatusBar.Panels(1).Text = "Loading game; please wait..."
  
  'if no game file exists, this is first
  'time game is being edited
  blnFirstOpen = (LenB(Dir(OpenGameDir & "*.wag")) = 0)
  
  'inline error trapping
  On Error Resume Next
  LoadGame OpenGameDir
  
  lngErr = Err.Number
  strError = Err.Description
  On Error GoTo ErrHandler
  
  blnWarnings = (lngErr = vbObjectError + 636)
  
  Select Case lngErr
  Case 0, vbObjectError + 636 'no error, or warnings only
    'compiled ok; maybe with warning
    frmMDIMain.Caption = "WinAGI GDS - " & GameID
    
    'build resource treelist
    BuildResourceTree GameID
    
    'select root
    frmMDIMain.tvwResources.Nodes(1).Selected = True
    frmMDIMain.SelectResourceFromTree frmMDIMain.tvwResources.SelectedItem.Index
    
    'set default directory
    BrowserStartDir = GameDir
    
    'add to mru
    AddToMRU GameDir
    
    'adjust menus
    AdjustMenus rtGame, True, False, False
    
    'show preview window and resource pane
    If Settings.ShowPreview Then
      Load PreviewWin
      PreviewWin.Show
    End If
    If Settings.ShowTree Then
      frmMDIMain.picResources.Visible = True
      frmMDIMain.picSplitH.Visible = True
      frmMDIMain.picSplitV.Visible = True
    End If
    
    'if warnings
    If blnWarnings Then
      'warn about errors
      MsgBox "Some errors in resource data were encountered. See errlog.txt in the game directory for details.", vbInformation + vbOKOnly, "Errors During Load"
    End If
    
    'if first time opening
    If blnFirstOpen Then
      'did the resource directory change?
      If ResDirName <> DefResDir Then
        'warn that assumption was made about resource directory
        MsgBox "No game file (*.wag) was found, so one has been created." & vbNewLine & vbNewLine & _
        "The subdirectory '" & ResDirName & "' is assumed to contain your" & vbNewLine & _
        "logic source files.  If this is not correct, you can change this" & vbNewLine & _
        "property on the Game Properties dialog.", vbInformation, "Open Game"
      Else
        'warn user that resource dir set to default
        MsgBox "No game file (*.wag) was found, so one has been created." & vbNewLine & vbNewLine & _
        "WinAGI is unable to determine if you have existing logic" & vbNewLine & _
        "source files so the subdirectory '" & ResDirName & "' has been created. You" & vbNewLine & _
        "can change the source directory for this game on the Game" & vbNewLine & _
        "Properties dialog.", vbInformation, "Open Game"
      End If
    End If
    
  Case Else
    'error
    Select Case Err.Number - vbObjectError
    Case 501
      strError = "A game is already loaded. Close it before opening another game."
    
    Case 502
      strError = "A file access error occurred while trying to open this game: " & vbNewLine & vbNewLine & strError
    
    Case 508
      strError = "This directory had multiple game property files. Unable to determine which is the file for resources" & _
      "in this directory. Remove all *.wag files from this directory except the game property file, and try again."
    
    Case 524
      strError = "A critical game file (" & JustFileName(strError) & " is missing."
    Case 541
      strError = ChrW$(39) & OpenGameDir & "' is not a valid AGI game directory."
    
    Case 542
      strError = ChrW$(39) & Left$(strError, Len(strError) - 31) & "' is an invalid directory file."
    
    Case 545
      'resource loading error; current error string is sufficient
    
    Case 597
      strError = "WinAGI GDS only supports version 2 and 3 of AGI."
    Case Else
      'can't get any other errors
    End Select
    
    'show error message
    MsgBox strError, vbCritical + vbOKOnly, "Unable to Open Game"
  End Select
  
  'reset browser start dir to this dir
  BrowserStartDir = OpenGameDir
  
  'local copy of colors, to speed up color matching
  For i = 0 To 15
    lngEGACol(i) = EGAColor(i)
  Next i
  
  'reset cursor
  frmMDIMain.MousePointer = vbDefault
  'clear status bar
  MainStatusBar.Panels(1).Text = vbNullString
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Public Sub OpenSound(ByVal ResNum As Byte, Optional ByVal Quiet As Boolean = False)
  'this method opens a Sound editor window

  Dim i As Integer, blnLoaded As Boolean
  Dim blnWinOpen As Boolean
  Dim frmNew As frmSoundEdit
  
  On Error GoTo ErrHandler
  
  'set main form mousepointer to hourglass
  frmMDIMain.MousePointer = vbHourglass
  
  'step through all Sound editor windows
  For i = 1 To SoundEditors.Count
    'if Sound number matches
    If SoundEditors(i).SoundNumber = ResNum Then
      blnWinOpen = True
      'exit
      Exit For
    End If
  Next i
  
  'if found,
  If blnWinOpen Then
    'file is already open in another window so set focus to it
    'if minimized,
    If SoundEditors(i).WindowState = vbMinimized Then
      SoundEditors(i).WindowState = vbNormal
    End If
    SoundEditors(i).SetFocus
    
    'set main form mousepointer to hourglass
    frmMDIMain.MousePointer = vbDefault
    Exit Sub
  End If

  'if max number of editors already open
  If SoundEditors.Count = MaxSoundEditors Then
    If Not Quiet Then
      MsgBox "Too many editors already open. Close some of them and try again.", vbInformation, "Can't Open Sound Editor"
    End If
    
    'set main form mousepointer to hourglass
    frmMDIMain.MousePointer = vbDefault
    Exit Sub
  End If
  
  'open a new Sound editing window
  Set frmNew = New frmSoundEdit
  
  'if the resource is not loaded,
  blnLoaded = Sounds(ResNum).Loaded
  If Not blnLoaded Then
    'load the Sound
    Sounds(ResNum).Load
    If Err.Number <> 0 Then
      If Not Quiet Then
        MsgBox "An error occurred while loading Sound resource:" & vbNewLine & vbNewLine & vbTab & Err.Description, , "Sound Load Error"
      End If
      Err.Clear
      Unload frmNew
      
      'set main form mousepointer to default
      frmMDIMain.MousePointer = vbDefault
      Exit Sub
    End If
  End If
  
  'load the Sound into the editor
  If frmNew.EditSound(Sounds(ResNum)) Then
    'show the form
    frmNew.Show
    
    'add to collection
    SoundEditors.Add frmNew
  Else
    'error
    Unload frmNew
    Set frmNew = Nothing
  End If
  
  'unload if necessary
  If Not blnLoaded Then
    Sounds(ResNum).Unload
  End If
  
  'set main form mousepointer to default
  frmMDIMain.MousePointer = vbDefault
Exit Sub

ErrHandler:
  Resume Next
End Sub
Public Sub OpenTextFile(strOpenFile As String, Optional ByVal Quiet As Boolean = False)
  'this method opens a text editor window
  
  Dim i As Integer
  Dim intFile As Integer, strInput As String
  Dim blnWinOpen As Boolean, frmNew As frmTextEdit
  Dim Cscore As Long
  
  On Error GoTo ErrHandler
  
  'set main form mousepointer to hourglass
  frmMDIMain.MousePointer = vbHourglass
  
  'step through all log windows
  For i = 1 To LogicEditors.Count
    'if a text editor
    If LogicEditors(i).FormMode = fmText Then
      'if name matches
      If LogicEditors(i).FileName = strOpenFile Then
        blnWinOpen = True
        'exit
        Exit For
      End If
    End If
  Next i
  
  'if found,
  If blnWinOpen Then
    'file is already open in another window so set focus to it
    'if minimized,
    If LogicEditors(i).WindowState = vbMinimized Then
      LogicEditors(i).WindowState = vbNormal
    End If
    LogicEditors(i).SetFocus
    
    'restore main form mousepointer and exit
    frmMDIMain.MousePointer = vbDefault
    Exit Sub
  End If

  'if max number of editors already open
  If LogicEditors.Count = MaxLogicEditors Then
    If Not Quiet Then
      MsgBox "Too many editors already open. Close some of them and try again.", vbInformation, "Can't Open Text Editor"
    End If
    Exit Sub
  End If
  
  'open a new logic editing window
  Set frmNew = New frmTextEdit
  
  'if file does not exist,
  If Not CanAccessFile(strOpenFile) Then
    'file does not exist,
    Unload frmNew
    If Not Quiet Then
      MsgBox "File not found:" & vbNewLine & strOpenFile, , "File Open Error"
    End If
    'restore main form mousepointer and exit
    frmMDIMain.MousePointer = vbDefault
    Exit Sub
  End If
  
  'load from file
  intFile = FreeFile()
  Open strOpenFile For Binary As intFile
  'get file text
  strInput = String$(LOF(1), 0)
  Get intFile, 1, strInput
  'close file
  Close intFile
  
  With frmNew
    'set syntax to default syntax
    .rtfLogic.HighlightSyntax = Settings.HighlightText
    .TextSyntax = GuessSyntax(strInput, Settings.DefaultSyntax)
    .rtfLogic.Syntax = .TextSyntax
  
    'assign text to text box
    .rtfLogic.Text = strInput
    'clear undo buffer
    .rtfLogic.EmptyUndo
    'clear dirty flag
    .rtfLogic.Dirty = False

    'set filename, caption
    .FileName = strOpenFile
    .Caption = "Text editor - " & JustFileName(strOpenFile)
  
    'reset dirty flag
    .rtfLogic.Dirty = False
      
    'maximize, if that's the current setting
    If Settings.MaximizeLogics Then
      .WindowState = vbMaximized
    End If
  End With
  
  'add form to collection
  LogicEditors.Add frmNew
  
  'show it
  frmNew.Show
  'restore main form mousepointer and exit
  frmMDIMain.MousePointer = vbDefault
Exit Sub

ErrHandler:
  'show error msg
  If Not Quiet Then
    MsgBox "Error while trying to open file " & vbNewLine & vbNewLine & CStr(Err.Number) & ":" & Err.Description, , "File Open Error"
  End If
  Err.Clear
  'restore main form mousepointer and exit
  frmMDIMain.MousePointer = vbDefault
End Sub

Public Sub OpenLogic(ByVal ResNum As Byte, Optional ByVal Quiet As Boolean = False)
  'this method opens a logic editor window

  Dim i As Integer, blnLoaded As Boolean
  Dim blnWinOpen As Boolean
  Dim frmNew As frmLogicEdit
  
  On Error GoTo ErrHandler

  'set main form mousepointer to hourglass
  frmMDIMain.MousePointer = vbHourglass
  
  'step through all logic editor windows
  For i = 1 To LogicEditors.Count
    'if window is a logic editor
    If LogicEditors(i).FormMode = fmLogic Then
      'if logic number and ingame status matches
      If LogicEditors(i).LogicNumber = ResNum And LogicEditors(i).InGame Then
        blnWinOpen = True
        'exit
        Exit For
      End If
    End If
  Next i
  
  'if found,
  If blnWinOpen Then
    'file is already open in another window so set focus to it
    'if minimized,
    If LogicEditors(i).WindowState = vbMinimized Then
      LogicEditors(i).WindowState = vbNormal
    End If
    LogicEditors(i).SetFocus
  
    'restore main form mousepointer and exit
    frmMDIMain.MousePointer = vbDefault
    Exit Sub
  End If

  'if max number of editors already open
  If LogicEditors.Count = MaxLogicEditors Then
    If Not Quiet Then
      MsgBox "Too many editors already open. Close some of them and try again.", vbInformation, "Can't Open Logic Editor"
    End If
    'restore main form mousepointer and exit
    frmMDIMain.MousePointer = vbDefault
    Exit Sub
  End If
  
  'open a new logic editing window
  Set frmNew = New frmLogicEdit
  
  'if the resource is not loaded,
  blnLoaded = Logics(ResNum).Loaded
  If Not blnLoaded Then
    Logics(ResNum).Load
  End If
  If Not Logics(ResNum).SourceCode.Loaded Then
    'load the logic
    On Error Resume Next
    Logics(ResNum).SourceCode.Load
    If Err.Number <> 0 Then
      If Not Quiet Then
        MsgBox "An error occurred while loading logic resource:" & vbNewLine & vbNewLine & vbTab & Err.Description, , "Logic Load Error"
      End If
      Err.Clear
      Unload frmNew
      'restore main form mousepointer and exit
      frmMDIMain.MousePointer = vbDefault
      Exit Sub
    End If
    On Error GoTo ErrHandler
  End If
  
  'load the logic into the editor
  If frmNew.EditLogic(Logics(ResNum)) Then
    'show the form
    frmNew.Show
    
    'add to collection
    LogicEditors.Add frmNew
  Else
    'error
    Unload frmNew
    Set frmNew = Nothing
  End If
  
  'unload if necessary
  If Not blnLoaded Then
    Logics(ResNum).Unload
  End If
  
  'restore main form mousepointer and exit
  frmMDIMain.MousePointer = vbDefault
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Public Sub OpenPicture(ByVal ResNum As Byte, Optional ByVal Quiet As Boolean = False)
  'this method opens a picture editor window
  
  Dim i As Integer, blnLoaded As Boolean
  Dim blnWinOpen As Boolean
  Dim frmNew As frmPictureEdit
  
  On Error GoTo ErrHandler
  
  'set main form mousepointer to hourglass
  frmMDIMain.MousePointer = vbHourglass
  
  'step through all Picture windows
  For i = 1 To PictureEditors.Count
    'if number matches
    If PictureEditors(i).PicNumber = ResNum Then
      blnWinOpen = True
      Exit For
    End If
  Next
  
  'if found,
  If blnWinOpen Then
    'Picture is already open
    If PictureEditors(i).WindowState = vbMinimized Then
      PictureEditors(i).WindowState = vbNormal
    End If
    PictureEditors(i).SetFocus
    'restore main form mousepointer and exit
    frmMDIMain.MousePointer = vbDefault
    Exit Sub
  End If
  
  'if max number already open
  If PictureEditors.Count = MaxPicEditors Then
    If Not Quiet Then
      MsgBox "Too many picture editors already open. Close some of them and try again.", vbInformation, "Can't Open Picture Editor"
    End If
    'restore main form mousepointer and exit
    frmMDIMain.MousePointer = vbDefault
    Exit Sub
  End If
  
  'open a new edit Picture form
  Set frmNew = New frmPictureEdit
  
  'if the resource is not loaded
  blnLoaded = Pictures(ResNum).Loaded
  If Not blnLoaded Then
    Pictures(ResNum).Load
    If Err.Number <> 0 Then
      If Not Quiet Then
        MsgBox "An error occurred while loading logic resource:" & vbNewLine & vbNewLine & vbTab & Err.Description, , "Logic Load Error"
      End If
      Err.Clear
      Unload frmNew
      'restore main form mousepointer and exit
      frmMDIMain.MousePointer = vbDefault
      Exit Sub
    End If
  End If
  
  'load Picture into editor
  If frmNew.EditPicture(Pictures(ResNum)) Then
    'show the form
    frmNew.Show
    
    'add to collection
    PictureEditors.Add frmNew
  Else
    'error
    Unload frmNew
    Set frmNew = Nothing
  End If
  
  'unload if necessary
  If Not blnLoaded Then
    Pictures(ResNum).Unload
  End If
  
  'restore main form mousepointer and exit
  frmMDIMain.MousePointer = vbDefault
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub
Public Sub OpenView(ByVal ResNum As Byte, Optional ByVal Quiet As Boolean = False)
  'this method opens a view editor window
  
  Dim i As Integer, blnLoaded As Boolean
  Dim blnWinOpen As Boolean
  Dim frmNew As frmViewEdit
  
  On Error GoTo ErrHandler
  
  'set main form mousepointer to hourglass
  frmMDIMain.MousePointer = vbHourglass
  
  'step through all view windows
  For i = 1 To ViewEditors.Count
    'if number matches
    If ViewEditors(i).ViewNumber = ResNum Then
      blnWinOpen = True
      Exit For
    End If
  Next
  
  'if found,
  If blnWinOpen Then
    'view is already open
    If ViewEditors(i).WindowState = vbMinimized Then
      ViewEditors(i).WindowState = vbNormal
    End If
    ViewEditors(i).SetFocus
    
    'restore main form mousepointer and exit
    frmMDIMain.MousePointer = vbDefault
    Exit Sub
  End If
  
  'if max number of editors already open
  If ViewEditors.Count = MaxViewEditors Then
    If Not Quiet Then
      MsgBox "Too many editors already open. Close some of them and try again.", vbInformation, "Can't Open View Editor"
    End If
    'restore main form mousepointer and exit
    frmMDIMain.MousePointer = vbDefault
    Exit Sub
  End If
  
  'open a new edit view form
  Set frmNew = New frmViewEdit
  
  'if the resource is not loaded
  blnLoaded = Views(ResNum).Loaded
  If Not blnLoaded Then
    'use inline error handling
    On Error Resume Next
    'load the view
    Views(ResNum).Load
    If Err.Number <> 0 Then
      If Not Quiet Then
        MsgBox "An error occurred while loading view resource:" & vbNewLine & vbNewLine & vbTab & Err.Description, , "Logic Load Error"
      End If
      Err.Clear
      Unload frmNew
      'restore main form mousepointer and exit
      frmMDIMain.MousePointer = vbDefault
      Exit Sub
    End If
    On Error GoTo ErrHandler
  End If
  
  'load view into editor
  If frmNew.EditView(Views(ResNum)) Then
    'show form
    frmNew.Show
    
    'add to collection
    ViewEditors.Add frmNew
  Else
    'error
    Unload frmNew
    Set frmNew = Nothing
  End If
  
  'unload if necessary
  If Not blnLoaded Then
    Views(ResNum).Unload
  End If
  
  'restore main form mousepointer and exit
  frmMDIMain.MousePointer = vbDefault
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Public Function CloseThisGame() As Boolean

  Dim i As Integer, j As Integer
  Dim tmpPic As AGIPicture, tmpView As AGIView
  Dim tmpSnd As AGISound, tmpLog As AGILogic
  Dim rtn As VbMsgBoxResult, tmpForm As Form
  Dim strError As String, strErrSrc As String, lngError As Long
  
  On Error GoTo ErrHandler
  
  'if a game is open,
  If GameLoaded Then
    'unload any view edit windows
    For i = ViewEditors.Count To 1 Step -1
      'if in game
      If ViewEditors(i).InGame Then
        'save count
        j = ViewEditors.Count
        Unload ViewEditors(i)
        'check for cancellation
        If j = ViewEditors.Count Then
          Exit Function
        End If
      End If
    Next i
    
    'unload any picture edit windows
    For i = PictureEditors.Count To 1 Step -1
      'if in game
      If PictureEditors(i).InGame Then
        'save count
        j = PictureEditors.Count
        Unload PictureEditors(i)
        'check for cancellation
        If j = PictureEditors.Count Then
          Exit Function
        End If
      End If
    Next i
    
    'unload any logic editors
    For i = LogicEditors.Count To 1 Step -1
      If LogicEditors(i).FormMode = fmLogic Then
        'if in game
        If LogicEditors(i).InGame Then
          'save count
          j = LogicEditors.Count
          Unload LogicEditors(i)
          'check for cancellation
          If j = LogicEditors.Count Then
            Exit Function
          End If
        End If
      End If
    Next i
    
    'unload any sound editors
    For i = SoundEditors.Count To 1 Step -1
      'if in game
      If SoundEditors(i).InGame Then
        'save count
        j = SoundEditors.Count
        Unload SoundEditors(i)
        'check for cancellation
        If j = SoundEditors.Count Then
          Exit Function
        End If
      End If
    Next i
    
    If Settings.ShowPreview Then
      'clear preview window
      PreviewWin.ClearPreviewWin
    End If
    
    'close layout editor
    If LEInUse Then
      Unload LayoutEditor
      'check for cancellation
      If LEInUse Then
        Exit Function
      End If
    End If
    
    For Each tmpForm In Forms
      'if a global defines editor or warnings window is open
      'for this game, it needs to be closed
      If tmpForm.Name = "frmGlobals" Then
        If tmpForm.InGame Then
          Unload tmpForm
        End If
      ElseIf tmpForm.Name = "frmTextEdit" Then
        'is it a warning file?
        If tmpForm.IsOutput Then
          Unload tmpForm
        End If
      End If
    Next
    
    
    'if nothing is being edited, and nothing is being previewed,
    'all resources should be unloaded
    'unload all resources
    For Each tmpLog In Logics
      Debug.Assert Not tmpLog.Loaded
      If tmpLog.Loaded Then
        'if dirty
        If tmpLog.IsDirty Then
          'ask about saving
          rtn = MsgBox(tmpLog.ID & " has changed. Do you want to save the changes?", vbQuestion + vbYesNoCancel, "Save Changes")
          Select Case rtn
          Case vbYes
            'save the resource
            tmpLog.Save
          Case vbCancel
            'exit
            Exit Function
          End Select
        End If
        tmpLog.Unload
      End If
    Next
    
    For Each tmpPic In Pictures
      Debug.Assert Not tmpPic.Loaded
      If tmpPic.Loaded Then
        'if dirty
        If tmpPic.IsDirty Then
          'ask about saving
          rtn = MsgBox(tmpPic.ID & " has changed. Do you want to save the changes?", vbQuestion + vbYesNoCancel, "Save Changes")
          Select Case rtn
          Case vbYes
            'save the resource
            tmpPic.Save
          Case vbCancel
            'exit
            Exit Function
          End Select
        End If
        tmpPic.Unload
      End If
    Next
    
    For Each tmpSnd In Sounds
      Debug.Assert Not tmpSnd.Loaded
      If tmpSnd.Loaded Then
        'if dirty
        If tmpSnd.IsDirty Then
          'ask about saving
          rtn = MsgBox(tmpSnd.ID & " has changed. Do you want to save the changes?", vbQuestion + vbYesNoCancel, "Save Changes")
          Select Case rtn
          Case vbYes
            'save the resource
            tmpSnd.Save
          Case vbCancel
            'exit
            Exit Function
          End Select
        End If
        tmpSnd.Unload
      End If
    Next
    
    For Each tmpView In Views
      Debug.Assert Not tmpView.Loaded
      If tmpView.Loaded Then
        'if dirty
        If tmpView.IsDirty Then
          'ask about saving
          rtn = MsgBox(tmpView.ID & " has changed. Do you want to save the changes?", vbQuestion + vbYesNoCancel, "Save Changes")
          Select Case rtn
          Case vbYes
            'save the resource
            tmpView.Save
          Case vbCancel
            'exit
            Exit Function
          End Select
        End If
        tmpView.Unload
      End If
    Next
    
    'unload Objects Editor
    If OEInUse Then
      Unload ObjectEditor
      If OEInUse Then
        Exit Function
      End If
    End If
    
    'unload word editor
    If WEInUse Then
      Unload WordEditor
      'if it is still there,
      If WEInUse Then
        'user cancelled
        Exit Function
      End If
    End If
    
    'unload layout editor
    If LEInUse Then
      Unload LayoutEditor
      If LEInUse Then
        Exit Function
      End If
    End If
    
    'unload globals editor
    If GEInUse Then
      Unload GlobalsEditor
      If GEInUse Then
        Exit Function
      End If
    End If
    
    'unload the menu editor
    If MEInUse Then
      Unload MenuEditor
      If MEInUse Then
        Exit Function
      End If
    End If
    
    'now close the game
    CloseGame

    If Settings.ShowTree Then
      'clear resource list
      frmMDIMain.ClearResourceTree
    End If
    
    'update menus, toolbars, and caption
    AdjustMenus rtNone, False, False, False
    frmMDIMain.Caption = "WinAGI GDS"
    
    
    'if using preview window
    If Settings.ShowPreview Then
      PreviewWin.Hide
      Unload PreviewWin
    End If
    'if using resource tree
    If Settings.ShowTree Then
      frmMDIMain.picResources.Visible = False
      frmMDIMain.picSplitH.Visible = False
      frmMDIMain.picSplitV.Visible = False
    End If
  End If
  
  'reset index marker so selection of resources
  'works correctly first time after another game loaded
  frmMDIMain.LastIndex = -1
  
  'always force useresname to current default
  LogicSourceSettings.UseReservedNames = Settings.UseReservedNames
  
  'game is closed
  CloseThisGame = True
Exit Function

ErrHandler:
  Debug.Assert False
  
  'pass on the error
  On Error GoTo 0: Err.Raise Err.Number, Err.Source, Err.Description
End Function
Public Function GetAGIColor(lngEGAColor As Long) As AGIColors
  
  Dim i As Byte
  Dim bytCloseColor As Byte, lngDiff As Long
  Dim bytRed As Byte, bytBlue As Byte, bytGreen As Byte
  Dim newdiff As Long
  
  On Error GoTo ErrHandler
  
  bytRed = lngEGAColor \ &H10000
  bytGreen = (lngEGAColor And &HFFFF&) \ &H100
  bytBlue = lngEGAColor And &HFF&
  
  'set initial difference to ensure first number resets it
  lngDiff = &HFFFFFF
  i = 0

  'loop until exact match is found,
  'or until all colors are compared
  Do Until lngDiff = 0 Or i = 16
    'get new diff
    bytRed = lngEGACol(i) \ &H10000
    bytGreen = (lngEGACol(i) And &HFFFF&) \ &H100&
    bytBlue = lngEGACol(i) And &HFF
    newdiff = (Abs(bytRed - lngEGAColor \ &H10000) + Abs(bytGreen - (lngEGAColor And &HFFFF&) \ &H100) + Abs(bytBlue - lngEGAColor And &HFF))
    
    'if difference between this color and color i is less than difference
    If newdiff < lngDiff Then
      lngDiff = newdiff
      bytCloseColor = i
    End If
    i = i + 1
  Loop
  
  'return best match
  GetAGIColor = bytCloseColor
Exit Function

ErrHandler:
  Debug.Assert False
  'just return black
  GetAGIColor = agBlack
End Function

Public Function CmdType(ByVal CommandText As String) As Long
  'converts a command string into a command value
  '
  '0 = any draw command
  '1 = set vis color command
  '2 = set pri color command
  '3 = set plot pen parameters
  On Error GoTo ErrHandler
  
  Select Case Left$(CommandText, 3)
  Case "Vis"
    CmdType = 1
  Case "Pri"
    CmdType = 2
  Case "Set"
    CmdType = 3
  End Select
Exit Function

ErrHandler:
  'for any error, set type to zero
  Err.Clear
  CmdType = 0

End Function

Public Function CoordText(ByVal x As Byte, ByVal y As Byte) As String
  'this function creates the coordinate text in the form
  ' (X, Y)
  
  CoordText = "(" & CStr(x) & ", " & CStr(y) & ")"
End Function

Public Function GetPriBand(ByVal y As Byte) As Byte

  'convert Y value into appropriate priority band
  GetPriBand = y \ 12 + 1
  If GetPriBand < 4 Then
    GetPriBand = 4
  End If
End Function
Public Function ExtractCoordinates(TreeText As String) As PT
  Dim strCoord() As String
  Dim lngPos As Long
  
  On Error GoTo ErrHandler
  
  'splits a treetext string into x and Y coordinates
  'input will always be "(#,#)" or "# -- (#,#)"
  
  'determine case of input
  If InStrB(1, TreeText, "-") <> 0 Then
    'need to skip pattern number and parentheses
    lngPos = InStr(5, TreeText, "(")
    strCoord = Split(Mid$(TreeText, lngPos + 1, Len(TreeText) - lngPos - 1), ",")
  Else
    'strip off parentheses
    strCoord = Split(Mid$(TreeText, 2, Len(TreeText) - 2), ",")
  End If
  
  'convert to long integers
  ExtractCoordinates.x = CLng(Val(strCoord(0)))
  ExtractCoordinates.y = CLng(strCoord(1))
Exit Function

ErrHandler:
  Debug.Assert False
  Resume Next
End Function
Sub FindInLogic(ByVal FindText As String, ByVal FindDir As FindDirection, ByVal MatchWord As Boolean, _
                ByVal MatchCase As Boolean, ByVal LogicLoc As FindLocation, _
                Optional ByVal Replacing As Boolean = False, Optional ByVal ReplaceText As String = vbNullString)

  'logic search strategy:
  '
  'determine current starting position; can be in a logic currently being edited
  'or from the globals, words or objects editor
  '
  'if from a logic editor, begin search at current position in current editor
  'if from a non-logic editor, begin search in closed logics
  '(note that findlocation will ALWAYS be flAll in this case)
  '
  'if this is a new search, set start logic and start pos
  'if this is NOT a new search, continue where left off
  'if search gets all the way back to beginning, stop
  
  Dim FoundPos As Long
  Dim SearchPos As Long
  Dim ResetSearch As Boolean, BeginClosedLogics As Boolean
  Dim lngNextLogWin As Long, lngFirstLogWin As Long
  Dim lngLogWinCount As Long
  Dim vbcComp As VbCompareMethod
  Dim i As Long
  Dim rtn As VbMsgBoxResult
  
  On Error GoTo ErrHandler
  
  'set comparison method for string search,
  vbcComp = CLng(MatchCase) + 1 ' CLng(True) + 1 = 0 = vbBinaryCompare; Clng(False) + 1 = 1 = vbTextCompare
  
  'if replacing and new text is the same
  If Replacing And (StrComp(FindText, ReplaceText, vbcComp) = 0) Then
    'exit
    Exit Sub
  End If
  
  'use hourglass cursor
  frmMDIMain.MousePointer = vbHourglass
  
  'if starting from a logic,
  If SearchForm.Name = "frmLogicEdit" Or SearchForm.Name = "frmTextEdit" Then
    'determine form number of starting logic
    lngLogWinCount = LogicEditors.Count
    For i = 1 To lngLogWinCount
      If LogicEditors(i) Is SearchForm Then
        lngNextLogWin = i
        Exit For
      End If
    Next i
    
    'set first logic to current logic
    lngFirstLogWin = lngNextLogWin
      
    'set SearchPos (add one because instr and instrrev are '1' based
    'but textbox positions are '0' based
    If FindDir = fdUp Then
      SearchPos = LogicEditors(lngFirstLogWin).rtfLogic.Selection.Range.StartPos
      'if not found
      If SearchPos = 0 Then
        'reset to end of string
        SearchPos = -1
      End If
    Else
      'get starting search position
      If Replacing Then
        SearchPos = LogicEditors(lngFirstLogWin).rtfLogic.Selection.Range.StartPos + 1
      Else
        SearchPos = LogicEditors(lngFirstLogWin).rtfLogic.Selection.Range.EndPos + 1
      End If
      'if starting a new search (findfirst will be false) but NOT replacing
      If Not FirstFind And Not Replacing Then
        'is searchword currently selected?
        If StrComp(Left$(LogicEditors(lngFirstLogWin).rtfLogic.Selection.Range.Text, Len(FindText)), FindText, vbTextCompare) = 0 Then
          'save this position to support find again
          'SearchStartLog = lngFirstLogWin
          'SearchStartPos = SearchPos - Len(FindText) ' - 1
          'set firstfind to true
          'FirstFind = True
        End If
      End If
    End If
  Else
    Debug.Assert FindDir = fdAll
    Debug.Assert LogicLoc = flAll
    
    If LogicEditors.Count <> 0 Then
      'start with first logic editor
      lngFirstLogWin = 1
      lngNextLogWin = 1
    Else
      'no editors open; begin search in closed logics
      'start with closed logics
      'first disable main form
      frmMDIMain.Enabled = False
      'set closelogics flag to false
      ClosedLogics = False
      'get number of next logic
      lngNextLogWin = FindInClosedLogics(FindText, FindDir, MatchWord, MatchCase, SearchType)
      'reenable form
      frmMDIMain.Enabled = True
      'if nothing found (lngnextlogwin =-1)
      If lngNextLogWin = -1 Then
        'show msgbox and exit
        MsgBox "Search text not found.", vbInformation, "Find in Logic"
        'restore cursor
        frmMDIMain.MousePointer = vbDefault
        Exit Sub
      End If
    End If
    
    If FindDir = fdUp Then
      SearchPos = -1
    Else
      SearchPos = 1
    End If
  End If
  
  'main search routine; at this point, a logic editor is open and available for searching
  Do
    'if direction is up,
    If FindDir = fdUp Then
      'if searching whole word
      If MatchWord Then
        FoundPos = FindWholeWord(SearchPos, LogicEditors(lngNextLogWin).rtfLogic.Text, FindText, MatchCase, FindDir = fdDown, SearchType, LogicEditors(lngNextLogWin).TextSyntax)
      Else
        'use instrrev
        FoundPos = InStrRev(LogicEditors(lngNextLogWin).rtfLogic.Text, FindText, SearchPos, vbcComp)
      End If
      'reset SearchPos
      SearchPos = -1
    Else
      'if searching whole word
      If MatchWord Then
        FoundPos = FindWholeWord(SearchPos, LogicEditors(lngNextLogWin).rtfLogic.Text, FindText, MatchCase, FindDir = fdDown, SearchType, LogicEditors(lngNextLogWin).TextSyntax)
      Else
        'use instr
        FoundPos = InStr(SearchPos, LogicEditors(lngNextLogWin).rtfLogic.Text, FindText, vbcComp)
      End If
      'reset SearchPos
      SearchPos = 1
    End If
    
    'if found,
    If FoundPos > 0 Then
      'if back at beginning point of search (after previously finding something)
      If (FoundPos = SearchStartPos) And (lngNextLogWin = SearchStartLog) Then
        'if NOT searching all logics
        If LogicLoc <> flAll Then
          'back at start; reset foundpos
          FoundPos = 0
          'exit loop
          Exit Do
        Else
          'set flag to begin searching closed logics
          BeginClosedLogics = True
        End If
      Else
        'exit loop; search text found
        Exit Do
      End If
    End If
    
    'if not found, action depends on search mode
    Select Case LogicLoc
    Case flCurrent
      'ask if user wants to continue search for up or down search
      Select Case FindDir
      Case fdUp
        If Not ResetSearch Then
          rtn = MsgBox("Beginning of search scope reached. Do you want to continue from the end?", vbQuestion + vbYesNo, "Find in Logic")
          If rtn = vbNo Then
            'reset cursor
            frmMDIMain.MousePointer = vbDefault
            Exit Sub
          End If
        End If
        
      Case fdDown
        'if not reset yet
        If Not ResetSearch Then
          rtn = MsgBox("End of search scope reached. Do you want to continue from the beginning?", vbQuestion + vbYesNo, "Find in Logic")
          If rtn = vbNo Then
            'reset cursor
            frmMDIMain.MousePointer = vbDefault
            Exit Sub
          End If
        End If
        
      Case fdAll
        'if reset,
        If ResetSearch Then
          'not found; exit
          Exit Do
        End If
      End Select
    
    Case flOpen
      'if back on start, and search already reset
      If (lngNextLogWin = lngFirstLogWin) And ResetSearch Then
        'not found- exit
        Exit Do
      End If
    
     'increment logic number
      lngNextLogWin = lngNextLogWin + 1
      If lngNextLogWin > LogicEditors.Count Then
        lngNextLogWin = 1
      End If
      
    Case flAll
      'if searching closed logics
      If BeginClosedLogics Or ClosedLogics Then
      
        'first disable main form
        frmMDIMain.Enabled = False
        'get number of next logic
        lngNextLogWin = FindInClosedLogics(FindText, FindDir, MatchWord, MatchCase, SearchType)
        'reenable form
        frmMDIMain.Enabled = True
        'if nothing found (lngnextlogwin =-1)
        If lngNextLogWin = -1 Then
          FoundPos = 0
          Exit Do
        End If
        'then select the newly opened logic
        LogicEditors(lngNextLogWin).SetFocus
        frmMDIMain.tmrFind.Enabled = True
        
      Else
        'if back on start, and search already reset
        If (lngNextLogWin = lngFirstLogWin) And ResetSearch Then
          'not found- set flag to search closed logics
          BeginClosedLogics = True
        End If
      
       'increment logic number
        lngNextLogWin = lngNextLogWin + 1
        If lngNextLogWin > LogicEditors.Count Then
          lngNextLogWin = 1
        End If
      End If
    End Select
    
    'set reset search flag so when we are back to starting logic, search will end
    ResetSearch = True
  'loop is exited by finding the searchtext or reaching end of search area
  Loop
  
  'if search string was found,
  If FoundPos > 0 Then
    'if first found word in a new search
    If Not FirstFind Then
      'save this position to support find again
      SearchStartLog = lngNextLogWin
      SearchStartPos = FoundPos
      'set firstfind to true
      FirstFind = True
    End If
  
    'highlight searchtext and show editor
    LogicEditors(lngNextLogWin).rtfLogic.Selection.Range.StartPos = FoundPos - 1
    LogicEditors(lngNextLogWin).rtfLogic.Selection.Range.EndPos = FoundPos - 1 + Len(FindText)
    'bring the selected window to the top of the order
    LogicEditors(lngNextLogWin).SetFocus
    frmMDIMain.tmrFind.Enabled = True
    
    'if in replace mode,
    If Replacing Then
      'selection is highlighted with search text; just reset it
      LogicEditors(lngNextLogWin).rtfLogic.Selection.Range.Text = ReplaceText
      'the richtext box handles undo automatically
      
      'recurse the find method to get the next occurrence
      FindInLogic FindText, FindDir, MatchWord, MatchCase, LogicLoc, False
    End If
    
    'this form is now the search form
    Set SearchForm = LogicEditors(lngNextLogWin)
    
  Else  'search string was NOT found
    'if something previously found (firstfind=true)
    If FirstFind Then
      'search complete; no new instances found
      MsgBox "The specified region has been searched.", vbInformation, "Find in Logic"
    Else
      'show not found msg
      MsgBox "Search text not found.", vbInformation, "Find in Logic"
    End If
    frmMDIMain.tmrFind.Enabled = True
    'reset search flags
    FirstFind = False
    SearchStartLog = -1
    SearchStartPos = -1
    ClosedLogics = False
  End If
  
  'if activeform is and editor
  If frmMDIMain.ActiveForm.Name = "frmLogicEdit" Or frmMDIMain.ActiveForm.Name = "frmTextEdit" Then
    'always select the logic edit window
    frmMDIMain.ActiveForm.rtfLogic.SetFocus
  End If
  'reset cursor
  frmMDIMain.MousePointer = vbDefault
Exit Sub

ErrHandler:
  Resume Next
End Sub


Public Sub AssignItems(ctl As Control, strlItems As StringList, Optional blnNumbers As Boolean = False)
  Dim i As Long
  'ctl must be a list box or combobox
  If Not ((TypeOf ctl Is ComboBox) Or (TypeOf ctl Is ListBox)) Then
    'need error statement here
    Exit Sub
  End If
  
  'clear the control
  ctl.Clear
  'add all items  in stringlist into control
  If blnNumbers Then
    For i = 0 To strlItems.Count - 1
      ctl.AddItem CStr(i + 1) & ". " & strlItems.StringLine(i)
    Next i
  Else
    For i = 0 To strlItems.Count - 1
      ctl.AddItem strlItems.StringLine(i)
    Next i
  End If
End Sub



Public Sub AdjustMenus(ByVal NewMode As AGIResType, ByVal InGame As Boolean, ByVal Editing As Boolean, ByVal IsDirty As Boolean)
  
  Dim tmpPanel As Panel
  Dim tmpFrm As Form
  Dim strTemp As String
  
  On Error GoTo ErrHandler
  
  'possible choices:
  'rtLogic = 0
  'rtPicture = 1
  'rtSound = 2
  'rtView = 3
  'rtObjects
  'rtWords
  'rtText
  'rtGame
  'rtGlobals
  'rtLayout
  'rtMenu
  'rtNone = 255
  
  With frmMDIMain
    'commands that are only available if a game is loaded
    .mnuGClose.Enabled = GameLoaded
    .mnuGCompile.Enabled = GameLoaded
    .mnuGCompileTo.Enabled = GameLoaded
    .mnuGRun.Enabled = GameLoaded
    .mnuGRebuild.Enabled = GameLoaded
    .mnuGCompDirty.Enabled = GameLoaded
    .mnuGProperties.Enabled = GameLoaded
    .mnuTLayout.Enabled = GameLoaded
    .mnuRImport.Enabled = GameLoaded
    
    'window menu is enabled by default; if it needs to be
    'disabled, the LastForm method will handle it
    .mnuWindow.Enabled = True
    
    'export available for anything but rtNone and rtLayout, as long as not game layout, with no game loaded
    .mnuRExport.Enabled = (NewMode <> rtNone) And (NewMode <> rtLayout) And (NewMode <> rtGame Or GameLoaded)
    
    
    'save available if editing, and resource is dirty
    .mnuRSave.Enabled = (Editing And IsDirty)
    
    'renumber only available if in game
    .mnuRRenumber.Enabled = InGame
    
    'remove/add available only if game loaded AND a logic, pic, snd, or view
    .mnuRInGame.Enabled = GameLoaded And (NewMode <= 3)
    If InGame Then
      .mnuRInGame.Caption = "&Remove from Game"
      .Toolbar1.Buttons("remove").Image = 10
      .Toolbar1.Buttons("remove").ToolTipText = "Remove from Game"
    Else
      .mnuRInGame.Caption = "&Add to Game"
      .Toolbar1.Buttons("remove").Image = 3
      .Toolbar1.Buttons("remove").ToolTipText = "Add to Game"
    End If
    
    'default is to show description
    .mnuRDescription.Visible = True
    
    'if a printer is available
    If Not NoPrinter Then
      'printing disabled for none and game and menu
      .mnuRPrint.Enabled = (NewMode <> rtGame And NewMode <> rtNone And NewMode <> rtMenu)
    Else
      .mnuRPrint.Enabled = False
    End If
    
    'hide custom menus
    .mnuRBar2.Visible = False
    .mnuRCustom1.Visible = False
    .mnuRCustom2.Visible = False
    .mnuRCustom3.Visible = False
    .mnuEBar2.Visible = False
    .mnuECustom1.Visible = False
    .mnuECustom2.Visible = False
    'custom 2,3 uses check mark for some windows, so reset them
    .mnuRCustom2.Checked = False
    .mnuRCustom3.Checked = False
    
    'default is to enable the property scrollbar
    .fsbProperty.Enabled = True
    
    Select Case NewMode
    Case rtNone
      'no game loaded
      .mnuEdit.Visible = False
      'reset save and export
      .mnuRSave.Caption = "&Save Resource"
      .mnuRExport.Caption = "&Export Resource"
      .mnuRRenumber.Caption = "&Renumber Resource"
      .mnuRRenumber.Enabled = False
      'hide description
      .mnuRDescription.Visible = False
      .mnuRInGame.Caption = "&Add to Game"
      'disable property scrollbar
      .fsbProperty.Enabled = False
      
    Case rtGame
      'game is loaded, windows available
      .mnuEdit.Visible = False
      .mnuRSave.Caption = "&Save Resource"
      .mnuRSave.Enabled = False
      'export becomes 'export all'
      .mnuRExport.Caption = "&Export All"
      .mnuRRenumber.Caption = "&Renumber Resource"
      .mnuRRenumber.Enabled = False
      .mnuRInGame.Caption = "&Add to Game"
      'hide description
      .mnuRDescription.Visible = False
      
    Case rtLayout
      'game is loaded, layout is active
      .mnuEdit.Visible = True
      'set captions
      .mnuRSave.Caption = "&Save Layout"
      .mnuRExport.Caption = "Export Layout"
      .mnuRRenumber.Caption = "&Renumber Resource"
      .mnuRRenumber.Enabled = False
      .mnuRBar2.Visible = True
      .mnuRCustom1.Visible = True
      .mnuRCustom1.Enabled = True
      .mnuRCustom1.Caption = "R&epair Layout" & vbTab & "Alt+P"
      
      'hide description
      .mnuRDescription.Visible = False
      
    Case rtGlobals
      'game may or may not be loaded, globals are active
      .mnuEdit.Visible = True
      'set captions
      .mnuRSave.Caption = "&Save"
      .mnuRExport.Caption = "Save &As..."
      .mnuRRenumber.Caption = "&Renumber Resource" & vbTab & "Alt+N"
      .mnuRRenumber.Enabled = False
      .mnuRBar2.Visible = True
      .mnuRCustom1.Visible = True
      .mnuRCustom1.Enabled = True
      .mnuRCustom1.Caption = "Add from File..." & vbTab & "Alt+F"
      
    Case rtLogic
      'enable edit menu if editing
      .mnuEdit.Visible = Editing
      'set captions
      .mnuRSave.Caption = "&Save Logic Source"
      'export ingame logics; save as for non-ingame logics
      If InGame Then
        .mnuRExport.Caption = "&Export Logic"
      Else
        .mnuRExport.Caption = "Save &As..."
      End If
      .mnuRRenumber.Caption = "&Renumber Logic" & vbTab & "Alt+N"
      'set custom menus
      .mnuRBar2.Visible = Editing
      .mnuRCustom1.Visible = Editing And InGame
      .mnuRCustom1.Enabled = True
      .mnuRCustom1.Caption = "Compile Source" & vbTab & "F8"
      .mnuRCustom2.Visible = Editing
      .mnuRCustom2.Enabled = True
      .mnuRCustom2.Caption = "Message Cleanup" & vbTab & "Alt+M"
      
    Case rtPicture
      'enable edit menu if editing
      .mnuEdit.Visible = Editing
      'set captions
      .mnuRSave.Caption = "&Save Picture"
      'export ingame pictures; save as for non-ingame pictures
      If InGame Then
        .mnuRExport.Caption = "&Export Picture"
      Else
        .mnuRExport.Caption = "Save &As..."
      End If
      .mnuRRenumber.Caption = "&Renumber Picture" & vbTab & "Alt+N"
      .mnuRBar2.Visible = Editing
      .mnuRCustom2.Visible = Editing
      .mnuRCustom2.Enabled = True
      .mnuRCustom2.Caption = "Enable Test Mode" & vbTab & "Alt+M"
      .mnuRCustom3.Visible = Editing
      .mnuRCustom3.Enabled = True
      .mnuRCustom3.Caption = "Background..." & vbTab & "Alt+B"
      
    Case rtSound
      'enable edit menu if editing
      .mnuEdit.Visible = Editing
      'set captions
      .mnuRSave.Caption = "&Save Sound"
      'export ingame sounds; save as for non-ingame sounds
      If InGame Then
        .mnuRExport.Caption = "&Export Sound"
      Else
        .mnuRExport.Caption = "Save &As..."
      End If
      .mnuRRenumber.Caption = "&Renumber Sound" & vbTab & "Alt+N"
    
    Case rtView
      'enable edit menu if editing
      .mnuEdit.Visible = Editing
      'set captions
      .mnuRSave.Caption = "&Save View"
      'export ingame views; save as for non-ingame views
      If InGame Then
        .mnuRExport.Caption = "&Export View"
      Else
        .mnuRExport.Caption = "Save &As..."
      End If
      .mnuRRenumber.Caption = "&Renumber View" & vbTab & "Alt+N"
      
    Case rtText
      'enable edit menu if editing
      .mnuEdit.Visible = Editing
      'set captions
      .mnuRSave.Caption = "&Save"
      .mnuRExport.Caption = "Save &As..."
      .mnuRRenumber.Caption = "&Renumber Resource"
      'ingame never allowed for text
      .mnuRInGame.Enabled = False
      .mnuRInGame.Caption = "Add to Game"
      
      'text files have no description
      .mnuRDescription.Visible = False
      
      'show syntax related commands
      .mnuRBar2.Visible = True
      .mnuRCustom2.Visible = True
      .mnuRCustom2.Enabled = True
      .mnuRCustom2.Caption = "Highlight Syntax" & vbTab & "Shift+Ctrl+H"
      .mnuRCustom3.Visible = True
      .mnuRCustom3.Enabled = True
      .mnuRCustom3.Caption = "Convert Logic Format" & vbTab & "Shift+Ctrl+S"
      
    Case rtWords
      'enable edit menu if editing
      .mnuEdit.Visible = Editing
      'set captions
      .mnuRSave.Caption = "&Save WORDS.TOK"
      'export ingame word lists; save as for non-ingame word lists
      If InGame Then
        .mnuRExport.Caption = "&Export WORDS.TOK"
      Else
        .mnuRExport.Caption = "Save &As..."
      End If
      'renumber and ingame always disabled
      .mnuRRenumber.Enabled = False
      .mnuRRenumber.Caption = "&Renumber Resource"
      .mnuRInGame.Enabled = False
      .mnuRInGame.Caption = "Add to Game"
      
      .mnuRBar2.Visible = Editing
      'set custom menus
      .mnuRBar2.Visible = Editing
      .mnuRCustom1.Visible = Editing
      .mnuRCustom1.Enabled = True
      .mnuRCustom1.Caption = "Merge from File..." & vbTab & "Alt+F"
      .mnuRDescription.Enabled = GameLoaded Or Editing
      
    Case rtObjects
      'enable edit menu if editing
      .mnuEdit.Visible = Editing
      'set captions
      .mnuRSave.Caption = "&Save OBJECT"
      'export ingame object lists; save as for non-ingame object lists
      If InGame Then
        .mnuRExport.Caption = "&Export OBJECT"
      Else
        .mnuRExport.Caption = "Save &As..."
      End If
      'renumber and ingame always disabled
      .mnuRRenumber.Enabled = False
      .mnuRInGame.Enabled = False
      .mnuRInGame.Caption = "Add to Game"
      .mnuRRenumber.Caption = "&Renumber Resource"
      .mnuRBar2.Visible = Editing
      .mnuRCustom3.Visible = Editing
      .mnuRCustom3.Enabled = True
      .mnuRCustom3.Caption = "Encrypt File" & vbTab & "Shift+Ctrl+E"
      .mnuRDescription.Enabled = GameLoaded Or Editing
      
    Case rtMenu
      'enable editing
      .mnuEdit.Visible = True
      'set captions
      .mnuRDescription.Visible = False
      .mnuRInGame.Enabled = False
      .mnuRInGame.Caption = "Add to Game"
      .mnuRRenumber.Enabled = False
      .mnuRRenumber.Caption = "&Renumber Resource"
      .mnuRExport.Visible = False
      .mnuRSave.Caption = "Save Menu"
      If Not GameLoaded Then
        .mnuRSave.Enabled = False
      End If
    End Select
  End With
    
  With frmMDIMain.Toolbar1
    'set toolbar buttons
    .Buttons("close").Enabled = GameLoaded
    .Buttons("run").Enabled = GameLoaded
    .Buttons("import_r").Enabled = GameLoaded
    .Buttons("layout").Enabled = GameLoaded
    .Buttons("menu").Enabled = frmMDIMain.mnuTMenuEditor.Enabled
    .Buttons("globals").Enabled = frmMDIMain.mnuTGlobals.Enabled
    
    .Buttons("print").Enabled = frmMDIMain.mnuRPrint.Enabled
    .Buttons("remove").Enabled = frmMDIMain.mnuRInGame.Enabled
    'export button only available for resources in a game
    .Buttons("export").Enabled = InGame And (NewMode = rtLogic Or _
                                            NewMode = rtPicture Or _
                                            NewMode = rtSound Or _
                                            NewMode = rtView Or _
                                            NewMode = rtObjects Or _
                                            NewMode = rtWords)
    .Buttons("save").Enabled = frmMDIMain.mnuRSave.Enabled
  End With
  
  If MainStatusBar.Panels.Count > 0 Then
    If LenB(MainStatusBar.Panels(1).Text) <> 0 Then
      'save compile status so it can be restored after update
      strTemp = MainStatusBar.Panels(1).Text
    End If
  End If
  
  'adjust statusbar
  With MainStatusBar
    .Panels.Clear
    If Editing Then
      .Tag = CStr(NewMode)
    Else
      .Tag = vbNullString
    End If
    
    'if editing,
    If Editing Then
      Select Case NewMode
      Case rtNone, rtGame, rtGlobals
        'only caps, num, and insert
        Set tmpPanel = .Panels.Add(1, , , sbrText)
          tmpPanel.AutoSize = sbrSpring
          tmpPanel.Bevel = sbrNoBevel
          tmpPanel.MinWidth = 132
         
         Set tmpPanel = .Panels.Add(2, , , sbrCaps)
           tmpPanel.Alignment = sbrCenter
           tmpPanel.MinWidth = 750
           tmpPanel.Width = 750
         
         Set tmpPanel = .Panels.Add(3, , , sbrNum)
           tmpPanel.Alignment = sbrCenter
           tmpPanel.MinWidth = 750
           tmpPanel.Width = 750
    
         Set tmpPanel = .Panels.Add(4, , , sbrIns)
           tmpPanel.Alignment = sbrCenter
           tmpPanel.MinWidth = 750
           tmpPanel.Width = 750
           
      Case rtLogic, rtText
        Set tmpPanel = .Panels.Add(1, "Status", , sbrText)
          tmpPanel.AutoSize = sbrSpring
          tmpPanel.Alignment = sbrLeft
          tmpPanel.Text = strTemp
          
         Set tmpPanel = .Panels.Add(2, "Syntax", , sbrText)
          tmpPanel.MinWidth = 1323
          tmpPanel.Width = 1323
          
         Set tmpPanel = .Panels.Add(3, "Row", , sbrText)
           tmpPanel.MinWidth = 1587
           tmpPanel.Width = 1587
         
         Set tmpPanel = .Panels.Add(4, "Col", , sbrText)
           tmpPanel.MinWidth = 1323
           tmpPanel.Width = 1323
         
         Set tmpPanel = .Panels.Add(5, , , sbrCaps)
           tmpPanel.Alignment = sbrCenter
           tmpPanel.MinWidth = 750
           tmpPanel.Width = 750
         
         Set tmpPanel = .Panels.Add(6, , , sbrNum)
           tmpPanel.Alignment = sbrCenter
           tmpPanel.MinWidth = 750
           tmpPanel.Width = 750
    
         Set tmpPanel = .Panels.Add(7, , , sbrIns)
           tmpPanel.Alignment = sbrCenter
           tmpPanel.MinWidth = 750
           tmpPanel.Width = 750
         
      Case rtPicture
        Set tmpPanel = .Panels.Add(1, "Scale", , sbrText)
          tmpPanel.Width = 1720
          tmpPanel.MinWidth = 1720
          
        Set tmpPanel = .Panels.Add(2, "Mode", , sbrText)
          tmpPanel.Width = 1323
          tmpPanel.MinWidth = 1323
          
        Set tmpPanel = .Panels.Add(3, "Tool", , sbrText)
          tmpPanel.MinWidth = 1323
          tmpPanel.Width = 2646
          
        Set tmpPanel = .Panels.Add(4, , , sbrText)
          tmpPanel.AutoSize = sbrSpring
          tmpPanel.Bevel = sbrNoBevel
          tmpPanel.MinWidth = 132
          
        Set tmpPanel = .Panels.Add(5, "CurX", , sbrText)
          tmpPanel.MinWidth = 1111
          tmpPanel.Width = 1111
          
        Set tmpPanel = .Panels.Add(6, "CurY", , sbrText)
          tmpPanel.MinWidth = 1111
          tmpPanel.Width = 1111
          
        Set tmpPanel = .Panels.Add(7, "PriBand", , sbrText)
          tmpPanel.Alignment = sbrRight
          tmpPanel.MinWidth = 1587
          tmpPanel.Width = 1587
          
      Case rtSound
        Set tmpPanel = .Panels.Add(1, "Scale", , sbrText)
          tmpPanel.Width = 860
          tmpPanel.MinWidth = 860
          
        Set tmpPanel = .Panels.Add(2, "Time", , sbrText)
          tmpPanel.Width = 1323
          tmpPanel.MinWidth = 1323
          
        Set tmpPanel = .Panels.Add(3, , , sbrText)
          tmpPanel.AutoSize = sbrSpring
          tmpPanel.Bevel = sbrNoBevel
          tmpPanel.MinWidth = 132
          
        Set tmpPanel = .Panels.Add(4, , , sbrCaps)
          tmpPanel.Alignment = sbrCenter
          tmpPanel.MinWidth = 750
          tmpPanel.Width = 750
        
        Set tmpPanel = .Panels.Add(5, , , sbrNum)
          tmpPanel.Alignment = sbrCenter
          tmpPanel.MinWidth = 750
          tmpPanel.Width = 750
        
        Set tmpPanel = .Panels.Add(6, , , sbrIns)
          tmpPanel.Alignment = sbrCenter
          tmpPanel.MinWidth = 750
          tmpPanel.Width = 750
              
      Case rtView
        Set tmpPanel = .Panels.Add(1, "Scale", , sbrText)
          tmpPanel.Width = 1720
          tmpPanel.MinWidth = 1720
          
        Set tmpPanel = .Panels.Add(2, "Tool", , sbrText)
          tmpPanel.Width = 1984
          tmpPanel.MinWidth = 1984
          
        Set tmpPanel = .Panels.Add(3, , , sbrText)
          tmpPanel.AutoSize = sbrSpring
          tmpPanel.Bevel = sbrNoBevel
          tmpPanel.MinWidth = 132
          
        Set tmpPanel = .Panels.Add(4, "CurX", , sbrText)
          tmpPanel.MinWidth = 1111
          tmpPanel.Width = 1111
          
        Set tmpPanel = .Panels.Add(5, "CurY", , sbrText)
          tmpPanel.MinWidth = 1111
          tmpPanel.Width = 1111
            
      Case rtObjects
        Set tmpPanel = .Panels.Add(1, "Count", , sbrText)
          tmpPanel.MinWidth = 1587
          tmpPanel.Width = 1587
       
        Set tmpPanel = .Panels.Add(2, "Encrypt", , sbrText)
          tmpPanel.MinWidth = 1587
          tmpPanel.Width = 1587
       
        Set tmpPanel = .Panels.Add(3, , , sbrText)
          tmpPanel.AutoSize = sbrSpring
          tmpPanel.Bevel = sbrNoBevel
          tmpPanel.MinWidth = 132
         
        Set tmpPanel = .Panels.Add(4, , , sbrCaps)
          tmpPanel.Alignment = sbrCenter
          tmpPanel.MinWidth = 750
          tmpPanel.Width = 750
        
        Set tmpPanel = .Panels.Add(5, , , sbrNum)
          tmpPanel.Alignment = sbrCenter
          tmpPanel.MinWidth = 750
          tmpPanel.Width = 750
        
        Set tmpPanel = .Panels.Add(6, , , sbrIns)
          tmpPanel.Alignment = sbrCenter
          tmpPanel.MinWidth = 750
          tmpPanel.Width = 750
       
      Case rtWords
        Set tmpPanel = .Panels.Add(1, "GroupCount", , sbrText)
          tmpPanel.MinWidth = 1587
          tmpPanel.Width = 1587
        
        Set tmpPanel = .Panels.Add(2, "WordCount", , sbrText)
          tmpPanel.MinWidth = 1587
          tmpPanel.Width = 1587
        
        Set tmpPanel = .Panels.Add(3, , , sbrText)
          tmpPanel.AutoSize = sbrSpring
          tmpPanel.Bevel = sbrNoBevel
          tmpPanel.MinWidth = 132
          
        Set tmpPanel = .Panels.Add(4, , , sbrCaps)
          tmpPanel.Alignment = sbrCenter
          tmpPanel.MinWidth = 750
          tmpPanel.Width = 750
        
        Set tmpPanel = .Panels.Add(5, , , sbrNum)
          tmpPanel.Alignment = sbrCenter
          tmpPanel.MinWidth = 750
          tmpPanel.Width = 750
    
        Set tmpPanel = .Panels.Add(6, , , sbrIns)
          tmpPanel.Alignment = sbrCenter
          tmpPanel.MinWidth = 750
          tmpPanel.Width = 750
          
      Case rtLayout
        Set tmpPanel = .Panels.Add(1, "Scale", , sbrText)
          tmpPanel.MinWidth = 750
          tmpPanel.Width = 750
          
        Set tmpPanel = .Panels.Add(2, "Tool", , sbrText)
          tmpPanel.MinWidth = 2000
          tmpPanel.Width = 2000
          
        Set tmpPanel = .Panels.Add(3, "ID", , sbrText)
          tmpPanel.Width = 1323
          tmpPanel.MinWidth = 1323
          
        Set tmpPanel = .Panels.Add(4, "Type", , sbrText)
          tmpPanel.Width = 1323
          tmpPanel.MinWidth = 1323
          
        Set tmpPanel = .Panels.Add(5, "Room1", , sbrText)
          tmpPanel.Width = 1323
          tmpPanel.MinWidth = 1323
          
        Set tmpPanel = .Panels.Add(6, "Room2", , sbrText)
          tmpPanel.Width = 1323
          tmpPanel.MinWidth = 1323
          
        Set tmpPanel = .Panels.Add(7, , , sbrText)
          tmpPanel.AutoSize = sbrSpring
          tmpPanel.Bevel = sbrNoBevel
          tmpPanel.MinWidth = 132
          
        Set tmpPanel = .Panels.Add(8, "CurX", , sbrText)
          tmpPanel.MinWidth = 1111
          tmpPanel.Width = 1111
          
        Set tmpPanel = .Panels.Add(9, "CurY", , sbrText)
          tmpPanel.MinWidth = 1111
          tmpPanel.Width = 1111
      End Select
    'not editing
    Else
      Select Case NewMode
      Case rtLogic, rtPicture, rtSound, rtView
        Set tmpPanel = .Panels.Add(1, , , sbrText)
          tmpPanel.AutoSize = sbrSpring
          tmpPanel.Bevel = sbrNoBevel
          tmpPanel.MinWidth = 132
        
        Set tmpPanel = .Panels.Add(2, , , sbrCaps)
          tmpPanel.Alignment = sbrCenter
          tmpPanel.MinWidth = 750
          tmpPanel.Width = 750
        
        Set tmpPanel = .Panels.Add(3, , , sbrNum)
          tmpPanel.Alignment = sbrCenter
          tmpPanel.MinWidth = 750
          tmpPanel.Width = 750
        
        Set tmpPanel = .Panels.Add(4, , , sbrIns)
          tmpPanel.Alignment = sbrCenter
          tmpPanel.MinWidth = 750
          tmpPanel.Width = 750
        
      Case Else
        'same as game/none
        Set tmpPanel = .Panels.Add(1, , , sbrText)
          tmpPanel.AutoSize = sbrSpring
          tmpPanel.Bevel = sbrNoBevel
          tmpPanel.MinWidth = 132
        
        Set tmpPanel = .Panels.Add(2, , , sbrCaps)
          tmpPanel.Alignment = sbrCenter
          tmpPanel.MinWidth = 750
          tmpPanel.Width = 750
        
        Set tmpPanel = .Panels.Add(3, , , sbrNum)
          tmpPanel.Alignment = sbrCenter
          tmpPanel.MinWidth = 750
          tmpPanel.Width = 750
        
        Set tmpPanel = .Panels.Add(4, , , sbrIns)
          tmpPanel.Alignment = sbrCenter
          tmpPanel.MinWidth = 750
          tmpPanel.Width = 750
      End Select
    End If
  End With
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Public Sub RemovePicture(ByVal PicNum As Byte)

  'removes a picture from the game, and updates
  'preview and resource windows
  On Error GoTo ErrHandler
  
  Dim i As Long
  Dim tmpNode As Node
  
  'remove it from game
  Pictures.Remove PicNum
  
  'remove it from resource list
  Set tmpNode = frmMDIMain.tvwResources.Nodes(3).Child
  Do Until CByte(tmpNode.Tag) = PicNum
    Set tmpNode = tmpNode.Next
  Loop
  frmMDIMain.tvwResources.Nodes.Remove tmpNode.Index
  
  'call nodeclick to update preview window
  frmMDIMain.SelectResourceFromTree frmMDIMain.tvwResources.SelectedItem.Index
  
  'if an editor is open
  For i = 1 To PictureEditors.Count
    If PictureEditors(i).InGame And PictureEditors(i).PicNumber = PicNum Then
      'set number to -1 to force close
      PictureEditors(i).PicNumber = -1
      'close it
      Unload PictureEditors(i)
      Exit For
    End If
  Next i
Exit Sub

ErrHandler:
  'if error is invalid resid,
  If Err.Number = vbObjectError + 617 Then
    'pass it along
    On Error GoTo 0: Err.Raise Err.Number, Err.Source, Err.Description
    Exit Sub
  End If

  Resume Next
End Sub
Public Sub RemoveSound(ByVal SndNum As Byte)

  'removes a view from the game, and updates
  'preview and resource windows
  
  Dim i As Long
  Dim tmpNode As Node
  
  'remove it from game
  Sounds.Remove SndNum
  
  'remove it from resource list
  Set tmpNode = frmMDIMain.tvwResources.Nodes(4).Child
  Do Until CByte(tmpNode.Tag) = SndNum
    Set tmpNode = tmpNode.Next
  Loop
  frmMDIMain.tvwResources.Nodes.Remove tmpNode.Index
  
  'call nodeclick to update preview window
  frmMDIMain.SelectResourceFromTree frmMDIMain.tvwResources.SelectedItem.Index
  
  'if an editor is open
  For i = 1 To SoundEditors.Count
    If SoundEditors(i).InGame And SoundEditors(i).SoundNumber = SndNum Then
      'set number to -1 to force close
      SoundEditors(i).SoundNumber = -1
      'close it
      Unload SoundEditors(i)
      Exit For
    End If
  Next i
End Sub

Public Sub RemoveView(ByVal ViewNum As Byte)
  'removes a view from the game, and updates
  'preview and resource windows
  
  Dim i As Long
  Dim tmpNode As Node
  
  'remove it from game
  Views.Remove ViewNum
  
  'remove it from resource list
  Set tmpNode = frmMDIMain.tvwResources.Nodes(5).Child
  Do Until CByte(tmpNode.Tag) = ViewNum
    Set tmpNode = tmpNode.Next
  Loop
  frmMDIMain.tvwResources.Nodes.Remove tmpNode.Index
  
  'call nodeclick to update preview window
  frmMDIMain.SelectResourceFromTree frmMDIMain.tvwResources.SelectedItem.Index
  
  'if an editor is open
  For i = 1 To ViewEditors.Count
    If ViewEditors(i).InGame And ViewEditors(i).ViewNumber = ViewNum Then
      'set number to -1 to force close
      ViewEditors(i).ViewNumber = -1
      'close it
      Unload ViewEditors(i)
      Exit For
    End If
  Next i
End Sub

Public Function RenumberResource(ByVal OldResNum As Byte, ByVal ResType As AGIResType) As Byte

  'renumbers a resource; return value is the new number
  
  Dim tmpNode As Node, tvwRel As TreeRelationshipConstants
  Dim strResType As String, strCaption As String
  
  On Error GoTo ErrHandler
  
  'default to old number, incase user cancels
  RenumberResource = OldResNum
  
  'show renumber resoure form
  With frmGetResourceNum
    .ResType = ResType
    .OldResNum = OldResNum
    .WindowFunction = grRenumber
    .Show vbModal, frmMDIMain
  End With
  
  'if user makes a choice AND number is different
  If Not frmGetResourceNum.Canceled And frmGetResourceNum.NewResNum <> OldResNum Then
    'get new number
    RenumberResource = frmGetResourceNum.NewResNum
      
    'change number for this resource
    Select Case ResType
    Case rtLogic
      'renumber it
      Logics.Renumber OldResNum, RenumberResource
      strResType = "l"
      strCaption = ResourceName(Logics(RenumberResource), True, True)
      
    Case rtPicture
      'renumber it
      Pictures.Renumber OldResNum, RenumberResource
      strResType = "p"
      strCaption = ResourceName(Pictures(RenumberResource), True, True)
      
    Case rtSound
      'renumber it
      Sounds.Renumber OldResNum, RenumberResource
      strResType = "s"
      strCaption = ResourceName(Sounds(RenumberResource), True, True)
      
    Case rtView
      'renumber it
      Views.Renumber OldResNum, RenumberResource
      strResType = "v"
      strCaption = ResourceName(Views(RenumberResource), True, True)
    End Select
    
    With frmMDIMain.tvwResources
      'remove the old node
      .Nodes.Remove strResType & CStr(OldResNum)
    
      'start with first node of this type
      Set tmpNode = .Nodes(ResType + 2).Child
      
      'if there are no nodes
      If tmpNode Is Nothing Then
        'add first child
        Set tmpNode = .Nodes(ResType + 2)
        tvwRel = tvwChild
      'if this node belongs at end of list
      ElseIf RenumberResource > tmpNode.LastSibling.Tag Then
        'add to end
        Set tmpNode = tmpNode.LastSibling
        tvwRel = tvwNext
      Else
        'get position which should immediately follow this resource
        'step through until a node is found that is past this new number
        Do Until CByte(tmpNode.Tag) > RenumberResource
          Set tmpNode = tmpNode.Next
        Loop
        tvwRel = tvwPrevious
      End If
      
      'put the resource in it's new location
      .Nodes.Add(tmpNode.Index, tvwRel, strResType & CStr(RenumberResource), strCaption).Selected = True
      .SelectedItem.Tag = RenumberResource
      .SelectedItem.EnsureVisible
      'if node is a logic
      If ResType = rtLogic Then
        'highlight in red if not compiled
        Debug.Assert Logics(RenumberResource).SourceCode.Loaded
        If Not Logics(RenumberResource).Compiled Then
          .SelectedItem.ForeColor = vbRed
        End If
      End If
      
      'update by re-selecting
      frmMDIMain.SelectResourceFromTree frmMDIMain.tvwResources.SelectedItem.Index
    End With
  End If
  
  'unload the get resource number form
  Unload frmGetResourceNum
Exit Function

ErrHandler:
  Select Case Err.Number
  Case vbObjectError + 564
    MsgBox "You attempted to change a resource to a number that is already in use. Try renumbering again, with an unused resource number.", vbInformation, "Renumber Resource Error"
    
  Case Else
    MsgBox "Unhandled error in 'RenumberResource': (" & CStr(Err.Number) & "). Resource list may not display correct numbers. Close/reopen game to refresh.", vbInformation, "Renumber Resource Error"
  End Select
  
  'unload the get resource number form
  Unload frmGetResourceNum
  
  Err.Clear
End Function

Public Sub ReplaceAll(ByVal FindText As String, ByVal ReplaceText As String, ByVal FindDir As FindDirection, _
                      ByVal MatchWord As Boolean, ByVal MatchCase As Boolean, ByVal LogicLoc As FindLocation, Optional ByVal SearchType As AGIResType = rtNone)

  Dim i As Long, LogNum As Long
  
  On Error GoTo ErrHandler
  
  'if search type is words or objects, the editor does progress status and msgs
  
  If SearchType = rtNone Then
    'set mouse cursor and disable main form
    frmMDIMain.MousePointer = vbHourglass
    frmMDIMain.Enabled = False
    'refresh
    DoEvents
  End If
  
  'if replacing and text is the same
  If (StrComp(FindText, ReplaceText, IIf(MatchCase, vbBinaryCompare, vbTextCompare)) = 0) Then
    'restore mouse, reneable main form, and exit
    frmMDIMain.MousePointer = vbDefault
    frmMDIMain.Enabled = True
    Exit Sub
  End If
  

  Select Case LogicLoc
  Case flCurrent
    ReplaceAllWords FindText, ReplaceText, MatchWord, MatchCase, True, Nothing, SearchForm
  
  Case flOpen
    'show progress form
    frmProgress.Caption = "Replace All"
    frmProgress.lblProgress.Caption = "Searching..."
    frmProgress.pgbStatus.max = LogicEditors.Count
    frmProgress.Show vbModeless, frmMDIMain
    frmProgress.Refresh

    'replace in all open editors
    For i = 1 To LogicEditors.Count
      'update progress bar
      frmProgress.pgbStatus.Value = i - 1
      frmProgress.lblProgress.Caption = "Searching " & LogicEditors(i).LogicEdit.ID & "..."
      'replace
      ReplaceAllWords FindText, ReplaceText, MatchWord, MatchCase, True, Nothing, LogicEditors(i)
    Next i
    
    'close the progress form
    Unload frmProgress
    
  Case flAll
    If SearchType = rtNone Then
      'show progress form
      frmProgress.Caption = "Replace All"
      frmProgress.lblProgress.Caption = "Searching..."
      frmProgress.pgbStatus.max = Logics.Count
      frmProgress.Show vbModeless, frmMDIMain
      frmProgress.Refresh
    End If
    
    'replace in all open editors
    For i = 1 To LogicEditors.Count
      If SearchType = rtNone Then
        'update progress bar
        frmProgress.pgbStatus.Value = i - 1
        frmProgress.lblProgress.Caption = "Searching " & LogicEditors(i).LogicEdit.ID & "..."
      End If
      
      'repace
      ReplaceAllWords FindText, ReplaceText, MatchWord, MatchCase, True, Nothing, LogicEditors(i), SearchType
    Next i
    
    'now do all closed logics
    
    'get next available logic number
    LogNum = NextClosedLogic(-1)
    
    Do Until LogNum = -1
      If SearchType = rtNone Then
        'update progress bar
        frmProgress.pgbStatus.Value = i - 1
        frmProgress.lblProgress.Caption = "Searching " & Logics(LogNum).ID & "..."
        'refresh window
        DoEvents
      End If
      
      'if not loaded
      If Not Logics(LogNum).Loaded Then
        Logics(LogNum).Load
      End If
      If Not Logics(LogNum).SourceCode.Loaded Then
        Logics(LogNum).SourceCode.Load
      End If
      ReplaceAllWords FindText, ReplaceText, MatchWord, MatchCase, False, Logics(LogNum), Nothing, SearchType
      
      'if dirty
      If Logics(LogNum).SourceCode.IsDirty Then
        'save logic source
        Logics(LogNum).SourceCode.Save
        UpdateSelection rtLogic, LogNum, umPreview
      End If
      
      'unload it
      Logics(LogNum).Unload
      
      'get next logic
      LogNum = NextClosedLogic(LogNum)
      'increment counter
      i = i + 1
    Loop
    
    If SearchType = rtNone Then
      'close the progress form
      Unload frmProgress
    End If
  End Select
    
  If SearchType = rtNone Then
    'if found,
    If ReplaceCount > 0 Then
      MsgBox "The specified region has been searched. " & CStr(ReplaceCount) & " replacments were made.", vbInformation, "Replace All"
    Else
      MsgBox "Search text not found.", vbInformation, "Replace All"
    End If
    frmMDIMain.tmrFind.Enabled = True
    
    'enable form, reenable main form and reset cursor
    frmMDIMain.Enabled = True
    frmMDIMain.MousePointer = vbDefault
    frmMDIMain.SetFocus
  End If
    
  'reset search flags
  FirstFind = False
  SearchStartLog = -1
  SearchStartPos = -1
  ClosedLogics = False
  ReplaceCount = 0
  
Exit Sub

ErrHandler:
  Resume Next
End Sub

Private Sub ReplaceAllWords(ByVal FindText As String, ByVal ReplaceText As String, _
                            ByVal MatchWord As Boolean, ByVal MatchCase As Boolean, _
                            Optional ByVal InWindow As Boolean, _
                            Optional SearchLogic As AGILogic, _
                            Optional SearchWin As Form, _
                            Optional ByVal SearchType As AGIResType = rtNone)


  'replaces text in either a logic, or a textbox
  'user MUST ensure a valid reference to a richtextbox
  'or a logic is passed

  Dim FoundPos As Long
  Dim StartPos As Long
  Dim vbcComp As VbCompareMethod
  Dim i As Long

  On Error GoTo ErrHandler

  'if NOT a regualr search
  If SearchType <> rtNone Then
    'ignore text editors
    If InWindow Then
      If SearchWin.Name = "frmTextEdit" Then
        Exit Sub
      End If
    End If
  End If
  
  'set comparison method for string search,
  vbcComp = CLng(MatchCase) + 1 ' CLng(True) + 1 = 0 = vbBinaryCompare; Clng(False) + 1 = 1 = vbTextCompare

  'start at beginning
  FoundPos = 1

  Do
    'if searching whole word
    If MatchWord Then
      'if in a window
      If InWindow Then
        FoundPos = FindWholeWord(FoundPos, SearchWin.rtfLogic.Text, FindText, vbcComp, False, SearchType, SearchWin.TextSyntax)
      Else
        FoundPos = FindWholeWord(FoundPos, SearchLogic.SourceCode.Text, FindText, vbcComp, False, SearchType, SearchLogic.SourceCode.Syntax)
      End If
    Else
      'if in a window
      If InWindow Then
        FoundPos = InStr(FoundPos, SearchWin.rtfLogic.Text, FindText, vbcComp)
      Else
        FoundPos = InStr(FoundPos, SearchLogic.SourceCode.Text, FindText, vbcComp)
      End If
    End If

    If FoundPos > 0 Then
      'if replacing in a window
      If InWindow Then
        'instr is 1 based; richedit boxes are 0 based
        'so need to subtract one from foundpos
        SearchWin.rtfLogic.Selection.Range.StartPos = FoundPos - 1
        SearchWin.rtfLogic.Selection.Range.EndPos = SearchWin.rtfLogic.Selection.Range.StartPos + Len(FindText)
        'recalculate selection again; sometimes it gets
        'set incorrectly the first time(bug in richtext editor??)
        SearchWin.rtfLogic.Selection.Range.StartPos = FoundPos - 1
        SearchWin.rtfLogic.Selection.Range.EndPos = SearchWin.rtfLogic.Selection.Range.StartPos + Len(FindText)
        'if selected text does not match,
        If LCase$(SearchWin.rtfLogic.Selection.Range.Text) <> LCase$(FindText) Then
          'error
          MsgBox "An error was encountered in the replace feature of the rich text" & vbNewLine & "editor. Not all instances of search text have been replaced.", vbCritical + vbOKOnly, "Replace All Error"
          Exit Sub
        End If
        
        SearchWin.rtfLogic.Selection.Range.Text = ReplaceText
      Else
        'replace word
        SearchLogic.SourceCode.Text = Left$(SearchLogic.SourceCode.Text, FoundPos - 1) & ReplaceText & Right$(SearchLogic.SourceCode.Text, Len(SearchLogic.SourceCode.Text) - Len(FindText) - FoundPos + 1)
      End If

      'reset foundpos
      FoundPos = FoundPos + Len(ReplaceText)
      'increment count
      ReplaceCount = ReplaceCount + 1
    Else
      Exit Do
    End If
  Loop

Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Function ResourceName(ThisResource As Object, ByVal IsInGame As Boolean, Optional ByVal NoNumber As Boolean = False) As String

  'formats resource name based on user preference
  'format includes: option for upper, lower or title case of type;
  '                 space or period for separator;
  '                 forcing number to include leading zeros
                 
  'if the resource is not part of a game,
  'the ID is returned regardless of ID/number setting
  
  On Error GoTo ErrHandler
  
  'if using numbers AND resource is ingame,
  If Settings.ShowResNum And IsInGame Then
    With Settings.ResFormat
      ResourceName = StrConv(ResTypeName(CInt(ThisResource.Resource.ResType)), .NameCase) & .Separator & format$(ThisResource.Number, .NumFormat)
    End With
  Else
    If Settings.IncludeResNum And IsInGame And Not NoNumber Then
      ResourceName = ThisResource.Number & " - "
    End If
    ResourceName = ResourceName & ThisResource.ID
  End If
Exit Function

ErrHandler:
  Resume Next
End Function


Public Sub UpdateExitInfo(ByVal LogicNumber As Long, ThisLogic As AGILogic)
  
  'updates the layout editor (if it is open) and the layout file
  '(if there is one) whenever exit info for a room is changed
  '(including when IsRoom property is changed, or when a room is
  'deleted from the game)
   
  Dim tmpExits As AGIExits
  Dim blnSave As Boolean, blnShow As Boolean
  
  On Error GoTo ErrHandler
  
  'is there an existing layout editor file?
  blnSave = FileExists(GameDir & GameID & ".wal")
  
  'if layout file does not exist AND not editing layout
  If Not blnSave And Not LEInUse Then
    'no file, and editor is not in use;
    'no updates are necessary
    Exit Sub
  End If
  
  'if removing a logic from the game, no logic object is passed
  If ThisLogic Is Nothing Then
    blnShow = False
  Else
    'show or hide depending on isroom flag
    blnShow = ThisLogic.IsRoom
  End If
  
  'if showing the room,
  If blnShow Then
    'get new exits from the logic that was passed
    Set tmpExits = ExtractExits(ThisLogic)
  End If
  
  'if layout editor is open
  If LEInUse Then
    'use layout editor update method
    LayoutEditor.UpdateLayout LogicNumber, blnShow, tmpExits
    'and redraw to refresh the editor
    LayoutEditor.DrawLayout
  End If
  
  'if a layout file exists, it needs to be updated too
  If blnSave Then
    'add line to output file
    UpdateLayoutFile LogicNumber, tmpExits, Not blnShow
  End If
Exit Sub

ErrHandler:
  Resume Next
End Sub

Public Function ParseExits(strExitInfo As String) As AGIExits
  'parses the string that contains exit info that comes from the layout editor
  'data file
  'if error is encountered,
  
  Dim strExit() As String, strData() As String
  Dim i As Long
  
  Set ParseExits = New AGIExits
  
  On Error GoTo ErrHandler
  
  'R|##|v|o|x|y|index:room:reason:style:xfer:leg:spx:spy:epx:epy|...
  
  strData = Split(strExitInfo, "|")
  
  'get exit info
  For i = 0 To UBound(strData) - 6
    strExit = Split(strData(i + 6), ":")
    'should be ten elements (ubound of 9)
    If UBound(strExit) = 9 Then
      
      'add new exit, and flag as new, in source
      ParseExits.Add(strExit(0), strExit(1), strExit(2), strExit(3), strExit(4), strExit(5)).Status = esOK
      
      With ParseExits.Item(ParseExits.Count - 1)
        .SPX = CSng(strExit(6))
        .SPY = CSng(strExit(7))
        .EPX = CSng(strExit(8))
        .EPY = CSng(strExit(9))
      End With
      
    End If
  Next i
Exit Function

ErrHandler:
  'error!
  Debug.Assert False
  Resume Next
  Set ParseExits = Nothing
End Function
